/*->h.border */


#define BORDERNAMELEN 16


/* object of type OBORDER */

#define BORDER 0
#define SHADOW 1



#define BDRACT 0x1
#define BDRDES 0x2
#define BDRREP 0x4
#define BDRSTR 0x8


#define BDRTOP   0x1
#define BDRRIGHT 0x2
#define BDRBOT   0x4
#define BDRLEFT  0x8

#define BDRFANCY 0x1


typedef struct subborderstr
{
 int         active;
 int         width;
 colourvalue colour;
 int         mode;
} subborderstr;



typedef struct borderdatastr
{
 char         name[BORDERNAMELEN];
 subborderstr border[2];

} borderdatastr;



typedef struct borderchangebits
{
 unsigned int xactive:1;
 unsigned int xwidth:1;
 unsigned int xcolour:1;
 unsigned int xmode:1;
 unsigned int xrepeat:1;
 unsigned int xstretch:1;
 unsigned int xdesign:1;

} borderchangebits;



typedef struct modifyborderdatastr
{
 borderdatastr     border;
 int               xname;
 borderchangebits  bits[2];
} modifyborderdatastr;



typedef struct borderlinestr
{
 int           key;
 int           type;

 chainstr      chain;

 int           spare1;
 int           spare2;

 borderdatastr data;

} borderlinestr;




#define DSTFRAMEBORDER    0x1300
#define DSTBORDER         0x1301
#define DSTSHADOW         0x1302




extern int        borderdefn;

extern os_error * sampleborder(int x,int y,int w,int h,int d,
                                                       int n,int selected);

extern os_error * getbordersize(int border,filestr * file,
                                           int * width,curvestr * c);

extern os_error * createborder(modifyborderdatastr * borderp,filestr * file,
                                          int * border,int oldborder);

extern void        borderchange(modifyborderdatastr * borderp,
                                      borderdatastr * xnew,borderdatastr * old);


extern int getborderinfo(int n,int * width);

extern int        bordercmp(int * width1,int * width2);
extern os_error * deleteborder(int border,filestr * file);

extern os_error * copyborder(int * dn,int sn,filestr * file);
extern os_error * copyborderm(int * dn,filestr * dfile,
                              int sn,filestr * sfile,int mode);

extern os_error * renderborder(int border,curvestr * fcurve,transformstr * tr,
                                          viewredrawstr * v);

extern os_error * getframemaxbox(sobjectstr ** sobp,int frame,filestr * file,
                                                      transformstr * tr);


extern int        getborderindex(char * name);
extern void       getbordername(char * name,int index);


extern os_error * borderselection(modifyborderdatastr * borderp,filestr * file);

extern os_error * dswriteframeborder(int bordern,buffer * bf,filestr * file);


extern os_error * bordergetcolour(int border,int * message,
                                             void * data,filestr * file);

extern os_error * bordersetcolour(int border,void * data,filestr * file);


extern os_error * borderinit(void);


