/*->c.cconv */

#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "transform.h"


#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "alloc.h"
#include "fsx.h"
#include "bf.h"
#include "trans.h"
#include "xmath.h"
#include "etc.h"


#include "str.h"
#include "constants.h"


#include "xxcolour.h"
#include "xcolour.h"

#include "cconv.h"


/****************************************************************************/

/* rgb 0..MAXCV   */
/* h   0..HUE360  */
/* v   0..MAXCV   */
/* s   0..MAXCV   */



#ifdef OLDDEF

void rgb2hsv(quadstr * rgb,quadstr * hsv)
{
 int max;
 int min;

 max=MAX(rgb->type.rgb.r,rgb->type.rgb.g);
 max=MAX(max,rgb->type.rgb.b);
 hsv->type.hsv.v=max;

 min=MIN(rgb->type.rgb.r,rgb->type.rgb.g);
 min=MIN(min,rgb->type.rgb.b);

 if(min==max)
 {
  hsv->type.hsv.s=0;
  hsv->type.hsv.h=0;
 }
 else
 {
  hsv->type.hsv.s=scale(MAXCV,max-min,max);

  if(min==rgb->type.rgb.b)
  {
   hsv->type.hsv.h=scale(HUE120,rgb->type.rgb.g-min,
                                rgb->type.rgb.r+rgb->type.rgb.g-2*min);
  }
  else
  if(min==rgb->type.rgb.r)
  {
   hsv->type.hsv.h=HUE120+scale(HUE120,rgb->type.rgb.b-min,
                                       rgb->type.rgb.b+rgb->type.rgb.g-2*min);
  }
  else
  {
   hsv->type.hsv.h=HUE240+scale(HUE120,rgb->type.rgb.r-min,
                                       rgb->type.rgb.r+rgb->type.rgb.b-2*min);
  }
 }
}


/* rgb 0..MAXCV */
/* h 0..HUE360  */
/* v 0..MAXCV   */
/* s 0..MAXCV   */

void hsv2rgb(quadstr * hsv,quadstr * rgb)
{
 int min;
 int h;

 min=scale(hsv->type.hsv.v,MAXCV-hsv->type.hsv.s,MAXCV);
 h=hsv->type.hsv.h;

 if(h<=HUE120)
 {
  rgb->type.rgb.b=min;
  if(h<=HUE60)
  {
   rgb->type.rgb.r=hsv->type.hsv.v;
   rgb->type.rgb.g=min+scale(h,hsv->type.hsv.v-min,HUE120-h);
  }
  else
  {
   rgb->type.rgb.g=hsv->type.hsv.v;
   rgb->type.rgb.r=min+scale(HUE120-h,hsv->type.hsv.v-min,h);
  }
 }
 else
 if(h<=HUE240)
 {
  rgb->type.rgb.r=min;
  if(h<=HUE180)
  {
   rgb->type.rgb.g=hsv->type.hsv.v;
   rgb->type.rgb.b=min+scale(h-HUE120,hsv->type.hsv.v-min,HUE240-h);
  }
  else
  {
   rgb->type.rgb.b=hsv->type.hsv.v;
   rgb->type.rgb.g=min+scale(HUE240-h,hsv->type.hsv.v-min,h-HUE120);
  }
 }
 else
 {
  rgb->type.rgb.g=min;
  if(h<=HUE300)
  {
   rgb->type.rgb.b=hsv->type.hsv.v;
   rgb->type.rgb.r=min+scale(h-HUE240,hsv->type.hsv.v-min,HUE360-h);
  }
  else
  {
   rgb->type.rgb.r=hsv->type.hsv.v;
   rgb->type.rgb.b=min+scale(HUE360-h,hsv->type.hsv.v-min,h-HUE240);
  }
 }
}

#else



void rgb2hsv(quadstr * rgb,quadstr * hsv)
{
 int max;
 int min;

 max=MAX(rgb->type.rgb.r,rgb->type.rgb.g);
 max=MAX(max,rgb->type.rgb.b);
 hsv->type.hsv.v=max;

 min=MIN(rgb->type.rgb.r,rgb->type.rgb.g);
 min=MIN(min,rgb->type.rgb.b);

 if(min==max)
 {
  hsv->type.hsv.s=0;
  hsv->type.hsv.h=0;
 }
 else
 {
  hsv->type.hsv.s=scale(MAXCV,max-min,max);

  if(min==rgb->type.rgb.b)
  {
   if(max==rgb->type.rgb.r)
   {
    hsv->type.hsv.h=scale(HUE60,rgb->type.rgb.g-min,rgb->type.rgb.r-min);
   }
   else
   {
    hsv->type.hsv.h=HUE120-scale(HUE60,rgb->type.rgb.r-min,rgb->type.rgb.g-min);   }
  }
  else
  if(min==rgb->type.rgb.r)
  {
   if(max==rgb->type.rgb.g)
   {
    hsv->type.hsv.h=
          HUE120+scale(HUE60,rgb->type.rgb.b-min,rgb->type.rgb.g-min);
   }
   else
   {
    hsv->type.hsv.h=
          HUE240-scale(HUE60,rgb->type.rgb.g-min,rgb->type.rgb.b-min);
   }
  }
  else
  {
   if(max==rgb->type.rgb.b)
   {
    hsv->type.hsv.h=
          HUE240+scale(HUE60,rgb->type.rgb.r-min,rgb->type.rgb.b-min);
   }
   else
   {
    hsv->type.hsv.h=
          HUE360-scale(HUE60,rgb->type.rgb.b-min,rgb->type.rgb.r-min);
   }
  }
 }
}


/* rgb 0..MAXCV */
/* h 0..HUE360  */
/* v 0..MAXCV   */
/* s 0..MAXCV   */

void hsv2rgb(quadstr * hsv,quadstr * rgb)
{
 int min;
 int h;

 min=scale(hsv->type.hsv.v,MAXCV-hsv->type.hsv.s,MAXCV);
 h=hsv->type.hsv.h;

 if(h<=HUE120)
 {
  rgb->type.rgb.b=min;
  if(h<=HUE60)
  {
   rgb->type.rgb.r=hsv->type.hsv.v;
   rgb->type.rgb.g=min+scale(h,hsv->type.hsv.v-min,HUE60);
  }
  else
  {
   rgb->type.rgb.g=hsv->type.hsv.v;
   rgb->type.rgb.r=min+scale(HUE120-h,hsv->type.hsv.v-min,HUE60);
  }
 }
 else
 if(h<=HUE240)
 {
  rgb->type.rgb.r=min;
  if(h<=HUE180)
  {
   rgb->type.rgb.g=hsv->type.hsv.v;
   rgb->type.rgb.b=min+scale(h-HUE120,hsv->type.hsv.v-min,HUE60);
  }
  else
  {
   rgb->type.rgb.b=hsv->type.hsv.v;
   rgb->type.rgb.g=min+scale(HUE240-h,hsv->type.hsv.v-min,HUE60);
  }
 }
 else
 {
  rgb->type.rgb.g=min;
  if(h<=HUE300)
  {
   rgb->type.rgb.b=hsv->type.hsv.v;
   rgb->type.rgb.r=min+scale(h-HUE240,hsv->type.hsv.v-min,HUE60);
  }
  else
  {
   rgb->type.rgb.r=hsv->type.hsv.v;
   rgb->type.rgb.b=min+scale(HUE360-h,hsv->type.hsv.v-min,HUE60);
  }
 }
}



#endif



/* rgb  0..MAXCV  */
/* cymk 0..MAXCV  */

void rgb2cmyk(quadstr * rgb,quadstr * cmyk)
{
 int c;
 int m;
 int y;
 int k;

 c=MAXCV-rgb->type.rgb.r;
 m=MAXCV-rgb->type.rgb.g;
 y=MAXCV-rgb->type.rgb.b;

 k=MIN(c,m);
 k=MIN(k,y);
 cmyk->type.cmyk.k=k;

 cmyk->type.cmyk.c=c-k;
 cmyk->type.cmyk.m=m-k;
 cmyk->type.cmyk.y=y-k;
}


void cmyk2rgb(quadstr * cmyk,quadstr * rgb)
{
 int c;
 int m;
 int y;
 int k;

 k=cmyk->type.cmyk.k;

 c=ROOF(k+cmyk->type.cmyk.c,MAXCV);
 m=ROOF(k+cmyk->type.cmyk.m,MAXCV);
 y=ROOF(k+cmyk->type.cmyk.y,MAXCV);

 rgb->type.rgb.r=MAXCV-c;
 rgb->type.rgb.g=MAXCV-m;
 rgb->type.rgb.b=MAXCV-y;
}




void cmyk2rgb3232(int * s,int * d,int size)
{
 int r;
 int g;
 int b;
 int c;
 int m;
 int y;
 int k;
 int cmyk;


 while(size--)
 {
  cmyk=*s++;

  k=(cmyk>>24) & 0xFF;
  y=(cmyk>>16) & 0xFF;
  m=(cmyk>>8) & 0xFF;
  c=cmyk & 0xFF;

  r=255-(c+k);
  if(r<0) r=0;

  g=255-(m+k);
  if(g<0) g=0;

  b=255-(y+k);
  if(b<0) b=0;

  *d++=(b<<16)|(g<<8)|r;
 }

}




void cmyk2bgr3232(int * s,int * d,int size)
{
 int r;
 int g;
 int b;
 int c;
 int m;
 int y;
 int k;
 int cmyk;


 while(size--)
 {
  cmyk=*s++;

  k=(cmyk>>24) & 0xFF;
  y=(cmyk>>16) & 0xFF;
  m=(cmyk>>8) & 0xFF;
  c=cmyk & 0xFF;

  r=255-(c+k);
  if(r<0) r=0;

  g=255-(m+k);
  if(g<0) g=0;

  b=255-(y+k);
  if(b<0) b=0;

  *d++=(r<<16)|(g<<8)|b;
 }

}
