/*->c.editpath */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "akbd.h"
#include "transform.h"


#include "err.h"
#include "poll.h"
#include "dbhi.h"
#include "fsx.h"
#include "bf.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "etc.h"
#include "colour.h"
#include "key.h"
#include "xmath.h"
#include "deb.h"


#include "str.h"
#include "constants.h"
#include "reslink.h"
#include "mhi.h"

#include "object.h"
#include "chain.h"
#include "undo.h"

#include "viewr.h"
#include "view.h"
#include "caret.h"
#include "file.h"
#include "select.h"
#include "posn.h"
#include "xredraw.h"
#include "curvelo.h"
#include "curve.h"
#include "geometry.h"
#include "units.h"
#include "grid.h"
#include "frameflow.h"
#include "pref.h"
#include "xcolour.h"


#include "toolstr.h"
#include "tools.h"

#include "editpath.h"


// things wrong - eptsn[] is apparently being used as a flag
// which means it can be non zero when the flex'd associated memory is zero
// BLOBSETP and BLOBCLEARP when used from eclear duplicate up with undo/redo




#define UNMOVEPT    0x9100
#define UNMOVETAN   0x9101
#define UNFLATTEN   0x9102
#define UNSNAP      0x9103
#define UNOCSWOP    0x9104
#define UNLCSWOP    0x9105
#define UNMOVE      0x9106
#define UNMODE      0x9107
#define UNADDBLOB4  0x9108
#define UNREMBLOB4  0x9109
#define UNVH        0x910A
#define BLOBCLEARP  0x910B
#define BLOBSETP    0x910C
#define UNEDITCLEAR 0x910D
#define UNEDITPOSN  0x910E

#define UNADDPOINT  0x910F
#define UNREMPOINT  0x9110
#define UNADDPOINTS 0x9111
#define UNADDPOINTF 0x9112
#define UNREMPOINTS 0x9113
#define UNREMPOINTF 0x9114


int        instantpathedit;


#define BLOBCHUNK 16*sizeof(blobstr)

#define EP_POINT    1
#define EP_CPOINT   2
#define EP_CTANGENT 3

#define EP_NONE         0
#define EP_EDIT         1
#define EP_DRAGTANGENT  2
#define EP_DRAGPOINT    3
#define EP_DRAG2TANGENT 4



#define CXSHIFT (5*MMSIZE)
#define CYSHIFT (5*MMSIZE)




typedef struct blobstr
{
 int n;
} blobstr;


static posnstr dragposn;
static int     dragtangent;
static int     edxc;
static int     edyc;
static int     eddx;
static int     eddy;
static int     eddx2;
static int     eddy2;
static int     eddr;
static int     eddr2;

static int      epfindoffset;
static int      epfindblobbase;
static int      epfindpathbase;
static coordstr epfindpoint;



/* there are 2 collections of blobs                            */
/* collection 0 is the selected points etc.                    */
/* collection 1 is the points that we want to change on screen */



typedef struct eposnstr
{
 int          section;
 int          page;
 int          object;
 int          otype;
 int          handle;
 int          htype;
 int          master;
 objectbitstr bits;
} eposnstr;



typedef struct editpathtoolstr
{
 eposnstr  editposn;          /* position that curve edit started at */
 int       editstate;         /* curve edit in progress ?            */
 blobstr * editpts[2];        /* selected point numbers              */
 int       editptn[2];        /* number of selected points           */
 epstr     editcurve;
 int       editmode;

} editpathtoolstr;


/* static editpathtoolstr * etool; */


static int blobs10;


static int        blobselected(editpathtoolstr * etool,int blob,int n);
static os_error * editchange(int quit,filestr * file,editpathtoolstr * etool);


/*****************************************************************************/


static void pos2epos(eposnstr * eposn,posnstr * posn)
{
 eposn->section=posn->section;
 eposn->page=posn->page;
 eposn->object=posn->object;
 eposn->otype=posn->otype;
 eposn->handle=posn->handle;
 eposn->htype=posn->htype;
 eposn->master=posn->master;
 eposn->bits=posn->bits;
}





/* offset is a word offset                */
/* delta is number of words to add/remove */


static os_error * pathinsert(int path,int ** pp,int offset,int delta,
                                                          filestr * file)
{
 os_error * err;
 pathstr  * pathp;
 int        size;
 int      * p;

 pathp=(pathstr*)fob_find(path,file);

 p=pathp->data;
 size=pathsize(p);

 if(delta<0)
 {
  memmove(p+offset,p+offset-delta,size-(offset-delta)*sizeof(int));
 }

 err=fob_change(path,file,
                     sizeof(pathstr)-sizeof(int)+size+delta*sizeof(int),
                                                         (fobjptr)&pathp);

 if(!err)
 {
  p=pathp->data;
  if(delta>0)
  {
   memmove(p+offset+delta,p+offset,size-offset*sizeof(int));
  }
 }

 *pp=p;

 return(err);
}




/* p points at DRAWCURVE  */
/* base is start of curve */

static int * gettangent(int * base,int * p)
{
 if(*(p+7)==DRAWCURVE) return(p+7);
 else
 if(*(p+7)==DRAWCLOSE)
 {
  p=base+3;  /* must start with a move */
  if(*p==DRAWCURVE) return(p);
 }
 return(NULL);
}


static int gettangentb(int * base,int * p,int blob,int bbase)
{
 if(*(p+7)==DRAWCURVE) return(blob+3);
 else
 if(*(p+7)==DRAWCLOSE)
 {
  p=base+3;  /* must start with a move */
  if(*p==DRAWCURVE) return(bbase+1);
 }
 return(-1);
}




/* p is the previous point, blob is previous blob */

static int getprevtangentb(int * p,int blob,int ** q)
{
 int   c;
 int * op;
 int * op2;
 int * r;

 *q=NULL;

 if(*p==DRAWCURVE)
 {
  *q=p;
  return(blob+1);
 }
 else
 if(*p==DRAWMOVE)  /* hunt for CLOSE */
 {
  op2=op=r=p;
  p+=3;
  blob++;

  while((c=*p)!=0)
  {
   op2=op;
   op=p;

   if(c==DRAWCLOSE) break;
   else
   if(c==DRAWMOVE)  break;
   else
   if(c==DRAWDRAW) 
   {
    blob++;
    p+=3;
   }
   else
   if(c==DRAWCURVE)
   {
    blob+=3;
    p+=7;
   }
  }

  if(c==DRAWCLOSE && *op2==DRAWCURVE)
  {
   if((*(r+1)==*(op2+5)) && (*(r+2)==*(op2+6)))
   *q=op2;
   return(blob-3+1);
  }
 }

 return(-1);
}




static int getloopb(int * base,int * p,int blobbase)
{
 int x;
 int y;
 int x1;
 int y1;

 if(*p==DRAWCLOSE)
 {
  x=*(p-2);
  y=*(p-1);
  x1=*(base+1);
  y1=*(base+2);

  if(x==x1 && y==y1) return(blobbase);
 }

 return(-1);
}


static int looppoint(int * p,int ** q) 
{
 int * s;
 int   c;
 int * op;
 int * op2;

 s=op=p;
 p+=3;

 while((c=*p)!=0)
 {
  op2=op;
  op=p;

  if(c==DRAWMOVE) break;
  else
  if(c==DRAWDRAW)  p+=3;
  else
  if(c==DRAWCURVE) p+=7;
  else
  if(c==DRAWCLOSE)
  {
   if((*(p-2)==*(s+1)) && (*(p-1)==*(s+2)))
   {
    *q=op2;
    return(0);
   }
  }
 }
 return(-1);
}



static void blobclear(editpathtoolstr * etool,int n)
{
 etool->editptn[n]=0;
 flex_free((flex_ptr)&etool->editpts[n]);
}


static void blobinit(editpathtoolstr * etool)
{
 int i;
 for(i=0;i<2;i++) blobclear(etool,i);
}


/* refresh the object being edited */

static os_error * editrefresh(filestr * file)
{
 return(viewrefreshall(file,-1,VRTOOLS));
}




static os_error * blob(int x,int y,transformstr * tr,viewredrawstr * v,int colour)
{
 os_error * err;
 coordstr   c;

 c.x=x;
 c.y=y;
 if(tr) tr_transformset(&c,1,tr);

 err=rseteorcol(WIMPWHITE,colour);

 x=v->ox+osunits(v->xpo+c.x,v->view);  
 y=v->oy-osunits(v->ypo+c.y,v->view);  

 err=bbc_move(x+DRSUB/2,y+DRSUB/2);
 err=bbc_plot(96+5,x-DRSUB/2,y-DRSUB/2);

 return(err);
}


#define REDITLINE    0x1
#define REDITNOBLOBS 0x2
#define REDITNOLINE  0x4
#define REDITNOFRAME 0x8
#define REDITFRAME   0x10      /* set when redrawing frame line */


static int reditmode;


static os_error * epseteorcol(editpathtoolstr * etool,
                              int wimpcol,viewredrawstr * v)
{
 if(etool->editcurve.coltype==EPC_NONE || etool->editcurve.invisible) 
                 return(rseteorcol(WIMPWHITE,wimpcol));
 else
 if(etool->editcurve.coltype==EPC_PAL)  
                 return(rseteorcolpal(etool->editcurve.colour.pal,wimpcol));
 else
 if(etool->editcurve.coltype==EPC_WIMP) 
                 return(rseteorcol(etool->editcurve.colour.wimpcol,wimpcol));
 else
 if(etool->editcurve.coltype==EPC_CV || 
    (etool->editcurve.coltype==EPC_CVG && !(v->view)->data.guides))
 {
  return(rseteorcolpal(vfindcolour(v->view,&etool->editcurve.colour.cv),
                                                                 wimpcol));
 }
 else
 if(etool->editcurve.coltype==EPC_CVG) return(rseteorcol(GUIDECOLOUR,wimpcol));

 return(NULL);
}


static os_error * reditline(editpathtoolstr * etool,int * p,
                            viewredrawstr * v,transformstr * t)
{
 os_error * err;
 int        over;
 int        c;
 int        x;
 int        y;
 coordstr   cx[4];
 int        blobn;
 int        selected;
 int        lastselected;
 int        pstate;
 int        tstate;
 int        tstate2;
 int        nfstate;

 err=NULL;
 over=0;
 blobn=0;
 selected=0;


 nfstate=(!(reditmode & REDITFRAME));
 pstate=(etool->editstate==EP_DRAGPOINT) && nfstate;
 tstate2=(etool->editstate==EP_DRAG2TANGENT) && nfstate;
 tstate=(etool->editstate==EP_DRAGTANGENT || tstate2) && nfstate;

 
 x=y=0;  /* compiler */

 while(!over)
 {
  lastselected=selected;
  c=*p++;

  switch(c)
  {
   case DRAWMOVE:
                 x=*p++;
                 y=*p++;

                 if(pstate && (selected=blobselected(etool,blobn,0))!=0)
                 {
                  x+=eddx;
                  y+=eddy;
                 }
                 selected=selected && (reditmode & REDITLINE);

                 blobn++;
                 break;

   case DRAWDRAW:
                 if(!etool->editptn[1] || 
                    (nfstate && blobselected(etool,blobn,1)) || lastselected)
                 {
                  rtbbc_move(x,y,t,v);

                  x=*p++;
                  y=*p++;

                  if(nfstate && blobselected(etool,blobn,0))
                  {
                   epseteorcol(etool,WIMPRED,v);
                   selected=reditmode & REDITLINE;

                   if(pstate)
                   {
                    x+=eddx;
                    y+=eddy;
                   }
                  }
                  else 
                  {
                   epseteorcol(etool,WIMPGREY2,v);
                   selected=0;
                  }

                  rtbbc_draw(x,y,t,v);
                 }
                 else
                 {
                  x=*p++;
                  y=*p++;
                 }

                 blobn++;
                 break;

   case DRAWCURVE:
                  if(!etool->editptn[1] || 
                     (nfstate && blobselected(etool,blobn+2,1)) || 
                     lastselected ||
                     (tstate && ((dragposn.handle==blobn) ||
                                 (dragposn.handle==(blobn+1))
                                )
                     )            ||
                     (tstate2 && ((dragtangent==blobn) ||
                                  (dragtangent==(blobn+1))
                                 )
                     )
                    )
                  {
                   cx[0].x=x;
                   cx[0].y=y;
                   cx[1].x=*p++;
                   cx[1].y=*p++;
                   cx[2].x=*p++;
                   cx[2].y=*p++;
                   x=cx[3].x=*p++;
                   y=cx[3].y=*p++;


                   if(nfstate && blobselected(etool,blobn+2,0))
                   {
                    epseteorcol(etool,WIMPRED,v);
                    selected=reditmode & REDITLINE;
                    if(pstate)
                    {
                     x=cx[3].x=x+eddx;
                     y=cx[3].y=y+eddy;
                    }
                   }
                   else 
                   {
                    epseteorcol(etool,WIMPGREY2,v);
                    selected=0;
                   }

                   if(pstate)
                   {
                    if(blobselected(etool,blobn,0))
                    {
                     cx[1].x+=eddx;
                     cx[1].y+=eddy;
                    }

                    if(blobselected(etool,blobn+1,0))
                    {
                     cx[2].x+=eddx;
                     cx[2].y+=eddy;
                    }
                   }
                   else
                   if(tstate)
                   {
                    if(dragposn.handle==blobn)
                    {
                     cx[1].x+=eddx;
                     cx[1].y+=eddy;
                    }
                    else
                    if(dragposn.handle==(blobn+1))
                    {
                     cx[2].x+=eddx;
                     cx[2].y+=eddy;
                    }

                    if(tstate2)
                    {
                     if(dragtangent==blobn)
                     {
                      cx[1].x+=eddx2;
                      cx[1].y+=eddy2;
                     }
                     else
                     if(dragtangent==(blobn+1))
                     {
                      cx[2].x+=eddx2;
                      cx[2].y+=eddy2;
                     }
                    }
                   }

                   rpathchunk(cx,v,t);
                  }
                  else
                  {
                   p+=4;
                   x=*p++;
                   y=*p++;
                  }
                  blobn+=3;
                  break;

   case DRAWEND:
                 over=1;
                 break;
  }
 }
 return(err);
}




static os_error * rpatheditline(editpathtoolstr * etool,int * path,
                                transformstr * tr,viewredrawstr * v)
{
 os_error * err;
 int      * p;
 int        c;
 int        x;
 int        y;
 int        x1;
 int        x2;
 int        x3;
 int        y1;
 int        y2;
 int        y3;
 int        blobn;
 int        pstate;
 int        tstate;
 int        tstate2;
 int        rselected;
 int        subblobn;        /* blobn for start of sub path */
 int        subx;            /* x and y for it */
 int        suby;
 int        skip;

 err=NULL;

 p=path;
 blobn=0;
 x=y=0;           /* compiler */
 rselected=0;     /* compiler */
 subblobn=-1;
 subx=suby=0;     /* compiler */

 pstate=(etool->editstate==EP_DRAGPOINT);
 tstate2=(etool->editstate==EP_DRAG2TANGENT);
 tstate=tstate2 || (etool->editstate==EP_DRAGTANGENT);


 while((c=*p)!=0)
 {
  if(c==DRAWCLOSE)
  {
   p++;
  }
  else
  if(c==DRAWMOVE || c==DRAWDRAW)
  {
   x=p[1];
   y=p[2];

   skip=(*(p+3)==DRAWCLOSE && subx==x && suby==y);

   if(!etool->editptn[1] || blobselected(etool,blobn,1))
   {
    if(!blobselected(etool,blobn,0) && !skip)
    {
     err=blob(x,y,tr,v,WIMPLBLUE);
    }
    else
    {
     if(pstate)
     {
      x+=eddx;
      y+=eddy;
     }
     if(!skip) err=blob(x,y,tr,v,WIMPRED);
    }
   }

   if(c==DRAWMOVE) 
   {
    subblobn=blobn;
    subx=p[1];           /* because don't want shift added */
    suby=p[2];
   }

   blobn++;
   p+=3;
  }
  else
  if(c==DRAWCURVE)
  {
   x1=*(p+1);
   y1=*(p+2);
   x2=*(p+3);
   y2=*(p+4);
   x3=*(p+5);
   y3=*(p+6);

   skip=(*(p+7)==DRAWCLOSE && subx==x3 && suby==y3);

   if(!etool->editptn[1] || blobselected(etool,blobn+2,1))
   {
    if(!blobselected(etool,blobn+2,0) && !skip)
    {
     err=blob(x3,y3,tr,v,WIMPLBLUE);
    }
    else
    {
     if(pstate)
     {
      x3+=eddx;
      y3+=eddy;
     }

     if(!skip) err=blob(x3,y3,tr,v,WIMPRED);
    }
   }

   if(((rselected=blobselected(etool,blobn,0))!=0 && 
       (!etool->editptn[1] || blobselected(etool,blobn,1))
      )
     )
   {
    if((pstate && rselected) || (tstate && blobn==dragposn.handle))
     
    {
     x1+=eddx;
     y1+=eddy;
    }
    else
    if(tstate2 && blobn==dragtangent)
    {
     x1+=eddx2;
     y1+=eddy2;
    }

    rseteorcol(WIMPWHITE,WIMPGREY2);
    rtbbc_move(x,y,tr,v);
    rtbbc_draw(x1,y1,tr,v);
    err=blob(x1,y1,tr,v,WIMPORANGE);
   }


   if(((rselected=blobselected(etool,blobn+1,0))!=0 && 
       (!etool->editptn[1] || blobselected(etool,blobn+1,1))
      )
     )
   {
    if((pstate && rselected) || (tstate && (blobn+1)==dragposn.handle))
                               
    {
     x2+=eddx;
     y2+=eddy;
    }
    else
    if(tstate2 && (blobn+1)==dragtangent)
    {
     x2+=eddx2;
     y2+=eddy2;
    }

    rseteorcol(WIMPWHITE,WIMPGREY2);
    rtbbc_move(x2,y2,tr,v);
    rtbbc_draw(x3,y3,tr,v);
    err=blob(x2,y2,tr,v,WIMPORANGE);
   }


   blobn+=3;

   x=x3;
   y=y3;

   p+=7;
  }
 }

 return(err);
}


/*****************************************************************************/



/* blobs10      is true, then set1 == set0                    */
/* blobs10==2            then set1 == set0, and set0 is empty */


static int blobselected(editpathtoolstr * etool,int blob,int n)
{
 int i;

 if(blobs10 && n==1) n=0;
 else
 if(blobs10==2 && n==0) return(0);

 if(etool->editpts[n])
 {
  for(i=0;i<etool->editptn[n];i++) 
    if(etool->editpts[n][i].n==blob) return(1);
 }
 return(0);
}



#ifdef NEVER

static os_error * blobcopy10(editpathtoolstr * etool)
{
 os_error * err;

 err=flex_alloc((flex_ptr)&etool->editpts[1],
                           etool->editptn[0]*sizeof(blobstr));
 if(!err)
 {
  etool->editptn[1]=etool->editptn[0];

  XMEMCPYX(etool->editpts[1],
         etool->editpts[0],
         etool->editptn[0]*sizeof(blobstr));
 }

 return(err);
}

#endif


static void blobmode10(editpathtoolstr * etool,int mode)
{
 blobs10=mode;
 etool->editptn[1]=mode;
}


/* change all blob numbers >=at by */

static void blobup(int at,int by,editpathtoolstr * etool)
{
 int       set;
 blobstr * b;
 int       n;
 int       i;

 for(set=0;set<2;set++)
 {
  n=etool->editptn[set];
  b=etool->editpts[set];
  if(b)
  {
   for(i=0;i<n;i++)
   {
    if(b->n>=at) b->n+=by;
    b++;
   }
  }
 }
}



static os_error * blobadd(editpathtoolstr * etool,int blob,int n)
{
 os_error * err;

 if(etool->editpts[n]) err=flex_chunk((flex_ptr)&etool->editpts[n],
                             (etool->editptn[n]+1)*sizeof(blobstr),BLOBCHUNK);
 else                  err=flex_alloc((flex_ptr)&etool->editpts[n],BLOBCHUNK);

 etool->editpts[n][etool->editptn[n]++].n=blob;

 return(err);
}


static void blobrem(editpathtoolstr * etool,int blob,int n)
{
 int i;
 int total;

 if(etool->editpts[n])
 {
  total=etool->editptn[n];

  for(i=0;i<total;i++) 
  {
   if(etool->editpts[n][i].n==blob)
   {
    memmove(&etool->editpts[n][i],
            &etool->editpts[n][i]+1,(total-(i+1))*sizeof(blobstr));

    etool->editptn[n]--;
    break;
   }
  }
 }
}





/* find the tangent points for a point */


static void findtangentpoints(filestr *file,editpathtoolstr * etool,
                                                  int * p1,int * p2,int * lp)
{
 pathstr    * path;
 int        * p;
 int        * q;


 *p1=*p2=*lp=-1;

 path=(pathstr*)fob_find(etool->editcurve.curve[etool->editmode].data.path.path,file);

 q=path->data;
 p=q+epfindoffset;
 q+=epfindpathbase;

 if(*p==DRAWCURVE)
 {
  *p2=etool->editposn.handle-1;
  *p1=gettangentb(q,p,etool->editposn.handle-2,epfindblobbase);
  *lp=getloopb(q,p+7,epfindblobbase);
 }
 else
 if(*p==DRAWDRAW || *p==DRAWMOVE)
 {
  *p1=gettangentb(q,p-4,etool->editposn.handle-2,epfindblobbase);
  *lp=getloopb(q,p+3,epfindblobbase);
 }
}




static os_error * addblob4(int p,int p1,int p2,int lp,
                           editpathtoolstr * etool,filestr * file)
{
 os_error * err;

 blobadd(etool,p,1);
 if(lp>=0) blobadd(etool,lp,1);

 reditmode=REDITNOFRAME;
 editrefresh(file);

 err=blobadd(etool,p,0);
 if(lp>=0) blobadd(etool,lp,0);

 if(p1>=0) 
 { 
  blobadd(etool,p1,0);
  blobadd(etool,p1,1);
 }

 if(p2>=0)
 {
  blobadd(etool,p2,0);
  blobadd(etool,p2,1);
 }

 editrefresh(file);
 blobclear(etool,1);
 reditmode=0;

 iprefreshpane(file,0x1,IP_PANE1);

 return(err);
}



static os_error * remblob4(int p,int p1,int p2,int lp,
                           editpathtoolstr * etool,filestr * file)
{
 blobadd(etool,p,1);
 if(lp>=0) blobadd(etool,lp,1);

 if(p1>=0) blobadd(etool,p1,1);
 if(p2>=0) blobadd(etool,p2,1);

 reditmode=REDITNOFRAME;
 editrefresh(file);

 blobrem(etool,p,0);
 if(lp>=0) blobrem(etool,lp,0);

 if(p1>=0) blobrem(etool,p1,0);
 if(p2>=0) blobrem(etool,p2,0);

 editrefresh(file);
 blobclear(etool,1);
 reditmode=0;

 iprefreshpane(file,0x1,IP_PANE1);

 return(NULL);
}




static os_error * unremblob4(filestr * file)
{
 int               p;
 int               p1;
 int               p2;
 int               lp;
 editpathtoolstr * etool;
 toolboxstr      * toolbox;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 undoread(file,&p,sizeof(int));
 undoread(file,&p1,sizeof(int)); 
 undoread(file,&p2,sizeof(int));
 undoread(file,&lp,sizeof(int));

 undowritefn(file,UNADDBLOB4,&p,sizeof(int));
 undowrite(file,&p1,sizeof(int));
 undowrite(file,&p2,sizeof(int));
 undowrite(file,&lp,sizeof(int));

 remblob4(p,p1,p2,lp,etool,file);

 return(NULL);
}


static os_error * unaddblob4(filestr * file)
{
 int               p;
 int               p1;
 int               p2;
 int               lp;
 editpathtoolstr * etool;
 toolboxstr      * toolbox;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 undoread(file,&p,sizeof(int));
 undoread(file,&p1,sizeof(int)); 
 undoread(file,&p2,sizeof(int));
 undoread(file,&lp,sizeof(int));

 undowritefn(file,UNREMBLOB4,&p,sizeof(int));
 undowrite(file,&p1,sizeof(int));
 undowrite(file,&p2,sizeof(int));
 undowrite(file,&lp,sizeof(int));

 addblob4(p,p1,p2,lp,etool,file);

 return(NULL);
}



static os_error * undowriteblobs(editpathtoolstr * etool,filestr * file)
{
 os_error * err;
 int        n;
 int        i;
 blobstr    blob;

 n=etool->editptn[0];

 err=undowrite(file,&n,sizeof(int));
 for(i=0;i<n;i++)
 {
  blob=etool->editpts[0][i];
  undowrite(file,&blob,sizeof(blobstr));
 }

 return(err);
}



// concerned with the selected blobs

/* tagged to BLOBCLEARP */

static os_error * blobclearp(filestr * file)
{
 editpathtoolstr * etool;
 toolboxstr      * toolbox;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 reditmode=REDITNOFRAME;
 blobmode10(etool,1);
 editrefresh(file);
 blobmode10(etool,2);
 editrefresh(file);
 blobmode10(etool,0);
 reditmode=0;

// cprintf("blobclearp");

 undowritefn(file,BLOBSETP,NULL,0);
 undowriteblobs(etool,file);

 blobinit(etool);

 iprefreshpane(file,0x1,IP_PANE1);

 return(NULL);
}




static os_error * undoreadblobs(editpathtoolstr * etool,filestr * file)
{
 os_error * err;
 int        n;
 int        i;
 blobstr    blob;

 undoread(file,&n,sizeof(int));

 if(etool->editpts[0]) err=flex_chunk((flex_ptr)&etool->editpts[0],
                             n*sizeof(blobstr),BLOBCHUNK);
 else      err=flex_alloc((flex_ptr)&etool->editpts[0],n*sizeof(blobstr));

 if(!err)
 {
  etool->editptn[0]=n;

  for(i=0;i<n;i++)
  {
   undoread(file,&blob,sizeof(blobstr));
   etool->editpts[0][i]=blob;
  }
 }

 return(err);
}



// concerned with the selected blobs

/* tagged to BLOBSETP */

static os_error * blobsetp(filestr * file)
{
 os_error        * err;
 editpathtoolstr * etool;
 toolboxstr      * toolbox;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 undowritefn(file,BLOBCLEARP,NULL,0);

// cprintf("blobsetup");

 err=undoreadblobs(etool,file);

 reditmode=REDITNOFRAME;
 blobmode10(etool,2);
 editrefresh(file);
 blobmode10(etool,1);
 editrefresh(file);
 blobmode10(etool,0);

 reditmode=0;

 iprefreshpane(file,0x1,IP_PANE1);

 return(err);
}




static os_error * blobaddp(filestr * file,editpathtoolstr * etool,
                                          eposnstr * eposn,int clear)
{
 os_error * err;
 int        p1;
 int        p2;
 int        lp;

 err=NULL;

 if(!blobselected(etool,eposn->handle,0))
 {
  undostart(file);

  if(clear) blobclearp(file);

  /* find tangent points */
  findtangentpoints(file,etool,&p1,&p2,&lp);

  undowritefn(file,UNREMBLOB4,&eposn->handle,sizeof(int));
  undowrite(file,&p1,sizeof(int));
  undowrite(file,&p2,sizeof(int));
  undowrite(file,&lp,sizeof(int));

  addblob4(eposn->handle,p1,p2,lp,etool,file);

  undoend(file);
 }
 return(err);
}



static void blobremp(filestr * file,editpathtoolstr * etool,eposnstr * eposn)
{
 int       p1;
 int       p2;
 int       lp;

 if(blobselected(etool,eposn->handle,0))
 {
  undostart(file);

  findtangentpoints(file,etool,&p1,&p2,&lp);

  undowritefn(file,UNADDBLOB4,&eposn->handle,sizeof(int));
  undowrite(file,&p1,sizeof(int));
  undowrite(file,&p2,sizeof(int));
  undowrite(file,&lp,sizeof(int));

  remblob4(eposn->handle,p1,p2,lp,etool,file);

  undoend(file);
 }
}






static void blobbox(int * p,boxstr * box,viewstr * view,transformstr * tr)
{
 int      dim;
 coordstr tscale;

 dim=ourunits(DRSUB,view);

 tr_getscale(tr,&tscale);

 box->w=scale(dim,0x10000,tscale.x);
 box->h=scale(dim,0x10000,tscale.y);

 box->x=p[0]-box->w/2;
 box->y=p[1]-box->h/2;
}







static int findedithandle(editpathtoolstr * etool,posnstr * posn,int behind)
{
 coordstr     point;
 pathstr    * path;
 boxstr       box;
 int        * op;
 int        * op2;
 int        * p;
 int        * q;
 int        * pb;
 int          blob;
 int          blobb;
 int          oblob;
 int          oblob2;
 int          i;
 int          flags;
 int          hit;
 transformstr tr;
 int          x;
 int          y;
 int        * p2;
 int          pathbase;
 int          blobbase;


 hit=0;

 if(etool->editstate)
 {
  if(posn->page==etool->editposn.page)
  {
   point.x=posn->x;
   point.y=posn->y;

   tr=etool->editcurve.tr[etool->editmode];

   tr_inverseset(&point,1,&tr);

   path=(pathstr*)fob_find(etool->editcurve.curve[etool->editmode].data.path.path,
                                                                   posn->file);

   flags=0;

   q=p=op=path->data;
   oblob=blob=blobbase=0;
   pathbase=0;

   while(*p)
   {
    if(blob==behind && hit) break;

    op2=op;
    oblob2=oblob;

    op=p;
    oblob=blob;

    switch(*p)
    {
      case DRAWCLOSE:
                     p++;
                     break;


      case  DRAWMOVE:
                     blobbase=blob;
                     pathbase=p-q;

      case  DRAWDRAW:
                     blobbox(p+1,&box,posn->view,&tr);
                     if(insidebox(point.x,point.y,&box))
                     {
                      posn->htype=EP_POINT;
                      posn->handle=blob;
                      epfindoffset=p-q;
                      epfindblobbase=blobbase;
                      epfindpathbase=pathbase;
                      epfindpoint.x=*(p+1);
                      epfindpoint.y=*(p+2);
                      hit=1;
                     }
                     p+=3;
                     blob++;
                     break;

      case DRAWCURVE:
                     pb=p;
                     blobb=blob;
                     p++;
                     for(i=0;i<3;i++)
                     {
                      if(blobselected(etool,blob,0) || i==2)
                      {
                       blobbox(p,&box,posn->view,&tr);
                       if(insidebox(point.x,point.y,&box))
                       {
                        if(i==2) posn->htype=EP_CPOINT;
                        else     
                        {
                         posn->htype=EP_CTANGENT;
                         dragtangent=-1;

                         if(i==0) /* co tan is previous point */
                         {
                          dragtangent=getprevtangentb(op2,oblob2,&p2);

                          if(p2)
                          {
                           x=*(p2+5);
                           y=*(p2+6);
                           eddr2=pythag(x-(*(p2+3)),y-(*(p2+4)));
                           eddr=pythag(x-(*(pb+1)),y-(*(pb+2)));
                          }
                         }
                         else
                         if(i==1) /* co tan is next point */
                         {
                          dragtangent=gettangentb(q+epfindpathbase,pb,
                                                    blobb,epfindblobbase);
                          p2=gettangent(q+epfindpathbase,pb);
                          if(p2)
                          {
                           x=*(pb+5);
                           y=*(pb+6);
                           eddr2=pythag(x-(*(p2+1)),y-(*(p2+2)));
                           eddr=pythag(x-(*(pb+3)),y-(*(pb+4)));
                          }
                         }

                         if(!eddr2) eddr2=1;
                         if(!eddr) eddr=eddr2;
                        }
                        posn->handle=blob;
                        epfindoffset=(pb-q);
                        epfindblobbase=blobbase;
                        epfindpathbase=pathbase;
                        epfindpoint.x=*p;
                        epfindpoint.y=*(p+1);
                        hit=1;
                       }
                      }
                      blob++;
                      p+=2;
                     }
                     break;
    }
   }
  }
 }

 if(hit)
 {
  tr_transformset(&epfindpoint,1,&tr);
 }

 return(hit);
}





static int getblobn(filestr * file,editpathtoolstr * etool,
                                            int bn,int * cx,int * cy)
{
 pathstr    * path;
 int        * p;
 int          blob;


 if(etool->editstate)
 {
  blob=0;

  path=(pathstr*)fob_find(etool->editcurve.curve[etool->editmode].data.path.path,file);
  p=path->data;
  blob=0;

  while(*p)
  {
   switch(*p)
   {
     case  DRAWCLOSE:
                     p++;
                     break;

      case  DRAWDRAW:
      case  DRAWMOVE:
                     if(bn==blob)
                     {
                      *cx=*(p+1);
                      *cy=*(p+2);
                      return(1);
                     }
                     p+=3;
                     blob++;
                     break;

      case DRAWCURVE:
                     if(bn==blob)
                     {
                      *cx=*(p+1);
                      *cy=*(p+2);
                      return(1);
                     }
                     else
                     if(bn==(blob+1))
                     {
                      *cx=*(p+3);
                      *cy=*(p+4);
                      return(1);
                     }
                     else
                     if(bn==(blob+2))
                     {
                      *cx=*(p+5);
                      *cy=*(p+6);
                      return(1);
                     }
                     p+=7;
                     blob+=3;
                     break;
   }
  }
 }
 return(0);
}



static os_error * editredraw(toolboxstr * toolbox,viewredrawstr * v)
{
 os_error        * err;
 editpathtoolstr * etool;
 pathstr         * path;
 int               emode;
 filestr         * file;

 etool=(editpathtoolstr*)toolbox->toolstate[toolbox->current].hprivate;
 file=v->file;


 if(etool->editstate && v->page==etool->editposn.page)
 {
  emode=etool->editmode;

  if(emode!=EP_FRAME && !(reditmode & REDITNOFRAME))
  {
   if(etool->editcurve.curve[EP_FRAME].type==CPATH)
   {
    path=(pathstr*)fob_find(etool->editcurve.curve[EP_FRAME].data.path.path,file); 
    reditmode|=REDITFRAME;
    err=reditline(etool,path->data,v,&etool->editcurve.tr[EP_FRAME]);
    reditmode^=REDITFRAME;
   }
  }

  if(etool->editcurve.curve[emode].type==CPATH)
  {
   path=(pathstr*)fob_find(etool->editcurve.curve[emode].data.path.path,file);

   if(!(reditmode & REDITNOLINE))
      err=reditline(etool,path->data,v,&etool->editcurve.tr[emode]);

   if(!(reditmode & REDITNOBLOBS))
      err=rpatheditline(etool,path->data,&etool->editcurve.tr[emode],v);
  }
 }
 return(NULL);
}


/*****************************************************************************/

static os_error * editclear(editpathtoolstr * etool,filestr * file)
{
 os_error * err;

 err=NULL;

 if(etool->editstate!=EP_NONE)
 {
  undowritefn(file,BLOBSETP,NULL,0);
  undowriteblobs(etool,file);

  undowritefn(file,UNEDITPOSN,&etool->editposn,sizeof(eposnstr));
  undowrite(file,&etool->editmode,sizeof(int));

  err=editrefresh(file);
  blobinit(etool);

  etool->editstate=EP_NONE;
  etool->editmode=EP_FRAME;

  editchange(1,file,etool);

  iprefreshpane(file,0x1,IP_PANE1);
 }

 return(err);
}


/* tagged to UNEDITCLEAR */

static os_error * uneditclear(filestr * file)
{
 editpathtoolstr * etool;
 toolboxstr      * toolbox;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 return(editclear(etool,file));
}



int editpathcanedit(curvestr * c)
{
 int i;

 for(i=0;i<3;i++)
 {
  if(c[i].type==CPATH) return(1);
 }

 return(0);
}



/* there is a problem if this is called on a composite object          */
/* in that one of the child objects is edited, but we don't know which */
/* fix is to pass back object in epstr                                 */


static os_error * editposn(editpathtoolstr * etool,eposnstr * eposn,
                                         filestr * file,int emode)
{
 int message;
 int i;

 etool->editposn=*eposn;
 etool->editmode=emode;

 vxstart(file);


 iprefreshpane(file,0x2,IP_PANE1);

 etool->editcurve.invisible=!instantpathedit;
 for(i=0;i<3;i++) etool->editcurve.change[i]=0;

 message=OM_EDITPATH;
 objectmessage2(eposn->object,file,&message,&etool->editcurve);

 vxend(file,VRBACK,eposn->page,eposn->section);

 if(!message)
 {
  if(etool->editcurve.curve[etool->editmode].type!=CPATH) etool->editmode++;
  if(etool->editcurve.curve[etool->editmode].type!=CPATH) etool->editmode++;

/*  if(undo)
  {
   undoreadblobs(etool,file);
  }
  else */
  {
   etool->editptn[0]=0;
  }


  etool->editstate=EP_EDIT;

  editrefresh(file);
  iprefreshpane(file,0x2,IP_PANE1);

  undowritefn(file,UNEDITCLEAR,NULL,0);
 }

 return(NULL);
}


/* tagged to UNEDITPOSN */

static os_error * uneditposn(filestr * file)
{
 editpathtoolstr * etool;
 toolboxstr      * toolbox;
 eposnstr          eposn;
 int               emode;

 toolbox=file->toolbox;

 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 undoread(file,&eposn,sizeof(eposnstr));
 undoread(file,&emode,sizeof(int));

 return(editposn(etool,&eposn,file,emode));
}





/* Edit path protocol

   Click on object,
   Edit path sends message OM_EDITPATH to object,
   Object sets up parameter block and calls editpath(),

   Whenever path is changed, Edit path sends OM_EDITCHANGE to object

   OM_EDITPATH and OM_EDITCHANGE, have a flag telling object to
   be invisible.

*/


static os_error * editchange(int quit,filestr * file,editpathtoolstr * etool)
{
 os_error * err;
 int        message;
 int        i;

 err=NULL;

 if(!quit) 
 {
  err=modfile(file,etool->editposn.section);

  etool->editcurve.change[etool->editmode]|=1;
  for(i=0;i<3;i++) 
  {
   etool->editcurve.change[i]|=etool->editcurve.change[i]<<1;
   etool->editcurve.change[i]&=~0x1;
  }
  if(instantpathedit) etool->editcurve.change[etool->editmode]|=1;
 }
 else
 {
  for(i=0;i<3;i++) 
  {
   etool->editcurve.change[i]|=etool->editcurve.change[i]>>1;
  }
 }

 if(!err)
 {
  if((quit && !instantpathedit) || (!quit && instantpathedit))
  {
   vxstart(file);
   frflstart(file);
  }
                                                                                  etool->editcurve.invisible=!(quit || instantpathedit);
 /* etool->editcurve.update=(quit || instantpathedit); */

  etool->editcurve.quit=quit;

  etool->editcurve.change[etool->editmode]=1;

  message=OM_EDITCHANGE;
  objectmessage2(etool->editposn.object,file,&message,&etool->editcurve);

  if((quit && !instantpathedit) || (!quit && instantpathedit)) 
  {
   frflflush(file);
   vxflush(file,VRBACK,etool->editposn.page,etool->editposn.section);

   frflvalid(file);

   frflscrap(file);
   vxscrap();
  }
 }
 return(err);
}



/* return 0 if we can edit this object */


static int editobject(posnstr * posn)
{
 if(!posn->master || posn->bits.local)
 {
  return(0);
 }

 return(1);
}



static os_error * editclick(toolboxstr * toolbox,posnstr * posn)
{
 editpathtoolstr * etool;
 eposnstr          eposn;
 filestr         * file;
 viewstr         * view;


 if(!posn->ghost)
 {
  file=posn->file;
  view=posn->view;

  etool=(editpathtoolstr*)toolbox->toolstate[toolbox->current].hprivate;

  if((posn->buttons & VBCLICKS) || (posn->buttons & VBCLICKA))
  {                                              /*single click select*/
   if(findedithandle(etool,posn,-1))
   {
    etool->editposn.handle=posn->handle;
    etool->editposn.htype=posn->htype;

    if(posn->htype==EP_POINT || posn->htype==EP_CPOINT)
    {
     if((posn->buttons & VBCLICKS) && !(posn->buttons & VBCTRL))	// making Control+select act like adjust take out Select+Ctrl
     {
      if(!blobselected(etool,posn->handle,0))
      {
       blobaddp(file,etool,&etool->editposn,1);
       iprefreshpane(file,0x1,IP_PANE1);
      }
     }
     else
     {
      if(!blobselected(etool,posn->handle,0)) 
                                     blobaddp(file,etool,&etool->editposn,0);
      else                           blobremp(file,etool,&etool->editposn);
      iprefreshpane(file,0x1,IP_PANE1);
     }
    }
   }
   else
   {
    if(findbox(posn,-1))
    {
     if(!(etool->editstate==EP_EDIT && etool->editposn.object==posn->object) &&
        !editobject(posn))
     {
      undostart(file);
      editclear(etool,file);
      pos2epos(&eposn,posn);
      editposn(etool,&eposn,file,EP_FRAME);
      undoend(file);
     }
    }
    else 
    {
     undostart(file);
     editclear(etool,file);
     undoend(file);
    }
   }
  }
  else
  if((posn->buttons & VBDRAGS) || (posn->buttons & VBLONGCLICKS))
  {
   if(findedithandle(etool,posn,-1))  /* start a drag on a control point */
   {
    if(posn->htype==EP_CTANGENT)
    {
     if(posn->ctrl)   /* rely on finedithandle to set dragtangent */
     {
      etool->editstate=EP_DRAG2TANGENT;
     }
     else             etool->editstate=EP_DRAGTANGENT;
    }
    else              etool->editstate=EP_DRAGPOINT;

    dragposn=*posn;
    edxc=epfindpoint.x;
    edyc=epfindpoint.y;

    eddx=eddy=eddx2=eddy2=0;
    toolsstartdrag(posn,TOOLDRAGPAGE|TOOLDRAGKN);
    iprefreshpane(file,0x1,IP_PANE1);
   } 
  }
 }

 caretensure(posn->view);

 return(NULL);
}

/****************************************************************************/

static void editshiftpoints(filestr * file,editpathtoolstr * etool,int state)
{
 pathstr    * path;
 int        * p;
 int          i;
 int          blob;

 /* scan through points and apply shift */

 path=(pathstr*)fob_find(etool->editcurve.curve[etool->editmode].data.path.path,file);

 p=path->data;
 blob=0;

 while(*p)
 {
  switch(*p)
  {
     case DRAWCLOSE:
                    p++;
                    break;

     case  DRAWDRAW:
     case  DRAWMOVE:
                    if(state==EP_DRAGPOINT && blobselected(etool,blob,0))
                    {
                     p[1]+=eddx;
                     p[2]+=eddy;
                    }
                    p+=3;
                    blob++;
                    break;

     case DRAWCURVE:
                    if(state==EP_DRAGPOINT)
                    {
                     p++;
                     for(i=0;i<3;i++)
                     {
                      if(blobselected(etool,blob,0))
                      {
                       p[0]+=eddx;
                       p[1]+=eddy;
                      }
                      blob++;
                      p+=2;
                     }
                    }
                    else
                    if(state==EP_DRAGTANGENT || state==EP_DRAG2TANGENT)
                    {
                     if(dragposn.handle==blob)
                     {
                      p[1]+=eddx;
                      p[2]+=eddy;
                     }
                     else
                     if(dragposn.handle==blob+1)
                     {
                      p[3]+=eddx;
                      p[4]+=eddy;
                     }

                     if(dragtangent==blob)
                     {
                      p[1]+=eddx2;
                      p[2]+=eddy2;
                     }
                     else
                     if(dragtangent==blob+1)
                     {
                      p[3]+=eddx2;
                      p[4]+=eddy2;
                     }

                     blob+=3;
                     p+=7;
                    }
                    break;

  }
 }

/* getpathbox(&etool->editcurve.curve[etool->editmode].box,path->data); */

 validpath(&etool->editcurve.curve[etool->editmode].box,
        &etool->editcurve.curve[etool->editmode].data.path.flags,path->data);
}


static os_error * ewriteundopt(filestr * file)
{
 int x[2];

 x[0]=-eddx;
 x[1]=-eddy;

 return(undowritefn(file,UNMOVEPT,x,2*sizeof(int)));
}

/* tagged to UNMOVEPT */

static os_error * unmovept(filestr * file)
{
 os_error        * err;
 editpathtoolstr * etool;
 toolboxstr      * toolbox;
 int               x[2];

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolbox->current].hprivate;

 err=undoread(file,x,2*sizeof(int));
 eddx=x[0];
 eddy=x[1];

 ewriteundopt(file);

 reditmode=REDITLINE|REDITNOFRAME;

 blobmode10(etool,1);

 editrefresh(file);

 editshiftpoints(file,etool,EP_DRAGPOINT);

 editrefresh(file);

 blobmode10(etool,0);
 reditmode=0;
 iprefreshpane(file,0x1,IP_PANE1);

 editchange(0,file,etool);

 return(err);
}


static os_error * ewriteundotan(int state,filestr * file)
{
 int x[7];

 x[0]=state;
 x[1]=dragposn.handle;
 x[2]=dragtangent;

 x[3]=-eddx;
 x[4]=-eddy;
 x[5]=-eddx2;
 x[6]=-eddy2;

 return(undowritefn(file,UNMOVETAN,x,7*sizeof(int)));
}




/* tagged to UNMOVETAN */

static os_error * unmovetan(filestr * file)
{
 os_error        * err;
 int               state;
 editpathtoolstr * etool;
 toolboxstr      * toolbox;
 int               x[7];

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolbox->current].hprivate;

 err=undoread(file,&x,7*sizeof(int));

 state=x[0];
 dragposn.handle=x[1];
 dragtangent=x[2];
 eddx=x[3];
 eddy=x[4];
 eddx2=x[5];
 eddy2=x[6];

 ewriteundotan(state,file);

 reditmode=REDITLINE|REDITNOFRAME;

 blobmode10(etool,1);

 editrefresh(file);

 editshiftpoints(file,etool,state);

 editrefresh(file);

 blobmode10(etool,0);
 reditmode=0;
 iprefreshpane(file,0x1,IP_PANE1);

 editchange(0,file,etool);

 return(err);
}




static os_error * editdragend(toolboxstr * toolbox,posnstr * posn,
                                                             wimp_box * box)
{
 os_error        * err;
 editpathtoolstr * etool;
 filestr         * file;

 err=NULL;

 etool=(editpathtoolstr*)toolbox->toolstate[toolbox->current].hprivate;
 file=posn->file;


 undostart(file);
 if(etool->editstate==EP_DRAGPOINT) ewriteundopt(file);
 else
 if(etool->editstate==EP_DRAGTANGENT || 
    etool->editstate==EP_DRAG2TANGENT) 
                                    ewriteundotan(etool->editstate,file);

 editshiftpoints(file,etool,etool->editstate);
 etool->editstate=EP_EDIT;

 editchange(0,file,etool);

 undoend(file);

 iprefreshpane(file,0x1,IP_PANE1);

 return(err);

 USE(box);
}





static void editsetshift(editpathtoolstr * etool,posnstr * newposn,
                                                 posnstr * oldposn)
{
 coordstr     old;
 coordstr     xnew;
 int          dx;
 int          dy;


 dx=newposn->x-oldposn->x;
 dy=newposn->y-oldposn->y;

 if(isshift)
 {
  if((ABS(dx))>(ABS(dy))) dy=0;
  else                    dx=0;
 }

 old.x=edxc;
 old.y=edyc;
 xnew.x=gridsnapx(edxc+dx,newposn->view,0);
 xnew.y=gridsnapy(edyc+dy,newposn->view,0);

 tr_inverseset(&old,1,&etool->editcurve.tr[etool->editmode]);
 tr_inverseset(&xnew,1,&etool->editcurve.tr[etool->editmode]);

 eddx=xnew.x-old.x;
 eddy=xnew.y-old.y;

 if(etool->editstate==EP_DRAG2TANGENT)
 {
  eddx2=-scale(eddx,eddr2,eddr);
  eddy2=-scale(eddy,eddr2,eddr);
 }
}





static os_error * editmove(toolboxstr * toolbox,posnstr * posn,int move)
{
 editpathtoolstr * etool;


 etool=(editpathtoolstr*)toolbox->toolstate[toolbox->current].hprivate;

 if(move && posn->valid && !posn->ghost && posn->page==dragposn.page)
 {
  if(etool->editstate==EP_DRAGPOINT || etool->editstate==EP_DRAGTANGENT ||
                                       etool->editstate==EP_DRAG2TANGENT)
  {
   reditmode=REDITLINE|REDITNOFRAME;

   if(etool->editstate==EP_DRAGPOINT) blobmode10(etool,1);
   else
   {
    blobadd(etool,dragposn.handle,1);
    if(etool->editstate==EP_DRAG2TANGENT)
    {
     blobadd(etool,dragtangent,1);
    }
   }

   editrefresh(posn->file);

   posn->htype =dragposn.htype;
   posn->handle=dragposn.handle;
   posn->object=dragposn.object;
   editsetshift(etool,posn,&dragposn);

   editrefresh(posn->file);

   if(etool->editstate==EP_DRAGPOINT) blobmode10(etool,0);
   else
   {
    blobclear(etool,1);
   }

   reditmode=0;
   iprefreshpane(posn->file,0x1,IP_PANE1);
  }
 }

 return(NULL);
}





static os_error * editcancel(toolboxstr * toolbox,viewstr * view,
                                           filestr * file)
{
 editpathtoolstr * etool;
 int               state;


 etool=(editpathtoolstr*)toolbox->toolstate[toolbox->current].hprivate;
 state=etool->editstate;

 if(state==EP_DRAGPOINT || state==EP_DRAGTANGENT || state==EP_DRAG2TANGENT)
 {
  reditmode=REDITLINE|REDITNOFRAME;

  if(etool->editstate==EP_DRAGPOINT) blobmode10(etool,1);
  else
  {
   blobadd(etool,dragposn.handle,1);
   if(state==EP_DRAG2TANGENT)
   {
    blobadd(etool,dragtangent,1);
   }
  }

  editrefresh(file);

  eddx=eddy=eddx2=eddy2=0;

  editrefresh(file);

  etool->editstate=EP_EDIT;

  if(state==EP_DRAGPOINT) blobmode10(etool,0);
  else
  {
   blobclear(etool,1);
  }

  reditmode=0;
 }

 toolsstopdrag();

 return(NULL);
 USE(view);
}



/****************************************************************************/

#define EIPX      0
#define EIPY      1
#define EIPLINE   2
#define EIPADD    3
#define EIPREM    4
#define EIPFLAT   5
#define EIPOCSWOP 6
#define EIPSNAP   7
#define EIPMODE   8
#define EIPMOVE   9
#define EIPHORIZ  10
#define EIPVERT   11
#define EIPCURVE  12


static iconmap eipmap[]=
{
 51,0,0,IP_TIPS,
 3, 0,0,IP_TIPS,
 4, 0,0,IP_TIPS,
 5, 0,0,IP_TIPS,
 6, 0,0,IP_TIPS,
 7, 0,0,IP_TIPS,
 8, 0,0,IP_TIPS,
 9, 0,0,IP_TIPS,
 11,0,0,IP_TIPS,
 12,0,0,IP_TIPS,
 13,0,0,IP_TIPS,
 14,0,0,IP_TIPS,
 15,0,0,IP_TIPS,

 0, 0,0,0,      /* terminator */
};





/* curve/line swop */

static os_error * eipclswops(editpathtoolstr * etool,filestr * file,
                                                       int undo,int line)
{
 os_error   * err;
 pathstr    * path;
 int          pathk;
 int        * p;
 int        * q;
 int          blob;
 int          blobbase;
 int          pathbase;
 int          x;
 int          y;
 int          x1;
 int          y1;
 int          offset;
 int          b;
 int          temp[4];
 int          doblob;


 err=NULL;

 if(etool->editstate)
 {
  reditmode=REDITNOFRAME;
  blobmode10(etool,1);
  editrefresh(file);

  x=y=0;            /* compiler */
  offset=0;         /* compiler */
  blob=blobbase=0;
  pathbase=0;

  pathk=etool->editcurve.curve[etool->editmode].data.path.path;
  path=(pathstr*)fob_find(pathk,file);
  p=q=path->data;
  blob=0;

  while(*p)
  {
   switch(*p)
   {
     case  DRAWCLOSE:
                     p++;
                     break;


      case  DRAWMOVE:
                     pathbase=p-q;
                     blobbase=blob;
                     x=*(p+1);
                     y=*(p+2);
                     p+=3;
                     blob++;
                     break;


      case  DRAWDRAW:
                     if(blobselected(etool,blob,0))
                     {
                      offset=p-q;

                      if(undo) undoread(file,&doblob,sizeof(int));
                      else     doblob=(line!=0);
                      undowrite(file,&doblob,sizeof(int));
                     }
                     else doblob=0;

                     if(doblob)
                     {
                      if(undo)
                      {
                       undoread(file,temp,4*sizeof(int));
                      }

                      pathinsert(pathk,&q,offset,4,file);
                      p=q+offset;
                      *p=DRAWCURVE;
                      x1=*(p+5);
                      y1=*(p+6);
          
                      if(undo)
                      {
                       XMEMCPYX(p+1,temp,4*sizeof(int));
                      }
                      else
                      {
                       *(p+1)=x+(x1-x)/3;
                       *(p+2)=y+(y1-y)/3;
                       *(p+3)=x+(2*(x1-x))/3;
                       *(p+4)=y+(2*(y1-y))/3;
                      }
                      
                      blobup(blob,2,etool);
                      blobadd(etool,blob+1,0);
                      b=gettangentb(q+pathbase,p,blob,blobbase);
                      if(b>=0) blobadd(etool,b,0);

                      p+=7;
                      blob+=3;
                      x=x1;
                      y=y1;
                     }
                     else
                     {
                      x=*(p+1);
                      y=*(p+2);
                      p+=3;
                      blob++;
                     }

                     break;

      case DRAWCURVE:
                     if(blobselected(etool,blob+2,0))
                     {
                      offset=p-q;

                      if(undo) undoread(file,&doblob,sizeof(int));
                      else     doblob=(line==0);
                      undowrite(file,&doblob,sizeof(int));
                     } 
                     else doblob=0;

                     if(doblob)
                     {
                      blobrem(etool,blob+1,0);
                      b=gettangentb(q+pathbase,p,blob,blobbase);
                      if(b>=0) blobrem(etool,b,0);

                      offset=p-q;

                      XMEMCPYX(temp,p+1,4*sizeof(int));
                      undowrite(file,temp,4*sizeof(int));

                      pathinsert(pathk,&q,offset,-4,file);
                      p=q+offset;
                      *p=DRAWDRAW;

                      blobup(blob,-2,etool);
                      x=*(p+1);
                      y=*(p+2);
                      blob++;
                      p+=3;
                     }
                     else
                     {
                      x=*(p+5);
                      y=*(p+6);
                      p+=7;
                      blob+=3;
                     }
                     break;
   }
  }

 /* getpathbox(&etool->editcurve.curve[etool->editmode].box,path->data); */

  validpath(&etool->editcurve.curve[etool->editmode].box,
        &etool->editcurve.curve[etool->editmode].data.path.flags,path->data);

  editrefresh(file);
  blobmode10(etool,0);
  reditmode=0;

  editchange(0,file,etool);
 }

 return(err);
}



/* tagged to UNLCSWOP */

static os_error * unlcswop(filestr * file)
{
 editpathtoolstr * etool;
 toolboxstr      * toolbox;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 undowritefn(file,UNLCSWOP,NULL,0);

 return(eipclswops(etool,file,1,0));
}


static os_error * eipline(editpathtoolstr * etool,filestr * file)
{
 os_error * err;

 err=undostart(file);
 if(!err)
 {
  undowritefn(file,UNLCSWOP,NULL,0);
  err=eipclswops(etool,file,0,0);
  undoend(file);
 }
 return(err);
}


static os_error * eipcurve(editpathtoolstr * etool,filestr * file)
{
 os_error * err;

 err=undostart(file);
 if(!err)
 {
  undowritefn(file,UNLCSWOP,NULL,0);
  err=eipclswops(etool,file,0,1);
  undoend(file);
 }
 return(err);
}


/*****************************************************************************/


typedef struct eopstr
{
 char remove;
 char insert;
 char bn;
 char blobby;
 int  offset;
 int  blobat;
 int  data[20];

} eopstr;




static os_error * eopwrite(int code,eopstr * eop,filestr * file,int n)
{
 int len;

 len=(3+n)*sizeof(int);
 undowritefn(file,code,&len,sizeof(int));
 return(undowrite(file,eop,len));
}



/* tagged to UNADDPOINT */

static os_error * unaddpoint(filestr * file)
{
 os_error        * err;
 toolboxstr      * toolbox;
 editpathtoolstr * etool;
 pathstr         * path;
 int               pathk;
 int             * q;
 eopstr            eop;
 eopstr            dop;
 int               len;
 int               i;

 err=NULL;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;
 pathk=etool->editcurve.curve[etool->editmode].data.path.path;

 undoread(file,&len,sizeof(int));
 undoread(file,&eop,len);

 dop.remove=eop.insert;
 dop.insert=eop.remove;
 dop.offset=eop.offset;
 dop.blobat=eop.blobat;
 dop.blobby=eop.blobby;
 dop.bn=eop.bn;

 for(i=0;i<eop.bn;i++)
 {
  dop.data[i]=eop.data[i];
 }

 path=(pathstr*)fob_find(pathk,file);
 q=path->data+eop.offset;
 XMEMCPYX(dop.data+dop.bn,q,eop.remove*sizeof(int));
 eopwrite(UNREMPOINT,&dop,file,eop.remove+dop.bn);

 pathinsert(pathk,&q,eop.offset,eop.insert-eop.remove,file);
 q+=eop.offset;
 XMEMCPYX(q,eop.data+eop.bn,eop.insert*sizeof(int));

 blobup(eop.blobat,eop.blobby,etool);

 for(i=0;i<eop.bn;i++)
 {
  blobadd(etool,eop.data[i],0);
 }

 return(err);
}



/* tagged to UNREMPOINT */

static os_error * unrempoint(filestr * file)
{
 os_error        * err;
 toolboxstr      * toolbox;
 editpathtoolstr * etool;
 pathstr         * path;
 int               pathk;
 int             * q;
 eopstr            eop;
 eopstr            dop;
 int               len;
 int               i;

 err=NULL;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;
 pathk=etool->editcurve.curve[etool->editmode].data.path.path;

 undoread(file,&len,sizeof(int));
 undoread(file,&eop,len);

 dop.remove=eop.insert;
 dop.insert=eop.remove;
 dop.offset=eop.offset;
 dop.blobat=eop.blobat;
 dop.blobby=eop.blobby;
 dop.bn=eop.bn;

 for(i=0;i<dop.bn;i++)
 {
  dop.data[i]=eop.data[i];
 }

 path=(pathstr*)fob_find(pathk,file);
 q=path->data+eop.offset;
 XMEMCPYX(dop.data+dop.bn,q,eop.remove*sizeof(int));
 eopwrite(UNADDPOINT,&dop,file,eop.remove+dop.bn);

 pathinsert(pathk,&q,eop.offset,eop.insert-eop.remove,file);
 q+=eop.offset;
 XMEMCPYX(q,eop.data+eop.bn,eop.insert*sizeof(int));

 for(i=0;i<eop.bn;i++)
 {
  blobrem(etool,eop.data[i],0);
 }

 blobup(eop.blobat,-eop.blobby,etool);

 return(err);
}














/* curve/line - move swop */


/* scan path

   find selected move
     remove the move
      if move preceded by a close, remove the close
       find end of sub path and insert close/tweek coords

   find selected line/curve
     remove it
      if part of closed sub path insert a close, tweek previous element

     insert move
      if sub path closed, tweek last element

*/



/* returns the element that is followed by a close */

static int * efindclose(int * p,int ** l)
{
 int * op;
 int * op2;
 int   c;

 op=op2=NULL;
 *l=NULL;

 while((c=*p)!=0)
 {
  op2=op;
  op=p;

  if(c==DRAWCLOSE) return(op2);
  else
  if(c==DRAWMOVE) break;
  else
  if(c==DRAWDRAW) p+=3;
  else
  if(c==DRAWCURVE) p+=7;
 }

 *l=op2;
 return(NULL);
}


static void eminc(int * p,int dx,int dy)
{
 if(*p==DRAWDRAW)
 {
  *(p+1)+=dx;
  *(p+2)+=dy;
 }
 else
 if(*p==DRAWCURVE)
 {
  *(p+5)+=dx;
  *(p+6)+=dy;
 }
}


static void emset(int * p,int x,int y)
{
 if(*p==DRAWDRAW)
 {
  *(p+1)=x;
  *(p+2)=y;
 }
 else
 if(*p==DRAWCURVE)
 {
  *(p+5)=x;
  *(p+6)=y;
 }
}



static os_error * eipmove(editpathtoolstr * etool,filestr * file)
{
 os_error   * err;
 pathstr    * path;
 int          pathk;
 int        * p;
 int        * op;
 int        * op2;
 int        * op3;
 int        * q;
 int        * l;
 int          blob;
 int          blobbase;
 int          pathbase;
 int          x;
 int          y;
 int          offset;
 int          offset2;
 int          offset3;
 int          toffset;
 int          b;
 int        * cp;
 int          lmx;
 int          lmy;
 int          wasclosed;


 err=NULL;

 if(etool->editstate)
 {
  reditmode=REDITNOFRAME;
  blobmode10(etool,1);
  editrefresh(file);

  x=y=0;  /* compiler */
  lmx=lmy=0;
  blob=blobbase=0;
  pathbase=0;

  pathk=etool->editcurve.curve[etool->editmode].data.path.path;
  path=(pathstr*)fob_find(pathk,file);
  op=op2=p=q=path->data;
  blob=0;

  while(*p)
  {
   op3=op2;
   op2=op;
   op=p;


   switch(*p)
   {
     case  DRAWCLOSE:
                     p++;
                     break;


      case  DRAWMOVE:
                     pathbase=p-q;

                     if(blobselected(etool,blob,0) && p>op2 && *op2!=DRAWMOVE)
                     {
                      *p=DRAWDRAW;

                      wasclosed=0;
                      if(*op2==DRAWCLOSE)
                      {
                       wasclosed=1;
                       eminc(op3,CXSHIFT,CYSHIFT);

                       offset=p-q;
                       offset2=op2-q;
                       offset3=op3-q;

                       pathinsert(pathk,&q,op2-q,-1,file);

                       p=op=q+offset-1;
                       op2=q+offset2;
                       op3=q+offset3;
                      }

                      cp=efindclose(p+3,&l);
                      if(cp)
                      {
                       emset(cp,lmx,lmy);
                      }
                      else
                      if(l && wasclosed)
                      {
                       emset(cp,lmx,lmy);

                       offset=p-q;
                       offset2=op2-q;
                       offset3=op3-q;
                       toffset=l-q;

                       pathinsert(pathk,&q,l-q,1,file);

                       p=op=q+offset;
                       op2=q+offset2;
                       op3=q+offset3;
                       l=q+toffset;
                       *l=DRAWCLOSE;
                      }
                      p+=3;
                      blob++;
                     }
                     else
                     {
                      lmx=*(p+1);
                      lmy=*(p+2);
                      p+=3;
                      blob++;
                     }
                     break;


      case  DRAWDRAW:
                     if(blobselected(etool,blob,0))
                     {
                      cp=efindclose(p+3,&l);

                      *p=DRAWMOVE;

                      if(cp)
                      {
                       toffset=cp-q;
                       offset=p-q;
                       offset2=op2-q;
                       offset3=op3-q;

                       pathinsert(pathk,&q,offset,1,file);

                       p=op=q+offset+1;
                       op2=q+offset2;
                       op3=q+offset3;
                       cp=q+toffset+1;
                       *(p-1)=DRAWCLOSE;

                       emset(op2,lmx,lmy);

                       x=*(p+1);
                       y=*(p+2);

                       emset(cp,x,y);
                      }

                      blob++;
                      p+=3;
                     }
                     else
                     {
                      p+=3;
                      blob++;
                     }
                     break;

      case DRAWCURVE:
                     if(blobselected(etool,blob+2,0))
                     {
                      cp=efindclose(p+7,&l);

                      blobrem(etool,blob+1,0);
                      b=gettangentb(q+pathbase,p,blob,blobbase);
                      if(b>=0) blobrem(etool,b,0);

                      offset=p-q;

                      pathinsert(pathk,&q,offset,-4,file);

                      p=q+offset;
                      *p=DRAWMOVE;

                      blobup(blob,-2,etool);

                      if(cp)
                      {
                       toffset=cp-q;
                       offset=p-q;
                       offset2=op2-q;
                       offset3=op3-q;

                       pathinsert(pathk,&q,offset,1,file);

                       p=op=q+offset+1;
                       op2=q+offset2;
                       op3=q+offset3;
                       cp=q+toffset+1;
                       *(p-1)=DRAWCLOSE;

                       emset(op2,lmx,lmy);

                       x=*(p+1);
                       y=*(p+2);

                       emset(cp,x,y);
                      }

                      blob++;
                      p+=3;
                     }
                     else
                     {
                      p+=7;
                      blob+=3;
                     }
                     break;

   }
  }

 /* getpathbox(&etool->editcurve.curve[etool->editmode].box,q); */

  validpath(&etool->editcurve.curve[etool->editmode].box,
        &etool->editcurve.curve[etool->editmode].data.path.flags,q);

  editrefresh(file);
  blobmode10(etool,0);
  reditmode=0;

  editchange(0,file,etool);
 }

 return(err);
}


/* tagged to UNMOVE */

static os_error * unmove(filestr * file)
{

 USE(file);

 return(NULL);
}


/*****************************************************************************/


static void writebez(int * p,bezier * a)
{
 *p++=DRAWCURVE;
 *p++=a->leftc.x;
 *p++=a->leftc.y;
 *p++=a->rightc.x;
 *p++=a->rightc.y;
 *p++=a->right.x;
 *p++=a->right.y;
}





/* tagged to UNADDPOINTS */
/* this function is always called last in undo/redo */

static os_error * unaddpoints(filestr * file)
{
 os_error        * err;
 toolboxstr      * toolbox;
 editpathtoolstr * etool;
 pathstr         * path;
 int               pathk;
 int             * q;

 err=NULL;

 undowritefn(file,UNADDPOINTF,NULL,0);

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 pathk=etool->editcurve.curve[etool->editmode].data.path.path;
 path=(pathstr*)fob_find(pathk,file);
 q=path->data;

/* getpathbox(&etool->editcurve.curve[etool->editmode].box,q); */

 validpath(&etool->editcurve.curve[etool->editmode].box,
        &etool->editcurve.curve[etool->editmode].data.path.flags,q);

 editrefresh(file);
 blobmode10(etool,0);
 reditmode=0;

 editchange(0,file,etool);

 return(err);
}



/* tagged to UNADDPOINTF */
/* this function is always called first in undo/redo */

static os_error * unaddpointf(filestr * file)
{
 os_error        * err;
 toolboxstr      * toolbox;
 editpathtoolstr * etool;

 err=NULL;

 undowritefn(file,UNADDPOINTS,NULL,0);

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 reditmode=REDITNOFRAME;
 blobmode10(etool,1);
 editrefresh(file);

 return(err);
}













static os_error * eipaddpoint(editpathtoolstr * etool,filestr * file)
{
 os_error   * err;
 pathstr    * path;
 int          pathk;
 int        * p;
 int        * q;
 int          blob;
 int          x;
 int          y;
 int          offset;
 bezier       a;
 bezier       b;
 bezier       c;
 eopstr       eop;


 err=NULL;

 if(etool->editstate && etool->editptn[0])
 {
  err=undostart(file);
  if(!err)
  {
   undowritefn(file,UNADDPOINTS,NULL,0);


   reditmode=REDITNOFRAME;
   blobmode10(etool,1);
   editrefresh(file);

   x=y=0;  /* compiler */
   blob=0;

   pathk=etool->editcurve.curve[etool->editmode].data.path.path;
   path=(pathstr*)fob_find(pathk,file);
   p=q=path->data;
   blob=0;

   while(*p)
   {
    switch(*p)
    {
      case  DRAWCLOSE:
                      p++;
                      break;

       case  DRAWDRAW:
                      if(blobselected(etool,blob,0))
                      {
                       offset=p-q;

                       eop.remove=3;
                       eop.insert=0;
                       eop.offset=offset;
                       eop.blobat=blob;
                       eop.blobby=1;
                       eop.bn=1;
                       eop.data[0]=blob;
                       eopwrite(UNREMPOINT,&eop,file,1);

                       pathinsert(pathk,&q,offset,3,file);
                       p=q+offset;
                       blobup(blob,1,etool);
                       blobadd(etool,blob,0);

                       *p=DRAWDRAW;
                       *(p+1)=(x+(*(p+1+3)))/2;
                       *(p+2)=(y+(*(p+2+3)))/2;
                       p+=3;
                       blob++;
                      }
                        /* falls through */
       case  DRAWMOVE:
                      x=*(p+1);
                      y=*(p+2);
                      p+=3;
                      blob++;
                      break;

       case DRAWCURVE:
                      if(blobselected(etool,blob+2,0))
                      {
                       c.left.x=x;
                       c.left.y=y;
                       c.leftc.x=*(p+1);
                       c.leftc.y=*(p+2);
                       c.rightc.x=*(p+3);
                       c.rightc.y=*(p+4);
                       c.right.x=*(p+5);
                       c.right.y=*(p+6);
                       bezsplit2(&c,&a,&b,0x8000);

                       offset=p-q;

                       eop.remove=14;
                       eop.insert=7;
                       eop.offset=offset;
                       eop.blobat=blob;
                       eop.blobby=3;
                       eop.bn=3;
                       eop.data[0]=blob+1;
                       eop.data[1]=blob+2;
                       eop.data[2]=blob+3;

                       XMEMCPYX(eop.data+3,p,7*sizeof(int));
                       eopwrite(UNREMPOINT,&eop,file,7+3);

                       pathinsert(pathk,&q,offset,7,file);
                       p=q+offset;

                       blobup(blob,3,etool);
                       blobadd(etool,blob+3,0);
                       blobadd(etool,blob+1,0);
                       blobadd(etool,blob+2,0);

                       writebez(p,&a);
                       p+=7;
                       blob+=3;

                       writebez(p,&b);
                       p+=7;
                       blob+=3;
                      }
                      else
                      {
                       x=*(p+5);
                       y=*(p+6);
                       p+=7;
                       blob+=3;
                      }
                      break;

    }
   }

  /* getpathbox(&etool->editcurve.curve[etool->editmode].box,q); */

  validpath(&etool->editcurve.curve[etool->editmode].box,
       &etool->editcurve.curve[etool->editmode].data.path.flags,q);

   editrefresh(file);
   blobmode10(etool,0);
   reditmode=0;

   editchange(0,file,etool);

   undowritefn(file,UNADDPOINTF,NULL,0);
   undoend(file);
  }
 }

 return(err);
}





/*****************************************************************************/


/* tagged to UNREMPOINTS */

static os_error * unrempoints(filestr * file)
{
 os_error        * err;
 toolboxstr      * toolbox;
 editpathtoolstr * etool;
 pathstr         * path;
 int               pathk;
 int             * q;

 err=NULL;

 undowritefn(file,UNREMPOINTF,NULL,0);

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 pathk=etool->editcurve.curve[etool->editmode].data.path.path;
 path=(pathstr*)fob_find(pathk,file);
 q=path->data;

/* getpathbox(&etool->editcurve.curve[etool->editmode].box,q); */

 validpath(&etool->editcurve.curve[etool->editmode].box,
      &etool->editcurve.curve[etool->editmode].data.path.flags,q);

 editrefresh(file);
 blobmode10(etool,0);
 reditmode=0;

 editchange(0,file,etool);

 return(err);
}




/* tagged to UNREMPOINTF */

static os_error * unrempointf(filestr * file)
{
 os_error        * err;
 toolboxstr      * toolbox;
 editpathtoolstr * etool;

 err=NULL;

 undowritefn(file,UNREMPOINTS,NULL,0);

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 reditmode=REDITNOFRAME;
 blobmode10(etool,1);
 editrefresh(file);

 return(err);
}





static os_error * eiprempoint(editpathtoolstr * etool,filestr * file)
{
 os_error   * err;
 pathstr    * path;
 int          pathk;
 int        * p;
 int        * q;
 int          blob;
 int          blobbase;
 int          pathbase;
 int          x;
 int          y;
 int          offset;
 int          b;
 int          deletedlast;
 eopstr       eop;
 int          bn;


 err=NULL;

 if(etool->editstate && etool->editptn[0])
 {
  err=undostart(file);
  if(!err)
  {
   undowritefn(file,UNADDPOINTS,NULL,0);



   reditmode=REDITLINE|REDITNOFRAME;
 
   blobmode10(etool,1);
   editrefresh(file);
   blobmode10(etool,0);
   reditmode=REDITNOFRAME;

   x=y=0;  /* compiler */
   blob=blobbase=0;
   pathbase=0;
   deletedlast=0;

   pathk=etool->editcurve.curve[etool->editmode].data.path.path;
   path=(pathstr*)fob_find(pathk,file);
   p=q=path->data;
   blob=0;

   while(*p)
   {
    switch(*p)
    {
      case  DRAWCLOSE:
                      if(deletedlast) 
                      {
                       blobadd(etool,blob,1);
                       deletedlast=0;
                      }
                      p++;
                      blob++;
                      break;
  
       case  DRAWDRAW:
                      if(blobselected(etool,blob,0))
                      {
                       offset=p-q;
   
                       eop.remove=0;
                       eop.insert=3;
                       eop.offset=offset;
                       eop.blobat=blob;
                       eop.blobby=1;
                       eop.bn=1;
                       eop.data[0]=blob;
                       XMEMCPYX(eop.data+1,p,3*sizeof(int));
                       eopwrite(UNADDPOINT,&eop,file,1+3);

                       pathinsert(pathk,&q,offset,-3,file);
                       p=q+offset;

                       blobrem(etool,blob,0);
                       blobup(blob,-1,etool);

                       deletedlast=1;
                      }
                      else
                      {
                       if(deletedlast) 
                       {
                        blobadd(etool,blob,1);
                        deletedlast=0;
                       }

                       x=*(p+1);
                       y=*(p+2);
                       p+=3;
                       blob++;
                      }
                      break;

       case  DRAWMOVE:
                      pathbase=p-q;
                      blobbase=blob;
                      x=*(p+1);
                      y=*(p+2);
                      p+=3;
                      if(blobselected(etool,blob,0)) 
                                             blobadd(etool,blob,1);
                      blob++;
                      break;

       case DRAWCURVE:
                      if(blobselected(etool,blob+2,0))
                      {
                       blobrem(etool,blob+1,0);
                       eop.data[0]=blob+1;
                       blobrem(etool,blob+2,0);
                       eop.data[1]=blob+2;
                       bn=2;

                       b=gettangentb(q+pathbase,p,blob,blobbase);
                       if(b>=0) 
                       {
                        blobrem(etool,b,0);
                        eop.data[2]=b;
                        bn++;
                       }

                       blobup(blob,-3,etool);
                       offset=p-q;

                       eop.remove=0;
                       eop.insert=7;
                       eop.offset=offset;
                       eop.blobat=blob;
                       eop.blobby=1;
                       eop.bn=(char)bn;
                       XMEMCPYX(eop.data+bn,p,7*sizeof(int));
                       eopwrite(UNADDPOINT,&eop,file,bn+7);

                       pathinsert(pathk,&q,offset,-7,file);
                       p=q+offset;
                       deletedlast=1;
                      }
                      else
                      {
                       if(deletedlast) 
                       {
                        blobadd(etool,blob+2,1);
                        deletedlast=0;
                       }

                       x=*(p+5);
                       y=*(p+6);
                       p+=7;
                       blob+=3;
                      }
                      break;
  
    }
   }


   if(deletedlast) blobadd(etool,blob,1);

 /*  getpathbox(&etool->editcurve.curve[etool->editmode].box,q); */

  validpath(&etool->editcurve.curve[etool->editmode].box,
       &etool->editcurve.curve[etool->editmode].data.path.flags,q);

   reditmode=REDITNOBLOBS|REDITNOFRAME;
   editrefresh(file);
   blobclear(etool,1);
   reditmode=0;

   editchange(0,file,etool);

   undowritefn(file,UNADDPOINTF,NULL,0);
   undoend(file);
  }
 }

 return(err);
}


/****************************************************************************/

static double xatan2(int y,int x)
{
 double at;
 if(x)
 {
  at=atan2((double)y,(double)x);
  if(at<0) at+=2.0*PI;
  return(at);
 }
 else  
 {
  if(y<0) return((3.0*PI)/2.0);
  else    return(PI/2.0);
 }
}


static os_error * eipflattens(editpathtoolstr * etool,filestr * file,int undo)
{
 os_error   * err;
 pathstr    * path;
 int        * p;
 int        * q;
 int        * r;
 int          blob;
 coordstr     b;
 coordstr     c;
 coordstr     f;
 transformstr tr;
 double       angle;
 int          fr;
 int          br;
 int          offset;
 int          roffset;
 int          pathk;
 int          pathbase;


 err=NULL;

 if(etool->editstate)
 {
  reditmode=REDITLINE|REDITNOFRAME;

  blobmode10(etool,1);
  editrefresh(file);

  blob=0;
  pathbase=0;

  tr=etool->editcurve.tr[etool->editmode];

  pathk=etool->editcurve.curve[etool->editmode].data.path.path;

  path=(pathstr*)fob_find(pathk,file);
  p=q=path->data;
  blob=0;

  while(*p)
  {
   switch(*p)
   {
     case  DRAWCLOSE:
                     p++;
                     break;

      case  DRAWMOVE:
                     pathbase=p-q;

      case  DRAWDRAW:
                     p+=3;
                     blob++;
                     break;


      case DRAWCURVE:
                     if(blobselected(etool,blob+2,0))
                     {
                      b.x=*(p+3);
                      b.y=*(p+4);
                      c.x=*(p+5);
                      c.y=*(p+6);

                      r=gettangent(q+pathbase,p);
                      if(r)
                      {
                       f.x=*(r+1);
                       f.y=*(r+2);

                       offset=p-q;
                       roffset=r-q;

                       undowrite(file,&b,sizeof(coordstr));
                       undowrite(file,&f,sizeof(coordstr));

                       if(undo)
                       {
                        undoread(file,&b,sizeof(coordstr));
                        undoread(file,&f,sizeof(coordstr));
                       }
                       else
                       {
                        angle=(xatan2(f.y-c.y,f.x-c.x)+
                               xatan2(c.y-b.y,c.x-b.x))/2;
                  
                        fr=pythag(f.y-c.y,f.x-c.x);
                        br=pythag(c.y-b.y,c.x-b.x);

                        f.x=c.x+(int)((double)fr*cos(angle));
                        f.y=c.y+(int)((double)fr*sin(angle));
                        b.x=c.x-(int)((double)br*cos(angle));
                        b.y=c.y-(int)((double)br*sin(angle));
                       }

                       path=(pathstr*)fob_find(pathk,file);
                       q=path->data;
                       p=q+offset;
                       r=q+roffset;

                       *(r+1)=f.x;
                       *(r+2)=f.y;
                       *(p+3)=b.x;
                       *(p+4)=b.y;
                      }
                     }
                     p+=7;
                     blob+=3;
                     break;
   }
  }

 /* getpathbox(&etool->editcurve.curve[etool->editmode].box,q); */

 validpath(&etool->editcurve.curve[etool->editmode].box,
           &etool->editcurve.curve[etool->editmode].data.path.flags,q);

  editrefresh(file);
  blobmode10(etool,0);
  reditmode=0;

  editchange(0,file,etool);
 }

 return(err);
}


/* tagged to UNFLATTEN */

static os_error * unflatten(filestr * file)
{
 editpathtoolstr * etool;
 toolboxstr      * toolbox;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 undowritefn(file,UNFLATTEN,NULL,0);

 return(eipflattens(etool,file,1));
}


static os_error * eipflatten(editpathtoolstr * etool,filestr * file)
{
 os_error * err;

 err=undostart(file);
 if(!err)
 {
  undowritefn(file,UNFLATTEN,NULL,0);
  err=eipflattens(etool,file,0);
  undoend(file);
 }
 return(err);
}


/****************************************************************************/


static os_error * eipocswops(editpathtoolstr * etool,filestr * file,int undo)
{
 os_error   * err;
 pathstr    * path;
 int          pathk;
 int        * p;
 int        * q;
 int        * op;
 int        * op2;
 int          blob;
 int          cblob;
 coordstr     cx;
 int          seenclose;
 int          offset;


 err=NULL;

 if(etool->editstate)
 {
  blob=0;
  seenclose=0;

  pathk=etool->editcurve.curve[etool->editmode].data.path.path;
  path=(pathstr*)fob_find(pathk,file);
  op=op2=p=q=path->data;
  blob=0;
  cblob=0;                      /* compiler */

  while(*p && !seenclose)
  {
   op2=op;
   op=p;

   switch(*p)
   {
     case  DRAWCLOSE:
                     p++;
                     seenclose=1;
                     break;

      case  DRAWMOVE:
                     cx.x=*(p+1);
                     cx.y=*(p+2);
                     cblob=blob;

      case  DRAWDRAW:
                     p+=3;
                     blob++;
                     break;

      case DRAWCURVE:
                     p+=7;
                     blob+=3;
                     break;
   }
  }


  if(seenclose)
  {
    /* have to remove close command */
    /* offset previous item         */

   if(*op==DRAWDRAW)
   {
    blobadd(etool,blob-1,1);
   }
   else
   if(*op==DRAWCURVE)
   {
    blobadd(etool,blob-1,1);
   }

   reditmode=REDITNOFRAME;
   editrefresh(file);

   offset=p-q;
   pathinsert(pathk,&q,offset-1,-1,file);
   p=q+offset;

   if(*op2==DRAWDRAW)
   {
    *(op2+1)+=CXSHIFT;
    *(op2+2)+=CYSHIFT;
   }
   else
   if(*op2==DRAWCURVE)
   {
    *(op2+3)+=CXSHIFT;
    *(op2+4)+=CYSHIFT;
    *(op2+5)+=CXSHIFT;
    *(op2+6)+=CYSHIFT;
   }

  /* getpathbox(&etool->editcurve.curve[etool->editmode].box,q); */

   validpath(&etool->editcurve.curve[etool->editmode].box,
             &etool->editcurve.curve[etool->editmode].data.path.flags,q);

   editrefresh(file);
   blobclear(etool,1);
   reditmode=0;

   editchange(0,file,etool);
  }
  else
  {
   /* have to insert close command */
   /* tweek previous item          */

   if(*op==DRAWDRAW)
   {
    blobadd(etool,blob-1,1);
   }
   else
   if(*op==DRAWCURVE)
   {
    blobadd(etool,blob-1,1);
   }

   reditmode=REDITNOFRAME;
   editrefresh(file);

   blobadd(etool,cblob,1);
   blobadd(etool,cblob,0);

   if(*op==DRAWDRAW)
   {
    *(op+1)=cx.x;
    *(op+2)=cx.y;
   }
   else
   {
    *(op+5)=cx.x;
    *(op+6)=cx.y;
   }

   offset=p-q;
   pathinsert(pathk,&q,offset,1,file);
   p=q+offset;
   *p=DRAWCLOSE;

  /* getpathbox(&etool->editcurve.curve[etool->editmode].box,q); */

   validpath(&etool->editcurve.curve[etool->editmode].box,
             &etool->editcurve.curve[etool->editmode].data.path.flags,q);

   editrefresh(file);
   blobclear(etool,1);
   reditmode=0;

   editchange(0,file,etool);
  }
 }

 return(err);

 USE(undo);
}


/* tagged to UNOCSWOP */

static os_error * unocswop(filestr * file)
{
 editpathtoolstr * etool;
 toolboxstr      * toolbox;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 undowritefn(file,UNOCSWOP,NULL,0);

 return(eipocswops(etool,file,1));
}


static os_error * eipocswop(editpathtoolstr * etool,filestr * file)
{
 os_error * err;

 err=undostart(file);
 if(!err)
 {
  undowritefn(file,UNOCSWOP,NULL,0);
  err=eipocswops(etool,file,0);
  undoend(file);
 }

 return(err);
}


/*****************************************************************************/

static os_error * eipsnaps(editpathtoolstr * etool,filestr * file,
                                                   viewstr * view)
{
 os_error   * err;
 pathstr    * path;
 int          pathk;
 int        * p;
 int        * q;
 int        * r;
 int          blob;
 coordstr     c;
 coordstr     d;
 transformstr tr;
 int          offset;
 int          dx;
 int          dy;
 int          pathbase;


 err=NULL;

 if(etool->editstate)
 {
  reditmode=REDITLINE|REDITNOFRAME;

  blobmode10(etool,1);
  editrefresh(file);

  blob=0;
  pathbase=0;

  tr=etool->editcurve.tr[etool->editmode];

  pathk=etool->editcurve.curve[etool->editmode].data.path.path;

  path=(pathstr*)fob_find(pathk,file);
  p=q=path->data;
  blob=0;

  while(*p)
  {
   switch(*p)
   {
     case  DRAWCLOSE:
                     p++;
                     break;

      case  DRAWMOVE:
                     pathbase=p-q;

      case  DRAWDRAW:
                     if(blobselected(etool,blob,0))
                     {
                      c.x=*(p+1);
                      c.y=*(p+2);

                      offset=p-q;

                      undowrite(file,&c,sizeof(coordstr));

                      if(!view)
                      {
                       undoread(file,&c,sizeof(coordstr));
                      }
                      else
                      {
                       tr_transformset(&c,1,&tr);

                       c.x=gridsnapx(c.x,view,1);
                       c.y=gridsnapy(c.y,view,1);

                       tr_inverseset(&c,1,&tr);
                      }

                      path=(pathstr*)fob_find(pathk,file);
                      q=path->data;
                      p=q+offset;

                      *(p+1)=c.x;
                      *(p+2)=c.y;
                     }
                     p+=3;
                     blob++;
                     break;


      case DRAWCURVE:
                     if(blobselected(etool,blob+2,0))
                     {
                      c.x=*(p+5);
                      c.y=*(p+6);

                      offset=p-q;

                      if(!view)
                      {
                       undoread(file,&dx,sizeof(int));
                       undoread(file,&dy,sizeof(int));
                      }
                      else
                      {
                       dx=-c.x;
                       dy=-c.y;

                       tr_transformset(&c,1,&tr);

                       d.x=gridsnapx(c.x,view,1);
                       d.y=gridsnapy(c.y,view,1);

                       tr_inverseset(&d,1,&tr);

                       dx+=d.x;
                       dy+=d.y;
                      }

                      dx=-dx;
                      dy=-dy;
                      undowrite(file,&dx,sizeof(int));
                      undowrite(file,&dy,sizeof(int));
                      dx=-dx;
                      dy=-dy;

                      path=(pathstr*)fob_find(pathk,file);
                      q=path->data;
                      p=q+offset;

                      *(p+3)+=dx;
                      *(p+4)+=dy;
                      *(p+5)+=dx;
                      *(p+6)+=dy;

                      r=gettangent(q+pathbase,p);
                      if(r)
                      {
                       *(r+1)+=dx;
                       *(r+2)+=dy;
                      }
                     }
                     p+=7;
                     blob+=3;
                     break;
    }
  }

 /* getpathbox(&etool->editcurve.curve[etool->editmode].box,q); */

  validpath(&etool->editcurve.curve[etool->editmode].box,
            &etool->editcurve.curve[etool->editmode].data.path.flags,q);

  editrefresh(file);
  blobmode10(etool,0);
  reditmode=0;

  iprefreshpane(file,0x1,IP_PANE1);

  editchange(0,file,etool);
 }

 return(err);
}



/* tagged to UNSNAP */

static os_error * unsnap(filestr * file)
{
 editpathtoolstr * etool;
 toolboxstr      * toolbox;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 undowritefn(file,UNSNAP,NULL,0);

 return(eipsnaps(etool,file,NULL));
}


static os_error * eipsnap(editpathtoolstr * etool,filestr * file,
                                                           viewstr * view)
{
 os_error * err;

 err=undostart(file);
 if(!err)
 {
  undowritefn(file,UNSNAP,NULL,0);
  err=eipsnaps(etool,file,view);
  undoend(file);
 }
 return(err);
}

/*****************************************************************************/

static os_error * eipvhs(editpathtoolstr * etool,filestr * file,int horiz)
{
 os_error   * err;
 pathstr    * path;
 int          pathk;
 int        * p;
 int        * q;
 int        * r;
 int          blob;
 coordstr     c;
 int          offset;
 int          temp[6];
 int          x;
 int          y;
 int          goodxy;


 err=NULL;

 if(etool->editstate)
 {
  reditmode=REDITLINE|REDITNOFRAME;

  blobmode10(etool,1);
  editrefresh(file);

  pathk=etool->editcurve.curve[etool->editmode].data.path.path;
  path=(pathstr*)fob_find(pathk,file);
  p=q=path->data;
  blob=0;
  x=y=0;
  goodxy=0;


  while(*p)
  {
   switch(*p)
   {
     case  DRAWCLOSE:
                     p++;
                     break;

      case  DRAWMOVE:
                     if((looppoint(p,&r)>=0) && r>p)
                     {
                      x=*(r-2);
                      y=*(r-1);
                      goodxy=1;
                     }

      case  DRAWDRAW:
                     if(blobselected(etool,blob,0) && goodxy)
                     {
                      c.x=*(p+1);
                      c.y=*(p+2);

                      offset=p-q;

                      undowrite(file,&c,sizeof(coordstr));

                      if(horiz<0)
                      {
                       undoread(file,&c,sizeof(coordstr));
                      }
                      else
                      {
                       if(horiz) c.y=y;
                       else      c.x=x;
                      }

                      path=(pathstr*)fob_find(pathk,file);
                      q=path->data;
                      p=q+offset;

                      *(p+1)=c.x;
                      *(p+2)=c.y;
                     }

                     goodxy=1;
                     x=*(p+1);
                     y=*(p+2);
                     p+=3;
                     blob++;
                     break;

      case DRAWCURVE:
                     if(blobselected(etool,blob+2,0))
                     {
                      XMEMCPYX(temp,p+1,6*sizeof(int));

                      offset=p-q;

                      undowrite(file,temp,6*sizeof(int));

                      if(horiz<0)
                      {
                       undoread(file,temp,6*sizeof(int));
                      }
                      else
                      {
                       if(horiz) 
                       {
                        temp[1]=y;
                        temp[3]=y;
                        temp[5]=y;
                       }
                       else
                       {
                        temp[0]=x;
                        temp[2]=x;
                        temp[4]=x;
                       }
                      }

                      path=(pathstr*)fob_find(pathk,file);
                      q=path->data;
                      p=q+offset;

                      XMEMCPYX(p+1,temp,6*sizeof(int));
                     }
                     x=*(p+5);
                     y=*(p+6);
                     p+=7;
                     blob+=3;
                     break;
    }
  }


  /* getpathbox(&etool->editcurve.curve[etool->editmode].box,q); */

  validpath(&etool->editcurve.curve[etool->editmode].box,
            &etool->editcurve.curve[etool->editmode].data.path.flags,q);

  editrefresh(file);
  blobmode10(etool,0);
  reditmode=0;

  editchange(0,file,etool);
 }

 return(err);
}



/* tagged to UNVH */

static os_error * unvh(filestr * file)
{
 editpathtoolstr * etool;
 toolboxstr      * toolbox;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 undowritefn(file,UNVH,NULL,0);

 return(eipvhs(etool,file,-1));
}


static os_error * eipvh(editpathtoolstr * etool,filestr * file,int horiz)
{
 os_error * err;

 err=undostart(file);
 if(!err)
 {
  undowritefn(file,UNVH,NULL,0);
  err=eipvhs(etool,file,horiz);
  undoend(file);
 }

 return(err);
}


/*****************************************************************************/

static os_error * eipmodes(editpathtoolstr * etool,filestr * file,int newmode)
{
 os_error * err;

 err=NULL;

 if(etool->editmode==EP_FRAME)
 {
  /* get rid of blobs, switch mode, do new curve */

  reditmode=REDITNOFRAME;
  editrefresh(file);
  blobclear(etool,0);

  reditmode=0;
  etool->editmode=newmode;
  editrefresh(file);
  reditmode=0;
 }
 else
 if(newmode==EP_FRAME)
 {
  /* get rid of blobs and line, switch mode, add blobs */

  reditmode=REDITNOFRAME;
  editrefresh(file);
  blobclear(etool,0);
  etool->editmode=newmode;
  reditmode=REDITNOLINE;
  editrefresh(file);
  reditmode=0;
 }
 else
 {
  /* get rid of blobs and line, switch mode, do new curve */

  reditmode=REDITNOFRAME;
  editrefresh(file);
  blobclear(etool,0);
  etool->editmode=newmode;
  editrefresh(file);
  reditmode=0;
 }

 iprefreshpane(file,0x2,IP_PANE1);

 return(err);
}



/* tagged to UNMODE */

static os_error * unmode(filestr * file)
{
 editpathtoolstr * etool;
 toolboxstr      * toolbox;
 int               newmode;

 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 undoread(file,&newmode,sizeof(int));
 undowritefn(file,UNMODE,&etool->editmode,sizeof(int));

 return(eipmodes(etool,file,newmode));
}



static os_error * eipmode(editpathtoolstr * etool,filestr * file)
{
 os_error * err;
 int        newmode;

 err=NULL;

 newmode=etool->editmode+1;
 if(newmode>=3) newmode=0;
 if(etool->editcurve.curve[newmode].type!=CPATH)
 {
  newmode++;
  if(newmode>=3) newmode=0;
  if(etool->editcurve.curve[newmode].type!=CPATH)
  {
   return(err);
  }
 }

 undostart(file);

 undowritefn(file,UNMODE,&etool->editmode,sizeof(int));
 err=eipmodes(etool,file,newmode);

 undoend(file);

 return(err);
}


/****************************************************************************/


static os_error * eipclick(int handle,int userhandle,wimp_mousestr * m)
{
 os_error        * err;
 viewstr         * view;
 filestr         * file;
 toolboxstr      * toolbox;
 editpathtoolstr * etool;

 err=NULL;

 view=(viewstr *)userhandle;
 file=view->file;
 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;

 switch(m->i)
 {
  case 4:
         err=eipline(etool,file);
         break;

 case 15:
         err=eipcurve(etool,file);
         break;

  case 5:
         err=eipaddpoint(etool,file);
         break;

  case 6:
         err=eiprempoint(etool,file);
         break;

  case 7:
         err=eipflatten(etool,file);
         break;

  case 8:
         err=eipocswop(etool,file);
         break;

  case 9:
         err=eipsnap(etool,file,view);
         break;

 case 11:
         err=eipmode(etool,file);
         break;

 case 12:
         err=eipmove(etool,file);
         break;

 case 13:
 case 14:
         err=eipvh(etool,file,m->i==13);
         break;
 }

 return(err);

 USE(handle);
}


static char * emodevalid[3]={"ip_frame",
                             "ip_inner",
                             "ip_outer"};


static os_error * eiprefresh(viewstr * view,int handle,int code)
{
 filestr         * file;
 toolboxstr      * toolbox;
 coordstr          c;
 int               state;
 int               blob;
 editpathtoolstr * etool;



 file=view->file;
 toolbox=file->toolbox;
 etool=(editpathtoolstr*)toolbox->toolstate[toolbox->current].hprivate;


 if(code==-1)
 {
  writeiconf(view->info,IP_HELPI,"%s","{PATH00}");
 }

 if(code & 0x1)
 {
  state=etool->editstate;

  if(state!=EP_NONE && etool->editptn[0])
  {
   if(state==EP_DRAGPOINT || state==EP_DRAGTANGENT || state==EP_DRAG2TANGENT) 
                                           blob=dragposn.handle;
   else                                    blob=etool->editpts[0][0].n;


   getblobn(file,etool,blob,&c.x,&c.y);

   if(state==EP_DRAGPOINT || state==EP_DRAGTANGENT || state==EP_DRAG2TANGENT)
   {
    c.x+=eddx;
    c.y+=eddy;
   }


   tr_transformset(&c,1,&etool->editcurve.tr[etool->editmode]);

   writeiconc(handle,eipmap[EIPX].realicon,
                     unitstostring(c.x-prefp(file)->rulerx,view->data.units));

   writeiconc(handle,eipmap[EIPY].realicon,
                     unitstostring(c.y-prefp(file)->rulery,view->data.units));
  }
  else
  {
   writeiconc(handle,eipmap[EIPX].realicon,"");
   writeiconc(handle,eipmap[EIPY].realicon,"");
  }
 }


 if(code & 0x2)
 {
  wimp_slice_icon(handle,eipmap[EIPMODE].realicon,'a',emodevalid[etool->editmode]);
 }

 return(NULL);
}






static os_error * eipkey(int handle,int userhandle,int icon,int * key)
{
 os_error        * err;
 editpathtoolstr * etool;
 viewstr         * view;
 filestr         * file;
 toolboxstr      * toolbox;
 char            * p;
 coordstr          xnew;
 coordstr          old;


 err=NULL;

 if(*key==13)
 {
  view=(viewstr *)userhandle;
  file=view->file;
  toolbox=file->toolbox;
  etool=(editpathtoolstr*)toolbox->toolstate[toolbox->current].hprivate;

  if(etool->editstate!=EP_NONE && etool->editptn[0])
  {
   getblobn(file,etool,etool->editpts[0][0].n,&old.x,&old.y);

   iconaddr(handle,eipmap[EIPX].realicon,&p);
   stringtounits(p,&xnew.x,view->data.units);
   xnew.x+=prefp(file)->rulerx;

   iconaddr(handle,eipmap[EIPY].realicon,&p);
   stringtounits(p,&xnew.y,view->data.units);
   xnew.y+=prefp(file)->rulery;

   tr_inverseset(&xnew,1,&etool->editcurve.tr[etool->editmode]);

   reditmode=REDITLINE|REDITNOFRAME;

   blobmode10(etool,1);
   editrefresh(file);

   eddx=xnew.x-old.x;
   eddy=xnew.y-old.y;

   undostart(file);
   ewriteundopt(file);
   
   editshiftpoints(file,etool,EP_DRAGPOINT);

   editrefresh(file);
   reditmode=0;
   blobmode10(etool,0);

   editchange(0,file,etool);

   undoend(file);
  }
  *key=-1;
 }

 return(err);
 USE(icon);
}




static ipstr eipstr=
{
 eipclick,       /* click    */
 eipkey,         /* key      */
 eipmap,         /* icon map */
 TPATHTOOL,      /* template */
 NULL,           /* redraw   */
 eiprefresh,     /* refresh  */
};




static os_error * editselect(toolboxstr * toolbox,viewstr * view,
                                           filestr * file,int select)
{
 editpathtoolstr * etool;
 eposnstr          eposn;


 if(!undoactive(file))
 {
  etool=(editpathtoolstr*)toolbox->toolstate[toolbox->current].hprivate;

  if(select)
  {
   if(nselected(&eposn.object,file))
   {
    eposn.section=selsectk;
    eposn.page=selpagek;
    eposn.otype=((objhdrstr*)fob_find(eposn.object,file))->type;
    objectmaster(eposn.object,file,&eposn.master,&eposn.bits);
    clearselectionlo();
    editposn(etool,&eposn,file,EP_FRAME);
   }
   else clearselectionlo();
  }
  else
  {
   editclear(etool,file);
  }
 }

 ipchangepane(toolbox,IP_PANE1,select?&eipstr:NULL);

 return(NULL);
 USE(view);
}


static os_error * editptr(toolboxstr * toolbox,posnstr * posn)
{
 return(NULL);
 USE(posn);
 USE(toolbox);
}



static os_error * editmenu(toolboxstr * toolbox,viewstr * view,
                                         filestr * file,wimp_mousestr * m)
{
 return(openmenu("main_menu"));
 USE(view);
 USE(file);
 USE(m);
 USE(toolbox);
}


static os_error * editkey(toolboxstr * toolbox,int * key,fkeyfn * fk)
{
 menukey(key);
 if(*key==-1) *fk=menukey;
 return(NULL);
 USE(toolbox);
}






static os_error * eselectall(int eventn,int user,filestr * file,int * claim)
{
 os_error   * err;
 toolboxstr * toolbox;
 editpathtoolstr * etool;

 err=NULL;

 if(toolcurrent(file)==TL_PATHEDIT)
 {
  toolbox=file->toolbox;
  etool=(editpathtoolstr*)toolbox->toolstate[toolbox->current].hprivate;

  if(etool->editstate!=EP_NONE)
  {
   *claim=1;
//   err=selectall(&act);
  }
 }

 return(err);

 USE(eventn);
 USE(user);
}




static os_error * eclearselection(int eventn,int user,filestr * file,int * claim)
{
 os_error   * err;
 toolboxstr * toolbox;
 editpathtoolstr * etool;

 err=NULL;

 if(toolcurrent(file)==TL_PATHEDIT)
 {
  toolbox=file->toolbox;
  etool=(editpathtoolstr*)toolbox->toolstate[toolbox->current].hprivate;

  if(etool->editstate!=EP_NONE)
  {
   *claim=1;
//   err=selectall(&act);
  }
 }

 return(err);

 USE(eventn);
 USE(user);
}








static os_error * edpref(int eventn,int user,viewstr * view,prefdatastr * old)
{
 filestr     * file;
 prefdatastr * xnew;

 file=view->file;

 if(toolcurrent(file)==TL_PATHEDIT)
 {
  xnew=prefp(file);

  if(xnew->units!=old->units || xnew->rulerx!=old->rulerx || 
                               xnew->rulery!=old->rulery)
  {
   iprefreshpane(file,0x1,IP_PANE1);
  }
 }

 return(NULL);
 USE(eventn);
 USE(user);
}




static os_error * editinit(toolboxstr * toolbox,int code)
{
 os_error        * err;
 editpathtoolstr * etool;

 err=NULL;

 if(code==TINITBOOT)
 {
           err=addevent(EVENT_PREFERENCES,(eventfn)edpref,0);
  if(!err) err=addevent(EVENT_SELECTALL,(eventfn)eselectall,0);
  if(!err) err=addevent(EVENT_CLEARSELECTION,(eventfn)eclearselection,0);
 }
 else
 if(code==TINITDELETE)
 {
  if(toolbox)
  {
   etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;
   blobinit(etool);
  }
 }

 return(err);
}





static os_error * emess(toolboxstr * toolbox,filestr * file,
                                      int message,void * data)
{
 editpathtoolstr * etool;

 if(message==TSAVEPOSN)
 {
  etool=(editpathtoolstr*)toolbox->toolstate[toolindex(TL_PATHEDIT)].hprivate;
  if(etool->editstate!=EP_NONE)
  {
   undowritefn(file,BLOBSETP,NULL,0);
   undowriteblobs(etool,file);
   undowritefn(file,UNEDITPOSN,&etool->editposn,sizeof(eposnstr));
   undowrite(file,&etool->editmode,sizeof(int));
  }
 }

 return(NULL);

 USE(toolbox);
 USE(data);
}








toolstr pathedit=
{
 TL_PATHEDIT,
 "pathedit",
 "t_pathedit\0t_ppathedit",
 "{PAETIP}",
 1,
 editclick,
 editmove,
 editselect,
 editptr,
 editcancel,
 editredraw,
 editdragend,
 editmenu,
 editkey,
 NULL,
 editinit,
 emess,
 0,

 0,       /*  preselect */
 0,       /*  noicon    */
 0,       /*  spare2    */
 0,       /*  spare3    */
 0,       /*  spare4    */ 
 0,       /*  spare5    */
 0,       /*  spare6    */
 0,       /*  spare7    */

 TPOINTER,
 0,
 sizeof(editpathtoolstr),
 3,       /*  rank      */
};




#define UNDOS 21

static undofnstr undos[UNDOS]=
{
 unmovept,       NULL, UNMOVEPT,      "{UEPT}",
 unmovetan,      NULL, UNMOVETAN,     "{UETAN}",
 unflatten,      NULL, UNFLATTEN,     "{UEFLAT}",
 unsnap,         NULL, UNSNAP,        "{UESNAP}",
 unocswop,       NULL, UNOCSWOP,      "{UEOC}",
 unlcswop,       NULL, UNLCSWOP,      "{UELC}",
 unmove,         NULL, UNMOVE,        "{UEMV}",
 unmode,         NULL, UNMODE,        "{UEMD}",
 unaddblob4,     NULL, UNADDBLOB4,    "{UESEL}",
 unremblob4,     NULL, UNREMBLOB4,    "{UEDES}",
 unvh,           NULL, UNVH,          "{UEVH}",
 blobclearp,     NULL, BLOBCLEARP,    NULL,
 blobsetp,       NULL, BLOBSETP,      NULL,
 uneditclear,    NULL, UNEDITCLEAR,   "{UECLR}",
 uneditposn,     NULL, UNEDITPOSN,    "{UEED}",
 unaddpoints,    NULL, UNADDPOINTS,   "{UEADD}",
 unaddpointf,    NULL, UNADDPOINTF,   "{UEADD}",
 unaddpoint,     NULL, UNADDPOINT,    NULL,
 unrempoint,     NULL, UNREMPOINT,    NULL,
 unrempoints,    NULL, UNREMPOINTS,   "{UEREM}",
 unrempointf,    NULL, UNREMPOINTF,   "{UEREM}",

};




os_error * patheditinit(void)
{
 os_error * err;

 err=toolregister(&pathedit);
 if(!err) err=undoaddblock(undos,UNDOS);
 

 return(err);
}

