/*->h.file */


#define PRSAVETYPE 0x8000
#define FRSAVEUNDO 0x10000


typedef void ** fobjptr;

typedef os_error * (*fileclosefn)(filestr * file,int userhandle);
typedef os_error * (*fileopenfn)(filestr * file,int userhandle);

extern os_error * addfileclose(fileclosefn fileclose);
extern os_error * addfileopen(fileopenfn fileopen);
extern os_error * remfileclose(fileclosefn fileclose);
extern os_error * remfileopen(fileopenfn fileopen);


extern filestr  * firstfile;
extern filestr  * deffile;

extern filestr  * getdeffile(void);
extern os_error * updatedefaultfile(void);


extern filestr  * xloadfile;

extern os_error * loaddoc(char * name,int type,int userhandle,int xvolatile);

#define FL_NOFONTMISSING 0x1

extern os_error * loaddocpost1(int * load,int flags);
extern os_error * loaddocpost(int userhandle);


extern int  filefromview(int fp);
extern int  currentview(void);
extern int  currentfile(void);
extern int  fileinfo(int fp);
extern int  setcurrentview(int fp);
extern int  setcurrentfile(int fp);
extern int  nextfile(int fp);
extern int  nextuserfile(int fp);
extern int  defaultfile(int fp);


extern void       reverttosaved(int fp);
extern int        issaved(int fp);
extern int        ischanged(int fp);
extern os_error * closedoc(filestr * file);
extern void       filescrap(int fp);
extern void       getfiletimestring(int fp);
extern void       autosavereset(filestr * file);
extern int        scriptloadfile(int fp);



#define FILELDTST 0x1
#define FILESVTST 0x2

extern int        filetest;





#define FLNOVIEW    0x1
#define FLPERMANENT 0x2
#define FLNOLOAD    0x4




extern os_error * loadanyfile(char * name,int flags);


extern os_error * savedoc(char * name,filestr * file,int type);
extern os_error * savedocs(char * name,filestr * file,int type);
extern void       savedocument(int fp);
extern void       saveasdefault(int fp);
extern os_error * createdocumentfile(char * filename);

extern os_error * initdoc(void);
extern os_error * finitdoc(void);

extern void       gennewname(filestr * file,char * name);
extern int        unsaved(void);


extern os_error * modfile(filestr * file,int section);

extern void       unmodfile(filestr * file);

extern filestr  * firstfilep(void);
extern void setcurrentfileview(filestr * file,viewstr * view);


extern os_error * newfile(filestr ** filep);
extern os_error * deletefile(filestr * file);

extern void     * fob_find(int n,filestr * file);
extern os_error * fob_mod(int n,filestr * file,fobjptr pointer);
extern os_error * fob_change(int n,filestr * file,int newsize,fobjptr pointer);
extern os_error * fob_create(int size,filestr * file,int type,fobjptr pointer);
extern os_error * fob_delete(int n,filestr * file);
extern os_error * fob_lock(fobjptr pointer,int n,filestr * file);
extern os_error * fob_unlock(fobjptr pointer,filestr * file);
extern os_error * fob_copy(fobjptr dpointer,filestr * dfile,
                                                  int sn,filestr * sfile);


extern os_error * fob_setbits(int n,filestr * file,int bits,fobjptr pointer);

extern os_error * fob_static(fobjptr pointer,int n,filestr * file);
extern os_error * fob_free(fobjptr pointer,filestr * file);
extern int        fob_size(int n,filestr * file,fobjptr pointer);


extern os_error * fob_compact(filestr * file);
extern os_error * fob_compactall(void);
extern os_error * fob_checkfree(int need,filestr * file);

extern os_error * fob_test(filestr * file);
extern os_error * fob_testdebug(filestr * file,char * where);


