/*->c.page */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "err.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "colour.h"
#include "redraw.h"
#include "deb.h"


#include "constants.h"
#include "str.h"

#include "units.h"
#include "geometry.h"
#include "object.h"
#include "chain.h"
#include "viewr.h"
#include "view.h"
#include "file.h"
#include "select.h"
#include "dbmore.h"

#include "xredraw.h"
#include "xrender.h"
#include "xcolour.h"
#include "curve.h"
#include "fillstub.h"


#include "xprint.h"

#include "dscript.h"

#include "page.h"





typedef struct pagecoordstr
{
 wimp_box box;


} pagecoordstr;




void getpageoscoords(viewredrawstr * v)
{
 viewstr    * view;
 filestr    * file;
 sectionstr * sectionp;
 int          leftpb;
 int          rightpb;
 int          hx;
 int          wx;
 int          h;
 int          w;
 int          hand;


 view=v->view;
 file=v->file;

 if(v->isprinter)
 {
  v->pagebox.x0=(v->ox+osunits(v->xps,view));
  v->pagebox.y0=(v->oy-osunits(v->ype,view));
  v->pagebox.x1=(v->ox+osunits(v->xpe,view));
  v->pagebox.y1=(v->oy-osunits(v->yps,view));
 }
 else
 {
  sectionp=(sectionstr*)fob_find(v->section,file);
  w=sectionp->data.width;
  h=sectionp->data.height;

  hand=v->xps>0;


  hx=(v->ypo-v->yps)-view->border.toppb;
  hx=(osunits(hx,view)+cvdu.deltay-1)&cvdu.masky;

  v->pagebox.y1=(v->oy-osunits(v->yps,view))-hx;

  v->pagebox.y0=(v->oy-osunits(v->ypo+h+view->border.botpb,view));


  /* left hand */

  if(view->data.pasteboard)
  {
   if(hand && view->data.dble) leftpb=view->border.mid2pb;
   else                        leftpb=view->border.leftpb;
  }
  else                         leftpb=0;


  wx=osunits(v->xpo-v->xps-leftpb,view);
  wx=(wx+cvdu.deltax-1)&cvdu.maskx;

  v->pagebox.x0=((v->ox+osunits(v->xps,view))&cvdu.maskx)+wx;


  /* right hand */

  if(view->data.pasteboard)
  {
   if(!hand && view->data.dble) rightpb=view->border.mid1pb;
   else                         rightpb=view->border.rightpb;
  }
  else                          rightpb=0;

  v->pagebox.x1=(v->ox+osunits(v->xpo+w+rightpb,view));
 }
}





static os_error * pagegaps(viewredrawstr * v,int w,int h,
                                             viewstr * view,int hand)
{
 os_error * err;
 int        leftpb;
 int        rightpb;
 int        hx;
 int        wx;


 err=rwimp_setcolour(WIMPGREY4);


 /* inter page gaps */


 hx=(v->ypo-v->yps)-view->border.toppb;
 if(hx)
 {
  err=bbc_rectanglefill(v->ox+osunits(v->xps,view),
                        v->oy-osunits(v->yps,view),
                        osunits(v->xpe-v->xps,view),-osunits(hx,view));
 }


 hx=v->ype-(v->ypo+h+view->border.botpb);
 if(hx)
 {
  err=bbc_rectanglefill(v->ox+osunits(v->xps,view),
                        v->oy-osunits(v->ypo+h+view->border.botpb,view),
                        osunits(v->xpe-v->xps,view),-osunits(hx,view));
 }


 /* left hand */

 if(view->data.pasteboard)
 {
  if(hand && view->data.dble) leftpb=view->border.mid2pb;
  else                        leftpb=view->border.leftpb;
 }
 else                         leftpb=0;

 wx=v->xpo-v->xps-leftpb;
 if(wx)
 {
  err=bbc_rectanglefill(v->ox+osunits(v->xps,view),
                        v->oy-osunits(v->yps,view),
                        osunits(wx,view),-osunits(v->ype-v->yps,view));
 }


 /* right hand */

 if(view->data.pasteboard)
 {
  if(!hand && view->data.dble) rightpb=view->border.mid1pb;
  else                         rightpb=view->border.rightpb;
 }
 else                          rightpb=0;


 wx=v->xpe-(v->xpo+w+rightpb);
 if(wx)
 {
  err=bbc_rectanglefill(v->ox+osunits(v->xpo+w+rightpb,view),
                        v->oy-osunits(v->yps,view),
                        osunits(wx,view),-osunits(v->ype-v->yps,view));
 }


 return(err);
}



/*
static int leftmargin=(10*MMSIZE);
static int rightmargin=(10*MMSIZE);
static int topmargin=(10*MMSIZE);
static int botmargin=(10*MMSIZE);
*/

os_error * redrawghost(viewredrawstr * v,int hand)
{
 os_error   * err;
 sectionstr * section;
/* int          x;
 int          y;
 int          w;
 int          h; */
 viewstr    * view;


#ifdef NEVER
 section=fob_find(v->section,v->file);
 
 x=leftmargin;
 y=topmargin;
 w=section->data.width-(leftmargin+rightmargin);
 h=section->data.height-(topmargin+botmargin);

 rwimp_setcolour(WIMPWHITE);

 err=bbc_rectanglefill(v->ox+osunits(v->xps,v->view),
                       v->oy-osunits(v->yps,v->view),
                             osunits(v->xpe-v->xps,v->view),
                            -osunits(v->ype-v->yps,v->view));


 pagegaps(v,section->data.width,section->data.height,v->view,hand);


 rwimp_setcolour(GHOSTCOLOUR);
 err=bbc_rectanglefill(v->ox+osunits(v->xpo+x,v->view),
                   v->oy-osunits(v->ypo+y,v->view),
                           osunits(w,v->view),
                          -osunits(h,v->view));



#else

 view=v->view;

 rwimp_setcolour(GHOSTCOLOUR);
 err=bbc_rectanglefill(v->ox+osunits(v->xps,v->view),
                       v->oy-osunits(v->yps,v->view),
                           osunits(v->xpe-v->xps,v->view),
                          -osunits(v->ype-v->yps,v->view));


 section=(sectionstr*)fob_find(v->section,v->file);

 pagegaps(v,section->data.width,section->data.height,view,hand);


 if(view->data.dble && hand)
 {
  rwimp_setcolour(WIMPBLACK);
  bbc_move(v->ox+osunits(v->xpo,view),v->oy-osunits(v->ypo,view));
  bbc_draw(v->ox+osunits(v->xpo,view),
                  v->oy-osunits(v->ypo+section->data.height,view));
 }


#endif






 return(err);
}




static os_error * redrawgud(viewredrawstr * v,pagestr * page)
{
 os_error    * err;
 chainobject * glinep;
 int           gline;

 err=NULL;

 gline=page->gchain.child;
 while(gline)
 {
  glinep=(chainobject*)fob_find(gline,v->file);
  gline=glinep->chain.next;
  err=objectredraw(v,(objhdrstr*)glinep);
 }

 return(err);
}



static os_error * redrawguides(viewredrawstr * v,pagestr * page)
{
 os_error * err;

 if(((v->view)->data.guides)) 
 {
  err=redrawgud(v,page);
 }
 else err=NULL;

 return(err);
}





#define DROPDIM ((3*MMSIZE)/2)


/* redraw exterior of page */

static os_error * redexpage(viewredrawstr * v,pagestr * page,pagecoordstr * c)
{
 os_error   * err;
 int          transparent;
 sectionstr * sectp;
 viewstr    * view;
 filestr    * file;
 int          hand;
 int          xdrop;
 int          xdrop2;
 int          xc;
 int          yc;
 int          base;
 int          side;
 int          split;
 sobjectstr * sob;
 boxstr       boxes[4];
 int          n;
 boxstr       pbox;
 aboxstr      apbox;
 colourvalue  cv;
 boxstr       sbox;
 int          dx;
 int          dy;




 err=NULL;

 if(page->key==v->object) v->ignore=0;

// cprintf("red ex page ig %d isp %d",v->ignore,v->isprinter);


 if(!v->ignore)
 {
  view=v->view;
  file=v->file;

  if(v->isprinter)
  {
   sectp=(sectionstr*)fob_find(v->section,file);
   if(sectp->data.dble)
   {
    base=getpagebase(sectp);
    side=!islhpb(page,base);
   }
   else side=0;

//   err=vsetcolour(&sectp->data.colour[side],&transparent,view);
   if(!err)
   {
//    if(!transparent)
    {
     curvestr      c;
     curvestylestr cstyle;

     c.type=CBOX;
     c.box.x=v->xps;
     c.box.y=v->yps;
     c.box.w=v->xpe-v->xps;
     c.box.h=v->ype-v->yps;

     cstyle.fill.fill=0;
     cstyle.fillcolour=sectp->data.colour[side];
     cstyle.pstyle.action=0x2;


//     err=bbc_rectanglefill(v->ox+osunits(v->xps,view),
//                           v->oy-osunits(v->yps,view),
//                                 osunits(v->xpe-v->xps,view),
//                                -osunits(v->ype-v->yps,view));
//      cprintf("red ex page fill");
     
     err=renderfill(v,&c,&cstyle,NULL);
    }
   }
  }
  else
  {
   hand=(v->xps>0);

   if(view->data.pasteboard)
   {
    rwimp_setcolour(WIMPGREY1);

    err=bbc_rectanglefill(v->ox+osunits(v->xps,view),
                          v->oy-osunits(v->yps,view),
                                osunits(v->xpe-v->xps,view),
                               -osunits(v->ypo-v->yps,view));


  /*  dprintf(0,"%d %d %d %d",v->ox+osunits(v->xps,view),
                            v->oy-osunits(v->yps,view),
                            osunits(v->xpe-v->xps,view),
                            -osunits(v->ypo-v->yps,view)); */

    /* left hand side  */

    if(!view->data.dble || !hand)
    {
     err=bbc_rectanglefill(v->ox+osunits(v->xps,view),
                           v->oy-osunits(v->ypo,view),
                                 osunits(v->xpo-v->xps,view),
                                -osunits(page->box.h,view));
    }

    /* right hand side */
  
    if(!view->data.dble || hand)
    {
     err=bbc_rectanglefill(v->ox+osunits(v->xpo+page->box.w,view),
                           v->oy-osunits(v->ypo,view),
                                 osunits(v->xpe-(v->xpo+page->box.w),view),
                                -osunits(page->box.h,view));
    }

    err=bbc_rectanglefill(v->ox+osunits(v->xps,view),
                          v->oy-osunits(v->ypo+page->box.h,view),
                                osunits(v->xpe-v->xps,view),
                               -osunits(v->ype-(v->ypo+page->box.h),view));


    /* drop shadow */

    if(!nodropshadow)
    {
     rwimp_setcolour(WIMPGREY4);

     xdrop=(view->data.dble && hand)?0:DROPDIM;
     xdrop2=(view->data.dble && !hand)?0:DROPDIM;
     xc=v->ox+osunits(v->xpo+page->box.w+xdrop2,view);
     yc=v->oy-osunits(v->ypo+page->box.h+DROPDIM,view);

     err=bbc_rectanglefill(xc,yc,-osunits(page->box.w+xdrop2-xdrop,view),
                                  osunits(DROPDIM,view));

     if(!view->data.dble || hand)
     {
      err=bbc_rectanglefill(xc,yc,-osunits(DROPDIM,view),
                                  osunits(page->box.h,view));
     }
    }

    predregmarks(v,page->box.w,page->box.h,hand);
   }

   sectp=(sectionstr*)fob_find(v->section,file);
   if(sectp->data.dble)
   {
    base=getpagebase(sectp);
    side=!islhpb(page,base);
   }
   else side=0;

   err=vsetcolour(&sectp->data.colour[side],&transparent,view);
   if(!err)
   {
    if(transparent && !v->isprinter)
    {
     rwimp_setcolour(WIMPWHITE);
     transparent=0;
    }

    if(!transparent)
    {
     split=0;
     if(page->chain.child)
     {
      sob=(sobjectstr*)fob_find(page->chain.child,file);
      if(sob->fcurve.type==CBOX && !(tr_type(&sob->transform) & TR_ROTATE))
      {
       objectread(OREADFILL,(objhdrstr*)sob,file,&cv);
       split=(vfindcolour(view,&cv)!=-1);
      }
     }

     if(split)
     {
      getmaxbox(&sbox,&sob->fcurve.box,&sob->transform);

      dx=ourunits(cvdu.deltax,view);

      if(cvdu.deltax==cvdu.deltay) dy=dx;
      else                         dy=ourunits(cvdu.deltay,view);

      sbox.x+=dx;
      sbox.w-=2*dx;
      sbox.y+=dy;
      sbox.h-=2*dy;
      if(sbox.w<0) sbox.w=0;
      if(sbox.h<0) sbox.h=0;

      pbox=page->box;
      box2abox(&pbox,&apbox);

      if(apbox.x0<v->xlos) apbox.x0=v->xlos;
      if(apbox.x1>v->xhis) apbox.x1=v->xhis;
      if(apbox.y0<v->ylos) apbox.y0=v->ylos;
      if(apbox.y1>v->yhis) apbox.y1=v->yhis;  

      if(apbox.y1>apbox.y0 && apbox.x1>apbox.x0)
      {
       abox2box(&apbox,&pbox);

       n=splitboxes(&pbox,&sbox,boxes);

       while(n--)
       {
        err=rbbc_rectanglefill(&boxes[n],v);
       }
      }
     }
     else
     {
      err=rbbc_rectanglefill(&page->box,v);
     }
    }
   }

   pagegaps(v,page->box.w,page->box.h,view,hand);

   if(view->data.pasteboard)
   {
    rwimp_setcolour(WIMPBLACK);
    err=rbbc_rectangle(&page->box,v);
   }
   else
   if(view->data.dble && hand)
   {
    rwimp_setcolour(WIMPBLACK);
    bbc_move(v->ox+osunits(v->xpo,view),v->oy-osunits(v->ypo,view));
    bbc_draw(v->ox+osunits(v->xpo,view),
             v->oy-osunits(v->ypo+page->box.h,view));

   }
  }
 }
 return(err);
}



static os_error * redrawpage(viewredrawstr * v,pagestr * pagep)
{
 os_error    * err;
 int           childk;
 chainobject * childp;
 pagestr       page;
 wimp_box      scrapbox;
 void        * handle;
 pagecoordstr  c;
 int           visible;

 page=*pagep;

// cprintf("redraw page 0");

 err=redexpage(v,&page,&c);

 if(!err) 
 {
  render_setclipwindow(&v->redrawstr,&v->pagebox,&scrapbox,&handle,&visible,v);
  if(visible)
  {
   if(!(v->view)->data.guidelinefb) redrawguides(v,&page);

   childk=page.chain.child;

//   if(!handle) cprintf("redraw page 1 handle %x",handle);

   while(childk)
   {
//    cprintf("childk %d",childk);
    childp=(chainobject*)fob_find(childk,v->file);
    childk=childp->chain.next;
//    cprintf("next %d key %d",childk,childp->key);
    err=objectredraw(v,(objhdrstr*)childp);
    if(err) break;
   }

   if((v->view)->data.guidelinefb) redrawguides(v,&page);

   render_resetclipwindow(&v->redrawstr,&scrapbox,handle,v);
  }
 }

 return(err);
}



/* return last page in section */

int lastpageinsection(int sectionkey,filestr * file)
{
 sectionstr * section;
 pagestr    * page;
 int          pagekey;

 section=(sectionstr*)fob_find(sectionkey,file);
 pagekey=section->chain.child;

 while((page=(pagestr*)fob_find(pagekey,file))->chain.next)
 {
  pagekey=page->chain.next;
 }

 return(pagekey);
}




static void setuppagecoords(pagestr * page,newpagestr * newpage)
{
 page->data.number=newpage->pagenumber;
 page->box.w=newpage->data.width;
 page->box.h=newpage->data.height;
}



static os_error * newpage(objectloc * loc,newpagestr * newpage)
{
 os_error   * err;
 pagestr    * page;
 filestr    * file;

 file=loc->file;

 err=fob_create(sizeof(pagestr),file,OPAGE,(fobjptr)&page);
 if(!err)
 {
  setuppagecoords(page,newpage);
  page->section=loc->section;
  page->branch=loc->branch;

  loc->object=page->key;
 }

 return(err);
}



/* copy all child boxes */


static os_error * copypage(objectloc * src,objectloc * dest,transformstr * tr)
{
 os_error    * err;
 int           srcchild;
 int           destchild;
 int           gsrcchild;
 pagestr     * pagep;
 chainobject * chainp;

 err=NULL;

 pagep=(pagestr*)fob_find(src->page,src->file);
 srcchild=pagep->chain.child;
 gsrcchild=pagep->gchain.child;
 destchild=0;

 while(srcchild)
 {
  src->object=srcchild;
  dest->after=destchild;

  err=objectcopy(src,dest,tr);

  destchild=dest->object;

  chainp=(chainobject*)fob_find(srcchild,src->file);
  srcchild=chainp->chain.next;
 }


 destchild=0;
 src->chain=dest->chain=PGLINECHAIN;
 while(gsrcchild)
 {
  src->object=gsrcchild;
  dest->after=destchild;

  err=objectcopy(src,dest,tr);

  destchild=dest->object;

  chainp=(chainobject*)fob_find(gsrcchild,src->file);
  gsrcchild=chainp->chain.next;
 }

 return(err);
}



static int findpage(posnstr * posn,pagestr * pagep,int * before,int last)
{
 int           pagek;
 int           childk;
 chainobject * childp;
 int           glast;

 pagek=pagep->key;
 last=pagek;         /* always inside page */

 if((posn->view)->data.guides)
 {
  childk=pagep->gchain.child;
  while(childk)
  {
   childp=(chainobject*)fob_find(childk,posn->file);
   childk=childp->chain.next;
   last=objectfind(posn,(objhdrstr*)childp,before,last);
  }

  if(last!=pagek)
  {
   posn->chain=PGLINECHAIN;
   if((posn->view)->data.guidelinefb) return(last);
  }
 }

 glast=last;
 pagep=(pagestr*)fob_find(pagek,posn->file);

 childk=pagep->chain.child;
 while(childk)
 {
  childp=(chainobject*)fob_find(childk,posn->file);
  childk=childp->chain.next;
  last=objectfind(posn,(objhdrstr*)childp,before,last);
 }

 if(last!=glast) posn->chain=0;

 return(last);
}



static int selectpage(pagestr * pagep,posnstr * posn,int type)
{
 selsetpagesection(pagep->key,pagep->section,posn->file);
 return(type);
}





static textflowstr defflow=
{
 0,
 FRFBOTH,
 FROFRAME,
};


static os_error * pageflow(pagestr * pagep,filestr * file,
                                             objectflowstr * flow,int read)
{
 if(read)
 {
  flow->flow=defflow;
  tr_setidentity(&flow->tr);
 }

 return(NULL);

 USE(file);
 USE(pagep);
}



static os_error * pagesetflow(pagestr * pagep,sobjectstr * fix,
                                      filestr * file,int * end)
{
 os_error    * err;
 chainobject * childp;
 int           child;

 err=NULL;


 if(fix->key==pagep->key)
 {
  *end=1;
 }
 else
 {
  child=pagep->chain.child;
  while(child)
  {
   childp=(chainobject*)fob_find(child,file);
   if(childp)
   {
    child=childp->chain.next;
    err=objectsetflow((objhdrstr*)childp,(objhdrstr*)fix,file,end);
    if(err) break;
    if(*end) break;
   }
   else break;
  }
 }

 return(err);
}




/*****************************************************************************/

#define DSTPAGE             0x481
#define DSTMPAGE            0x482


/* {masterpage}  */

static os_error * dsmpage(int fp,int argc,objectloc * loc)
{
 os_error       * err;
 filestr        * file;
 dsobjectstr    * ds;
 int              mpage;
 int              msection;
 int              dsection;
 sectionstr     * sectionp;
 int              n;
 newpagestr       newpage;
 dsobjectstr    * ds1;
 int              nsp;
 int              sp;
 colourvalue      cv;


 err=NULL;


 file=loc->file;

 msection=loc->section;

 sectionp=(sectionstr*)fob_find(msection,file);
 dsection=sectionp->dual;

 newpage.data=sectionp->data;
 mpage=sectionp->chain.child;

 if(mpage) n=1;    /* use as dble flag too */
 else      n=0;

 cv=sectionp->data.colour[n];

 sp=fp+2;

 while(argc--)
 {
  ds=(dsobjectstr*)(dsstack+sp);
  nsp=sp+ds->len/sizeof(int);
  ds1=(dsobjectstr*)(dsstack+sp+2);

  switch(ds->type)
  {
   case DSTCOLOURVALUE:
                       cv.data.tint.key=ds1->data.integer;
                       ds1=(dsobjectstr*)(dsstack+sp+2+3);
                       cv.data.tint.tint=ds1->data.integer;
                       if(nsp>(sp+2+6))
                       {
                        ds1=(dsobjectstr*)(dsstack+sp+2+6);
                        cv.data.tint.overprint=ds1->data.integer;
                       }
                       break;
  }
  sp=nsp;
 }


 newpage.pagenumber=n;

 err=objectnew(loc,OPAGE,&newpage);

// cprintf("new mst page %d",loc->page);

 if(mpage) 
 {
  insafter(loc->object,mpage,0,0,file);
 }

 loc->page=loc->object;
 loc->parent=loc->object;
 loc->after=0;

 fob_mod(msection,file,(fobjptr)&sectionp);
 sectionp->np++;
 sectionp->data.colour[n]=cv;
 sectionp->data.dble=n;
 if(!mpage) sectionp->chain.child=loc->page;

 fob_mod(dsection,file,(fobjptr)&sectionp);
 sectionp->data.colour[n]=cv;
 sectionp->data.dble=n;

 file->hdr.np[MST]++;


 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.integer=loc->page;
 ds->len=3*sizeof(int);

 return(err);
}




/* {page} == catpage but don't copy master page frames */

static os_error * dspage(int fp,int argc,objectloc * loc)
{
 os_error    * err;
 filestr     * file;
 dsobjectstr * ds;
 int           dpage;
 int           dsection;
 sectionstr  * sectionp;
 pagestr     * pagep;
 int           n;
 newpagestr    newpage;


 err=NULL;

 file=loc->file;

 dsection=loc->section;

 sectionp=(sectionstr*)fob_find(dsection,file);

 newpage.data=sectionp->data;

 if(sectionp->branch)
 {
  loc->branch=0;
  loc->section=dsection=sectionp->dual;
  sectionp=(sectionstr*)fob_find(dsection,file);
  dpage=0;
 }
 else
 {
  dpage=loc->page;
 }

 if(dpage)
 {
  pagep=(pagestr*)fob_find(dpage,file);
  n=pagep->data.number+1;
 }
 else
 {
  n=sectionp->data.pagenumber.number;
 }

 newpage.pagenumber=n;

 err=objectnew(loc,OPAGE,&newpage);

// cprintf("new doc page %d",loc->page);

 if(dpage)
 {
  insafter(loc->object,dpage,0,0,file);
 }
 else
 {
  sectionp=(sectionstr*)fob_find(dsection,file);
  sectionp->chain.child=loc->object;
 }

 loc->page=loc->object;
 loc->parent=loc->object;
 loc->after=0;

 sectionp=(sectionstr*)fob_find(dsection,file);
 sectionp->np++;

 file->hdr.np[DOC]++;

 ds=(dsobjectstr*)(dsstack+fp);
 ds->data.integer=loc->page;
 ds->len=3*sizeof(int);

 return(err);

 USE(fp);
 USE(argc);
}




static os_error * dsmessage(pagestr * pagep,int * message,
                                                  filestr * file,buffer * bf)
{
 os_error   * err;
 int          page;
 int          child;
 int          gchild;
 sectionstr * sectionp;
 colourvalue  cv;

 page=pagep->key;
 child=pagep->chain.child;
 gchild=pagep->gchain.child;

 if(pagep->branch)
 {
  sectionp=(sectionstr*)fob_find(pagep->section,file);

  if(!pagep->chain.prev) cv=sectionp->data.colour[0];
  else                   cv=sectionp->data.colour[1];

  err=bf_printfeoln(bf,2,"PAGE_%02x={masterpage %s}",page,dscvstring(&cv,file));
 }
 else
 {
  err=bf_printfeoln(bf,2,"PAGE_%02x={page}",page);
 }

          err=objectchainmessage(gchild,file,message,bf);
 if(!err) err=objectchainmessage(child,file,message,bf);

 return(err);
}



static void dsname(pagestr * pagep,char * data)
{
 sprintf(data,"PAGE_%02x",pagep->key);
}



static int dszerolist[]={
                         DSTENDLIST
                        };





static dscreator dsdefs[]=
{
 0,0,0,0, "page",       dspage,    0, DSTPAGE,      dszerolist,
 0,0,0,0, "masterpage", dsmpage,   0, DSTMPAGE,     dszerolist,
};



static void pagesize(pagestr * pagep,sectiondatastr * data)
{
 pagep->box.w=data->width;
 pagep->box.h=data->height;
}



static os_error * message(pagestr * page,filestr * file,
                                                   int * message,void * data)

{
 os_error * err;
 snapfn     snapbox;
 int        gchild;

 switch(*message)
 {
  case        OM_DSSAVE:
                        return(dsmessage(page,message,file,(buffer*)data));
                        break;

  case        OM_DSNAME:
                        dsname(page,(char*)data);
                        break;

   case      OM_SNAPBOX:
                        snapbox=((snapfn)data);
                        snapbox(page->key,NULL,&page->box);
                        break;


  case      OM_PAGESIZE:
                        pagesize(page,(sectiondatastr*)data);
                        break;
                   
                default:
                        break;
 }

 gchild=page->gchain.child;

          err=objectchainmessage(page->chain.child,file,message,data);
 if(!err) err=objectchainmessage(gchild,file,message,data);

 return(err);
}







static objectstr pageobject=
{
 OPAGE,                           /* type */
 (objectnewfn)newpage,            /* new  */
 (objectcopyfn)copypage,          /* copy */
 (objectredrawfn)redrawpage,      /* redraw */
 NULL,                            /* create */
 (objectfindfn)findpage,          /* find   */ 
 (objectselectfn)selectpage,      /* select */
 NULL,                            /* transform */
 NULL,                            /* load type */
 NULL,                            /* load */
 NULL,                            /* load post */
 (objectmessagefn)message,        /* message */
 NULL,                            /* object db's */
 (objectflowfn)pageflow,          /* text flow       */
 NULL,                            /* delete          */
 NULL,                            /* text reflow     */
 (objectsetflowfn)pagesetflow,    /* object set flow */
 NULL,                            /* master object?  */
 NULL,                            /* local object    */
 NULL,                            /* x9 */
 NULL,                            /* x10 */
 NULL,                            /* x12 */

};





os_error * pageinit(void)
{
 dsaddblock(dsdefs,sizeof(dsdefs)/sizeof(dscreator));
 return(objectregister(&pageobject));
}


