t/*->c.tools */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "akbd.h"
#include "transform.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "temp.h"
#include "sp.h"
#include "trans.h"
#include "xmath.h"
#include "colour.h"
#include "key.h"
#include "drag.h"
#include "alloc.h"
#include "dbhi.h"
#include "pane.h"
#include "xhelp.h"
#include "fsx.h"
#include "bf.h"
#include "deb.h"
#include "osunits.h"
#include "tooltips.h"


#include "etc.h"

#include "str.h"
#include "constants.h"

#include "reslink.h"
#include "file.h"
#include "page.h"
#include "undo.h"

#include "viewo.h"
#include "view.h"
#include "object.h"
#include "dbmore.h"

#include "posn.h"
#include "infopal.h"


#include "dbscale.h"
#include "dbchoices.h"
#include "caret.h"
#include "new.h"

#include "toolstr.h"
#include "tools.h"


#define UNTOOLSELECTS  0x9200
#define UNTOOLSELECTF  0x9201
#define UNTSAVEPOSN    0x9202
#define UNTOOLSELECTA  0x9203


/*****************************************************************************/

static toolboxstr * firstbox;
static toolstr    * tools;
static int          tooln;
static int          disptooln;
static int          toolboxsize=sizeof(toolboxstr)-sizeof(toolstatestr);
static int          maxcommon;


#define TIWIDTH  52// 56 /* 48 */ /* 64 */
#define TIHEIGHT 52//56 /* 48 */ /* 60 */
#define TIVSTEP  52//56 /* 48 */ /* 60 */
#define TIHSTEP  52//56 /* 48 */ /* 64 */

#define TIXBORDER 6//8
#define TIYBORDER 6//8


#define TOOLSXLEFT    0x7FFFFFF0
#define TOOLSXRIGHT   0x7FFFFFF1
#define TOOLSXTOP     0x7FFFFFF2
#define TOOLSXBOTTOM  0x7FFFFFF3




       int toolboxx=1;       /* no of icons across */
       int toolboxy=12;      /* no of icons down   */

       int toolboxattached;
       int toolboxoffscreen;
       int toolboxposnx;
       int toolboxposny;

/*       int toolsxshift;
       int toolsyshift;   */


static os_error * createtoolicons(toolboxstr * toolbox);
static os_error * deletetoolicons(toolboxstr * toolbox);


static fkeyfn lastkeyfn;



#define TCHUNK 16*sizeof(toolstr)

os_error * toolregister(toolstr * tool)
{
 os_error * err;

 if(tools)
 {
  err=flex_chunk((flex_ptr)&tools,(tooln+1)*sizeof(toolstr),TCHUNK);
 }
 else
 {
  err=flex_alloc((flex_ptr)&tools,TCHUNK);
 }

 if(!err)
 {
  tools[tooln]=*tool;
  if(tool->init) err=tool->init(NULL,TINITBOOT);
  if(!tool->noicon) disptooln++;
  tooln++;

  toolboxsize+=sizeof(toolstatestr)+tool->privatesize;
  maxcommon=MAX(maxcommon,tool->commonsize);
 }
 return(err);
}




static void checktooldims(int * xp,int * yp)
{
 int x;
 int y;

 x=*xp;
 y=*yp;

 while(x*y<disptooln)
 {
  if(x>y) x++;
  else    y++;
 }

/*
 while(x*y>disptooln)
 {
  if(x>y && y*(x-1)>=disptooln) x--;
  else
  if(x*(y-1)>=disptooln) y--;
  else break;
 }
*/

 *xp=x;
 *yp=y;
}




static int cmptools(const void * t1,const void * t2)
{
 return(((toolstr*)t1)->rank-((toolstr*)t2)->rank);
}



static os_error * sorttools(void)
{
 qsort(tools,tooln,sizeof(toolstr),cmptools);

 checktooldims(&toolboxx,&toolboxy);

 defviewdata.toolboxx=toolboxx;
 defviewdata.toolboxy=toolboxy;

 return(NULL);
}




static subtoolstr    * subtools;
static int             subtooln;


#define STCHUNK 4*sizeof(subtoolstr)

os_error * subtoolregister(subtoolstr * subtool)
{
 os_error * err;

 if(subtools)
 {
  err=flex_chunk((flex_ptr)&subtools,(subtooln+1)*sizeof(subtoolstr),STCHUNK);
 }
 else
 {
  err=flex_alloc((flex_ptr)&subtools,STCHUNK);
 }

 if(!err)
 {
  subtools[subtooln++]=*subtool;
  if(subtool->init) err=subtool->init(NULL,TINITBOOT);
 }

 return(err);
}


/*****************************************************************************/

static int orgx;
static int orgy;







static int tool2icon(int tool)
{
 int icon;
 int i;

 icon=0;
 for(i=0;i<tool;i++)
 {
  if(!tools[i].noicon) icon++;
 }

 return(icon);
}


static int icon2tool(int icon)
{
 int tool;
 int i;

 i=0;
 for(tool=0;tool<tooln;tool++)
 {
  if(!tools[tool].noicon)
  {
   if(i==icon) break;
   i++;
  }
 }

 return(tool);
}




/*

static void updatetoolposns(int oldx,int newx)
{
 filestr * file;
 viewstr * view;
 int       dx;

 dx=(oldx-newx)*TIHSTEP;

 file=firstfile;
 while(file)
 {
  view=file->view;
  while(view)
  {
   view->toolsxshift-=dx;
   view=view->next;
  }
  file=file->next;
 }

 toolboxposnx-=dx;
}

*/


//static void sizezero(int userhandle)

static os_error * sizezero(int handle,int userhandle,wimp_mousestr * m)
{
 os_error   * err;
 int          x;
 int          y;
 mousestr     mouse;
 wimp_wstate  wst;
 toolboxstr * toolbox;
 viewstr    * view;
 int          dx;
 int          tx;
 int          ty;

 toolbox=(toolboxstr*)userhandle;

 getpointer(&mouse);

 x=(mouse.x-orgx-2*TIXBORDER)/TIHSTEP;
 y=-((mouse.y-orgy-2*TIYBORDER)/TIVSTEP);

 if(x>0 || y>0)
 {
  if(x>y) y=(disptooln+(x-1))/x;
  else    x=(disptooln+(y-1))/y;


  view=toolbox->view;
  if(view && toolboxattached)
  {
   tx=view->data.toolboxx;
   ty=view->data.toolboxy;
  }
  else
  {
   tx=toolboxx;
   ty=toolboxy;
  }

  if(x!=tx || y!=ty)
  {
   deletetoolicons(toolbox);

   /* updatetoolposns(toolboxx,x); */

   dx=(toolboxx-x)*TIHSTEP;


   if(view && toolboxattached)
   {
    view->data.toolsxshift-=dx;
    view->data.toolboxx=x;
    view->data.toolboxy=y;
    updateviewdata(view);
   }

/*   defviewdata.toolsxshift-=dx;  */

   toolboxx=x;
   toolboxy=y;


   createtoolicons(toolbox);

   refreshwindow(toolbox->handle);
 
   err=wimp_get_wind_state(toolbox->handle,&wst);
   if(!err)
   {
    wst.o.box.y0=wst.o.box.y1-(toolboxy*TIVSTEP+2*TIYBORDER);
    wst.o.box.x1=wst.o.box.x0+(toolboxx*TIHSTEP+2*TIXBORDER);
    err=wimp_open_wind(&wst.o);
   }
  }
 }

	return(NULL);

 USE(handle);
 USE(m);
}


static os_error * dragend(int handle,int userhandle,wimp_box * box)
{
// remzeroevent(sizezero,userhandle);


 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(box);
}




static os_error * startsizedrag(toolboxstr * toolbox,wimp_mousestr * m)
{
 wimp_dragstr dblock;
 windowstr    window;
 viewstr    * view;
 int          tx;
 int          ty;

 getw(toolbox->handle,&window);

 dblock.window=toolbox->handle;
 dblock.type=wimp_USER_HIDDEN;

 view=toolbox->view;
 if(view && toolboxattached)
 {
  tx=view->data.toolboxx;
  ty=view->data.toolboxy;
 }
 else
 {
  tx=toolboxx;
  ty=toolboxy;
 }


 orgx=dblock.box.x0=window.x0;
 orgy=dblock.box.y1=window.y1;
 dblock.box.x1=dblock.box.x0+tx*TIHSTEP+2*TIXBORDER;
 dblock.box.y0=dblock.box.y1-ty*TIVSTEP-2*TIYBORDER;

 dblock.parent.x0=window.x0+TIHSTEP+2*TIXBORDER;
 dblock.parent.y1=window.y1-TIVSTEP-2*TIYBORDER;
 dblock.parent.x1=window.x0+disptooln*TIHSTEP+2*TIXBORDER;
 dblock.parent.y0=window.y1-disptooln*TIVSTEP-2*TIYBORDER;

// startdrag(toolbox->handle,(int)toolbox,dragend);
// addzeroevent(sizezero,(int)toolbox);
// problem here with a single right click producing no capture
// but zero event running

 startdrag2(toolbox->handle,(int)toolbox,dragend,sizezero);

 return(wimp_drag_box(&dblock));

 USE(m);
}



/*************************************************************************/





static int starticon;


static os_error * movedragend(int handle,int userhandle,wimp_box * box)
{
 mousestr     mouse;
 int          t1;
 int          t2;
 toolstr      t;
 toolboxstr * toolbox;
 toolstatestr s;
 filestr    * file;
 toolboxstr * tb;


// xdragaspritestop();																																													`

 toolbox=(toolboxstr*)userhandle;

 getpointer(&mouse);

 if(mouse.icon>=0)
 {
  t1=icon2tool(starticon);
  t2=icon2tool(mouse.icon);

  if(t1!=t2)
  {
   t=tools[t1];
   tools[t1]=tools[t2];
   tools[t2]=t;
   SWOP(tools[t1].rank,tools[t2].rank);

   file=firstfile;
   while(file)
   {
    tb=file->toolbox;

    s=tb->toolstate[t1];
    tb->toolstate[t1]=tb->toolstate[t2];
    tb->toolstate[t2]=s;

    if(tb->current==t1) tb->current=t2;
    else
    if(tb->current==t2) tb->current=t1;

    file=file->next;
   }

   deletetoolicons(toolbox);

   createtoolicons(toolbox);

   refreshwindow(toolbox->handle);
  }
 }

 return(NULL);

 USE(handle);
 USE(box);
}



static os_error * movetool(toolboxstr * toolbox,wimp_mousestr * m)
{
 wimp_dragstr dblock;
 windowstr    window;
 iconstr      icon;

 if(m->i>=0)
 {
  starticon=m->i;

  getw(toolbox->handle,&window);
  geti(toolbox->handle,m->i,&icon);

  dblock.window=toolbox->handle;
  dblock.type=wimp_USER_FIXED;

  dblock.box.x0=window.bx+icon.ix0;
  dblock.box.y0=window.by+icon.iy0;
  dblock.box.x1=window.bx+icon.ix1;
  dblock.box.y1=window.by+icon.iy1;

  dblock.parent.x0=window.x0;
  dblock.parent.y1=window.y1;
  dblock.parent.x1=window.x1;
  dblock.parent.y0=window.y0;

  startdrag(toolbox->handle,(int)toolbox,movedragend);
  wimp_drag_box(&dblock);
//  xdragasprite(icon2tool(starticon),&dblock);
 }

 return(NULL);
}




/* clicks on the tools pane call this fuction */


static os_error * toolclick(int handle,int userhandle,wimp_mousestr * m)
{
 os_error   * err;
 viewstr    * view;
 filestr    * file;
 toolboxstr * toolbox;
 int          n;

 err=NULL;

 view=(viewstr*)userhandle;
 file=view->file;
 toolbox=file->toolbox;

// cprintf("bbits %x %d handle %x mh %x",m->bbits,m->i,handle,m->w);

 if((m->bbits==0x4 || m->bbits==0x1) && !isshift)
 {
  n=icon2tool(m->i);
  if(tools[n].type==TRADIO) /*such tools are outside undo... */
  {
   err=toolselect(tools[n].tooln,m->bbits==1,view,file);
  }
  else
  if(n!=toolbox->current)  /* not for non pointer tools */
  {
   err=undostart(file);
   if(!err)
   {
    err=toolselect(tools[n].tooln,m->bbits==1,view,file);
    undoend(file);
   }
  }
 }
 else
 if(m->bbits==0x40)
 {
  if(isctrl) err=movetool(toolbox,m);
  else
  if(isshift || m->i==-1) err=dragawindow(m);
 }
 else
 if(m->bbits==0x10 && m->i==-1)
 {
  err=startsizedrag(toolbox,m);
 }

// cprintf("tool click x");

 return(err);

 USE(handle);
}



void picktool(int fp)
{
 os_error   * err;
 int          tooln;
 int          adjust;
 toolboxstr * toolbox;

 err=NULL;

 tooln=stack[fp];
 adjust=stack[fp+1];

 toolbox=menufile->toolbox;

 if(tooln!=tools[toolbox->current].tooln)  /* not for non pointer tools */
 {
  err=undostart(menufile);
  if(!err)
  {
   err=toolselect(tooln,adjust,menuview,menufile);
   undoend(menufile);
  }
 }

 zreport(err);
}



static os_error * toolhelp(int handle,int userhandle,int icon,char ** p)
{
 *p=helpfindtagstring(userhandle,(icon>=0)?tools[icon2tool(icon)].tooln:-1);
 return(NULL);
 USE(handle);
}


/*****************************************************************************/



os_error * checktools(viewstr * view,filestr * file)
{
 opentools(view,file);
 openinfopal(view,file);
 setactiveview(view);
 return(caretensure(view));
}




static int        tooldrag;
static int        tooldragtype;
static int        tooldragskip;


static int        ptrclaimed;
static pointstr * ptrdata;
static int        ptrtype;
static char     * ptrsprites;

static pointstr * curptrdata;
static int        curptrtype;


static int        oldx;
static int        oldy;




/* called when a tool changes pointer */

os_error * toolschangepointer2(int priority,int type,pointstr * pointdata,char * sprites)
{

 if(priority>ptrclaimed)
 {
  ptrdata=pointdata;
  ptrtype=type;
  ptrclaimed=priority;
  ptrsprites=sprites;
 }

 return(NULL);
}


os_error * toolschangepointer(int priority,int type,pointstr * pointdata)
{
 return(toolschangepointer2(priority,type,pointdata,NULL));
}


static void toolpointerstart(void)
{
 ptrclaimed=-1;
}


static void toolpointerend(int force,int * set)
{
 if(!(tooldrag & TOOLDRAGPTR))
 {
// cprintf("claimed=%d type=%d",ptrclaimed,ptrtype);

  if(ptrclaimed>=0)
  {
   if(curptrtype!=ptrtype || curptrdata!=ptrdata || force)
   {
//    cprintf("change ptr %s",ptrdata?ptrdata->name:"");

    changepointer(ptrtype,ptrdata,ptrsprites);
    curptrtype=ptrtype;
    curptrdata=ptrdata;
    if(set) *set=1;
   }
  }
 }
}



os_error * toolspointeroff(void)
{
 toolschangepointer(0,NOPOINTER,NULL);
 return(NULL);
}



static void scrappointer(void)
{
 oldx=oldy=-1;
 curptrtype=BADPOINTER;
}




/* clicks on the main window call this function */

os_error * toolsicon(viewstr * view,filestr * file,wimp_mousestr * m)
{
 os_error   * err;
 posnstr      posn;
 int          i;
 int          j;
 int          claim;
 toolboxstr * toolbox;

 err=NULL;
 claim=1;

 toolbox=file->toolbox;

// cprintf("bbits %x",m->bbits);

 if(tooldragskip && 
    (m->bbits & (VBDRAGS|VBDRAGA|VBDRAGM))) return(NULL);
 tooldragskip=0;



 if(m->bbits & (VBCLICKS|VBCLICKA|VBCLICKM)) dbstacksmash(&dbviewstack);

 if(m->bbits==VBCLICKM)
 {
  if((i=toolbox->current)>=0)
  {
   if(tools[i].menu) err=tools[i].menu(toolbox,view,file,m);
  }
 }
 else
 {
  opentools(view,file);

  initposn(&posn,view,file,m);

  err=getposn(&posn);

  if(!err && posn.valid)
  {
   toolpointerstart();

   if((i=toolbox->current)>=0)
   {
    for(j=0;j<subtooln;j++)
    {
     if(tools[i].tooln==subtools[j].tooln && subtools[j].click)
     {
      *subtools[j].pass=0;
      *subtools[j].claim=1;
      err=subtools[j].click(toolbox,&posn);
      claim=*subtools[j].claim;
      if(!claim) break;
     }
    }

    if(claim)
    {
     if(tools[i].click) err=tools[i].click(toolbox,&posn);

     for(j=0;j<subtooln;j++)
     {
      if(tools[i].tooln==subtools[j].tooln && subtools[j].click)
      {
       *subtools[j].pass=1;
       *subtools[j].claim=1;
       err=subtools[j].click(toolbox,&posn);
       claim=*subtools[j].claim;
       if(!claim) break;
      }
     }
    }
   }

   toolpointerend(0,NULL);
  }
  openinfopal(view,file);
  setactiveview(view);
 }
 return(err);
}



os_error * toolredraw(viewredrawstr * v)
{
 os_error   * err;
 int          i;
 int          j;
 int          claim;
 viewstr    * view;
 toolboxstr * toolbox;

 err=NULL;
 view=v->view;
 claim=1;
 toolbox=v->file->toolbox;


 if((i=toolbox->current)>=0)
 {
  if(!(v->onelayer && v->layer==VRTOOLS))
  {
   for(j=0;j<subtooln;j++)
   {
    if(tools[i].tooln==subtools[j].tooln && subtools[j].redraw)
    {
     *subtools[j].pass=0;
     *subtools[j].claim=1;
     err=subtools[j].redraw(toolbox,v);
     claim=*subtools[j].claim;
     if(!claim) break;
    }
   }
  }

  if(claim)
  {
   if(!(v->onelayer && v->layer==VRTOOLS2))
   {
    if(tools[i].redraw) err=tools[i].redraw(toolbox,v);
   }

   if(!(v->onelayer && v->layer==VRTOOLS))
   {
    for(j=0;j<subtooln;j++)
    {
     if(tools[i].tooln==subtools[j].tooln && subtools[j].redraw)
     {
      *subtools[j].pass=1;
      *subtools[j].claim=1;
      err=subtools[j].redraw(toolbox,v);
      claim=*subtools[j].claim;
      if(!claim) break;
     }
    }
   }
  }
 }

 return(err);
}




static os_error * changeicon(toolboxstr * toolbox,int tool,int select)
{
 int icon;

 if(toolbox->handle)
 {
  if(!tools[tool].noicon)
  {
   icon=tool2icon(tool);
   selectst(toolbox->handle,icon,select);
  }
 }

 return(NULL);
}



int toolcurrent(filestr  * file)
{
 toolboxstr * toolbox;

 toolbox=file->toolbox;

 return(tools[toolbox->current].tooln);
}


void toolrecord(filestr  * file,toolrecordstr ** record) 
{
 toolboxstr * toolbox;

 toolbox=file->toolbox;
 *record=&toolbox->record;
}



int toolindex(int toolkey)
{
 int i;

 for(i=0;i<tooln;i++)
 {
  if(tools[i].tooln==toolkey) return(i);
 }

 return(-1);
}





static os_error * toolselectsub(viewstr * view,int i,int pass,
                                                     int * claim,int select)
{
 os_error * err;
 int        j;
 filestr  * file;

 err=NULL;

 *claim=1;

 file=view->file;

 for(j=0;j<subtooln;j++)
 {
  if(tools[i].tooln==subtools[j].tooln && subtools[j].select)
  {
   *subtools[j].pass=pass;
   *subtools[j].claim=1;
   err=subtools[j].select(file->toolbox,view,file,select);
   *claim=*subtools[j].claim;
   if(!(*claim)) break;
  }
 }

 return(err);
}




static os_error * toolselecti(int n,viewstr * view,filestr * file,
                                                toolrecordstr * record)
{
 os_error   * err;
 int          i;
 toolboxstr * toolbox;
 int          claim;

 err=NULL;

 toolbox=file->toolbox;

 lastkeyfn=NULL;
 oldx=oldy=-1;

 if(tools[n].type==TPOINTER)
 {
  if((i=toolbox->current)>=0)
  {
   err=toolselectsub(view,i,0,&claim,0);
   if(claim)
   {
    if(tools[i].select) err=tools[i].select(toolbox,view,file,0);
    if(!err)            err=toolselectsub(view,i,1,&claim,0);
   }
   if(!err)
   {
    changeicon(toolbox,i,0);
    toolbox->toolstate[i].selected=0;
   }
  }

  undowritefn(file,UNTOOLSELECTA,&toolbox->record,sizeof(toolrecordstr));
  toolbox->current=n;
  toolbox->record=*record;

  err=toolselectsub(view,n,0,&claim,1);
  if(claim)
  {
   if(tools[n].select) err=tools[n].select(toolbox,view,file,1);
   if(!err)            err=toolselectsub(view,n,1,&claim,1);
  }

  if(!err)
  {
   changeicon(toolbox,n,1);
   toolbox->toolstate[n].selected=1;
  }
 }
 else /* its a different type of tool */
 if(tools[n].type==TRADIO)
 {
  if(!toolbox->toolstate[n].selected)
  {
   for(i=0;i<tooln;i++)
   {
    if(tools[i].type==TRADIO && tools[i].group==tools[n].group)
    {
     if(tools[i].select && toolbox->toolstate[i].selected)
     {
      err=tools[i].select(toolbox,view,file,0);
      changeicon(toolbox,i,0);
      toolbox->toolstate[i].selected=0;
     }
    }
   }
   toolbox->toolstate[n].selected=1;
   if(tools[n].select) err=tools[n].select(toolbox,view,file,1);
   changeicon(toolbox,n,1);
  }
 }

 return(err);
}





static os_error * toolmessagesub(filestr * file,int i,int pass,
                                       int * claim,int message,void * data)
{
 os_error * err;
 int        j;

 err=NULL;

 *claim=1;

 for(j=0;j<subtooln;j++)
 {
  if(tools[i].tooln==subtools[j].tooln && subtools[j].message)
  {
   *subtools[j].pass=pass;
   *subtools[j].claim=1;
   err=subtools[j].message(file->toolbox,file,message,data);
   *claim=*subtools[j].claim;
   if(!(*claim)) break;
  }
 }

 return(err);
}




os_error * toolmessage(filestr * file,int message,void * data)
{
 os_error   * err;
 int          i;
 toolboxstr * toolbox;
 int          claim;

 err=NULL;

 toolbox=file->toolbox;

 if((i=toolbox->current)>=0)
 {
  err=toolmessagesub(file,i,0,&claim,message,data);
  if(claim)
  {
   if(tools[i].message) err=tools[i].message(toolbox,file,message,data);
   if(!err)             err=toolmessagesub(file,i,1,&claim,message,data);
  }
 }

 return(err);
}




static int nexttooln;

int nexttool(void)
{
 return(nexttooln);
}


static int lasttooln;

int lasttool(void)
{
 return(lasttooln);
}



/* Beware! This code is rentered from frametool in a way which should */
/* not be in the undo loop                                            */

static os_error * toolselects(toolrecordstr * record,
                              viewstr * view,filestr * file)
{
 os_error   * err;
 int          n;
 toolboxstr * toolbox;

 toolbox=file->toolbox;

 for(n=0;n<tooln;n++)
 {
  if(tools[n].tooln==record->toolkey)
  {
   lasttooln=tools[toolbox->current].tooln;
   nexttooln=record->toolkey;
   err=toolselecti(n,view,file,record);
   nexttooln=0;
   lasttooln=0;
   return(err);
  }
 }

 return(NULL);
}


/* there is a problem, if a tool is selected twice, the previous tool */
/* will be itself...                                                  */

/* Beware! This code is rentered from frametool in a way which should */
/* not be in the undo loop                                            */

os_error * toolselect(int tkey,int adjust,viewstr * view,filestr * file)
{
 toolrecordstr   tn;
 toolrecordstr   xnew;
 toolboxstr    * toolbox;

 toolbox=file->toolbox;

 tn=toolbox->record;
 xnew.prevadjust=tn.adjust;
 xnew.prevtoolkey=tn.toolkey;
 xnew.adjust=adjust;
 xnew.toolkey=tkey;

/* undowritefn(file,UNTOOLSELECTS,NULL,0); */
 toolselects(&xnew,view,file);
/* undowritefn(file,UNTOOLSELECTF,&tn,sizeof(toolrecordstr)); */

 return(NULL);
}



#ifdef NEVER

static toolrecordstr xtn;
static toolrecordstr ntn;


/* tagged to UNTOOLSELECTS */
/* this function is always called last in undo/redo */

static os_error * untoolselects(filestr * file)
{
 return(undowritefn(file,UNTOOLSELECTF,&xtn,sizeof(toolrecordstr)));
}



/* tagged to UNTOOLSELECTF */
/* this function is always called first in undo/redo */

static os_error * untoolselectf(filestr * file)
{
 toolboxstr    * toolbox;

 toolbox=file->toolbox;

 xtn=toolbox->record;

 undoread(file,&ntn,sizeof(toolrecordstr));

 return(undowritefn(file,UNTOOLSELECTS,NULL,0));
}



#endif





/* tagged to UNTOOLSELECTA */
/* this function is always called first in undo/redo */

static os_error * untoolselecta(filestr * file)
{
 toolboxstr    * toolbox;
 toolrecordstr   tn;

 toolbox=file->toolbox;

 undoread(file,&tn,sizeof(toolrecordstr));

 return(toolselects(&tn,toolbox->view,file));
}







/* called first when file is reloaded */

static os_error * tunsaveposn(filestr * file)
{
 toolrecordstr tn;
 undoread(file,&tn,sizeof(toolrecordstr));
 return(toolselects(&tn,file->view,file));
}


/* called just before file is saved */

os_error * toolsaveposn(filestr *  file)
{
 os_error       * err;
 toolrecordstr    tn;
 toolboxstr     * toolbox;

 toolbox=file->toolbox;

 err=toolmessage(file,TSAVEPOSN,NULL);

 tn=toolbox->record;

 undowritefn(file,UNTSAVEPOSN,&tn,sizeof(toolrecordstr));

 return(err);
}



os_error * toolactivepoint(filestr * file,toolactstr * act)
{
 return(toolmessage(file,TACTPOINT,act));
}



os_error * toolclaimsubtool(filestr * file,int type)
{
 return(toolmessage(file,TCLAIMSUB,(void*)type));
}


os_error * toolnudgekey(int * key)
{
 int      ch;
 int      dx;
 int      dy;
 mousestr mouse;

 ch=*key;
 dx=dy=0;

 switch(ch)
 {
  case  CLEFT:
              dx=-1;
              break;

  case CRIGHT:
              dx=1;
              break;

  case    CUP:
              dy=-1;
              break;

  case  CDOWN:
              dy=1;
              break;

      default:
              return(NULL);
 }

 *key=-1;

 getpointer(&mouse);

 mouse.x=xcoordos2pix(mouse.x);
 mouse.y=ycoordos2pix(mouse.y);
 mouse.x+=dx;
 mouse.y+=dy;
 mouse.x=xcoordpix2os(mouse.x);
 mouse.y=ycoordpix2os(mouse.y);

 return(setmouse(mouse.x,mouse.y));
}





static int tdxps;
static int tdxpe;
static int tdyps;
static int tdype;


static int ostdxps;
static int ostdxpe;
static int ostdyps;
static int ostdype;


static os_error * startpagedrag(viewstr * view)
{
 int x0;
 int x1;
 int y0;
 int y1;

 ostdxps=x0=view->mainwindow.bx+osunits(tdxps,view);//mainpane
 ostdxpe=x1=view->mainwindow.bx+osunits(tdxpe,view);
 ostdype=y0=view->mainwindow.by-osunits(tdype,view);
 ostdyps=y1=view->mainwindow.by-osunits(tdyps,view);

 x0=MAX(x0,(view->mainwindow.x0+view->left));
 x1=MIN(x1,view->mainwindow.x1);
 y0=MAX(y0,view->mainwindow.y0);
 y1=MIN(y1,view->mainwindow.y1);

 return(userdrag(view->handle,x0,y0,x1,y1));//mainpane
}




/*
#define ASZONE  8
#define ASRANGE 16
#define ASSPLIT 12
#define ASMAG   1
*/


#define ASZ 0x2000
#define AS0 0x1000
#define AS1 0x4000
#define AS2 0x8000


static int asz=ASZ;
static int as0=AS0;
static int as1=AS1;
static int as2=AS2;



void autoscrollparams(int fp)
{
 asz=stack[fp];
 as0=stack[fp+1];
 as1=stack[fp+2];
 as2=stack[fp+3];
}


static int autoscrollx(viewstr * view,wimp_mousestr * m)
{
 windowstr window;
 int       width;
 int       height;
 int       xshift;
 int       yshift;
 int       mag;

 window=view->mainwindow; //mainpane

 window.x0+=view->left;
 window.y1-=view->top;
 window.x1-=view->right;
 window.y0+=view->bottom;

 width=scale(window.x1-window.x0,asz,0x10000);
 height=scale(window.y1-window.y0,asz,0x10000);

 xshift=yshift=0;

// cprintf("m->x %d window.x0 %d",m->x,window.x0);

 if(m->x<(window.x0+width))
 {
  xshift=(m->x-(window.x0+width));  /* 0..-width */
 }

 if(m->x>(window.x1-width))         /* 0..width */
 {
  xshift=(m->x-(window.x1-width));
 }

 if(xshift && width)
 {
/*  mag=(ABS(xshift)*ASRANGE)/width;
  if(mag<ASSPLIT) xshift=xshift/(ASSPLIT-mag);
  else            xshift=xshift*(1+ASMAG*(mag-ASSPLIT)); */

  mag=scale(0x10000,ABS(xshift),width);

  mag=as0+scale(as1,mag,0x10000)+
          scale(as2,scale(mag,mag,0x10000),0x10000);

  xshift=scale(xshift,mag,0x10000);
 }


 if(tooldragtype==TOOLDRAGPAGE)
 {
  if(xshift<0)
  {
   if(ostdxps>(window.x0+xshift)) xshift=ostdxps-window.x0;
   if(xshift>0) xshift=0;
  }


  if(xshift>0)
  {
   if(ostdxpe<(window.x1+xshift)) xshift=ostdxpe-window.x1;
   if(xshift<0) xshift=0;
  }
 }


 if(m->y<(window.y0+height))
 {
  yshift=(m->y-(window.y0+height));
 }

 if(m->y>(window.y1-height))
 {
  yshift=(m->y-(window.y1-height));
 }

 if(yshift && height)
 {
/*  mag=(ABS(yshift)*ASRANGE)/height;
  if(mag<ASSPLIT) yshift=yshift/(ASSPLIT-mag);
  else            yshift=yshift*(1+ASMAG*(mag-ASSPLIT)); */

  mag=scale(0x10000,ABS(yshift),height);

  mag=as0+scale(as1,mag,0x10000)+scale(as2,scale(mag,mag,0x10000),0x10000);

  yshift=scale(yshift,mag,0x10000);
 }


 if(tooldragtype==TOOLDRAGPAGE)
 {
  if(yshift>0)
  {
   if(ostdyps<(window.y1+yshift)) yshift=ostdyps-window.y1;
   if(yshift<0) yshift=0;
  }

  if(yshift<0)
  {
   if(ostdype>(window.y0+yshift)) yshift=ostdype-window.y0;
   if(yshift>0) yshift=0;
  }
 }


 if(ABS(xshift)<cvdu.extrax) xshift=0;
 if(ABS(yshift)<cvdu.extray) yshift=0;

 if(tooldrag & TOOLHLOCK) xshift=0;
 if(tooldrag & TOOLVLOCK) yshift=0;



// cprintf("xshift %d",xshift);

 if(xshift || yshift) 
 {
  viewopenshift(view,xshift,yshift);

  return((window.scx-view->mainwindow.scx) || (window.scy-view->mainwindow.scy));//mainpane
 }
 else return(0);
}



int autoscroll(viewstr * view,wimp_mousestr * m)
{
 int code;
 tooldrag=tooldragtype=TOOLDRAGWINDOW;
 code=autoscrollx(view,m);
 tooldrag=tooldragtype=0;
 return(code);
}



/* if you move the pointer at the instant a drag ends, you can */
/* get it out of the window and not generate and enter events  */

#ifdef NEVER

static viewstr * dodragendcheck;

static int dragendcheck(int handle,int icon,viewstr * view)
{
 wimp_eventstr ev;

 /* this is not foolproof - pointer can still escape */
 /* probably should check pixel boundaries           */
 /* should probably do this on mode changes too      */

 if(dodragendcheck==view)
 {
  dodragendcheck=NULL;

  if(handle!=view->handle || icon<-1)
  {
   ev.e=wimp_EPTRLEAVE;
   ev.data.o.w=view->handle;
   pollfake(&ev);

   if(icon>=-1)
   {
    ev.e=wimp_EPTRENTER;
    ev.data.o.w=handle;
    pollfake(&ev);
   }

   return(1);
  }
 }

 return(0);
}


#endif


static viewstr * nosnapview;
static viewstr * scrollview;

static void scrollzero(int userhandle);

/* while we have the pointer in a window, or we are hold of it */
/* call a zero poll function                                   */

#define MINTIME 8

static os_error * pointerzero(int userhandle,wimp_mousestr * mstr)
{
 os_error    * err;
 posnstr       posn;
 viewstr     * sview;
 viewstr     * dview;
 filestr     * sfile;
 int           move;
 int           scroll;
 int           i;
 int           claim;
 int           j;
 toolboxstr  * toolbox;
 viewstr     * xnosnapview;


 err=NULL;

 claim=1;

 xnosnapview=nosnapview;
 nosnapview=NULL;

 sview=dview=(viewstr*)userhandle;

 scrollview=NULL;

// if(dragendcheck(mstr->w,mstr->i,sview)) return(NULL);

 if(tooldragtype==TOOLDRAGTRANSFER)
 {
  dview=findview(mstr->w);
  if(!dview) return(NULL);
 }

 if(dview==xnosnapview) dview->nosnap=1;

 sfile=sview->file;
 toolbox=sfile->toolbox;

 posn.mousex=mstr->x;
 posn.mousey=mstr->y;
 posn.buttons=mstr->bbits;
 posn.view=dview;
 posn.file=dview->file;

 if(tooldrag && !(tooldrag & TOOLDRAGNS)) scroll=autoscrollx(dview,mstr);
 else                                     scroll=0;

 if(scroll)
 {
  scrollview=(viewstr*)userhandle;
  addscheduledevent((zerofn)scrollzero,(int)scrollview,MINTIME);
 }


 if(scroll && tooldragtype==TOOLDRAGPAGE)
 {
  err=startpagedrag(dview);
 }


 err=getposn(&posn);
 if(!err && posn.valid)
 {
  move=(oldx!=posn.mousex) || (oldy!=posn.mousey) || scroll;
  toolpointerstart();

  if((i=toolbox->current)>=0)
  {
   for(j=0;j<subtooln;j++)
   {
    if(tools[i].tooln==subtools[j].tooln && subtools[j].move)
    {
     *subtools[j].pass=0;
     *subtools[j].claim=1;
     err=subtools[j].move(toolbox,&posn,move);
     claim=*subtools[j].claim;
     if(!claim) break;
    }
   }

   if(claim)
   {
    if(tools[i].move)
    {
     err=tools[i].move(toolbox,&posn,move);
    }

    for(j=0;j<subtooln;j++)
    {
     if(tools[i].tooln==subtools[j].tooln && subtools[j].move)
     {
      *subtools[j].pass=1;
      *subtools[j].claim=1;
      err=subtools[j].move(toolbox,&posn,move);
      claim=*subtools[j].claim;
      if(!claim) break;
     }
    }
   }
  }

  if(move)
  {
   oldx=posn.mousex;
   oldy=posn.mousey;
  }

  toolpointerend(0,NULL);
 }

 dview->nosnap=0;

 return(err);
}


static void scrollzero(int userhandle)
{
 wimp_mousestr m;

 wimp_get_point_info(&m);

 scrollview=NULL;
 pointerzero(userhandle,&m);
}



os_error * toolmousemove(int handle,int userhandle,wimp_mousestr * mz)
{
 os_error * err;


 err=NULL;

// cprintf("toolmousemove");


 if(scrollview)
 {
  remscheduledevent((zerofn)scrollzero,(int)scrollview);
  scrollview=NULL;
 }
 err=pointerzero(userhandle,mz);

 return(err);
 USE(handle);
}








/* there is a catch here. whilst a drag is going on we may get lose/gain */
/* pointer events. if we reset the pointer to the system pointer,        */
/* we will reset the drag box and lose the pointer                       */



static  os_error * toolsenddrag(int handle,int userhandle,wimp_box * box)
{
 os_error    * err;
 posnstr       posn;
 int           i;
 wimp_mousestr m;
 viewstr     * sview;
 viewstr     * dview;
 filestr     * sfile;
 int           j;
 int           claim;
 toolboxstr  * toolbox;


 claim=1;

 err=wimp_get_point_info(&m);

 sview=dview=(viewstr *)userhandle;

 if(tooldragtype==TOOLDRAGTRANSFER)
 {
  dview=findview(m.w);
 }
                  /* interestingly enough we don't know the view here */

 sfile=sview->file;
 toolbox=sfile->toolbox;

 tooldrag=tooldragtype=0;

 posn.mousex=m.x;
 posn.mousey=m.y;
 posn.buttons=m.bbits;

 if(dview)
 {
  posn.view=dview;
  posn.file=dview->file;
  err=getposn(&posn);
 }
 else
 {
  posn.valid=0;
 }

 if(!err)
 {
  if((i=toolbox->current)>=0)
  {
   for(j=0;j<subtooln;j++)
   {
    if(tools[i].tooln==subtools[j].tooln && subtools[j].dragend)
    {
     *subtools[j].pass=0;
     *subtools[j].claim=1;
     err=subtools[j].dragend(toolbox,&posn,box);
     claim=*subtools[j].claim;

     if(!claim) break;
    }
   }

   if(claim)
   {
    if(tools[i].dragend) err=erroradd(err,tools[i].dragend(toolbox,&posn,box));

    for(j=0;j<subtooln;j++)
    {
     if(tools[i].tooln==subtools[j].tooln && subtools[j].dragend)
     {
      *subtools[j].pass=1;
      *subtools[j].claim=1;
      err=erroradd(err,subtools[j].dragend(toolbox,&posn,box));
      claim=*subtools[j].claim;
      if(!claim) break;
     }
    }
   }
  }
 }

// dodragendcheck=sview;

 return(err);
 USE(handle);
}



static os_error * toolmode(wimp_msgstr * msg,int * ack)
{
 scrappointer();

 return(NULL);
 USE(msg);
 USE(ack);
}





/* it matters which view the drag starts in */

os_error * toolsstartdrag(posnstr * posn,int flags)
{
 os_error       * err;
 viewstr        * view;
// wimp_eventstr    ev;

 view=posn->view;

/*
 if(flags & TOOLFORCE)
 {
  if(ourwindow!=view->handle)
  {
   ev.e=wimp_EPTRENTER;
   ev.data.o.w=view->handle;
//   pollfake(&ev);
  }
 }
*/

// cprintf("toolsstart drag");

 if(flags & TOOLDRAGPTR) toolpointerend(1,NULL);

 tooldrag=flags;

 err=startdrag2(view->handle,(int)view,toolsenddrag,toolmousemove);//mainpane

 tooldragtype=tooldrag & TOOLDRAGTYPE;

 if(tooldragtype==TOOLDRAGTRANSFER || tooldragtype==TOOLDRAGSCREEN)
 {
  userdrag(view->handle,0,0,cvdu.screenx,cvdu.screeny);//mainpane
 }
 else
 if(tooldragtype==TOOLDRAGWINDOW)
 {
  userdrag(view->handle,view->mainwindow.x0+view->left,
                        view->mainwindow.y0,
                        view->mainwindow.x1,
                        view->mainwindow.y1); //mainpane
 }
 else
 if(tooldragtype==TOOLDRAGPAGE)
 {
  tdxps=posn->xps;
  tdxpe=posn->xpe;
  tdyps=posn->yps;
  tdype=posn->ype;

  err=startpagedrag(view);
 }

 return(err);
}


os_error * toolsstopdrag(void)
{
 dragstop();
 tooldrag=tooldragtype=0;
 tooldragskip=1;
 return(NULL);
}





static os_error * toolptrsub(viewstr * view,int i,int pass,int * claim,posnstr * posn)
{
 os_error * err;
 int        j;
 filestr  * file;

 err=NULL;

 *claim=1;

 file=view->file;

 for(j=0;j<subtooln;j++)
 {
  if(tools[i].tooln==subtools[j].tooln && subtools[j].pointer)
  {
   *subtools[j].pass=pass;
   *subtools[j].claim=1;
   err=subtools[j].pointer(file->toolbox,posn);
   *claim=*subtools[j].claim;
   if(!(*claim)) break;
  }
 }

 return(err);
}



/* On Windows called when cursor should be set                    */
/* don't want this going on in tooldrag                           */
/* called with leave when drag starts and with enter when it ends */


os_error * toolsetcursor(int handle,int userhandle,wimp_mousestr * m,int * set)
{
 os_error      * err;
 viewstr       * view;
 filestr       * file;
 int             i;
 posnstr         posn;
 toolboxstr    * toolbox;
 int             claim;


 err=NULL;


 if(!(tooldrag & TOOLDRAGPTR))
 {
  view=(viewstr*)userhandle;
  file=view->file;
  toolbox=file->toolbox;

  if(m->w==view->handle)
  {
   posn.mousex=m->x;
   posn.mousey=m->y;
   posn.buttons=m->bbits;
   posn.view=view;
   posn.file=file;

   err=getposn(&posn);

   if(!err)
   {
    toolpointerstart();

    if((i=toolbox->current)>=0)
    {
     toolptrsub(view,i,0,&claim,&posn);
     if(claim)
     {
      if(tools[i].pointer) err=tools[i].pointer(toolbox,&posn);
      if(!err) err=toolptrsub(view,i,1,&claim,&posn);
     }
    }

    toolpointerend(1,set);
   }
  } 
 }

 return(err);
 USE(handle);
}










static os_error * toolcancel(viewstr * view,filestr * file,int * claimp)
{
 os_error   * err;
 int          i;
 int          j;
 toolboxstr * toolbox;
 int          claim;

 err=NULL;
 claim=1;

 toolbox=file->toolbox;

 if((i=toolbox->current)>=0)
 {
  for(j=0;j<subtooln;j++)
  {
   if(tools[i].tooln==subtools[j].tooln && subtools[j].cancel)
   {
    *subtools[j].pass=0;
    *subtools[j].claim=1;
    err=subtools[j].cancel(toolbox,view,file);
    claim=*subtools[j].claim;
    if(!claim) break;
   }
  }

  if(claim)
  {
   if(tools[i].cancel) err=tools[i].cancel(toolbox,view,file);

   for(j=0;j<subtooln;j++)
   {
    if(tools[i].tooln==subtools[j].tooln && subtools[j].cancel)
    {
     *subtools[j].pass=1;
     *subtools[j].claim=1;
     err=subtools[j].cancel(toolbox,view,file);
     claim=*subtools[j].claim;
     if(!claim) break;
    }
   }
  }
 }

 *claimp=claim;

 return(err);
}





os_error * toolkey(int * key)
{
 os_error   * err;
 int          i;
 int          j;
 int          claim;
 toolboxstr * toolbox;


 err=NULL;

 if(menufile)
 {
  claim=1;

  toolbox=menufile->toolbox;

  toolpointerstart();

  if(*key!=-1)
  {
   if(tooldrag & TOOLDRAGKN)
   {
    toolnudgekey(key);
    if(*key==-1) nosnapview=menuview;
   }
  }
  
  if(lastkeyfn) err=lastkeyfn(key);

  if(*key!=-1 && !err)
  {
   if((i=toolbox->current)>=0)
   {
    for(j=0;j<subtooln;j++)
    {
     if(tools[i].tooln==subtools[j].tooln && subtools[j].key)
     {
      *subtools[j].pass=0;
      *subtools[j].claim=1;
      err=subtools[j].key(toolbox,key,&lastkeyfn);
      claim=*subtools[j].claim;
      if(!claim) break;
      if(*key==-1) break;
      if(err) break;
     }
    }

    if(claim && *key!=-1 && !err)
    {
     if(tools[i].key) err=tools[i].key(toolbox,key,&lastkeyfn);
   
     if(*key!=-1 && !err)
     {
      for(j=0;j<subtooln;j++)
      {
       if(tools[i].tooln==subtools[j].tooln && subtools[j].key)
       {
        *subtools[j].pass=1;
        *subtools[j].claim=1;
        err=subtools[j].key(toolbox,key,&lastkeyfn);
        claim=*subtools[j].claim;
        if(!claim) break;
       }
      }
     }
    }
   }
  }


  if(*key!=-1 && !err)
  {
   err=viewkey(key);
   if(*key==-1) lastkeyfn=viewkey;
  }

  if(*key!=-1 && !err)
  {
   if(*key==ESCAPE)
   {
    *key=-1;
    toolcancel(menuview,menufile,&claim);
    lastkeyfn=NULL;
    if(claim)
    {
     if(menuview->info && menuview->data.infopal)
     {
      int handle;

      getactive(&handle);
      setactive(handle==menuview->handle?menuview->info:menuview->handle);
     }
    }
   }
  }

  toolpointerend(0,NULL);
 }

 return(err);
}





os_error * toolcaret(viewstr * view,int gain)
{
 os_error   * err;
 int          i;
 int          j;
 int          claim;
 toolboxstr * toolbox;
 filestr    * file;


 err=NULL;
 claim=1;
 file=view->file;
 toolbox=file->toolbox;

 lastkeyfn=NULL;

 if((i=toolbox->current)>=0)
 {
  for(j=0;j<subtooln;j++)
  {
   if(tools[i].tooln==subtools[j].tooln && subtools[j].caret)
   {
    *subtools[j].pass=0;
    *subtools[j].claim=1;
    err=subtools[j].caret(toolbox,view,gain);
    claim=*subtools[j].claim;
    if(!claim) break;
   }
  }

  if(claim)
  {
   if(tools[i].caret) err=tools[i].caret(toolbox,view,gain);
   
   for(j=0;j<subtooln;j++)
   {
    if(tools[i].tooln==subtools[j].tooln && subtools[j].caret)
    {
     *subtools[j].pass=1;
     *subtools[j].claim=1;
     err=subtools[j].caret(toolbox,view,gain);
     claim=*subtools[j].claim;
     if(!claim) break;
    }
   }
  }
 }

 return(err);
}




/* called when a window is opened to set up tools */

os_error * addtoolstr(viewstr * view)
{
 os_error * err;

 err=NULL;

// err=addpointerevent(toolptr,view->handle,(int)view);
 view->claimedzero=0;

 checktooldims(&view->data.toolboxx,&view->data.toolboxy);

/*
 view->data.toolsxshift=toolsxshift;
 view->data.toolsyshift=toolsyshift;
 view->data.toolboxx=toolboxx;
 view->data.toolboxy=toolboxy;
*/

 return(err);
}



os_error * remtoolstr(viewstr * view)
{
 os_error * err;

 err=NULL;

 USE(view);

 return(err);
}


/* idea is to set the initial edit position            */
/* find first object in first page, and make it active */

os_error * setinittoolposn(viewstr * view)
{ 
 os_error   * err;
 filestr    * file;
 int          section;
 int          object;

 file=view->file;

 section=file->hdr.section[view->branch];

 err=getmainframe(section,file,&object);
 if(object)
 {
  err=toolmessage(file,TSELECTOBJECT,(void*)object);
 }


/*

 pagestr    * pagep;
 sectionstr * sectionp;
 int          page;

 int          xpo;
 int          ypo;
 sobjectstr * sob;
 coordstr     cx;
 wimp_mousestr m;


 sectionp=fob_find(section,file);
 page=sectionp->page;
 pagep=fob_find(page,file);
 object=pagep->chain.child;

 getpagecoords(view,page,section,&xpo,&ypo);
 sob=fob_find(object,file);
 cx.x=sob->fcurve.box.x;
 cx.y=sob->fcurve.box.y;
 tr_transformset(&cx,1,&sob->transform);

 m.x=view->window.x0+osunits(xpo+cx.x,view);
 m.y=view->window.y1-osunits(ypo+cx.y,view);
 m.w=view->handle;
 m.i=-1;
 m.bbits=VBCLICKS;

 toolsicon(view,file,&m);
*/

 return(NULL);
}



os_error * addfiletools(filestr * file)
{
 os_error   * err;
 toolboxstr * toolbox;
 int          i;
 char       * common;
 char       * hprivate;

 err=salloc((flex_ptr)&toolbox,toolboxsize+maxcommon);
 if(!err)
 {
  file->toolbox=toolbox;
  if(firstbox) firstbox->prev=toolbox;
  toolbox->next=firstbox;
  firstbox=toolbox;

  common=((char*)toolbox)+sizeof(toolboxstr)+(tooln-1)*sizeof(toolstatestr);
  hprivate=common+maxcommon;

  for(i=0;i<tooln;i++)
  {
   toolbox->toolstate[i].selected=tools[i].preselect;

   if(tools[i].preselect && tools[i].type==TPOINTER)
   {
    toolbox->current=i;
    toolbox->record.toolkey=tools[i].tooln;
   }

   toolbox->toolstate[i].common=common;
   toolbox->toolstate[i].hprivate=hprivate;
   hprivate+=tools[i].privatesize;
  }

  ipinitsubpanes(toolbox);

  for(i=0;i<tooln;i++)
  {
   if(tools[i].init) err=tools[i].init(toolbox,TINITCREATE);
  }
 }

 return(err);
}


os_error * remfiletools(filestr * file)
{
 os_error   * err;
 toolboxstr * next;
 toolboxstr * prev;
 toolboxstr * toolbox;
 int          i;

 toolbox=file->toolbox;

 for(i=0;i<tooln;i++)
 {
  if(tools[i].init) err=tools[i].init(toolbox,TINITDELETE);
 }

 next=toolbox->next;
 prev=toolbox->prev;

 if(next) next->prev=prev;
 if(prev) prev->next=next;
 if(firstbox==toolbox) firstbox=next;

 err=sfree((flex_ptr)&file->toolbox);

 return(err);
}


/****************************************************************************/

static os_error * createtoolicon(toolboxstr * toolbox,int n,int icon)
{
 os_error   * err;
 wimp_icreate wic;
 int          newicon;
 viewstr    * view;
 int          tx;
 int          ty;
 char         buffer[256];


 view=toolbox->view;
 if(view && toolboxattached)
 {
  tx=view->data.toolboxx;
  ty=view->data.toolboxy;
 }
 else
 {
  tx=toolboxx;
  ty=toolboxy;
 }


 if(tx>ty)
 {
  wic.i.box.x0=(icon % tx)*TIHSTEP+TIXBORDER;
  wic.i.box.y1=-TIVSTEP*(icon/tx)-TIYBORDER;
 }
 else
 {
  wic.i.box.x0=(icon/ty)*TIHSTEP+TIXBORDER;
  wic.i.box.y1=-TIVSTEP*(icon % ty)-TIYBORDER;
 }


 wic.w=toolbox->handle;
 wic.i.box.x1=wic.i.box.x0+TIWIDTH;

 wic.i.box.y0=wic.i.box.y1-TIHEIGHT;

#ifdef NEVER
 wic.i.flags=wimp_ISPRITE  | wimp_ITEXT | wimp_IHCENTRE | wimp_IVCENTRE | 
             wimp_INDIRECT |  /* wimp_IBORDER | */
             0x6000 | (WIMPWHITE<<28) | (WIMPBLACK<<24);

#endif

 wic.i.flags=(wimp_iconflags)0;
 if(toolbox->toolstate[n].selected) wic.i.flags=(wimp_iconflags)((int)wic.i.flags | wimp_ISELECTED);

 wic.i.data.indirecttext.buffer=buffer;
// sprintf(buffer,"\\C\\V\\KD1");
	sprintf(buffer,"\\C\\V\\s\\OS+P\\a%s\\E3\\k16\\O!S-!P\\a%s\\E2\\k33\\O1\\F\\KD1",tools[n].ticonvalid+strlen(tools[n].ticonvalid)+1,tools[n].ticonvalid);
// strcat(buffer,tools[n].ticonvalid);

 wic.i.data.indirecttext.bufflen=0;
 wic.i.data.indirecttext.validstring="abx";

 newicon=n;

 err=wimp_create_icon(&wic,&newicon);

 if(!err)
 {
		if(ihelp)
		{
   tooltipicon(toolbox->handle,newicon,tools[n].ticontip,NULL);
		}
	}


 return(err);
}



static os_error * createtoolicons(toolboxstr * toolbox)
{
 os_error * err;
 int        icon;
 int        i;
 
 err=NULL;

 icon=0;
 for(i=0;i<tooln;i++)
 {
  if(!tools[i].noicon) 
  {
   err=createtoolicon(toolbox,i,icon++);
  }
 }

 return(err);
}



static os_error * deletetoolicons(toolboxstr * toolbox)
{
 int i;

 for(i=0;i<disptooln;i++) wimp_delete_icon(toolbox->handle,i);

 return(NULL);
}


// here by accident, stops ALT+F4 closing tools?

static os_error * toolswclose(int handle,int userhandle)
{

// cprintf("toolswclose");

 return(NULL);

 USE(handle);
 USE(userhandle);
}




/* called when pane opened by wimp */

static os_error * toolswopen(int handle,int userhandle,wimp_openstr * o)
{
 os_error   * err;
 viewstr    * view;
 filestr    * file;
 windowstr    window;
 toolboxstr * toolbox;
 int          noopen;

 err=NULL;

 view=(viewstr*)userhandle;
 file=view->file;
 toolbox=file->toolbox;

 noopen=0;
 err=getw(toolbox->handle,&window);
 if(window.bhandle==-1) noopen=1;

// err=wimp_open_wind(o);

 if(!err) err=getw(toolbox->handle,&window);

 if(!err)
 {
  if(((wimp_openstr2*)o)->reason==WM_MOVE)
  {

   /* defviewdata.toolsxshift= */
   view->data.toolsxshift=window.x1-view->mainwindow.x0-view->vshift;

   /* defviewdata.toolsyshift= */
   view->data.toolsyshift=view->mainwindow.y1-window.y1;
  }

  toolboxposnx=window.x1;
  toolboxposny=window.y1;

  updateviewdata(view);

  if(!noopen) err=viewopenbehind(view,file,window.bhandle);
 }

 return(err);

 USE(o);
 USE(handle);
 USE(userhandle);
}




os_error * closetools(viewstr * view,filestr * file)
{
 os_error   * err;
 toolboxstr * toolbox;

 err=NULL;

 toolbox=file->toolbox;

 if(toolbox->handle && toolbox->view==view)
 {
 /* toolcancel(view,file); */
  if(scrollview) remscheduledevent((zerofn)scrollzero,(int)scrollview);
  scrollview=NULL;
  remclickevent(toolclick,toolbox->handle,(int)view);
  remopenevent(toolswopen,toolbox->handle,(int)view);
  remhelpevent(toolhelp,toolbox->handle,TTOOLBOX);
  remcloseevent(toolswclose,toolbox->handle,(int)view);
  err=closedown(&toolbox->handle);
  toolbox->view=NULL;
 }

 scrappointer();

 return(err);
}



static os_error * scraptoolbox(void)
{
 os_error   * err;
 toolboxstr * toolbox;
 viewstr    * view;

 err=NULL;
 
 toolbox=firstbox;
 while(toolbox)
 {
  view=toolbox->view;
  if(view)
  {
   closetools(view,view->file);
  }

  toolbox=toolbox->next;
 }

 return(err);
}



os_error * opentools(viewstr * view,filestr * file)
{
 os_error    * err;
 toolboxstr  * toolbox;
 wimp_wstate   wst;
 windowstr     window;
 int           prevpane;
 int           w;
 int           h;


 err=NULL;

 toolbox=file->toolbox;


 if(toolboxattached)
 {
  w=(view->data.toolboxx*TIHSTEP+2*TIXBORDER);
  h=(view->data.toolboxy*TIVSTEP+2*TIYBORDER);
 }
 else
 {
  w=(toolboxx*TIHSTEP+2*TIXBORDER);
  h=(toolboxy*TIVSTEP+2*TIYBORDER);
 }
                                         /* there is but one foolproof case */

 if(!(view->data.tools && toolbox->handle && toolbox->view==view))
 {
  scraptoolbox();

  if(view->data.tools)
  {
   err=createwindowparent(view->data.toolboxdocked?TTOOLBOX1:TTOOLBOX,&toolbox->handle,view->handle);
   if(!err)
   {
    toolbox->view=view;

    addclickevent(toolclick,toolbox->handle,(int)view);
    addopenevent(toolswopen,toolbox->handle,(int)view);
    addhelpevent(toolhelp,toolbox->handle,TTOOLBOX);
    addcloseevent(toolswclose,toolbox->handle,(int)view);

    if(!err) err=wimp_setwindowflags(toolbox->handle,WINDOWPANE,WINDOWPANE);

    createtoolicons(toolbox);

    err=wimp_get_wind_state(toolbox->handle,&wst);
    if(!err)
    {
     if(toolboxattached)
     {
      wst.o.box.x1=view->mainwindow.x0+view->data.toolsxshift;
      wst.o.box.y1=view->mainwindow.y1-view->data.toolsyshift;
      wst.o.box.x0=wst.o.box.x1-w; 
      wst.o.box.y0=wst.o.box.y1-h;

      if(!toolboxoffscreen)
      {
       if(!(view->mainwindow.wflags & wimp_MINIMISED))
       {
        coerceboxscreen(&wst.o.box,w,h); /* was r */
       }
      }

      toolboxposnx=wst.o.box.x1;
      toolboxposny=wst.o.box.y1;
      toolboxx=view->data.toolboxx;
      toolboxy=view->data.toolboxy;
     }
     else
     {
      wst.o.box.x1=toolboxposnx;
      wst.o.box.y1=toolboxposny;
      wst.o.box.x0=wst.o.box.x1-w; 
      wst.o.box.y0=wst.o.box.y1-h;
     }

     prevpane=viewprevpane(view,file,toolbox->handle);
     if(prevpane) 
     {
      getw(prevpane,&window);
      wst.o.behind=window.bhandle;
     }
     else
     {
      wst.o.behind=-1;
     }

     err=wcheckopen(&wst.o,toolboxattached);
    }
   }
  }
 }
 return(err);
}


os_error * toolschangeattachment(int xnew)
{
 os_error   * err;
 toolboxstr * toolbox;
 viewstr    * view;

 err=NULL;
 view=NULL;

 if(xnew!=toolboxattached)
 {
  toolbox=firstbox;
  while(toolbox)
  {
   view=toolbox->view;
   if(view)
   {
    closetools(view,view->file);
    break;
   }
   toolbox=toolbox->next;
  }

  toolboxattached=xnew;

  if(toolbox)
  {
   opentools(view,view->file);
  }
 }

 return(err);
}


static os_error * addtools(viewstr * view,filestr * file)
{
 os_error * err;

 if(!view->data.tools)
 {
  view->data.tools=1;
  err=opentools(view,file);
 }
 else err=NULL;

 return(err);
 USE(file);
}



static os_error * remtools(viewstr * view,filestr * file)
{
 os_error * err;

 if(view->data.tools)
 {
  err=closetools(view,file);
  view->data.tools=0;
 }
 else err=NULL;

 return(err);
 USE(file);
}




os_error * gettoolshandle(viewstr * view,filestr * file,int * handle)
{
 toolboxstr * toolbox;

 toolbox=file->toolbox;

// cprintf("tbview %x view %x tools %d handle %d",toolbox->view,view,view->data.tools,toolbox->handle);

 if(toolbox->view==view && view->data.tools) *handle=toolbox->handle;
 else                                        *handle=0;

 return(NULL);
}



os_error * opentoolspane(viewstr * view,filestr * file,wimp_openstr * o,windowstr * window)
{
 os_error   * err;
 wimp_openstr r;
 toolboxstr * toolbox;
 windowstr    twindow;
 int          w;
 int          h;
 wimp_wstate  wst;


 err=NULL;

 toolbox=file->toolbox;

 if(toolboxattached)
 {
  if(!view->data.toolboxdocked && window)
  {
   if(!(view->mainwindow.wflags & wimp_MINIMISED) && !(window->wflags & wimp_MINIMISED))
   {
    getw(toolbox->handle,&twindow);

    if(twindow.x0>(window->x1+window->x0)/2) 
    {
     view->data.toolsxshift+=o->box.x1-window->x1;
     view->data.toolsxshift-=o->box.x0-window->x0;
    }

    if(twindow.y1<(window->y1+window->y0)/2) 
    {
     view->data.toolsyshift-=o->box.y0-window->y0;
     view->data.toolsyshift+=o->box.y1-window->y1;
    }
   }
  }

  r.w=toolbox->handle;
  r.x=0;
  r.y=0;
  r.behind=o->behind;

  w=(view->data.toolboxx*TIHSTEP+2*TIXBORDER);
  h=(view->data.toolboxy*TIVSTEP+2*TIYBORDER);

  if(view->data.toolboxdocked)
  {
   r.box.x0=o->box.x0;
   r.box.x1=o->box.x0+w;
   r.box.y1=o->box.y1-view->hshift;
   r.box.y0=o->box.y0;
   h=r.box.y1-r.box.y0;
  }
  else
  {
   r.box.x1=o->box.x0+view->data.toolsxshift;
   r.box.y1=o->box.y1-view->data.toolsyshift;
   r.box.x0=r.box.x1-w;
   r.box.y0=r.box.y1-h;
  }

  if(!toolboxoffscreen && !view->data.toolboxdocked)
  {
   if(!(view->mainwindow.wflags & wimp_MINIMISED))
   {
    coerceboxscreen(&r.box,w,h);
   }
  }

  toolboxposnx=r.box.x1;
  toolboxposny=r.box.y1;

  err=wcheckopen(&r,1);
 }
 else
 {
  wimp_get_wind_state(toolbox->handle,&wst);
  wst.o.behind=o->behind;
  err=wimp_open_wind(&wst.o);
 }

 return(err);
}





os_error * toolsclip(wimp_openstr * o,viewstr * view,int bits)
{
 os_error   * err;
 windowstr    twindow;
 toolboxstr * toolbox;
 int          cx;
 int          cy;
 int          w;
 int          maxw;
 filestr    * file;
 int          left;
 int          newx0;


 err=NULL;

 if(toolboxattached && view->data.tools)
 {
  file=view->file;
  toolbox=file->toolbox;
  if(toolbox->handle && toolbox->view==view)
  {
   getw(toolbox->handle,&twindow);

   cx=(view->mainwindow.x1+view->mainwindow.x0)/2;
   cy=(view->mainwindow.y1+view->mainwindow.y0)/2;

   w=(view->data.toolboxx*TIHSTEP+2*TIXBORDER);

   if(twindow.x0>cx) 
   {

   }
   else
   {
    left=MIN(view->mainwindow.x0,-view->data.toolsxshift+w);

    newx0=o->box.x0;
    maxw=(cvdu.screenx-vscrlbar);

    if(o->box.x1>maxw) newx0-=o->box.x1-maxw;

    if(newx0<left)
    {
     o->box.x1+=(left-o->box.x0);
     o->box.x1=MIN(o->box.x1,maxw);
     o->box.x0=left;
    }
   }

   if(twindow.y1<cy) 
   {

   }

   if(!bits)
   {
    w=o->box.x1-o->box.x0;
    maxw=view->extent.x1-view->extent.x0;
    if(w>maxw) o->box.x1=o->box.x0+maxw;
   }
  }
 }

 return(err);
}


/****************************************************************************/


static os_error * chtoolssave(buffer * bf)
{
 int i;
 bf_printfeol(bf,"toolchoices(%d,%d,%d,%d);",toolboxx,toolboxy,0,0);

 for(i=0;i<tooln;i++)
 {
  bf_printfeol(bf,"toolrank(%d,%d,%d,%d);",tools[i].tooln,tools[i].rank,
                                tools[i].preselect|(tools[i].noicon<<1),0); 
 }

 return(NULL);
}



void toolchoices(int fp)
{
 defviewdata.toolboxx=toolboxx=stack[fp];
 defviewdata.toolboxy=toolboxy=stack[fp+1];
}


void toolrank(int fp)
{
 int i;
 int bits;
 int noicon;

 i=toolindex(stack[fp]);
 if(i>=0)
 {
  tools[i].rank=stack[fp+1];

  bits=stack[fp+2];

  tools[i].preselect=(bits & 0x1);

  noicon=(bits & 0x2)>>1;

  if(noicon ^ tools[i].noicon)
  {
   disptooln+=tools[i].noicon;
   disptooln-=noicon;
  }

  tools[i].noicon=noicon;
 }
}



static subchoicestr chtools=
{
 NULL,

 NULL,

 NULL,
 NULL,

 chtoolssave,
 NULL,
 NULL,
 NULL,
 NULL,
};


/*****************************************************************************/

int gettools(int fp)
{
 return(menuview->data.tools);
 USE(fp);
}


void xsettools(int open,viewstr * view)
{
 filestr * file;

 file=view->file;

 if(open && !view->data.tools) addtools(view,file);
 else
 if(!open && view->data.tools) remtools(view,file);
}


void settools(int fp)
{
 xsettools(stack[fp],menuview);
 updateviewdata(menuview);
}






static os_error * toolsrun(int eventn,int user,void * data,int data1)
{
 sorttools();

 return(remevent(EVENT_RUNPROGRAM,(eventfn)toolsrun,0));

 USE(data);
 USE(data1);
 USE(user);
 USE(eventn);
}



static os_error * toolsquit(int eventn,int user,void * data,int data1)
{
 scrappointer();

 return(NULL);

 USE(data);
 USE(data1);
 USE(user);
 USE(eventn);
}




#define UNDOS 2

static undofnstr undos[UNDOS]=
{
/* untoolselects,  NULL, UNTOOLSELECTS,     "{UNTOOL}",
 untoolselectf,  NULL, UNTOOLSELECTF,     "{UNTOOL}", */

 tunsaveposn,    NULL, UNTSAVEPOSN,       NULL,
 untoolselecta,  NULL, UNTOOLSELECTA,     "{UNTOOL}",
};


os_error * toolsinit(void)
{
 os_error * err;

 err=undoaddblock(undos,UNDOS);
 if(!err) err=addevent(EVENT_RUNPROGRAM,(eventfn)toolsrun,0);
 if(!err) err=addmessage(toolmode,wimp_MMODECHANGE);
 if(!err) err=choicesadd(&chtools);
 if(!err) err=addevent(EVENT_ENDPROGRAM,(eventfn)toolsquit,0);

 return(err);
}


