/*->c.dbgrid */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"

#include "wos.h"
#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "etc.h"
#include "dbhi.h"
#include "colour.h"
#include "deb.h"


#include "str.h"
#include "constants.h"

#include "units.h"
#include "reslink.h"
#include "mhi.h"

#include "object.h"

#include "view.h"
#include "viewr.h"

#include "mhi.h"

#include "dbscale.h"

#include "dbgrid.h"


extern dboxstr      gridboxdata;


static gridstr      cgrid;
static int          show;
static int          baseline;
static int          basecolour;
static viewstr    * cview;
static int          spacing;


static int uncolour[16];


#define CSTART 6
#define CEND   21

#define CBSTART 26
#define CBEND   41


static int brightness(int c1)
{
 return((c1>>8 & 255) + 2 * (c1>>16 & 255) + (c1>>24 & 255));
}



static void encodepal(void)
{
 os_error * err;
 int        bright[16];
 int        c;
 int        d;
 int        e;
 int        br;
 int        maxd;
 int        maxe;

 maxd=0; /* for compiler */

 err=NULL;

 for(c=0;c<16;c++) bright[c]=brightness(cvdu.vdupal.c[c].word);

 for(c=0;c<16;c++)
 {
  br=bright[c];
  maxe=-1;
  for(d=0;d<16;d++)
  {
   e=bright[d]-br;
   if(e<0) e=-e;
   if(e>maxe)
   {
    maxe=e;
    maxd=d;
   }
  }
  uncolour[c]=maxd;
 }
}


static void unhtpal(int palcolour,int base)
{
// wimp_set_icon_state(gridboxdata.handle,palcolour+base,(wimp_iconflags)0,(wimp_iconflags)5);
 
 wimp_set_icon_colour(gridboxdata.handle,palcolour+base,CCRGB|cvdu.vdupal.c[palcolour].word,CCRGB|cvdu.vdupal.c[palcolour].word);
}

static void htpal(int palcolour,int base) 
{
 int c3;

 c3=uncolour[palcolour];
// wimp_set_icon_state(gridboxdata.handle,palcolour+base,(wimp_iconflags)(c3 | 5),(wimp_iconflags)0x0F000005);

 wimp_set_icon_colour(gridboxdata.handle,palcolour+base,CCRGB|cvdu.vdupal.c[c3].word,CCRGB|cvdu.vdupal.c[palcolour].word);
}


static os_error * gridicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;

 cprintf("m->i=%d",m->i);

 if(m->i>=CSTART && m->i<=CEND && m->i!=cgrid.colour+CSTART)
 {
  unhtpal(cgrid.colour,CSTART);
  cgrid.colour=m->i-CSTART;
  htpal(cgrid.colour,CSTART);
 }

 if(m->i>=CBSTART && m->i<=CBEND && m->i!=basecolour+CBSTART)
 {
  unhtpal(basecolour,CBSTART);
  basecolour=m->i-CBSTART;
  htpal(basecolour,CBSTART);
 }

 return(err);

 USE(handle);
 USE(userhandle);
}



static os_error * gridclose(int code)
{
 os_error * err;
 int        change;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  change=((int)cview->data.grid.show!=show) ||
         ((int)cview->data.grid.baseline!=baseline) ||
         ((int)cview->data.grid.basecolour!=basecolour) ||
         (cview->data.grid.colour!=cgrid.colour) ||
         (cview->data.grid.subdiv!=cgrid.subdiv) ||
         (cview->data.grid.spacing!=cgrid.spacing) ||
         (cview->data.grid.spacediv!=cgrid.spacediv);


  if(change)
  {
   cgrid.show=show;
   cgrid.baseline=baseline;
   cgrid.basecolour=basecolour;
  }

  if((cview->data.grid.show || cview->data.grid.baseline) && change)
                                 err=viewrefreshview(cview,VRGRID|VRONELAYER);
  cview->data.grid=cgrid;
  if((cview->data.grid.show || cview->data.grid.baseline) && change) 
                                 err=viewrefreshview(cview,VRGRID|VRONELAYER);
  updateviewdata(cview);
 }

 return(err);
}


static os_error * gridoutu(int value,char * string)
{
 strcpy(string,unitstostring(value,cview->data.units));
 return(NULL);
}


static os_error * gridinu(int * value,char * string)
{
 os_error * err;
 err=stringtounitsv(string,&cgrid.spacing,cview->data.units);
 if(!err) *value=cgrid.spacing/cgrid.spacediv;
 return(err);
}


static os_error * gridout(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}

static os_error * gridin(int * value,char * string)
{
 return(stringtonumber(string,value));
 return(NULL);
}



static dbiconstr gridicondefs[]=
{
 /* N   &V           Type     Grp   Flags   Msk Key   -   -   clickfn 0 */

 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

   3, &spacing,      DBWRITE,0,   0,      -1, -1,  4, -1, gridinu,gridoutu,
   5, &cgrid.subdiv, DBWRITE,0,   0,      -1, -1, -1,  2, gridin,gridout,

 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

   1, NULL,         DBACTION, 0,   0,      DBOK,RETURN,     0,0,    NULL, 0,
   2, NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,    NULL, 0,

 /* N   &V           Type     Grp   Flags   Msk Key -  -      clickfn 0 */

   22, &cgrid.lock, DBTOGGLE, 0,    0,GRIDLOCK, F4,  0, 0,    NULL,   0,
    0, &show,       DBTOGGLE, 0,    0,      1, F4,  0, 0,     NULL,   0,
   25, &baseline,   DBTOGGLE, 0,    0,      1, F4,  0, 0,     NULL,   0,
   43, &cgrid.lock, DBTOGGLE, 0,    0,GRIDBASELOCK, F4,  0, 0,NULL,   0,


   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr gridboxdata=
{
 0,
 TGRID,
 DBFIX,
 0,
 gridclose,
 gridicon,
 NULL,
 NULL,
 gridicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};




/* script function opens the new document dialogue box */

int grid_box(int fp)
{
 int        open;
 static int menuhandle;

 open=stack[fp];

 if(open)
 {
  cview=menuview;
  cgrid=cview->data.grid;
  spacing=cgrid.spacing/cgrid.spacediv;
  show=cgrid.show;
  baseline=cgrid.baseline;
  basecolour=cgrid.basecolour;

  encodepal();
  dodboxparent(&gridboxdata,1,cview->handle);

  htpal(cgrid.colour,CSTART);
  htpal(basecolour,CBSTART);

/*
  for(i=0;i<16;i++)
  {
   if(i==cgrid.colour) htpal(i,CSTART);
   else                unhtpal(i,CSTART);
  }

  for(i=0;i<16;i++)
  {
   if(i==basecolour) htpal(i,CBSTART);
   else              unhtpal(i,CBSTART);
  }
*/
  menuhandle=create_dbox(gridboxdata.handle,menuhandle);
 }
 else
 {

 }

 return(menuhandle);
}



void opengridbox(int fp)
{

 cview=menuview;
 cgrid=cview->data.grid;
 spacing=cgrid.spacing/cgrid.spacediv;
 show=cgrid.show;
 baseline=cgrid.baseline;
 basecolour=cgrid.basecolour;

 encodepal();
 dodboxparent(&gridboxdata,1,cview->handle);

 htpal(cgrid.colour,CSTART);
 htpal(basecolour,CBSTART);

 USE(fp);
}


int getgrid(int fp)
{
 return(menuview->data.grid.show);
 USE(fp);
}



void setgrid(int fp)
{
 int       open;

 open=stack[fp];

 if((open && !menuview->data.grid.show) || (!open && menuview->data.grid.show))
 {
  if(menuview->data.grid.show || menuview->data.grid.baseline)
                               viewrefreshview(menuview,VRGRID|VRONELAYER);
  menuview->data.grid.show^=1;
  if(menuview->data.grid.show || menuview->data.grid.baseline) 
                               viewrefreshview(menuview,VRGRID|VRONELAYER);
  updateviewdata(menuview);
 }
}





int getbasegrid(int fp)
{
 return(menuview->data.grid.baseline);
 USE(fp);
}


void setbasegrid(int fp)
{
 int       open;

 open=stack[fp];

 if((open && !menuview->data.grid.baseline) || 
    (!open && menuview->data.grid.baseline))
 {
  if(menuview->data.grid.show || menuview->data.grid.baseline) 
                                viewrefreshview(menuview,VRGRID|VRONELAYER);
  menuview->data.grid.baseline^=1;
  if(menuview->data.grid.show || menuview->data.grid.baseline) 
                                viewrefreshview(menuview,VRGRID|VRONELAYER);
  updateviewdata(menuview);
 }
}




int getgridlock(int fp)
{
 return(menuview->data.grid.lock);
 USE(fp);
}




void setgridlock(int fp)
{
 menuview->data.grid.lock=stack[fp];
 updateviewdata(menuview);
 USE(fp);
}


