/*->c.trap */


#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>




#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "flex.h"

#include "xext.h"


#include "macros.h"


#include "trap.h"



static int traps;              /* number of serial traps     */


typedef struct trapstate
{
 int  traphit;                 /* trap number of hit         */
 int  traplo;                  /* trap buffer lo pointer     */
 int  trapslo;                 /* send lo byte               */
 int  trapshi;                 /* send hi byte               */
 int  traphi;                  /* trap buffer hi pointer     */
 char trapbuff[128];           /* trap buffer                */
 int  n;                       /* number of traps            */
} trapstate;



/*

  trapslo - lowest  byte not passed on
  trapshi - highest byte not needed
  traplo  - lowest  byte needed for match
  traphi  - highest byte in buffer

*/




static trapstate txtrap;


#define TRAPMASK 0x7F



typedef struct trapstr
{
 char  fn[32];                /* name of function to call  */
 char  match[96];             /* string to match           */
 int   len;                   /* length of string to match */
 int   type;                  /* 0 intercept 1 pass on     */
 int   dir;
} trapstr;

static trapstr * trap;



/*

void settrap(int type,int add,string & function,string & trap);

*/


void settrap(int fp)
{
 os_error * err;
 int        i;
 int        j;
 char       fn[32];
 char       match[96];
 int        len;
 int        add;
 int        type;


 err=NULL;

 type=stack[fp+0];
 add= stack[fp+1];

 strcpy(fn,stringptr(stack[fp+2]));
 convert(stringptr(stack[fp+3]),match,&len,96);

 for(i=0;i<traps;i++)
 {
  if(!strcmp(fn,trap[i].fn))
  {
   for(j=0;j<len;j++)
    if(trap[i].match[j]!=match[j]) break;
   if(j==len) break;
  }
 }

 if(i<traps && !add)   /* we hit a trap       */
 {
  flex_midextend((flex_ptr)&trap,sizeof(trapstr)*(i+1),-sizeof(trapstr));

  traps--;
  txtrap.n--;
 }
 else                  /* could not find trap */
 if(i==traps && add)
 {
  if(!trap) err=flex_alloc((flex_ptr)&trap,sizeof(trapstr));
  else      err=flex_extend((flex_ptr)&trap,sizeof(trapstr)*(traps+1));

  if(!err)
  {
   XMEMCPYX(trap[traps].fn,fn,32);
   XMEMCPYX(trap[traps].match,match,96);
   trap[traps].len=len;
   trap[traps].type=type;
   trap[traps].dir=0;

   traps++;
   txtrap.n++;
  }
 }

 zreport(err);
}


/* return 1 if a match, or else 0 */
/* object has to be to get trapshi as far towards traphi as possible */


static int trapcalcstate(trapstate * s,int dir)
{
 int     i;
 int     j;
 char *  match;
 int     len;
 int     ptr;
 int     newtrapshi=s->traphi;
 int     amatch=0;

 if(s->traplo!=s->traphi)
 {
  for(i=0;i<traps;i++)
  {
   if(trap[i].dir==dir)
   {
    match=trap[i].match;
    len=trap[i].len;
    ptr=s->traplo;
    if(len)
    {
     j=0;
     while(1)
     {
      if(match[j]!=s->trapbuff[ptr & TRAPMASK])
      {
       j=0;      /* this means that no way can this trap ever match */
       break;
      }
      j++;
      if(j==len)
      {
       s->traphit=i;
       return(1);
      }

      ptr++;
      if(ptr==s->traphi)
      {
       amatch=1;
       break;
      }
     }

     if(trap[i].type==1)  /* intercept */
     {
      if(j==0 && newtrapshi>s->traplo) newtrapshi=s->traplo+1;
      else                             newtrapshi=s->traplo;
     }
    }
   }
  }


  if(amatch) s->trapshi=newtrapshi;
  else
  {
   s->traplo++;                                     /* no match */
/*   if(s->trapshi<s->traplo) s->trapshi=s->traplo;  */
   s->trapshi=newtrapshi;
  }
 }
 return(0);
}


static void trapaddbyte(int byte,trapstate * s)
{
 if(byte==-1) return;
 s->trapbuff[(s->traphi)++ & TRAPMASK]=byte;
}


static int traprembyte(trapstate * s)
{
 if(s->trapslo==s->trapshi) return(-1);
 else                       return(s->trapbuff[(s->trapslo)++ & TRAPMASK]);
}



os_error * trapbyte(trapfn txfn,macrokeyhandler mfn,int * key)
{
 os_error * err;
 int        i;
 char       string[128];
 int        r0;
 int        result;
 int        byte;


 err=NULL;

 if(txtrap.n)
 {
  byte=*key;

  if(byte<256)
  {
   *key=-1;

   trapaddbyte(byte,&txtrap); 

   if(trapcalcstate(&txtrap,0))
   {
    XMEMCPYX(string,trap[txtrap.traphit].match,96);
    string[trap[txtrap.traphit].len]=0;

    if(!xexec(trap[txtrap.traphit].fn,&result,"S/RS",string,&r0,string))
    {
     if(r0)
     {
      i=0;
      txtrap.trapslo=txtrap.traphi;
      while(string[i]) txtrap.trapbuff[txtrap.traphi++ & TRAPMASK]=string[i++];
     }
    }

    txtrap.traplo=txtrap.trapshi=txtrap.traphi;
   }
  }
  else
  {
   txtrap.traplo=txtrap.trapshi=txtrap.traphi;    /* flush */
  }

/* dprintf(0,"trapslo=%d traplo=%d trapshi=%d traphi=%d",
          txtrap.trapslo,txtrap.traplo,txtrap.trapshi,txtrap.traphi); */

  while(txtrap.trapslo<txtrap.trapshi)
  {
   while((byte=traprembyte(&txtrap))!=-1) 
   {
    err=txfn(mfn,&byte);
    if(err) break;
   }

   if(err)
   {
    txtrap.traplo=txtrap.trapshi=txtrap.traphi=txtrap.trapslo;
    break;
   }

   if(txtrap.traplo<txtrap.traphi) trapcalcstate(&txtrap,0);
   else                            break;
  }

  if(byte>256 && !err) err=txfn(mfn,key);
 }
 else
 {
  err=txfn(mfn,key);
 }

 return(err);
}


