/*->c.croptool */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "akbd.h"
#include "transform.h"
#include "xprocess.h"

#include "err.h"
#include "poll.h"
#include "dbhi.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"
#include "poll.h"
#include "alloc.h"
#include "trans.h"
#include "etc.h"
#include "colour.h"
#include "key.h"
#include "xmath.h"

#include "str.h"
#include "constants.h"

#include "object.h"
#include "chain.h"

#include "mhi.h"
#include "reslink.h"
#include "viewo.h"
#include "viewr.h"
#include "view.h"
#include "file.h"
#include "select.h"
#include "posn.h"
#include "xredraw.h"
#include "curve.h"
#include "geometry.h"
#include "units.h"
#include "xcolour.h"

#include "toolstr.h"
#include "tools.h"
#include "caret.h"



#include "pxstr.h"
#include "pict.h"
#include "dbpicture.h"

#include "croptool.h"



static int       cropstate;
static posnstr   cropstart;
static posnstr   cropcur;
static boxbitstr cbits;
static curvestr  ccurve;


#define CXDRAG 1
#define CXLOCK 2


static pointstr cropptr=
{
 "p_crop",0,0
};


static pointstr lockptr=
{
 "p_lock",10,10
};





static os_error * croprefresh(void)
{
 return(viewrefresharea(cropstart.file,cropstart.page,NULL,VRTOOLS));
}



static void getccurve(void)
{
 int            x0;
 int            y1;
 int            x1;
 int            y0;
 transformstr   tr;

 tr_setidentity(&tr);
 tr_setrotationa(&tr,-cbits.angle);

 x0=cropstart.x-cbits.orgx;
 y1=cropstart.y-cbits.orgy;
 tr_delta(&tr,&x0,&y1);

 x1=cropcur.x-cbits.orgx;
 y0=cropcur.y-cbits.orgy;
 tr_delta(&tr,&x1,&y0);

 ccurve.type=CBOX;
 ccurve.box.w=x1-x0;
 ccurve.box.h=y0-y1;
 ccurve.box.x=x0;
 ccurve.box.y=y1;
}





static os_error * credraw(toolboxstr * toolbox,viewredrawstr * v)
{
 os_error     * err;
 int            wimpcolour;
 transformstr   tr;


 err=NULL;

 if(cropstate==CXDRAG && v->page==cropstart.page)
 {
  getccurve();
  tr_setshift(&tr,cbits.orgx,cbits.orgy);
  tr_setrotationa(&tr,cbits.angle);
  wimpcolour=WIMPGREY2|OUTLINEWIMPLINE|OUTLINEEOR|(WIMPWHITE<<4);
  err=outlinecurve(v,&ccurve,wimpcolour,NULL,&tr);
 }

 return(err);

 USE(toolbox);
}





static os_error * smenu(toolboxstr * toolbox,viewstr * view,
                                             filestr * file,wimp_mousestr * m)
{
 return(openmenu("main_menu"));
 USE(view);
 USE(file);
 USE(m);
 USE(toolbox);
}



static os_error * ckey(toolboxstr * toolbox,int * key,fkeyfn * fk)
{
 menukey(key);
 if(*key==-1) *fk=menukey;
 else
 {


 }

 return(NULL);
 USE(toolbox);
}



/* problem with crop tool is that pictupdatecontents() is using */
/* selection page to key area off                               */


static os_error * cclick(toolboxstr * toolbox,posnstr * posn)
{
 os_error     * err;
 pictboxstr   * pictp;

 err=NULL;

 if(findboxhandle(posn))
 {

 }
 else
 {
  if(findbox(posn,-1))
  {
   if(posn->buttons==VBCLICKS)
   {
    if(!isselectedbig(posn->object,posn->file))
    {
     changeselection(posn,SELECTOBJECT,1);
    }
   }
   else
   if(posn->buttons==VBCLICKA) /* single click adjust */
   {
    if(isselectedbig(posn->object,posn->file))
    {
     changeselection(posn,DESELECTOBJECT,0);
    }
    else
    {
     changeselection(posn,SELECTOBJECT,0);
    }
   }
   else
   if(posn->buttons==VBDRAGS || posn->buttons==VBLONGCLICKS)
   {
    if(posn->object && posn->otype==OPICTBOX)
    {

     cropstart=cropcur=*posn;
     pictp=(pictboxstr*)fob_find(posn->object,posn->file);

     if(pictp->pictdata.lockmode)
     {
      cropstate=CXLOCK;
      toolschangepointer(128,USERPOINTER,&lockptr);
      toolsstartdrag(posn,TOOLDRAGPAGE|TOOLDRAGPTR);
     }
     else
     {
      cropstate=CXDRAG;
      getboxbits(&pictp->fcurve.box,&pictp->transform,&cbits);
      toolschangepointer(128,USERPOINTER,&cropptr);
      toolsstartdrag(posn,TOOLDRAGPAGE|TOOLDRAGPTR);
      getccurve();
      iprefreshpane(posn->file,0x1,IP_PANE1);
     }
    }
   }
  }
 }

 caretensure(posn->view);

 return(err);

 USE(toolbox);
}


static os_error * cmove(toolboxstr * toolbox,posnstr * posn,int move)
{

 if(move && cropstate==CXDRAG)
 {
  croprefresh();
  cropcur=*posn;
  croprefresh();
  iprefreshpane(posn->file,0x1,IP_PANE1);

  toolschangepointer(0,USERPOINTER,&cropptr);
 }

 return(NULL);

 USE(toolbox);
}





static os_error * cdragend(toolboxstr * toolbox,
                               posnstr * posn,wimp_box * box)
{
 os_error              * err;
 int                     w;
 int                     h;
 int                     x0;
 int                     x1;
 int                     y0;
 int                     y1;
 unpackedpicturedatastr  upd;
 int                     xscale;
 int                     yscale;
 int                     xscale1;
 int                     yscale1;
 int                     xscale0;
 int                     yscale0;
 pictboxstr            * pictp;
 transformstr            tr;

 err=NULL;

 if(cropstate==CXDRAG)
 {
  croprefresh();
  cropstate=0;

  tr_setidentity(&tr);
  tr_setrotationa(&tr,-cbits.angle);

  x0=cropstart.x-cbits.orgx;
  y1=cropstart.y-cbits.orgy;
  tr_delta(&tr,&x0,&y1);

  x1=cropcur.x-cbits.orgx;
  y0=cropcur.y-cbits.orgy;
  tr_delta(&tr,&x1,&y0);

  if(x1<x0) SWOP(x1,x0);
  if(y0<y1) SWOP(y0,y1);

  w=x1-x0;
  h=y0-y1;

  pictp=(pictboxstr*)fob_find(cropstart.object,cropstart.file);
  unpackpicturedata(&upd,pictp);

  upd.pd.hbits&=~HBBOTLEFT;

  yscale0=yscale=upd.pd.scale;
  xscale0=xscale=ttmul(yscale,upd.pd.aspect);

  xscale=pixcutscale(scale(xscale,cbits.width,w));
  yscale=pixcutscale(scale(yscale,cbits.height,h));

  if(upd.pd.fixaspect)
  {
   if(xscale<yscale) yscale=xscale;
   xscale=ttmul(yscale,upd.pd.aspect);
  }

  xscale1=scale(0x10000,xscale,xscale0);
  yscale1=scale(0x10000,yscale,yscale0);

  upd.pd.scale=yscale;
  upd.pd.aspect=scale(xscale,0x10000,yscale);

  upd.pd.xshift=-scale((x0-upd.pd.xshift),xscale1,0x10000);
  upd.pd.yshift=-scale((y1-upd.pd.yshift),yscale1,0x10000);

  err=pictupdatecontents(cropstart.object,cropstart.section,
                                          cropstart.file,&upd);

  iprefreshpane(posn->file,0x1,IP_PANE1);
 }
 else
 if(cropstate==CXLOCK)
 {
  toolschangepointer(0,USERPOINTER,&cropptr);
  cropstate=0;
 }

 return(err);

 USE(box);
 USE(posn);
 USE(toolbox);
}



static os_error * ccancel(toolboxstr * toolbox,viewstr * view,
                                                   filestr * file)
{

 if(cropstate==CXDRAG)
 {
  croprefresh();
  cropstate=0;
  toolsstopdrag();
 }
 else
 if(cropstate==CXLOCK)
 {
  toolschangepointer(0,USERPOINTER,&cropptr);
  cropstate=0;
  toolsstopdrag();
 }

 return(NULL);

 USE(toolbox);
 USE(view);
 USE(file);
}






#define CIPX 0
#define CIPY 1
#define CIPH 3
#define CIPW 2


static iconmap cipmap[]=
{
 9,0,0,IP_TIPS,
 3,0,0,IP_TIPS,
 5,0,0,IP_TIPS,
 7,0,0,IP_TIPS,


 0,0,0,0,      /* terminator */
};







static os_error * ciprefresh(viewstr * view,int handle,int code)
{

 if(code==-1) 
 {
  writeiconf(view->info,IP_HELPI,"%s","{CRO00}");
 }

 if(code & 0x1)
 {
  if(cropstate==CXDRAG)
  {
   writeiconc(handle,cipmap[CIPX].realicon,
       unitstostring(ccurve.box.x,view->data.units));
   writeiconc(handle,cipmap[CIPY].realicon,
       unitstostring(ccurve.box.y,view->data.units));
   writeiconc(handle,cipmap[CIPW].realicon,
       unitstostring(ccurve.box.w,view->data.units));
   writeiconc(handle,cipmap[CIPH].realicon,
       unitstostring(ccurve.box.h,view->data.units));
  }
  else
  {
   writeiconc(handle,cipmap[CIPX].realicon,"");
   writeiconc(handle,cipmap[CIPY].realicon,"");
   writeiconc(handle,cipmap[CIPW].realicon,"");
   writeiconc(handle,cipmap[CIPH].realicon,"");
  }
 }



 return(NULL);
 USE(view);
}



static ipstr cipstr=
{
 NULL,           /* click    */
 NULL,           /* key      */
 cipmap,         /* icon map */
 TCROPTOOL,      /* template */
 0,              /* code     */
 ciprefresh,     /* refresh  */
};





static os_error * cselect(toolboxstr * toolbox,viewstr * view,
                                                   filestr * file,int select)
{

 ipchangepane(toolbox,IP_PANE1,select?&cipstr:NULL);


 return(NULL);

 USE(toolbox);
 USE(view);
 USE(file);
}




static os_error * cptr(toolboxstr * toolbox,posnstr * posn)
{
 toolschangepointer(0,USERPOINTER,&cropptr);

 return(NULL);

 USE(toolbox);
 USE(posn);
}




static os_error * cmess(toolboxstr * toolbox,filestr * file,
                                      int message,void * data)
{

 if(message==TSAVEPOSN) ssaveselection(file);

 return(NULL);

 USE(toolbox);
 USE(data);
}




static toolstr crop=
{
 TL_CROP,
 "crop",
 "t_crop\0t_pcrop",
 "{CRPTIP}",
 1,
 cclick,
 cmove,
 cselect,
 cptr,
 ccancel,
 credraw,
 cdragend,
 smenu,
 ckey,
 NULL,
 NULL,
 cmess,

 0,

 0,       /*  preselect */
 0,       /*  noicon    */
 0,       /*  spare2    */
 0,       /*  spare3    */
 0,       /*  spare4    */ 
 0,       /*  spare5    */
 0,       /*  spare6    */
 0,       /*  spare7    */


 TPOINTER,
 0,
 0,
 6,       /*  rank      */
};





os_error * croptoolinit(void)
{
 os_error * err;

 err=toolregister(&crop);

 return(err);
}


