/*->c.pxcache */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>
#include <time.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"


#include "transform.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "poll.h"
#include "bits.h"
#include "avl.h"
#include "xprocess.h"
#include "fsx.h"
#include "bf.h"
#include "xext.h"

#include "constants.h"
#include "str.h"

#include "object.h"

#include "reslink.h"
#include "units.h"

#include "file.h"
#include "view.h"
#include "viewr.h"
#include "new.h"
#include "undo.h"


#include "pxstr.h"

#include "impex.h"

#include "pxref.h"

#include "pxcache.h"





typedef struct pxcachelinestr
{
 int          parent;
 int          sibls[2];
 int          balance;
 int          name;

 int          object;
 int          prev;
 int          next;
 filestr    * file;

} pxcachelinestr;




typedef struct pxcachestr
{
 int            key;
 int            type;

 int            cachelines;
 int            mostru;
 int            freeline;
 int            rootp;

 pxcachelinestr cacheline[1];

} pxcachestr;


typedef struct pxnamestr
{
 int            key;
 int            type;

 char           name[1];
} pxnamestr;




static filestr * cachefile;
static int       cacheobject;
       int       pxcachemax;
static int       cachesize;



static int pxccmp1(void * key1,void * key2)
{
 int         name;
 pxnamestr * namep;

 name=*((int*)key2);

 namep=(pxnamestr*)fob_find(name,cachefile);

 return(cstrcmp((char*)key1,namep->name));
}




static int pxccmp2(void * key1,void * key2)
{
 int         name1;
 pxnamestr * name1p;
 int         name2;
 pxnamestr * name2p;

 name1=*((int*)key1);
 name2=*((int*)key2);

 name1p=(pxnamestr*)fob_find(name1,cachefile);
 name2p=(pxnamestr*)fob_find(name2,cachefile);

 return(cstrcmp(name1p->name,name2p->name));
}





static os_error * pxdropline(int cacheline)
{
 os_error        * err;
 pxcachestr      * cachep;
 int               prev;
 int               next;
 picturestr      * picturep;
 int               object;


 cachep=(pxcachestr*)fob_find(cacheobject,cachefile);

 object=cachep->cacheline[cacheline].object;
 cachep->cacheline[cacheline].object=0;
 picturep=(picturestr*)fob_find(object,cachefile);
 cachesize-=picturep->imagelen;


 if(cachep->mostru==cacheline)
 {
  cachep->mostru=cachep->cacheline[cachep->mostru].next;
 }


 if(cachep->mostru==cacheline)
 {
  cachep->mostru=-1;
 }
 else
 {
  prev=cachep->cacheline[cacheline].prev;
  next=cachep->cacheline[cacheline].next;
  cachep->cacheline[prev].next=next;
  cachep->cacheline[next].prev=prev;
 }

/* dprintf(0,"cacheline=%d free=%d",cacheline,cachep->freeline); */

 cachep->cacheline[cacheline].next=cachep->freeline;
 cachep->freeline=cacheline;
 cachep->cacheline[cacheline].file=NULL;


 avldelete(cacheline*sizeof(pxcachelinestr),&cachep->rootp,
                                           (char*)cachep->cacheline,pxccmp2);



 err=fob_delete(cachep->cacheline[cacheline].name,cachefile);
 err=fob_delete(object,cachefile);

 return(err);
}





static os_error * pxdropleastru(int exobject,int * dropped)
{
 os_error        * err;
 pxcachestr      * cachep;
 int               cacheline;

 err=NULL;

 *dropped=0;

 cachep=(pxcachestr*)fob_find(cacheobject,cachefile);
 if(cachep->mostru>=0)
 {
  cacheline=cachep->cacheline[cachep->mostru].prev;
  if(cachep->cacheline[cacheline].object!=exobject)
  {
   pxdropline(cacheline);
   *dropped=1;
  }
 }
 return(err);
}





static os_error * pxcacheloadfile(char * name,int ftype,int * object)
{
 os_error   * err;
 picturestr * picturep;
 int          dropped;
 fstat        fs;

/* dprintf(0,"pxcacheloadfile 1"); */

 fs_stat(name,&fs);
 if(fs.object)
 {
  while((cachesize+fs.length)>pxcachemax)
  {
   pxdropleastru(0,&dropped);
   if(!dropped) break;
  }
 }

/* dprintf(0,"pxcacheloadfile 2"); */

 ftype=fs_filetypefromextension(name);

 err=importload(name,ftype,0,object,cachefile);
	if(!err)
	{
  picturep=(picturestr*)fob_find(*object,cachefile);
		ftype=picturep->ftype;
  err=importloadpost(ftype,*object,cachefile);
	}

 if(!err)
 {
  picturep=(picturestr*)fob_find(*object,cachefile);
  cachesize+=picturep->imagelen;

 /* dprintf(0,"pxcacheloadfile 3"); */

  while(cachesize>pxcachemax)
  {
   pxdropleastru(*object,&dropped);
   if(!dropped) break;
  }

 /* dprintf(0,"pxcacheloadfile 4"); */
 }

 return(err);
}





static os_error * pxcachename(char * name,int ftype,filestr * file,
                                                    int * cacheobjectp)
{
 os_error        * err;
 pxcachestr      * cachep;
 pxcachelinestr  * cachelinep;
 int               cacheline;
 int               offset;
 pxnamestr       * namep=NULL;
 int               namek;
 int               object;
 int               prev;
 int               next;

 err=NULL;

 cacheline=0; /* compiler */

 cachep=(pxcachestr*)fob_find(cacheobject,cachefile);

/* dprintf(1,"pxcachename avlfind"); */

 offset=avlfind(name,cachep->rootp,(char*)cachep->cacheline,pxccmp1);

/*dprintf(1,"pxcachename %d mru=%d size=%d",offset,cachep->mostru,cachesize);*/
 if(offset>=0)
 {
  cachelinep=(pxcachelinestr*)(((char*)cachep->cacheline)+offset);
  *cacheobjectp=cachelinep->object;

  cachelinep->file=file;

  /* sort out most recently used */

  cacheline=offset/sizeof(pxcachelinestr);

 /* dprintf(0,"update cachline=%d",cacheline); */

  if(cacheline!=cachep->mostru)
  {
   next=cachelinep->next;
   prev=cachelinep->prev;

   cachep->cacheline[prev].next=next;
   cachep->cacheline[next].prev=prev;

   next=cachep->mostru;
   prev=cachep->cacheline[next].prev;

   cachep->cacheline[next].prev=cacheline;
   cachep->cacheline[prev].next=cacheline;
   cachep->cacheline[cacheline].prev=prev;
   cachep->cacheline[cacheline].next=next;
   cachep->mostru=cacheline;
  }
 }
 else
 {
  err=pxcacheloadfile(name,ftype,&object);

  *cacheobjectp=object;

  if(!err) err=fob_create(sizeof(pxnamestr)+strlen(name)+1,cachefile,
                                               OPXNAME,(fobjptr)&namep);
  if(!err)
  {
   namek=namep->key;
   strcpy(namep->name,name);

   cachep=(pxcachestr*)fob_find(cacheobject,cachefile);
   if(cachep->freeline>=0)
   {
    cacheline=cachep->freeline;
    cachep->freeline=cachep->cacheline[cacheline].next;
   /* dprintf(0,"free cachline %d",cacheline); */
   }
   else
   {
    err=fob_change(cacheobject,cachefile,
            sizeof(pxcachestr)+cachep->cachelines*sizeof(pxcachelinestr),
                        (fobjptr)&cachep);
    if(!err)
    {
     cacheline=cachep->cachelines;
     cachep->cachelines++;
    /* dprintf(0,"new cachline %d",cacheline); */
    }
   }

   if(!err)
   {
    cachep->cacheline[cacheline].object=object;
    cachep->cacheline[cacheline].name=namek;
    cachep->cacheline[cacheline].file=file;

   /* dprintf(0,"avlsearch A %d %d",cachep->cachelines,cachep->rootp); */

    if(cachep->rootp>=0)
    {
     pxcachelinestr * p;

     p=(pxcachelinestr*)(((char*)cachep->cacheline)+cachep->rootp);

    /* dprintf(0,"parent=%d sib[0]=%d sib[1]=%d",p->parent,p->sibls[0],
                                                         p->sibls[1]);*/

    }

    avlsearch(cacheline*sizeof(pxcachelinestr),&cachep->rootp,
                                             (char*)cachep->cacheline,pxccmp2);

   /* dprintf(0,"avlsearch B"); */

    if(cachep->mostru==-1)
    {
     cachep->cacheline[cacheline].prev=
                                  cachep->cacheline[cacheline].next=cacheline;
    }
    else
    {
     cachep->cacheline[cacheline].next=cachep->mostru;
     prev=cachep->cacheline[cacheline].prev=
          cachep->cacheline[cachep->mostru].prev;
     cachep->cacheline[cachep->mostru].prev=cacheline;
     cachep->cacheline[prev].next=cacheline;
    }

   /* dprintf(0,"cachename C"); */

    cachep->mostru=cacheline;
   }
  }
 }

 return(err);
}




os_error * pxuncachename(char * name,filestr * file)
{
 os_error        * err;
 pxcachestr      * cachep;
 int               cacheline;
 int               offset;

 err=NULL;

 cachep=(pxcachestr*)fob_find(cacheobject,cachefile);

 offset=avlfind(name,cachep->rootp,(char*)cachep->cacheline,pxccmp1);

 if(offset>=0)
 {
  cacheline=offset/sizeof(pxcachelinestr);
  pxdropline(cacheline);
 }

 return(err);

 USE(file);
}





os_error * pxcache(char * name,int ftype,filestr * file,int * cacheobjectp,
                                         filestr ** cachefilep)
{
 os_error * err;

 err=NULL;
 if(cachefilep) *cachefilep=cachefile;

 err=pxcachename(name,ftype,file,cacheobjectp);

 return(err);
}



os_error * pxrendername(picturestr * picturep,filestr * file,
                                              char * expandedname,int length)
{
 os_error     * err;
 char           name[FSMAXPATH];
 pxpreftagstr * tag;

 err=NULL;

 if(file->merge) /* && file->mergedata) */
 {
  tag=(pxpreftagstr*)pxfindtag(picturep,PXPREF2TAG);
  if(tag) strcpy(expandedname,tag->name);
 }
 else
 {
  tag=(pxpreftagstr*)pxfindtag(picturep,PXPREF1TAG);
  if(tag)
  {
   strcpy(name,tag->name);
   err=pxexpandpath(expandedname,length,name,file);
  }
 }

 return(err);
}


os_error * pxcache2(picturestr ** picturepp,filestr * file,
                                  int * cacheobjectp,filestr ** cachefilep)
{
 os_error     * err;
 picturestr   * picturep;
 int            pkey=0;
 char           expandedname[FSMAXPATH];
 int            ftype;


 picturep=*picturepp;
 if(cachefilep) *cachefilep=cachefile;
 ftype=picturep->ftype;

 err=pxrendername(picturep,file,expandedname,NITEM(expandedname));

 if(!err) err=pxcachename(expandedname,ftype,file,&pkey);
 if(!err)
 {
  if(cacheobjectp) *cacheobjectp=pkey;
  *picturepp=(picturestr*)fob_find(pkey,cachefile);
 }

 return(err);
}





/* called when file is closed */
/* DP 303 this can be called on the cachefile during shutdown */

static os_error * pxclose(int eventn,int user,filestr * file,int data1)
{
 os_error        * err;
 pxcachestr      * cachep;
 int               cacheline;

 err=NULL;

 if(file==cachefile)
 {
  cachefile=NULL;
 }
 else
 if(cachefile)
 {
  cachep=(pxcachestr*)fob_find(cacheobject,cachefile);
  cacheline=0;
  while(cacheline<cachep->cachelines)
  {
   if(cachep->cacheline[cacheline].file==file)
   {
    pxdropline(cacheline);
   }
   cacheline++;
  }


/*
 {
  int line;
  int lt=100;

  cachep=fob_find(cacheobject,cachefile);
  dprintf(0,"cachelines=%d mru=%d",cachep->cachelines,cachep->mostru);
  dprintf(1,"free=%d rootp=%d",cachep->freeline,cachep->rootp);

  line=cachep->freeline;

  while(line>=0 && lt--)
  {
   dprintf(0,"line=%d",line);
   line=cachep->cacheline[line].next;

  }
 }
*/


  fob_compact(cachefile);
 }

 return(NULL);
 USE(eventn);
 USE(user);
 USE(data1);
}


void pxcacheflush(int fp)
{
 filestr * file=(filestr*)stack[fp];

 zreport(pxclose(0,0,file,0));

}



static os_error * pxcacherun(int eventn,int user,void * data,int data1)
{
 os_error   * err;
 pxcachestr * cachep;

 err=createdefnewdoc(&cachefile,"PictureCache");

 if(!err)
 {
  cachefile->notuserfile=1;

  undozerosize(cachefile);

  err=fob_create(sizeof(pxcachestr),cachefile,OPXCACHE,(fobjptr)&cachep);
  if(!err)
  {
   cacheobject=cachep->key;
   cachep->cachelines=0;
   cachep->mostru=-1;
   cachep->freeline=-1;
   cachep->rootp=-1;
  }
 }

 remevent(EVENT_RUNPROGRAM2,(eventfn)pxcacherun,0);

 return(err);

 USE(data);
 USE(data1);
 USE(user);
 USE(eventn);
}





os_error * pxcacheinit(void)
{
 os_error * err;

          err=addevent(EVENT_RUNPROGRAM2,(eventfn)pxcacherun,0);
 if(!err) err=addevent(EVENT_FCLOSE,(eventfn)pxclose,0);

 cachesize=0;

 return(err);
}




