/*->h.splib */



typedef struct newspstr
{
 int spbpp;
 int dx;
 int dy;
 int mask;
 int palette;
 int mode;            /* <256, use, else generate */
 int fill;            /* >=0 byte fill            */
 int maskfill;        /* >=0 byte fill            */
 int masksize;
 int imagesize;
 int ln2bpp;
 int masksize2;
 int mbpp;

 int spare[1];

} newspstr;




typedef struct splibstr
{
 newsprite_header * spa;
 wimp_box        sbox;
 int             sflags;
 int             sxos;
 int             sxosp;
 int             syos;
 int             syosp;
 int             sxpos;
 int             sxposp;
 int             sypos;
 int             syposp;
 int             sypix;
 int             sxpix;
 int             sxdpi;
 int             sydpi;
 int             sxscale;
 int             syscale;
 int             sbpp;
 int             smode;
 newspstr        newsp;

} splibstr;





#define SP_BACKFILL 0x1
#define SP_PALETTE  0x2
#define SP_DFILL    0x4
#define SP_SCALE    0x8
#define SP_GREY     0x10
#define SP_INV56    0x20
#define SP_WIDE     0x40
#define SP_NOMASK   0x80



extern int sp_rendergetbox(wimp_box * box);
extern os_error * sp_rendermask(void);
extern os_error * sp_rendersprite(vdustr * vdu);
extern os_error * sp_renderpaint(vdustr * vdu);
extern os_error * sp_renderend(void);
extern os_error * sp_renderstart(wimp_box * box,int flags,int memory,
                                 int dx,int dy,int bpp,int xscale,int yscale);
extern os_error * sp_fill(void);
extern os_error * sp_pass(int pass);


extern void genpalette(int spbpp,int * palentries,int * paltab);


extern os_error * createsprite(newsprite_header ** spa,newspstr * xnew,
                                                          int xpix,int ypix);


extern os_error * createspritem(newsprite_header * spa,newspstr * xnew,
                                                          int xpix,int ypix);

extern os_error * checksprite(int memory,newspstr *xnew,int * sxpix,int *sypix);

extern int spritesize(newspstr *xnew,int xpix,int ypix);

extern os_error * sp_switch(int mask,newsprite_header * spa);
extern os_error * sp_switchtoscreen(vdustr * vdu);

extern splibstr * sp_getsp(void);


