/*->c.prf */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "flex.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "save.h"
#include "fsx.h"
#include "bf.h"



#include "str.h"
#include "constants.h"

#include "file.h"
#include "page.h"
#include "xpage.h"


#include "prstr.h"
#include "xprint.h"
#include "preg.h"

#include "prf.h"




#define PFNAMELEN   32
#define PFFNNAMELEN 32



typedef struct pageformatstr
{
 char name[PFNAMELEN];
 char fn[PFFNNAMELEN];
 char count[PFFNNAMELEN];
 char setup[PFFNNAMELEN];
 int  bits;
 int  mode;

} pageformatstr;



static pageformatstr * pfs;
static int             pfn;




/*
    void addpaperformat(string & formatname,int keyn,
                        string & paperfn,string & countfn,string & setupfn);

*/


void paperaddformat(int fp)
{
 os_error * err;
 char       fnname[PFFNNAMELEN];
 int        count;
 int        result;
 int        mode;

 err=NULL;

 if(!pfs) err=flex_alloc((flex_ptr)&pfs,sizeof(pageformatstr));
 else     err=flex_extend((flex_ptr)&pfs,(pfn+1)*sizeof(pageformatstr));

 if(!err)
 {
  pfs[pfn].mode=mode=stack[fp+1];
  xstrncpy(pfs[pfn].name,stringptr(stack[fp]),PFNAMELEN);
  xstrncpy(pfs[pfn].fn,stringptr(stack[fp+2]),PFFNNAMELEN);
  xstrncpy(pfs[pfn].count,stringptr(stack[fp+3]),PFFNNAMELEN);
  xstrncpy(pfs[pfn].setup,stringptr(stack[fp+4]),PFFNNAMELEN);
  xzstrncpy(fnname,pfs[pfn].fn,sizeof(fnname));
  pfn++;

  xexec(fnname,&result,"IIIIII/R",0,mode,10,0,0,0,&count);
  pfs[pfn-1].bits=count;
 }


/*
 {
  int i;

  for(i=0;i<pfn;i++)
    dprintf(0,"i=%d name=%s",i,pfs[i].name);

 }
*/

 zreport(err);
}



int prfindexfrommode(int mode)
{
 int i;

 for(i=0;i<pfn;i++)
  if(pfs[i].mode==mode) return(i);

 return(0);
}



int prfmodefromindex(int index)
{
 return(pfs[index].mode);
}




/* int paperformat(int n,string & name); */

int paperformat(int fp)
{
 int n;

 n=stack[fp];

 if(n>=pfn) return(0);
 assignstring(stack[fp+1],pfs[n].name);

 return(n+1);
}



char * prmodestring(int mode)
{
 if(pfs) return(pfs[prfindexfrommode(mode)].name);
 return("");
}


int prmodebits(int mode)
{
 if(pfs) return(pfs[prfindexfrommode(mode)].bits);
 return(PRMNOPRINTMARGINS);
}


int prvalidmode(int mode)
{
 if(pfs) return(pfs[prfindexfrommode(mode)].mode==mode);
 return(0);
}





static int        prfpage;
static int        prfsection;
static filestr  * prfile;
static printstr * prfpr;
static int        prfbranch;
static paperstr * prfps;
static int        prfnextsection;
static int        prfnextpage;
static int        prfbase;
static int        prfapno;
static int        prfwidth;
static int        prfheight;
static int        prfxscale;
static int        prfyscale;
static int        prfbits;
static int        prfbleed;
static int        prfmodeindex;
static int        prfmode;
static int        prfmarks;

static int        prfrange[PRRANGEMAX*2];
static int        prfrangemax;


/* void paperfirstpage(void); */
/* NB called below (0) */

void paperfirstpage(int fp)
{
 prfsection=0;
 prfnextsection=prfile->hdr.section[prfbranch];
 prfpage=0;
 prfnextpage=0;
 prfapno=-1;


 USE(fp);
}




/* int papernextpage(void); */
/* NB called below (0) */

int papernextpage(int fp)
{
 sectionstr * sectionp;
 pagestr    * pagep;
 int          bits;
 int          i;

 bits=0x40000000;

 prfpage=prfnextpage;
 if(!prfpage)
 {
  prfsection=prfnextsection;
  if(!prfsection) return(0);

  sectionp=(sectionstr*)fob_find(prfsection,prfile);
  prfnextsection=sectionp->chain.next;
  prfwidth=sectionp->data.width;
  prfheight=sectionp->data.height;
  prfbase=getpagebase(sectionp);

  prfpage=sectionp->chain.child;
 }

 prfapno++;

 pagep=(pagestr*)fob_find(prfpage,prfile);
 prfnextpage=pagep->chain.next;

 if((prfpr->all && !prfpr->range) || !prfrangemax) bits|=0x80000000;
 else
 {
  for(i=0;i<prfrangemax;i++)
  {
   if(prfapno>=prfrange[i*2] && prfapno<=prfrange[i*2+1])
   {
    bits|=0x80000000;
    break;
   }
  }
 }

 bits|=islhpb(pagep,prfbase)?1:0;

 return(bits);

 USE(fp);
}



/* int papercount(int parity); */

int papercount(int fp)
{
 int parity;
 int paper;
 int bits;

 paperfirstpage(0);
 parity=stack[fp];
 paper=0;

 bits=papernextpage(0);
 while(bits)
 {
  if(bits<0)
  {
   if(((bits & 0x1)==parity) || parity<0)
   {
    bits=papernextpage(0);
   }
   parity^=1;
   paper++;
  }
  else
  {
   bits=papernextpage(0);
  }
 }

 return(paper);
}





int paperpagewidth(int fp)
{
 return(prfwidth);
 USE(fp);
}


int paperpageheight(int fp)
{
 return(prfheight);
 USE(fp);
}


int paperbleed(int fp)
{
 return(prfbleed);
 USE(fp);
}



int papermarkx(int fp)
{
 aboxstr abox;
 regmsize(stack[fp],&abox);
 return(abox.x0+abox.x1);
}



int papermarky(int fp)
{
 aboxstr abox;
 regmsize(stack[fp],&abox);
 return(abox.x0+abox.x1);
}




int papermarks(int fp)
{
 return(prfmarks);
 USE(fp);
}


/* int paperxscale(void); */

int paperxscale(int fp)
{
 return(prfxscale);
 USE(fp);
}


/* int paperyscale(void); */

int paperyscale(int fp)
{
 return(prfyscale);
 USE(fp);
}


/* int paperbits(void);   */

int paperbits(int fp)
{
 return(prfbits);
 USE(fp);
}



/* void paperpage(int n,int xpo,int ypo,
                     int xlo,int xhi,int yhi,int ylo,int angle); */



void paperpage(int fp)
{
 int n;

 n=stack[fp];

 prfps->pset[n].xpo=stack[fp+1];
 prfps->pset[n].ypo=stack[fp+2];
 prfps->pset[n].abox.x0=stack[fp+3];
 prfps->pset[n].abox.x1=stack[fp+4];
 prfps->pset[n].abox.y1=stack[fp+5];
 prfps->pset[n].abox.y0=stack[fp+6];
 prfps->pset[n].angle=stack[fp+7];
 prfps->pset[n].page=prfpage;
 prfps->pset[n].section=prfsection;
 prfps->pset[n].scale=0;
}






/* void paperpagescale(int n,int xpo,int ypo,
        int xlo,int xhi,int yhi,int ylo,int angle,int xscale,int yscale); */



void paperpagescale(int fp)
{
 int n;

 n=stack[fp];

 prfps->pset[n].xpo=stack[fp+1];
 prfps->pset[n].ypo=stack[fp+2];
 prfps->pset[n].abox.x0=stack[fp+3];
 prfps->pset[n].abox.x1=stack[fp+4];
 prfps->pset[n].abox.y1=stack[fp+5];
 prfps->pset[n].abox.y0=stack[fp+6];
 prfps->pset[n].angle=stack[fp+7];
 prfps->pset[n].page=prfpage;
 prfps->pset[n].section=prfsection;
 prfps->pset[n].scalex=stack[fp+8];
 prfps->pset[n].scaley=stack[fp+9];
 prfps->pset[n].scale=1;
}







/* void paperpagearea(int n,int xlo,int xhi,int yhi,int ylo,int marks); */

void paperpagearea(int fp)
{
 int n;

 n=stack[fp];

 prfps->pset[n].cbox.x0=stack[fp+1];
 prfps->pset[n].cbox.x1=stack[fp+2];
 prfps->pset[n].cbox.y1=stack[fp+3];
 prfps->pset[n].cbox.y0=stack[fp+4];
 prfps->pset[n].marks=stack[fp+5];
}



/* void paperarea(int xlo,int xhi,int yhi,int ylo,int marks); */

void paperarea(int fp)
{
 prfps->cbox.x0=stack[fp];
 prfps->cbox.x1=stack[fp+1];
 prfps->cbox.y1=stack[fp+2];
 prfps->cbox.y0=stack[fp+3];
 prfps->marks=stack[fp+4];
}


void papermaxarea(int fp)
{
 prfps->mbox.x0=stack[fp];
 prfps->mbox.x1=stack[fp+1];
 prfps->mbox.y1=stack[fp+2];
 prfps->mbox.y0=stack[fp+3];
}




static os_error * prsetup(printstr * pr,paperstr * ps,
                                                   filestr * file,int branch)
{
 os_error * err;

 prfile=file;
 prfpr=pr;
 prfbranch=branch;
 prfps=ps;
 prfxscale=ttmul(prfpr->scale,prfpr->aspect);
 prfyscale=prfpr->scale;
 prfbleed=prfpr->bleed?bleedsize:0;
 prfbits=(prfpr->oddevenall|(prfpr->bleed<<5)|(prfpr->sideways<<4));
 prfmode=pr->mode+(pr->mode2<<4);
 prfmodeindex=prfindexfrommode(prfmode);
 prfmarks=pr->regm?(pr->marks ^ 0xFFFFFFFF):0;

 err=readpagerange((char*)&prfpr->from,prfrange,&prfrangemax,prfile,prfbranch);
 if(err) prfrangemax=0;

 return(err);
}



/*

int  papercount(int file,int keyn,int paperbits);

     return number of pieces of paper

*/


int prcountpages(printstr * pr,filestr * file,int branch)
{
 int  result;
 int  count;
 char countname[PFFNNAMELEN];

 prsetup(pr,NULL,file,branch);

 xzstrncpy(countname,pfs[prfmodeindex].count,sizeof(countname));

 xexec(countname,&result,"III/R",(int)file,prfmode,prfbits,&count);

 return(count);
}




/*

void papersetup(int file,int keyn,int paperbits,int paperno,int nopaper);

     generate the positions of the pages on this piece of paper

*/


void prsetlogicalpage(printstr * pr,paperstr * ps,int lpno,int nopages,
                                                  filestr * file,int branch)
{
 int result;
 int i;

 prsetup(pr,ps,file,branch);

 for(i=0;i<ps->n;i++)
 {
  ps->pset[i].page=0;
  ps->pset[i].section=0;
 }

 xexec(pfs[prfmodeindex].setup,&result,"IIIII",
                              (int)file,(int)prfmode,prfbits,lpno,nopages);
}
                                                                                



/* reason 0 */


int prpapern(filestr * file,printstr * pr)
{
 char fnname[PFFNNAMELEN];
 int  count;
 int  result;

 prsetup(pr,NULL,file,0);

 xzstrncpy(fnname,pfs[prfmodeindex].fn,sizeof(fnname));

 xexec(fnname,&result,"IIIIII/R",(int)file,prfmode,0,
               file->hdr.maxpagewidth[0],file->hdr.maxpageheight[0],0,&count);

 return(count);
}




/* reason 1 */

os_error * prbox(printstr * pr,paperstr * ps,filestr * file,int branch)
{
 char fnname[PFFNNAMELEN];
 int  count;
 int  result;

 prsetup(pr,ps,file,branch);

 xzstrncpy(fnname,pfs[prfmodeindex].fn,sizeof(fnname));

 xexec(fnname,&result,"IIIIII/R",(int)file,prfmode,1,
               file->hdr.maxpagewidth[0],file->hdr.maxpageheight[0],0,&count);

 return(NULL);
}



/* reason 2/3/4 */

os_error * prsetmode(printstr * pr,filestr * file,int * xscale,int * sideways)
{
 char fnname[PFFNNAMELEN];
 int  count;
 int  result;
 int  maxw;
 int  maxh;


 prsetup(pr,NULL,file,0);

 maxw=file->hdr.maxpagewidth[0];
 maxh=file->hdr.maxpageheight[0];

 xzstrncpy(fnname,pfs[prfmodeindex].fn,sizeof(fnname));

 xexec(fnname,&result,"IIIIII/R",(int)file,prfmode,2,maxw,maxh,0,&count);

 pfs[prfmodeindex].bits=count;

 if(xscale)
 {
  xexec(fnname,&result,"IIIIII/R",(int)file,prfmode,3,maxw,maxh,0,xscale);
 }

 if(sideways)
 {
  xexec(fnname,&result,"IIIIII/R",(int)file,prfmode,4,maxw,maxh,0,sideways);
 }

 return(NULL);
}



os_error * prmarginbox(printstr * pr,paperstr * ps,filestr * file,
                                     int lefthand,int pwidth,int pheight)
{
 char fnname[PFFNNAMELEN];
 int  count;
 int  result;


 prsetup(pr,ps,file,0);

 xzstrncpy(fnname,pfs[prfmodeindex].fn,sizeof(fnname));

 xexec(fnname,&result,"IIIIII/R",(int)file,prfmode,5,pwidth,pheight,lefthand,&count);

 return(NULL);
}





os_error * prfupdate(printstr * pr,filestr * file)
{
 char fnname[PFFNNAMELEN];
 int  count;
 int  result;

 prsetup(pr,NULL,file,0);

 for(prfmodeindex=0;prfmodeindex<pfn;prfmodeindex++)
 {
  xzstrncpy(fnname,pfs[prfmodeindex].fn,sizeof(fnname));
  xexec(fnname,&result,"IIIIII/R",(int)file,pfs[prfmodeindex].mode,6,
                                                               0,0,0,&count);
 }

 return(NULL);
}




os_error * prfchange(printstr * pr,filestr * file,int * change)
{
 char fnname[PFFNNAMELEN];
 int  result;
 int  value;

 prsetup(pr,NULL,file,0);

 for(prfmodeindex=0;prfmodeindex<pfn;prfmodeindex++)
 {
  xzstrncpy(fnname,pfs[prfmodeindex].fn,sizeof(fnname));
  xexec(fnname,&result,"IIIIII/R",(int)file,pfs[prfmodeindex].mode,7,
                                                              0,0,0,&value);
  if(value) *change=1;
 }

 return(NULL);
}



/*

Load the print format values from the document. Called when the dbox is
opened or a document is about to be printed.

*/


os_error * prsetfromfile(printstr * pr,filestr * file)
{
 char fnname[PFFNNAMELEN];
 int  count;
 int  result;
 int  maxw;
 int  maxh;

 prsetup(pr,NULL,file,0);

 maxw=file->hdr.maxpagewidth[0];
 maxh=file->hdr.maxpageheight[0];

 for(prfmodeindex=0;prfmodeindex<pfn;prfmodeindex++)
 {
  xzstrncpy(fnname,pfs[prfmodeindex].fn,sizeof(fnname));
  xexec(fnname,&result,"IIIIII/R",(int)file,pfs[prfmodeindex].mode,8,
                                                        maxw,maxh,0,&count);
  pfs[prfmodeindex].bits=count;
 }

 return(NULL);
}




/*

The print dbox menu is about to be popped up. Chance to calculate local
variable values.

*/


os_error * prfsetup(printstr * pr,filestr * file,int branch)
{
 char fnname[PFFNNAMELEN];
 int  count;
 int  result;
 int  maxw;
 int  maxh;

 prsetup(pr,NULL,file,0);

 maxw=file->hdr.maxpagewidth[0];
 maxh=file->hdr.maxpageheight[0];

 for(prfmodeindex=0;prfmodeindex<pfn;prfmodeindex++)
 {
  xzstrncpy(fnname,pfs[prfmodeindex].fn,sizeof(fnname));
  xexec(fnname,&result,"IIIIII/R",(int)file,pfs[prfmodeindex].mode,9,
                                                        maxw,maxh,0,&count);
 }

 return(NULL);

 USE(branch);
}




