/*->c.print */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "xmath.h"
#include "drag.h"
#include "conf.h"
#include "redraw.h"
#include "etc.h"
#include "bits.h"
#include "fsx.h"
#include "bf.h"
#include "dbhi.h"
#include "osprint.h"
#include "deb.h"
#include "osunits.h"
#include "imlib.h"

#include "str.h"
#include "constants.h"
#include "object.h"

#include "reslink.h"
#include "units.h"
#include "dbchoices.h"

#include "view.h"
#include "viewr.h"
#include "file.h"
#include "geometry.h"

#include "page.h"

#include "prstr.h"
#include "pract.h"
#include "dbprint.h"
#include "prf.h"
#include "preg.h"
#include "dbfields.h"
#include "dbmarks.h"
#include "postscript.h"
#include "psppd.h"

#include "xprint.h"




int inprinter; /* in printer code      */


int printmode; /* 0==poll 1==don't poll */

int bleedsize;

int regthickness;

int printmemory;

int printbits;


int crophlength;
int crophstandoff;
int cropvlength;
int cropvstandoff;

int reghlength;
int regvlength;
int regradius;
int reghstandoff;
int regvstandoff;



/*****************************************************************************/

static int rosprintarea=0;  /* is there a print area set up */

static prmarginstr prmargin;


#define MARGINCOLOUR 1


prmarginstr * printerarea(void)
{
 return(rosprintarea?&prmargin:NULL);
}


/* int printerwidth(void);  */

int printerwidth(int fp)
{
 return(rosprintarea?(prmargin.rightarea-prmargin.leftarea):-1);
 USE(fp);
}


/* int printerheight(void); */

int printerheight(int fp)
{
 return(rosprintarea?(prmargin.toparea-prmargin.botarea):-1);
 USE(fp);
}


/* int paperwidth(void); */

int paperwidth(int fp)
{
 return(rosprintarea?prmargin.paperxsize:-1);
 USE(fp);
}


/* int paperheight(void); */

int paperheight(int fp)
{
 return(rosprintarea?prmargin.paperysize:-1);
 USE(fp);
}


#ifdef NEVER
void prsavemargins(prmarginstr * margin)
{
 *margin=prmargin;
}

void prloadmargins(prmarginstr * margin)
{
 prmargin=*margin;
}


os_error * prsetupmargins(prmarginstr * margin)
{
/*
 os_regset   rx;

 rx.r[1]=margin->paperxsize;
 rx.r[2]=margin->paperysize;
 rx.r[3]=margin->leftarea;
 rx.r[4]=margin->rightarea;
 rx.r[5]=margin->toparea;
 rx.r[6]=margin->botarea;
*/
// return(os_swix(PDriver_SetPageSize,&rx));
 return(NULL);
}

#endif




void autoscalecentres(int width,int height,printstr * pr,prscalestr * prs,prmarginstr * prmargin) 
{
 int          prwidth;
 int          prheight;
 int          pgwidth;
 int          pgheight;
 int          pgswidth;
 int          pgsheight;
 int          bx;
 int          by;
 int          temp;
 int          xscale;
 int          yscale;



 yscale=pr->scale;
 xscale=ttmul(yscale,pr->aspect);

 prs->xshift=pr->cx;
 prs->yshift=pr->cy;

 if(prmargin && (pr->centrex || pr->centrey || pr->fitx || pr->fity))
 {
  pgwidth=width;
  pgheight=height;

  if(pr->centrex && pr->fitx)
  {
   /* find max of left and width-right */

   temp=prmargin->paperxsize-prmargin->rightarea;
   if(temp<prmargin->leftarea) temp=prmargin->leftarea;

   prwidth=prmargin->paperxsize-2*temp;
   bx=temp;

   /* find max of botarea and height-top */

   temp=prmargin->paperysize-prmargin->toparea;
   if(temp<prmargin->botarea) temp=prmargin->botarea;
   prheight=prmargin->paperysize-2*temp;
   by=temp;
  }
  else
  if(pr->centrex)
  {
   prwidth=prmargin->paperxsize;
   prheight=prmargin->paperysize;
   bx=by=0;

  /*
     prwidth=prmargin.rightarea-prmargin.leftarea;
     prheight=prmargin.toparea-prmargin.botarea;
     bx=prmargin.leftarea;
     by=prmargin.botarea;
  */

  }
  else
  {
   prwidth=prmargin->rightarea-prmargin->leftarea;
   prheight=prmargin->toparea-prmargin->botarea;
   bx=prmargin->leftarea;
   by=prmargin->botarea;
  }


  if(pr->fitx)
  {
   if(pr->sideways) xscale=scale(0x10000,prheight,pgwidth);
   else             xscale=scale(0x10000,prwidth,pgwidth);
  }

  if(pr->fity)
  {
   if(pr->sideways) yscale=scale(0x10000,prwidth,pgheight);
   else             yscale=scale(0x10000,prheight,pgheight);
  }

  if(pr->fitx)
  {                                   /* fix aspect ratio */
   if(xscale>yscale) xscale=yscale;
   else              yscale=xscale;
  }

  pgswidth =scale(pgwidth,xscale,0x10000);
  pgsheight=scale(pgheight,yscale,0x10000);




  if(pr->centrex || pr->fitx)
  {
   if(pr->sideways) prs->xshift=bx-(pgsheight-prwidth)/2;
   else             prs->xshift=bx-(pgswidth-prwidth)/2;
  }

  if(pr->centrey || pr->fity)
  {
   if(pr->sideways) prs->yshift=by-(pgswidth -prheight)/2;
   else             prs->yshift=by-(pgsheight-prheight)/2;
  }

 }

 prs->xscale=xscale;
 prs->yscale=yscale;
}


void autoscalecentre(int width,int height,printstr * pr,
                     paperstr * ps,int papern,prmarginstr * prmargin) 
{
 prscalestr   prscale;
 transformstr tr1;
 transformstr tr2;

 autoscalecentres(width,height,pr,&prscale,prmargin);

 tr_setnull(&ps->tr);

 ps->tr.e=prscale.xshift;
 ps->tr.f=prscale.yshift;

 if(pr->sideways)
 {
  ps->tr.b=prscale.xscale;

  if(pr->reflect)
  {
   ps->tr.c=prscale.yscale;
  }
  else
  {
   ps->tr.c=-prscale.yscale;
   ps->tr.e+=scale(height,prscale.yscale,0x10000);
  }
 }
 else
 {
  if(pr->reflect)
  {
   ps->tr.a=-prscale.xscale;
   ps->tr.e+=scale(width,prscale.xscale,0x10000);
  }
  else
  {
   ps->tr.a=prscale.xscale;
  }

  ps->tr.d=prscale.yscale;
 }

 if(pr->tumble && 
    (pr->oddevenall==PRODD || pr->oddevenall==PREVEN || (papern & 0x1)))
 {
  tr_setrotationa(&tr1,180*0x10000);
  tr1.e=width;
  tr1.f=height;

  tr2=ps->tr;

  tr_multiply(&ps->tr,&tr1,&tr2);
 }
}




static int calcprintarea(filestr * file,int section,int page,
                          int * widthp,int *heightp,
                          int * left,int * right,int * top,int * bot)
{
 coordstr     cx[2];
 oprintstr    opr;
 paperstr     ps;
 sectionstr * sectionp;
 pagestr    * pagep;
 int          width;
 int          height;
 int          lefthand;
 int          base;
 int          pwidth;
 int          pheight;
 int          bits;


 opr=*((oprintstr*)fob_find(file->hdr.print,file));
 bits=prmodebits(opr.pr.mode);


 if(bits & PRMNOPRINTMARGINS)
 {
  return(1);
 }
 else
 {
  sectionp=(sectionstr*)fob_find(section,file);
  if(sectionp==NULL) return(1);
  *widthp=pwidth=width=sectionp->data.width;
  *heightp=pheight=height=sectionp->data.height;
  base=getpagebase(sectionp);

  pagep=(pagestr*)fob_find(page,file);
  if(pagep==NULL) return(1);
  lefthand=islhpb(pagep,base);

  memset(&ps,0,sizeof(paperstr));
  ps.n=DEFPSET;

  prmarginbox(&opr.pr,&ps,file,lefthand,pwidth,pheight);

  if(ps.pset[0].marks)
  {
   praddmarks(&ps.pset[0].cbox,&ps.pset[0].cbox,ps.pset[0].marks);
   getsumabox(&ps.mbox,&ps.pset[0].abox);
  }

  if(ps.marks)
  {
   praddmarks(&ps.cbox,&ps.cbox,ps.marks);
   getsumabox(&ps.mbox,&ps.cbox);
  }


  width=ps.mbox.x1-ps.mbox.x0;
  height=ps.mbox.y1-ps.mbox.y0;

  cx[0].x=prmargin.leftarea;
  cx[0].y=prmargin.toparea;
  cx[1].x=prmargin.rightarea;
  cx[1].y=prmargin.botarea;

  autoscalecentre(width,height,&opr.pr,&ps,0,printerarea());

  tr_inverseset(cx,2,&ps.tr);

  if(opr.pr.sideways) SWOP(cx[0].x,cx[1].x);

  cx[0].x-=(ps.pset[0].xpo-ps.mbox.x0);
  cx[1].x-=(ps.pset[0].xpo-ps.mbox.x0);
  cx[0].y-=(ps.mbox.y1-ps.pset[0].ypo);
  cx[1].y-=(ps.mbox.y1-ps.pset[0].ypo);


  if(cx[0].x<0)       cx[0].x=0;
  if(cx[1].y<0)       cx[1].y=0;
  if(cx[1].x>pwidth)  cx[1].x=pwidth;
  if(cx[0].y>pheight) cx[0].y=pheight;


  *left=cx[0].x;
  *right=cx[1].x;
  *top=cx[0].y;
  *bot=cx[1].y;

  return(0);
 }
}





os_error * redrawprint(viewredrawstr * v)
{
 int          xleft;      /* do transform on these vars */
 int          xright;
 int          xtop;
 int          xbot;
 int          righth;
 int          lefth;
 filestr    * file;
 viewstr    * view;
 int          height;
 int          width;
 int          x;
 int          y;

 if(rosprintarea && !v->isprinter)
 {
  view=v->view;



  if(view->data.margins)
  {
   file=v->file;


   if(!calcprintarea(file,v->section,v->page,&width,&height,
                                         &xleft,&xright,&xtop,&xbot))
   {


    seteorcol(0,MARGINCOLOUR);

   /* left hand edge  */



    bbc_rectanglefill(v->ox+osunits(v->xpo,view),v->oy-osunits(v->ypo,view),
                      osunits(xleft,view),-osunits(height,view));

    x=v->ox+osunits(v->xpo,view)+osunits(xleft,view);
    y=v->oy-osunits(v->ypo,view);

    gros2pix(&x,&y);
    x++;
    grpix2osr(&x,&y);

    lefth=x;

   /* right hand edge */


    bbc_rectanglefill(v->ox+osunits(v->xpo+xright,view),
                      v->oy-osunits(v->ypo,view),
                      osunits(width-xright,view),-osunits(height,view)); 

    x=v->ox+osunits(v->xpo+xright,view);
    y=v->oy-osunits(v->ypo,view);

    gros2pix(&x,&y);
    x--;
    grpix2osr(&x,&y);
 
    righth=x;

   /* bottom edge     */

    bbc_rectanglefill(lefth,v->oy-osunits(v->ypo,view)-osunits(height,view),
                      righth-lefth,osunits(xbot,view));

   /* top edge        */

    bbc_rectanglefill(lefth,v->oy-osunits(v->ypo,view),
                      righth-lefth,-osunits(height-xtop,view));

   }
  }
 }
 return(NULL);
}







void prupdatefile(filestr * file,int pasteboard,int pass)
{
 viewstr * view;

 view=file->view;
 while(view)
 {
  if(!view->data.pasteboard || !pasteboard)
  {
   if(view->data.margins)
   {
    viewrefreshview(view,VRPRINT|VRONELAYER);
   }
  }
  else
  {
   if(pass)
   {
    viewrefreshview(view,VRBACK);
   }
  }

  view=view->next;
 }
}



static void prupdateall(void)
{
 filestr * file;

 file=firstfile;
 while(file)
 {
  prupdatefile(file,0,0);
  file=file->next;
 }
}



static void getpagesize(void)
{
 os_error * ep;
 int        changed=0;
 int        left;
 int        right;
 int        top;
 int        bottom;
 int        width;
 int        height;



 ep=osxprintmargins(&left,&right,&top,&bottom,&width,&height,FONTXRES,FONTYRES);

// cprintf("left %d right %d top %d bottom %d width %d height %d",left,right,top,bottom,width,height);
 
 if(ep)
 {
  if(rosprintarea)
  {
   prupdateall();
   rosprintarea=0;
  }
 }
 else
 {
  top=height-top;
  bottom=height-bottom;
  
  if(!rosprintarea)
  {
   rosprintarea=1;
   changed=1;
  }
  else
  {
   if(prmargin.leftarea!=left)  changed=1;
   if(prmargin.rightarea!=right) changed=1;
   if(prmargin.toparea!=top)   changed=1;
   if(prmargin.botarea!=bottom)   changed=1;

   if(changed) prupdateall();
  }

  prmargin.paperxsize=width;
  prmargin.paperysize=height;
  prmargin.leftarea=left;
  prmargin.rightarea=right;
  prmargin.toparea=top;
  prmargin.botarea=bottom;


  if(changed) prupdateall();
 }
}


/* called when printer configuration has changed */

static os_error * setprinterdriver(wimp_msgstr * msg,int * ack)
{
 cprintf("set printer driver");
 
 getpagesize();
 prdbwritetitle();

 event(EVENT_PRPAGECHANGE,0,NULL);

 return(NULL);
 USE(msg);
 USE(ack);
}

/* called when printer driver starts up */

static os_error * printinitdriver(wimp_msgstr * msg,int * ack)
{
 getpagesize();

 event(EVENT_PRCHANGE,0,NULL);

 return(NULL);
 USE(msg);
 USE(ack);
}


/***************************************************************************/

static printstr defprint=
{
 PRNORM,    /* mode - normal, pamphlet, thumb, tile */
 0,         /* fitx      */
 0,         /* fity      */
 1,         /* centrex   */
 1,         /* centrey   */
 0,         /* regm      */
 0,         /* sideways  */
 0,         /* backwards */
 0,         /* collate   */
 0,         /* pause     */
 0,         /* nopics    */
 0,         /* draft     */
 0,         /* merge     */
 1,         /* all       */
 PRALL,     /* oddevenall */
 0,         /* options    */
 0,         /* bleed      */
 0,         /* sheet      */
 PRODD,     /* sheetoddeven */
 0,         /* reflect      */
 0,         /* mode2      */

 1,         /* copies     */

 0,         /* from       */
 0,         /* to         */
 "",        /* froms      */
 "",        /* tos        */

 0,         /* headings     */
 0,         /* set on <2.48 */
 0,         /* range        */
 0,         /* tumble       */
 0,         /* print to file */
 0,         /* sheetoddevenall 3 more bits to combine with above */
	0,         /* print proxies */

 MMSIZE*10, /* tile */
 0x10000,   /* scale */
 0x10000,   /* aspect */
 0,         /* cx */
 0,         /* cy */

 0,         /* record */
 0,         /* sheet  */


 0,         /* marks bits */


 /* spare 13 */

 0,0,0,0,0,
 0,0,0,0,0,
 0,0,0,

 "",        /* merge path */

};



static os_error * newprint(filestr * file)
{
 os_error      * err;
 int             handle=0; /* init to make compiler happy */
 oprintstr     * pr;

 err=fob_create(sizeof(oprintstr),file,OPRINT,(fobjptr)&pr);
 if(!err)
 {
  handle=pr->key;
  pr->pr=defprint;
  file->hdr.print=handle;
 }
 return(err);
}






/* NB s==source d==dest. */

static os_error * printmkstyle(int eventn,int user,filestr * dfile,
                                                    filestr * sfile)
{
 os_error      * err;
 oprintstr     * pr;
 int             print;


 err=fob_copy((fobjptr)&pr,dfile,sfile->hdr.print,sfile);
 if(!err)
 {
  print=pr->key;
  dfile->hdr.print=print;
 }

 return(err);

 USE(eventn);
 USE(user);
}



static os_error * printnewevent(int eventn,int user,filestr * file,
                                                             void * data)
{
 return(newprint(file));
 USE(eventn);
 USE(data);
 USE(user);
}



static os_error * printsetupevent(int eventn,int user,filestr * file,
                                                             void * data)
{
 sectionstr * sectionp;
 oprintstr  * pr;
 int          shape;

 if(file->hdr.section[DOC]) sectionp=(sectionstr*)fob_find(file->hdr.section[DOC],file);
 else                       sectionp=(sectionstr*)fob_find(file->hdr.section[MST],file);

 if(sectionp)
 {
  shape=sectionp->data.shape;

  pr=(oprintstr*)fob_find(file->hdr.print,file);
  pr->pr.sideways=shape;
 }

 return(NULL);

 USE(eventn);
 USE(data);
 USE(user);
}







static os_error * printbareevent(int eventn,int user,filestr * file,
                                                             void * data)
{
 return(newprint(file));
 USE(eventn);
 USE(data);
 USE(user);
}






static errtag errortable[]=
{
 PR00,"{PR00}",
 PR01,"{PR01}",
 PR02,"{PR02}",
 PR03,"{PR03}",
 PR10,"{PR10}",
 PR11,"{PR11}",
 PR13,"{PR13}",
 PR14,"{PR14}",

 ELAST ,""
};

static errlink errorlink;





os_error * chprintsave(buffer * bf)
{
 os_error * err;

 err=bf_printfeol(bf,"printchoices(%d,%d,%d,%d);",
                            printmode,bleedsize,regthickness,printmemory);
 if(!err) err=bf_printfeol(bf,"printchoices2(%d,%d,%d,%d);",printbits,0,0,0);

 if(!err) err=bf_printfeol(bf,"printchoices3(%d,%d,%d,%d);",
                        crophlength,crophstandoff,cropvlength,cropvstandoff);

 if(!err) err=bf_printfeol(bf,"printchoices4(%d,%d,%d,%d,%d);",
                  reghlength,regvlength,regradius,reghstandoff,regvstandoff);

 if(!err) err=postscriptchoices(bf);

 return(err);
}


void printchoices(int fp)
{
 printmode=stack[fp];
 printmode=0; // Win
 bleedsize=stack[fp+1];
 regthickness=stack[fp+2];
 printmemory=stack[fp+3];
}


void printchoices2(int fp)
{
 printbits&=stack[fp+1];
 printbits^=stack[fp];

}


void printchoices3(int fp)
{
 crophlength=stack[fp];
 crophstandoff=stack[fp+1];
 cropvlength=stack[fp+2];
 cropvstandoff=stack[fp+3];
}


void printchoices4(int fp)
{
 reghlength=stack[fp];
 regvlength=stack[fp+1];
 regradius=stack[fp+2];
 reghstandoff=stack[fp+3];
 regvstandoff=stack[fp+4];
}



int getprintbits(void)
{
 return(printbits);
}

int xgetprintbits(int fp)
{
 return(printbits);
 USE(fp);
}



// int getprintername(int n,string & s);
// return 0 for no name return non-zero and name

int getprintername(int fp)
{
 os_error * err=NULL;
 char       string[256];
 int        code;
 int        n;

 code=0;
 n=stack[fp];

 err=osprgetnamen(n,string,sizeof(string));
 if(!err)
 {
  if(*string)
  {
   assignstring(stack[fp+1],string);
   code=n+1;
  }
 }

 zreport(err);

 return(code);
}


// void setprintername(string & s)

void setprintername(int fp)
{
 zreport(osprsetcurrentname(stringptr(stack[fp])));
 USE(fp);
}



// int gercurrentprinter(string & s)

int getcurrentprinter(int fp)
{
 char string[256];

 osprgetcurrentname(string,sizeof(string));

 assignstring(stack[fp],string);

 return(0);
}







os_error * printinit(void)
{
 os_error * err;

 cprintf("print init!!!!!!!!!!");

 err=osxprintinit();

 getpagesize();

 addmessage(setprinterdriver,wimp_MPrinterChange);
 addmessage(printinitdriver,wimp_MPrintInit);

 if(!err) err=adderrortable(errortable,&errorlink);
 if(!err) err=printactinit();

 if(!err) err=addevent(EVENT_MKSTYLE1,(eventfn)printmkstyle,0);
 if(!err) err=addevent(EVENT_NEWDOC1,(eventfn)printnewevent,0);
 if(!err) err=addevent(EVENT_NEWDOCA,(eventfn)printsetupevent,0);
 if(!err) err=addevent(EVENT_BAREDOC1,(eventfn)printbareevent,0);

 if(!err) err=prchoicesinit();

 if(!err) err=dbfieldsinit();


 return(err);
}














