/*->c.pstext */




#include "stdafx.h"

//#include "commctrl.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "bbc.h"
#include "font.h"
#include "flex.h"
#include "alloc.h"
#include "transform.h"
#include "xprocess.h"


#include "xext.h"
#include "wos.h"
#include "err.h"
#include "poll.h"
#include "colour.h"
#include "xmath.h"
#include "etc.h"
#include "bits.h"
#include "dbhi.h"
#include "fsx.h"
#include "bf.h"
#include "osprint.h"
#include "drawmod.h"
#include "deb.h"
#include "imlib.h"
#include "timex.h"
#include "key.h"
#include "comctls.h"
#include "conf.h"


#include "str.h"
#include "constants.h"
#include "object.h"
#include "reslink.h"

#include "geometry.h"
#include "xredraw.h"

#include "view.h"
#include "viewr.h"
#include "file.h"
#include "page.h"
#include "main.h"



#include "xxcolour.h"
#include "xcolour.h"
#include "cconv.h"
#include "colsep.h"
#include "splink.h"

#include "curve.h"


#include "prstr.h"
#include "xprint.h"
#include "prstat.h"
#include "pract.h"
#include "preg.h"

#include "txstr.h"
#include "codes.h"
#include "fx.h"
#include "fox.h"
#include "fcache.h"
#include "txchoices.h"
#include "dbscale.h"


#include "psinternal.h"

#include "postscript.h"


#include "psppd.h"





/***************************************************************************/

/*

  +Font Substitution Table
     Win Font  <PS Font>

  +Form to Tray Assignment
     Front Tray <A4>
     Manual <A4>

  +Paper/Output
     Paper size <A4>
     Paper source

  +Graphic
     Resolution
     Colour appearance

  +Printer Features
     < from PPD file >


  +PostScript Options
     Send Ctrl D before each job
     Send Ctrl D after each job
     Generate Job Control code
     Font Substitution <type 1, type 3>

  Duplex options


*/



#define MAXLINE    255
#define MAXKEYWORD 40

#define PPDSTRINGCHUNK 0x1000

#define PPDSELECTED    0x1


static void * ppdstringhandle;


typedef struct ppdkeywordstr
{
 char keyword[MAXKEYWORD+1];
 char option[MAXKEYWORD+1];
 int  value;              // string heap pointer
 int  transvalue;         // translation of value
 int  translation;        // string heap pointer, translation of option
 int  flags;              // selected?

} ppdkeywordstr;


#define PPDKEYCHUNK (16*sizeof(ppdkeywordstr))


static ppdkeywordstr * ppdkeyword;
static int             ppdkeywordn;



static char * ppdvalue(int i)
{
 if(i>=0 && i<ppdkeywordn)
 {
  if(ppdkeyword[i].transvalue) return(stringheapstring(ppdstringhandle,ppdkeyword[i].transvalue));
  if(ppdkeyword[i].value) return(stringheapstring(ppdstringhandle,ppdkeyword[i].value));
 }

 return("");
}


static char * ppdoption(int i)
{
 if(i>=0 && i<ppdkeywordn)
 {
  if(ppdkeyword[i].translation) return(stringheapstring(ppdstringhandle,ppdkeyword[i].translation));
 }

 return(ppdkeyword[i].option);
}


static int ppdkeywordsearch(char * keyword)
{
 int i;

 for(i=0;i<ppdkeywordn;i++)
 {
  if(!cstrcmp(ppdkeyword[i].keyword,keyword))
  {
   return(i);
  }
 }

 return(-1);
}



static os_error * ppdparseinit(void)
{

 if(ppdstringhandle) stringheapfinit(&ppdstringhandle);
 if(ppdkeyword)      flex_free((flex_ptr)&ppdkeyword);
	ppdkeywordn=0;


 return(NULL);
}


static os_error * ppdparse(char * filename)
{
 os_error * err;
 buffer     bf;
 int        eof;
 char       string[MAXLINE+2];
 int        ch=0;
 char     * p;
 char     * s;
 int        posn;
 int        posn2;
 int        offset;
 int        eolnseen;


 ppdparseinit();

 eolnseen=0;

 err=stringheapinit(&ppdstringhandle,PPDSTRINGCHUNK);
 if(!err) err=flex_alloc((flex_ptr)&ppdkeyword,PPDKEYCHUNK);

 if(!err)
 {
  if(fs_extensionis(filename,"ppd")) err=generror(0,"Need printer driver to have .ppd file");
 }

 if(!err)
 {
  err=bf_open(filename,'r',DEFBUFFSIZE,&bf);
  if(!err)
  {
   string[MAXLINE]=0;

   while(1)
   {
    bf_tell(&bf,&posn);

    err=bf_getstring(&bf,string,sizeof(string),&eof);
    if(err) break;

//    cprintf("%s",string);

    if(string[MAXLINE])
    {
     err=generror(0,"PPD file contains a line that is too long");
     break;
    }

    p=string;
    while(1)
    {
     ch=*p++;
     if(ch==0) break;
     if(ch<32 && ch!=9)
     {
      err=generror(0,"PPD (%s) contains illegal byte code <%x>",ch,filename);
      break;
     }
    }
    if(err) break;

    if(string[0]=='*')  // keyword
    {
     if(string[1]!='%') // chuck comments
     {
      p=string+1;

      while(1)           // parse out keyword
      {
       ch=*p++;
       if(ch==' ' || ch==':' || ch=='\t' || ch==0) break;
       if(ch>126)
       {
        err=generror(0,"PPD (%s) keyword contains illegal byte code <%x>",filename,ch);
        break;
       }
      }
      if(err) break;
                        // keyword is string+1 to p-1

      if((p-(string+1))>MAXKEYWORD) err=generror(0,"PPD (%s) keyword too long",filename);
      if(err) break;

      if(eolnseen)
      {
       if(cstrncmp("End",string+1,3))
       {
        err=generror(0,"PPD (%s) End not found",filename);
        break;
       }

       eolnseen=0;
       continue;           /* !!!!!!!!!!!!!!!! */
      }
      else
      {
       if(!cstrncmp("End",string+1,3))
       {
        err=generror(0,"PPD (%s) unexpected End found",filename);
        break;
       }
      }

      err=flex_chunk((flex_ptr)&ppdkeyword,(ppdkeywordn+1)*sizeof(ppdkeywordstr),PPDKEYCHUNK);
      if(err) break;
      memset(ppdkeyword+ppdkeywordn,0,sizeof(ppdkeywordstr));
      xzstrncpy(ppdkeyword[ppdkeywordn].keyword,string+1,p-(string+1));
      ppdkeywordn++;

      if(ch!=':' && ch!=0)  // possible option
      {
       while(1)             // strip white space
       {
        ch=*p++;
        if(ch!=' ' && ch!='\t')
        {
         p--;
         break;
        }
       }

       if(ch!=0 && ch!=':')
       {
        s=p;             // start of option

        while(1)
        {
         ch=*p++;
         if(ch=='/' || ch==':') break;
									if(ch==' ' || ch=='\t')	break; // these are actually illegal, but Fiery driver has space terminated option
         if(ch==0)
         {
          err=generror(0,"PPD (%s) option keyword incorrectly terminated",filename);
          break;
         }
        }
        if(err) break;
                         // option from s to (p-1)

        xzstrncpy(ppdkeyword[ppdkeywordn-1].option,s,p-s);

//        cprintf("add option %d",p-s);

								if(ch==' ' || ch=='\t')
								{
         while(1)        // strip white space
         {
          ch=*p++;
          if(ch=='/' || ch==':')	break;
										if(ch==0)
          {
           err=generror(0,"PPD (%s) option keyword incorrectly terminated",filename);
           break;
										}
         }
								}


        if(ch=='/')     // translation string terminated by ':'
        {
         s=p;

         while(1)
         {
          ch=*p++;
          if(ch==':') break;
          if(ch==0)
          {
           err=generror(0,"PPD (%s) keyword option translation string incorrectly terminated");
           break;
          }
         }
         if(err) break;

         stringheapsize(&ppdstringhandle,p-s,&offset);
         xzstrncpy(stringheapstring(ppdstringhandle,offset),s,p-s);
         ppdkeyword[ppdkeywordn-1].translation=offset;

        }             // end of translation string


       }
      }               // end of options


						if(ch!=0)
						{
       while(1)        // strip white space
       {
        ch=*p++;
        if(ch!=' ' && ch!='\t')
        {
         p--;
         break;
        }
       }

                    // potential value


       if(ch=='\"')   // quoted or invocation
       {
        bf_seek(&bf,posn+p-string+1);

        while(1)
        {
         bf_getc(&bf,&ch);
         if(ch==EOF)
         {
          err=generror(0,"PPD (%s) unexpected end of file",filename);
          break;
         }
         else
         if(ch=='\"')  // end of
         {

          break;
         }
         else
         {
          if(ch=='\r' || ch=='\n') eolnseen=1;

         }
        }

        bf_tell(&bf,&posn2);
        bf_seek(&bf,posn+p-string+1);


        stringheapsize(&ppdstringhandle,posn2-(posn+p-string+1),&offset);
        bf_read(&bf,stringheapstring(ppdstringhandle,offset),posn2-(posn+p-string+1));
        *(stringheapstring(ppdstringhandle,offset)+(posn2-(posn+p-string+1)-1))=0;
        ppdkeyword[ppdkeywordn-1].value=offset;

        // maybe translation string

        err=bf_getstring(&bf,string,sizeof(string),&eof);
        if(err) break;

//       cprintf("invoc trans %s",string);

        p=string;

        while(1)
        {
         ch=*p++;
         if(ch=='/' || ch==0) break;
        }

        if(ch=='/')
        {
         stringheapadd(&ppdstringhandle,p,&offset);
         ppdkeyword[ppdkeywordn-1].transvalue=offset;
        }
       }
       else
       if(ch=='^')   // symbol terminated by newline
       {
        stringheapadd(&ppdstringhandle,p+1,&offset);
        ppdkeyword[ppdkeywordn-1].value=offset;
       }
       else          // string terminated by newline or /
       {
        s=p;

        while(1)
        {
         ch=*p++;
         if(ch=='/' || ch==0) break;
        }
                   // s to p is string

        stringheapsize(&ppdstringhandle,p-s,&offset);
        xzstrncpy(stringheapstring(ppdstringhandle,offset),s,p-s);
        ppdkeyword[ppdkeywordn-1].value=offset;

        if(ch=='/') // p to eoln is string translation
        {
         stringheapadd(&ppdstringhandle,p,&offset);
         ppdkeyword[ppdkeywordn-1].transvalue=offset;
        }
       }

       if(err) break;
      }													// end of keyword args
					}              // not comment
    }               // end of keyword


    if(eof) break;
   }

   err=bf_close(&bf,err);
  }
 }


 {
  int i;

//  cprintf("keywordn %d",ppdkeywordn);

  for(i=0;i<ppdkeywordn;i++)
  {
//   cprintf("key %s %s",ppdkeyword[i].keyword,ppdkeyword[i].option);
//   if(ppdkeyword[i].transvalue) cprintf("key %s option %s trans value %s",ppdkeyword[i].keyword,ppdkeyword[i].option,stringheapstring(ppdstringhandle,ppdkeyword[i].transvalue));

   if(!cstrcmp(ppdkeyword[i].keyword,"OpenGroup"))
   {
//    cprintf("open group value %s",ppdvalue(i));

   }

   if(!cstrcmp(ppdkeyword[i].keyword,"OpenSubGroup"))
   {
//    cprintf("open sub group value %s",ppdvalue(i));

   }

   if(!cstrcmp(ppdkeyword[i].keyword,"OpenUI"))
   {
//    cprintf("openUI %s",ppdoption(i));

   }

  }
 }

 return(err);
}



os_error * ppdpslevel(int * level)
{
 int    val;
 char * p;

 *level=0;

 val=ppdkeywordsearch("LanguageLevel");

 if(val>=0)
 {
  p=ppdvalue(val);

//  cprintf("ppdpslevel %s",p);

  val=atoi(p);
  if(val<1 || val>3) val=0;
  *level=val;
 }


 return(NULL);
}


static char ppdpath[MAX_PATH];


os_error * ppdcache(char * filename)
{
 os_error * err;

 err=NULL;

 if(cstrcmp(filename,ppdpath))
 {
  ppdparseinit();

  if(fs_extensionis(filename,"ppd")==0)
  {
   err=ppdparse(filename);
   if(!err)
   {
    strcpy(ppdpath,filename);
   }
  }
 }

 return(err);
}



#ifdef NEVER



/*********************************************************************************/

// ppd database


typedef struct ppdprstr
{
 struct ppdprstr * next;
 struct ppdprstr * prev;
 int               len;
 char              data[1];  // first string printer name, then main,option,value


} ppdprstr;


#define PPDPRCHUNK 0x400


static ppdprstr * firstppdpr;


static ppdprstr * ppdfind(char * name)
{
 ppdprstr * ppdpr;

 ppdpr=NULL;

 if(name)
 {
  ppdpr=firstppdpr;
  while(ppdpr)
  {
   if(!cstrcmp(name,ppdpr->data)) break;
   ppdpr=ppdpr->next;
  }
 }

 return(ppdpr);
}


static os_error * ppdadd(char * name,ppdprstr ** ppdpr)
{
 os_error * err;
 ppdprstr * ppdptr;

 err=salloc((flex_ptr)ppdpr,sizeof(ppdprstr)+PPDPRCHUNK);
 if(!err)
 {
  ppdptr=*ppdpr;

  strcpy(ppdptr->data,name);
  ppdptr->len=strlen(name)+1;

  ppdptr->next=firstppdpr;
  ppdptr->prev=NULL;
  if(firstppdpr) firstppdpr->prev=ppdptr;
  firstppdpr=ppdptr;

 }

 return(err);
}


static ppdprstr * currentppdpr;

// ppdprinter(string & name)

void ppdprinter(int fp)
{
 os_error * err;

 err=NULL;

 currentppdpr=ppdfind(stringptr(stack[fp]));
 if(currentppdpr==NULL)
 {
  err=ppdadd(stringptr(stack[fp]),&currentppdpr);

 }

 zreport(err);
}


// ppdline(string & main,string & option,string & value);

void ppdline(int fp)
{



}


static os_error * ppdsave(void)
{
 os_error * err;
 int        i;
 ppdprstr * ppdptr;


 err=NULL;

 for(i=0;i<ppdkeywordn;i++)
 {
  if(!cstrcmp(ppdkeyword[i].keyword,"ModelName"))
  {
   break;
  }
 }

 if(i<ppdkeywordn)
 {
  ppdptr=ppdfind(stringheapstring(ppdstringhandle,ppdkeyword[i].value));
  if(ppdptr==NULL)
  {
   err=ppdadd(stringheapstring(ppdstringhandle,ppdkeyword[i].value),&ppdptr);

  }

  if(!err)
  {


  }
 }


 return(err);
}





static os_error * saveppdfn(char * name,int type)
{
 os_error * err;
 buffer     bf;
 char     * p0;
 char     * p1;
 char     * p2;
 char     * p3;
 ppdprstr * ppdpr;
 int        len;

 err=bf_open(name,'w',DEFBUFFSIZE,&bf);
 if(!err)
 {
  bf_printf(&bf,"void main(void)\r\n{\r\n");

  ppdpr=firstppdpr;
  while(ppdpr)
  {
   bf_printfeol(&bf,"ppdprinter(\"%s\");",ppdpr->data);
   len=strlen(ppdpr->data)+1;
   while(len<ppdpr->len)
   {
    p0=ppdpr->data+len;
    p1=p0+strlen(p0)+1;
    p2=p1+strlen(p1)+1;
    p3=p2+strlen(p2)+1;

    bf_printfeol(&bf,"ppdprinter(\"%s\",\"%s\",\"%s\");",p0,p1,p2);

    len+=p3-p0;
   }

   ppdpr=ppdpr->next;
  }
  

  bf_printfeol(&bf,"}");

  err=bf_closec(&bf,err,name,type);
 }
 

 return(err);

 USE(type);
}






static char * ppddefpath="<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\AutoRun\\!PPD.csc";


static os_error * savedefaultppd(void)
{
 os_error * err;
 int        result;

 err=confirmparent(NULL,CONYN,&result,"{FOXCC}");
 if(result==1)
 {
  err=fs_validatepath(ppddefpath,0);
  if(!err) err=saveppdfn(ppddefpath,SCRIPT2);
 }

 return(err);
}




/*******************************************************************************/

static int treehandle;



static os_error * treeevent(int event,int handle,int userhandle,int data,void * datap)
{

 USE(event);
 USE(handle);
 USE(userhandle);
 USE(data);
 USE(datap);

 return(NULL);
}



static os_error * ppdicon(int handle,int userhandle,wimp_mousestr * m)
{
 os_error * err;

 err=NULL;


 return(err);

 USE(m);
 USE(handle);
 USE(userhandle);
}






static os_error * ppdclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {

 }

 if(!err && (code==DBOK || code==DBCANCEL))
 {
  cc_remtree(treehandle);
 }

 return(err);
}



static dbiconstr ppdicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    1, NULL,         DBACTION, 0,   0,        DBOK,RETURN,0,0,NULL,0,
    2, NULL,         DBACTION, 0,   0,        DBCANCEL,ESCAPE,0,0 ,NULL ,0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static dboxstr ppdbox[1]=
{
 0,
 TPRINTPROP,
 DBFIX,
 0,
 ppdclose,
 ppdicon,
 NULL,
 NULL,
 ppdicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};




os_error * ps_properties(int parent,dboxstr * pbox)
{
 os_error * err;
 char       ppdname[MAX_PATH];


 err=dodboxspparent(ppdbox,1,pbox,&dbviewstack,parent);
 if(!err)
 {
  cc_addtree(ppdbox[0].handle,0,4,&treehandle,treeevent);

  {
   int handle;
   int parent;

   parent=0;

// cc_addtreeitem(int treehandle,int parent,int after,char * text,int mask,int childn,int id,int * handle);
//   cc_addtreeitem(treehandle,0,0,"Root",TVIF_CHILDREN|TVIF_TEXT,1,0,&handle);
//   cc_addtreeitem(treehandle,handle,0,"RootChild",TVIF_CHILDREN|TVIF_TEXT,0,0,&handle);

   int i;
   for(i=0;i<ppdkeywordn;i++)
   {
//   cprintf("key %s %s",ppdkeyword[i].keyword,ppdkeyword[i].option);
//   if(ppdkeyword[i].transvalue) cprintf("key %s option %s trans value %s",ppdkeyword[i].keyword,ppdkeyword[i].option,stringheapstring(ppdstringhandle,ppdkeyword[i].transvalue));

    if(!cstrcmp(ppdkeyword[i].keyword,"OpenGroup"))
    {
//    cprintf("open group value %s",ppdvalue(i));

   }

   if(!cstrcmp(ppdkeyword[i].keyword,"OpenSubGroup"))
   {
//    cprintf("open sub group value %s",ppdvalue(i));

   }

   if(!cstrcmp(ppdkeyword[i].keyword,"OpenUI"))
   {
//    cprintf("openUI %s",ppdoption(i));
    cc_addtreeitem(treehandle,parent,0,ppdoption(i),TVIF_CHILDREN|TVIF_TEXT,0,0,&handle);
   }

  }  
 
  
  }
  err=osxprinterdata(ppdname,sizeof(ppdname));
  if(!err) err=ppdcache(ppdname);
  osxprintcachefontsubs();
 }

 return(err);
}


#endif



pschoicestr defpschoice=
{
 0, // int level;
 0, // int generic;
 0, // int colour;
 1, // int fonttype;
 
 
};







void postscriptchoices0(int fp)
{
 defpschoice.level=stack[fp];
 defpschoice.fonttype=stack[fp+1];
 defpschoice.generic=stack[fp+2];
 defpschoice.colour=stack[fp+3];
}



static pschoicefn  choicefn;
static pschoicestr cpschoice;

static os_error * pschoiceclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  if(choicefn) err=choicefn(&cpschoice);
 }

 return(err);
}




static dbiconstr pschoiceicondefs[]=
{

   13, &cpschoice.generic,DBTOGGLE, 0,   0,      1,   F1,     0,0,    NULL, 0,

   15, &cpschoice.level, DBRADIO,   0,   0,      1,   F2,  1, 0,    NULL, 0,
   16, &cpschoice.level, DBRADIO,   0,   0,      2,   F3,  1, 0,    NULL, 0,
   17, &cpschoice.level, DBRADIO,   0,   0,      3,   F4,  1, 0,    NULL, 0,
   18, &cpschoice.level, DBRADIO,   0,   0,      0,   F4,  1, 0,    NULL, 0,

    9, &cpschoice.fonttype,DBRADIO, 0,   0,      1,   F5,  2, 0,    NULL, 0,
   10, &cpschoice.fonttype,DBRADIO, 0,   0,      3,   F6,  2, 0,    NULL, 0,


 /* N   &V           Type     Grp   Flags   Act Key     - -   clickfn 0 */

   1,  NULL,         DBACTION, 0,   0,      DBOK,RETURN, 0,0,    NULL, 0,
   2,  NULL,         DBACTION, 0,   0,      DBCANCEL,ESCAPE, 0,0,NULL, 0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0

};



static dboxstr pschoicebox=
{
 0,
 TPOSTSCRIPT,
 DBFIX,
 DBGRAB,
 pschoiceclose, /* close */
 NULL, /* icon  */
 NULL,
 NULL,
 pschoiceicondefs,
 0,
 0,
 0,NULL,
 0,
 0,
};




os_error * openpostscriptchoice(pschoicestr * pschoice,pschoicefn xpschoicefn,
                                dboxstr * parent,dbstackstr * dsp)
{
 os_error * err;

 choicefn=xpschoicefn;

 cpschoice=*pschoice;

 err=dodboxsp(&pschoicebox,1,parent,dsp);

 return(err);
}


os_error * postscriptchoices(buffer * bf)
{
 os_error * err;

 err=bf_printfeol(bf,"postscriptchoices0(%d,%d,%d,%d);",
                  defpschoice.level,defpschoice.fonttype,defpschoice.generic,defpschoice.colour);

 return(err);
}


