/*->h.codes */

                               /* codes that appear in docs */
#define EOT      0
#define EOTLEN   1
#define GCODE    1
#define EOBOX    2
#define EOPAGE   3
#define CHAPNO   4
#define ACTDATE  5

/* #define BSEQ  6 */

#define SPACESEQ   7
#define SPACELEN   16
#define SPACESEQNB 0x1
#define SPACESEQEM 0x2
#define SPACESEQDL 0x4

#define UNC16      8
#define UNC16LEN   3


#define TABCH    9
#define NL      10
#define CR      13
#define EINTSEQ 17
#define EINTLEN  5
#define TABSEQ  18
#define TSLEN    4
#define MACSEQ  19
#define MSLEN    4
#define SNO     20
#define SNLEN    4
#define DCHYPH  21
#define EOB     22
#define EOBLEN  32 
#define PAGENO  30
#define SPACE   32
#define NBSPACE 160
#define NBHYPH  173
#define HYPHEN  45

#define LIGFI   158
#define LIGFL   159
#define LIGOE   154
#define LIGoe   155
#define MINUS   153

#define U_LIGFI 0xFB01
#define U_LIGFL 0xFB02
#define U_MINUS 0x2212

#define U_QDBLL       0x201C
#define U_QDBLR       0x201D
#define U_QSINGL      0x2018
#define U_QSINGR      0x2019
#define U_GUISL       0x2039
#define U_GUISR       0x203A
#define U_OE          0x152
#define U_oe          0x153
#define U_EURO        0x20AC
#define U_DAGGER      0x2020
#define U_DAGGERDBL   0x2021
#define U_WCIRC       0x174
#define U_YCIRC       0x176
#define U_wCIRC       0x175
#define U_yCIRC       0x177
#define U_ELLIPSIS    0x2026
#define U_TRADEMARK   0x2122
#define U_EMDASH      0x2014
#define U_ENDASH      0x2013
#define U_PERTHOUSAND 0x2030


#define UNIBLANK 0xfffd



/* #define MAXCODELEN BSLEN */

#define MAXCODELEN EOBLEN


#define FF 12


#ifdef NEVER
                              /* font manager codes */
#define COMMENT    21
#define ULINECODE  25
#define FONTCODE   26
#define COLCODE    18
#define COLCODE2   19
#define FTRANSFORM 27

#define VM 11
#define HM 9


#define ULLEN   3
#define FCLEN   2
#define VMLEN   4
#define HMLEN   4
#define CCLEN   4
#define CC2LEN  8

#endif


#define XACTDATE   0x50000
#define XCHAPNO    0x50001
#define XEOBOX     0x50002
#define XEOPAGE    0x50003
#define XPAGENO    0x50004
#define XDCHYPH    0x50005
#define XDATE      0x50006
#define XTIME      0x50007
#define XDATETIME  0x50008
#define XNBHYPH    0x50009
#define XNBSPACE   0x5000A
#define XNEWLINE   0x5000B
#define XNEWPARA   0x5000C
#define XTABCH     0x5000D
#define XDELETEB   0x5000E
#define XDELETEF   0x5000F
#define XDOCNAME   0x50010
#define XDOCPATH   0x50011
#define XEMSPACED  0x50012
#define XENSPACED  0x50013
#define XEMSPACE   0x50014
#define XENSPACE   0x50015
#define XEMSPACEN  0x50016
#define XENSPACEN  0x50017
#define XEMSPACEND 0x50018
#define XENSPACEND 0x50019
#define XDOCDIR    0x50020



#define CODELEN    0xFF


#define CODETYPE     (0xF<<8)
#define CODEALPHA    (0x0<<8)
#define CODECODE     (0x1<<8)
#define CODEWHITE    (0x2<<8)
#define CODEPUNCT    (0x3<<8)
#define CODEDIGIT    (0x4<<8)
#define CODENONE     (0x5<<8)
#define CODESYMBOL   (0x6<<8)
#define CODELIGATURE (0x7<<8)


#define CODEUPPER      0x1000
#define CODETERMINATOR 0x2000


extern int codex[256];

extern int codefn(int c);

extern int spaceisdelim(char * p);

extern int code16tab[256];


extern int code8tab[256];
extern int altcode8tab[256];

extern int code16inv(int unicode);
extern int code16(int riscos8);
extern int code16winindex(int unicode);
extern int code16winindexcharset(int unicode,int charset);
extern int code16win(int win8);
extern int code16wincharset(int win8,int charset);
extern int code8inv(int win8);
extern int code8(int riscos8);
extern int altcode8(int riscos8);


extern int code8symbolinv(int win8);
extern int code8symbol(int riscos8);
extern int code16symbolinv(int win16);
extern int code16symbol(int riscos8);


extern os_error * txunccheck(filestr * file);
extern os_error * txunccheckstring(unsigned short * p,filestr * file);

extern os_error *	txstring21(unsigned short * s,char * d,int maxlen,int * len);
extern os_error *	txstring12(char * s,int maxin,unsigned short * d,int maxlen,int * len);


extern int riscos_isupper(int c);

extern int riscos_islower(int c);


extern int riscos_toupper(int c);

extern int riscos_tolower(int c);

extern int riscos_isalpha(int c);
extern int riscos_isalnum(int c);

extern void codeinit(void);
