/*->h.fx */


#define  FXMORE     0x1
#define  FXTABS     0x2
#define  FXHPEND    0x4
#define  FXHPEXP    0x8
#define  FXDROP     0x10
#define  FXEOBA     0x20
#define  FXNBSP     0x40
#define  FXBULLET   0x80
#define  FXBLMASK   0x300
#define  FXBLSHIFT  8
#define  FXLEADERF  0x400


#define FXFONTCODE   1
#define FXCOLCODE2   2
#define FXVM         3
#define FXHM         4
#define FXTRANSFORM  5

#define FXFCLEN      14
#define FXVMLEN      6
#define FXHMLEN      6
#define FXCC2LEN     10
#define FXTRANSLEN   18




typedef struct fxrendstr
{
 transformstr   transform;
 vector         vec;
 int            len;
 int            x;
 int            y;
 colourvalue    backcol;
 int            width;
 int            hpend; /* hyphen at end */
 int            dropcap;
 int            rubout;
 int            dobullet;
 bulletdatastr  bulletdata;

} fxrendstr;


extern int     fmaxlen;
extern int     fterminated;
extern char  * fbuff;
extern char ** ffb;
extern char ** ffl; 

extern int       fxitem;

extern int       fmaxpt;
extern int       fmaxld;
extern int       fmaxas;
extern int       fmaxht;
extern int       fxsmaxy;
extern int       fxsminy;

extern int       fxlineakern;  /* auto kern this line */
extern int       fxfirsteob;
extern int       fxlinejustify; /* justification on this line */
extern int       fxlinespace;
extern int       fxbullettab;

extern int       fxsmaxht;
extern int       fxfmaxld;
extern int       fxdropdiff;

extern int       fxmaxl;
extern int       fxmaxi;


extern os_error * fxchunki(void);
extern os_error * fxchunkl(void);



extern int       fxlinedx;
extern int       fxlineddx;
extern int       fxlinedy;
extern int       fxlineddy;

extern unsigned short fxdectab[MAXDECTABCHAR+1];
extern unsigned short fxhyphenchar[MAXHYPHENCHAR+1];
extern int       fxbaseorigin;
extern int       fxbasespacing;
extern int       fxautopageinsert;
extern int       fxautopageremove;


extern colourvalue       ffcol;        /* first values in a line         */
extern colourvalue       fbcol;
extern int       ffont;
extern int       ffontos;
extern int       ffxpt;
extern int       ffypt;
extern int       fxuni;          // in unicode mode

extern transformstr fxtr;


extern void      fxcheckprefs(filestr * file);

extern void      fxboxsetup(int angle);

extern void      fxinitjust(int sn,filestr * file);

extern os_error * fxrender(viewredrawstr * v,fxrendstr * fxr);
extern os_error * fxexpand(vector * v,int flags,int len,bulletdatastr * bdata);
extern os_error * fxsample(filestr * file,wimp_box * box,
                                          fxrendstr * fxr,xstylestr * s);

extern int        fspace(int bl);
extern int        fequivi(int bl,int * itemval);
extern int        fequivcode(int bl);
extern int        fspace(int bl);
extern int        fnexttolast(int * itemp);
extern int        fitem(int item);
extern int        fchop(int bl,char * ffb[],char * base);
extern int        striplen(sourcestr * s,int len,int offset);
extern int        getfirstspc(vector * s,int llen);
extern os_error * fxtotals(vector * v,int len,int * nsp,int * ncp);
extern os_error * fxtotals2(vector *v,int loffset,int len,int * nsp,int * ncp);
extern void       fxcalcdxs(int width,int ns,int nc);


#define FXSAKERN 0x1
#define FXSBBOX  0x2
#define FXSFFONT 0x4
#define FXSINCLUSIVE 0x8


extern os_error * fxstrwidth(font_string * fs,int dx,int ddx,int flags);
extern os_error * fxfsetcaret(font_string * fs,int dx,int ddx,int akern);

extern os_error * fontstate(vector * v,int offset,int len,
                            int * style,int * hasfont,int bits,int * ecode);
extern os_error * firstfont(vector * v,int bits);
extern os_error * getstylev(vector * s,int inclusive,int * sn);
extern os_error * getcaretstyle(vector * s,absstylestr * st);
extern os_error * getcaretstylex(vector * s,absstylestr * st);
extern os_error * getcaretstyleinc(vector * s,absstylestr * st);

extern os_error * fxmapout(vector * v,int len,int t1,int t2);

extern void expandbulletdata(vlstr * vline,bulletdatastr * bdata);
extern void packbulletdata(vlstr * vline,bulletdatastr * bdata);


extern os_error * fxvalidfont(int osfont,int fxpts,int fypts,int fangle,int * fh,int * fchange);
extern os_error * fxfont_paintextsymbol(int font,wchar_t * s,int len,int options,int x,int y,fontrect * rectp,int * exts);
extern os_error * fxpaintbase(char * s,int x,int y,viewredrawstr * v);



extern void       fxtrash(void);


extern os_error * fxinit(void);
