/*->c.textimport */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "wos.h"
#include "flex.h"
#include "bbc.h"
#include "font.h"
#include "transform.h"
#include "xprocess.h"
#include "akbd.h"
#include "convertutf.h"

#include "Drawlevel0.h"

#include "err.h"
#include "filetype.h"
#include "fsx.h"
#include "bf.h"
#include "alloc.h"
#include "colour.h"
#include "etc.h"
#include "poll.h"
#include "key.h"
#include "xext.h"
#include "deb.h"
#include "bits.h"

#include "constants.h"
#include "str.h"

#include "object.h"

#include "file.h"
#include "view.h"
#include "clip.h"

#include "dscript.h"


#include "pxstr.h"
#include "pict.h"
#include "impex.h"

#include "txstr.h"
#include "codes.h"
#include "fox.h"
#include "tx.h"
#include "txchoices.h"
#include "textimport.h"
#include "act.h"
#include "txdd.h"
#include "txds.h"
#include "stylemap.h"



#define MARKEDTEXT 0x10000

#define UNITTEXT   0x20000
#define UNITMASK   0xE0000

#define CLIPTEXT  0x100000


/***********************************************************************************/


static os_error * unicodetextintexport(int pict,int ftype,
                                         filestr * file,posnstr * posn)
{
/* dprintf(6,"type=%x",ftype);*/

 return(txdragndrop(posn,file==posn->file,(ftype & IMPFTYPE)==UNICODETEXTFILE));
 USE(pict);
}





static os_error * unicodetextexport(char * name,int text,int ftype,int xv,
                                                              filestr * file)
{
 os_error   * err;
 buffer       bf;
 int          source;
 textboxstr * textp;
 int          marked;
 int          u;
 texsrc     * texsp; 
 sourcestr  * sourcep;
 int          c;
 char       * p;
 int          bits;
 int          len;
 int          offset;
 int          maxoffset;
 int          fspace;


 err=bf_open(name,'w',DEFBUFFSIZE,&bf);
 if(!err)
 {
  if(!(ftype & CLIPTEXT)) err=bf_puts(&bf,0xFEFF);

  textp=(textboxstr*)fob_find(text,file);

  marked=ftype & MARKEDTEXT;
  u=(ftype & UNITMASK)/UNITTEXT;

  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

  source=texsp[u].source;

  err=fob_lock((fobjptr)&sourcep,source,file);
  if(!err)
  {
   if(marked)
   {
    offset=lozon->textsrc.offset;
    maxoffset=hizon->textsrc.offset;
   }
   else
   {
    maxoffset=sourcep->len;
    offset=0;
   }

   while(offset<maxoffset && !err)
   {
    p=txptr(sourcep,offset);

    c=*p;
    bits=codex[c];
    len=(bits & CODELEN);

    switch(c)
    {

       case EOBOX:
      case EOPAGE:
          case CR:
          case NL:
                           err=bf_puts(&bf,CR);
                  if(!err) err=bf_puts(&bf,NL);
                  break;

       case SPACE:
     case NBSPACE:
                  err=bf_puts(&bf,SPACE);
                  break;

        
      case NBHYPH:
                  err=bf_puts(&bf,'-');
                  break;

     case SPACESEQ:
                   fspace=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
                   if(fspace & SPACESEQDL) err=bf_puts(&bf,SPACE);
                   break;

     case  TABSEQ:
                  err=bf_puts(&bf,9);
                  break;

  					case	UNC16:
																		bf_puts(&bf,(*(p+1))+((*(p+2))<<8));
																		break;

          default:
                  if(c>31)
                  {
                   c=code16(c);
                   bf_puts(&bf,c);
                  }
                  break;
    }

    offset+=len;
   }

   fob_unlock((fobjptr)&sourcep,file);
  }

  if(ftype & CLIPTEXT) err=bf_puts(&bf,0);

  err=bf_closec(&bf,err,name,UNICODETEXTFILE);
 }

 return(err);

 USE(xv);
}





/*

		  byte[] bom = new byte[4]; // Get the byte-order mark, if there is one
    file.Read(bom, 0, 4);
    if ((bom[0] == 0xef && bom[1] == 0xbb && bom[2] == 0xbf) || // utf-8
        (bom[0] == 0xff && bom[1] == 0xfe) || // ucs-2le, ucs-4le, and ucs-16le
        (bom[0] == 0xfe && bom[1] == 0xff) || // utf-16 and ucs-2
        (bom[0] == 0 && bom[1] == 0 && bom[2] == 0xfe && bom[3] == 0xff)) // ucs-4
    {
        enc = System.Text.Encoding.Unicode;



Here's the file "Hello" in various encodings: 

48 65 6C 6C 6F 
This is the traditional ANSI encoding.

48 00 65 00 6C 00 6C 00 6F 00 
This is the Unicode (little-endian) encoding with no BOM.

FF FE 48 00 65 00 6C 00 6C 00 6F 00 
This is the Unicode (little-endian) encoding with BOM. The BOM (FF FE) serves two purposes: First, it tags the file as a Unicode document, and second, the order in which the two bytes appear indicate that the file is little-endian.

00 48 00 65 00 6C 00 6C 00 6F 
This is the Unicode (big-endian) encoding with no BOM. Notepad does not support this encoding.

FE FF 00 48 00 65 00 6C 00 6C 00 6F 
This is the Unicode (big-endian) encoding with BOM. Notice that this BOM is in the opposite order from the little-endian BOM.

EF BB BF 48 65 6C 6C 6F 
This is UTF-8 encoding. The first three bytes are the UTF-8 encoding of the BOM.

2B 2F 76 38 2D 48 65 6C 6C 6F 
This is UTF-7 encoding. The first five bytes are the UTF-7 encoding of the BOM. Notepad doesn't support this encoding.

Notice that the UTF7 BOM encoding is just the ASCII string "+/v8-", which is difficult to distinguish from just a regular file that happens to begin with those five characters (as odd as they may be). 

The encodings that do not have special prefixes and which are still supported by Notepad are the traditional ANSI encoding (i.e., "plain ASCII") and the Unicode (little-endian) encoding with no BOM. When faced with a file that lacks a special prefix, Notepad is forced to guess which of those two encodings the file actually uses. The function that does this work is IsTextUnicode, which studies a chunk of bytes and does some statistical analysis to come up with a guess. 

And as the documentation notes, "Absolute certainty is not guaranteed." Short strings are most likely to be misdetected.




*/




// leave *buffp pointing at something that can be free'd or set to NULL


static os_error * unicodeprocessutf16(char ** buffp,int * np,int stripmode,int ubits)
{
	os_error       * err;
	int              c;
	int              c2;
 int              lastchar;
 int              lastcharp;
 int              firstchar;
	unsigned short * r;
	unsigned short * w;
	unsigned short * end;
	int              len;
	int              size;
	char           * buff2;
	unsigned short * start;
	char           * p;

	err=NULL;

// the problem here is at which point are we handling unicode/8 bit chars
// would like to change to 8 bit chars early on, but can't because values like 0x8F
// in Unicode are out of band, but will be generated by mapping Unicode values to
// RISC OS characterset
// so after mapping can't tell difference between high byte 0 Unicode and things generated for RISC OS


	cprintf("unicode process");


	len=(*np)/2;
	start=(unsigned short*)(*buffp);

// 0th pass	sort out byte order

	c=*start;

	if(ubits & ISUNICODEBOM)
	{
		cprintf("unicode BOM");

		start++;
		len--;
	}

	if(ubits & ISUNICODEREVERSE)
	{
		cprintf("unicode reverse");

 	r=w=start;
  end=r+len;
		while(r<end)
		{
			c=*r++;
			c=((c & 0xFF)<<8) | ((c>>8) & 0xFF);
			*w++=(unsigned short)c;
		}
	}



// first pass for Windows convert CRLF to CR LFCR to LF


	r=w=start;
	end=r+len;
	lastchar=-1;
 while(r<end)
 {
  c=*r++;
  if((c==NL && lastchar==CR) || (c==CR && lastchar==NL))
  {
			// skip
   c=-1;
  }
  else
  {
			*w++=(unsigned short)c;
  }

  lastchar=c;
 }

	len=w-start;

 // second pass convert CR or LF to LF
 // in strip mode convert double CR or LF to LF convert single to space

	r=w=start;
	end=r+len;
 lastchar=-1;
 lastcharp=-1;
 firstchar=1;             

 while(r<end)																			// this is right because there are len number codes we want to look at
 {
		c=*r++;

  if(stripmode)
  {
   if(lastchar==CR || lastchar==NL)
   {
    if(c==CR || c==NL)
    {
     *w++=NL;
    }
    else
				{
     if(!(lastcharp==CR || lastcharp==NL))
     {
      *w++=SPACE;
     }
				}
   }
  }
  else
  {
   if(c==CR || c==NL)
   {
    c=NL;
    *w++=NL;
   }
  }


  switch(c)
  {
    case FF:
            c=EOPAGE;
            *w++=(unsigned short)c;
            break;


  case  '-':                 // generate emdash's from repeated hyphens
            if(txsmartq)
            {
             if(lastchar=='-')
             {
              *(w-1)=(unsigned short)(c=U_EMDASH);
             }
													else	*w++=(unsigned short)c;
            }
												else	*w++=(unsigned short)c;

            break;


  case '\'':
            if(txsmartq)                                                                    
            {                             
             if(firstchar || lastchar==SPACE || lastchar==NL || lastchar==CR || lastchar==TABCH) {c=U_QSINGL;}
             else                                                {c=U_QSINGR;}
            }
            *w++=(unsigned short)c;
            break;

   case '"':
            if(txsmartq)
            {
             if(firstchar || lastchar==SPACE || lastchar==NL || lastchar==CR || lastchar==TABCH) {c=U_QDBLL;}
             else                                                {c=U_QDBLR;}
            }
            *w++=(unsigned short)c;
            break;

    default:
            if(c>31 || c==TABCH) *w++=(unsigned short)c;
            break;
  }

  firstchar=0;
  lastcharp=lastchar;
  lastchar=c;
	}


 len=w-start;

	// pass 3, see how big the result is going to be

	r=start;
	end=r+len;

	size=0;

 while(r<end)
 {
		c=*r++;

		if(c==9)  size+=TSLEN;
		else
		{
			c2=code16inv(c);
			if(c2>=0)	size+=1;
			else      size+=UNC16LEN;
		}
	}


	err=salloc((flex_ptr)&buff2,size);
	if(!err)
	{
 	r=start;
		p=buff2;

  while(r<end)
  {
 		c=*r++;

 		if(c==9)
   {
				*p++=TABSEQ;
				*p++=0;
				*p++=0;
				*p++=0;
			}
 		else
			{
			 c2=code16inv(c);
  		if(c2>=0)
    {
     *p++=(char)c2;
 			}
  		else
    {
 				*p++=UNC16;
 				*p++=(char)c;
 				*p++=(char)(c>>8);
 			}
			}
 	}

		sfree((flex_ptr)buffp);
		*buffp=buff2;
		*np=size;
	}

	return(err);
}


#define UTF8CHUNK 0x1000
#define UTF8STEP  0x200

os_error * unicodeconvert_utf8_utf16(char ** buffp,int * np,int * ubits)
{
	os_error   * err;
 const UTF8 * sourceStart;
 const UTF8 * sourceEnd;
      UTF16 * targetStart;
      UTF16 * targetEnd;
	char       * buff2;
	int          b2len;
	char       * start;
	int          size;
 ConversionResult	result;

	err=NULL;

	
	b2len=0;
	buff2=NULL;

	err=salloc((flex_ptr)&buff2,UTF8CHUNK);
	if(!err)
	{
 	start=(*buffp);
 	size=*np;
 	if((*ubits) & ISUNICODEBOM)
  {
   start+=3;
 		size-=3;
 	}

 	sourceStart=(UTF8*)start;
 	sourceEnd=(UTF8*)(start+size);

 	while(sourceStart<sourceEnd)
 	{
 		err=schunk((flex_ptr)&buff2,b2len+UTF8STEP,UTF8CHUNK);
 		if(err) break;

 	 targetStart=(UTF16*)(buff2+b2len);
 		targetEnd=(UTF16*)(buff2+b2len+UTF8STEP);

 		result=ConvertUTF8toUTF16(&sourceStart,sourceEnd,&targetStart,targetEnd,lenientConversion);

   if(result==sourceExhausted || result==sourceIllegal) break;
	 // targetExhausted
  //	if(result!=conversionOK) break;

//		cprintf("target %x b2len %d",*(unsigned short*)(buff2+b2len),b2len);

 		b2len+=((char*)targetStart)-(char*)(buff2+b2len);

//		cprintf("b2len %d",b2len);
 	}

 	if(!err) err=schunk((flex_ptr)&buff2,b2len+2,UTF8CHUNK);
	}

	if(err)
	{
		sfree((flex_ptr)&buff2);
	}
	else
	{
		*(buff2+b2len)=0;								// to be safe, if the above ends with an error before reaching the end of text
		*(buff2+b2len+1)=0;

		sfree((flex_ptr)buffp);
		*buffp=buff2;
		*np=b2len;
		*ubits=((*ubits) & ~(ISUNICODE|ISUNICODEBOM)) | ISUNICODEUTF16;
	}

	return(err);
}




#define UTF32CHUNK 0x1000
#define UTF32STEP  0x200

os_error * unicodeconvert_utf32_utf16(char ** buffp,int * np,int * ubits)
{
	os_error   * err;
 const UTF32 * sourceStart;
 const UTF32 * sourceEnd;
      UTF16 * targetStart;
      UTF16 * targetEnd;
	char       * buff2;
	int          b2len;
	char       * start;
	int          size;
 ConversionResult	result;

	err=NULL;

	
	b2len=0;
	buff2=NULL;

	err=salloc((flex_ptr)&buff2,UTF32CHUNK);
	if(!err)
	{
 	start=(*buffp);
 	size=*np;
 	if((*ubits) & ISUNICODEBOM)
  {
   start+=4;
 		size-=4;
 	}

 	sourceStart=(UTF32*)start;
 	sourceEnd=(UTF32*)(start+size);

 	while(sourceStart<sourceEnd)
 	{
 		err=schunk((flex_ptr)&buff2,b2len+UTF32STEP,UTF32CHUNK);
 		if(err) break;

 	 targetStart=(UTF16*)(buff2+b2len);
 		targetEnd=(UTF16*)(buff2+b2len+UTF8STEP);

 		result=ConvertUTF32toUTF16(&sourceStart,sourceEnd,&targetStart,targetEnd,lenientConversion);

   if(result==sourceExhausted || result==sourceIllegal) break;
	 // targetExhausted
  //	if(result!=conversionOK) break;

//		cprintf("target %x b2len %d",*(unsigned short*)(buff2+b2len),b2len);

 		b2len+=((char*)targetStart)-(char*)(buff2+b2len);

//		cprintf("b2len %d",b2len);
 	}

 	if(!err) err=schunk((flex_ptr)&buff2,b2len+2,UTF8CHUNK);
	}

	if(err)
	{
		sfree((flex_ptr)&buff2);
	}
	else
	{
		*(buff2+b2len)=0;								// to be safe, if the above ends with an error before reaching the end of text
		*(buff2+b2len+1)=0;

		sfree((flex_ptr)buffp);
		*buffp=buff2;
		*np=b2len;
		*ubits=((*ubits) & ~(ISUNICODE|ISUNICODEBOM)) | ISUNICODEUTF16;
	}

	return(err);
}






static os_error * ansiprocess(char ** buffp,int * np,int stripmode)
{
	os_error       * err;
	int              c;
 int              lastchar;
 int              lastcharp;
 int              firstchar;
	char           * r;
	char           * w;
	char           * end;
	int              len;
	int              size;
	char           * buff2;
	char           * start;
	char           * p;

	err=NULL;


	len=(*np);
	start=(*buffp);


// first pass for Windows convert CRLF to CR LFCR to LF


	r=w=start;
	end=r+len;
	lastchar=-1;
 while(r<end)
 {
  c=*r++;
  if((c==NL && lastchar==CR) || (c==CR && lastchar==NL))
  {
			// skip
   c=-1;
  }
  else
  {
			*w++=(char)code8symbolinv(c);
  }

  lastchar=c;
 }

	len=w-start;

 //	in RISC OS char set here

 // second pass convert CR or LF to LF
 // in strip mode convert double CR or LF to LF convert single to space

	r=w=start;
	end=r+len;
 lastchar=-1;
 lastcharp=-1;
 firstchar=1;             

 while(r<end)																			// this is right because there are len number codes we want to look at
 {
		c=*r++;

  if(stripmode)
  {
   if(lastchar==CR || lastchar==NL)
   {
    if(c==CR || c==NL)
    {
     *w++=NL;
    }
    else
				{
     if(!(lastcharp==CR || lastcharp==NL))
     {
      *w++=SPACE;
     }
				}
   }
  }
  else
  {
   if(c==CR || c==NL)
   {
    c=NL;
    *w++=NL;
   }
  }


  switch(c)
  {
    case FF:
            c=EOPAGE;
            *w++=(char)c;
            break;


  case  '-':                 // generate emdash's from repeated hyphens
            if(txsmartq)
            {
             if(lastchar=='-')
             {
              *(w-1)=(char)(c=152);
             }
													else *w++=(char)c;
            }
												else	*w++=(char)c;

            break;


  case '\'':
            if(txsmartq)                                                                    
            {                             
             if(firstchar || lastchar==SPACE || lastchar==NL || lastchar==CR || lastchar==TABCH) {c=144;}
             else                                                {c=145;}
            }
            *w++=(char)c;
            break;

   case '"':
            if(txsmartq)
            {
             if(firstchar || lastchar==SPACE || lastchar==NL || lastchar==CR || lastchar==TABCH) {c=148;}
             else                                                {c=149;}
            }
            *w++=(char)c;
            break;

    default:
            if(c>31 || c==TABCH) *w++=(char)c;
            break;
  }

  firstchar=0;
  lastcharp=lastchar;
  lastchar=c;
	}


 len=w-start;

	// pass 3, see how big the result is going to be

	r=start;
	end=r+len;

	size=0;

 while(r<end)
 {
		c=*r++;

		if(c==9)  size+=TSLEN;
		else						size++;
	}


	err=salloc((flex_ptr)&buff2,size);
	if(!err)
	{
 	r=start;
		p=buff2;

  while(r<end)
  {
 		c=*r++;

 		if(c==9)
   {
				*p++=TABSEQ;
				*p++=0;
				*p++=0;
				*p++=0;
			}
 		else
			{
				*p++=(char)c;
			}
 	}

		sfree((flex_ptr)buffp);
		*buffp=buff2;
		*np=size;
	}

	return(err);
}








static os_error * unicodeprocess(char ** buffp,int * np,int stripmode,int ubits)
{
	os_error * err;
	int        utype;

	
 err=NULL;

	utype=(ubits & ISUNICODE);


	if(utype==ISUNICODEUTF8)
	{
		err=unicodeconvert_utf8_utf16(buffp,np,&ubits);
	 utype=(ubits & ISUNICODE);
	}

	if(utype==ISUNICODEUTF32)
	{
		err=unicodeconvert_utf32_utf16(buffp,np,&ubits);
	 utype=(ubits & ISUNICODE);
	}

	if(utype==ISUNICODEUTF16) err=unicodeprocessutf16(buffp,np,stripmode,ubits);
	else	                     err=ansiprocess(buffp,np,stripmode);	// all else fails


	return(err);
}











static os_error * xtextimport(char * name,int ftype,int xv,int * object,filestr * file)
{
 os_error   * err;
 int          n;
 int          chunk;
 int          eof;
 int          read;
	char       * buff;
 sourcestr  * sourcep;
	int          ubits;


	cprintf("xtextimport %s",name);

 buff=NULL;
 n=0;
 *object=0;

 err=bf_loadstart(name);

	report(err);

 if(!err)
 {
  do
  {
   err=bf_loadsize(&chunk);
   if(err) break;

   if(buff==NULL)
   {
    err=salloc((flex_ptr)&buff,n+chunk);
    if(err) break;
   }
   else
   {
    err=srealloc((flex_ptr)&buff,n+chunk);
    if(err) break;
   }

   err=bf_loaddata(name,buff+n,chunk,&read,&eof);
   if(err) break;

   n+=read;
  } while(!eof);
 }

 if(!err)
 {
		cprintf("unicode s len %d",n);

		ubits=0;

		if(ftype==TEXTFILE)
		{
			if(xv==0) ubits=isunicode(buff,n);
		}
		else
		if(ftype==UNICODETEXTFILE)
		{
			if(xv==1) ubits=ISUNICODEUTF16;							// clipboard
			else					 ubits=isunicode(buff,n);
		}

		cprintf("ubits %x",ubits);

		if(ubits & ISUNICODE)
  {
   err=txunccheck(file);
   if(!err) err=unicodeprocess(&buff,&n,(xv==0)?isctrl:0,ubits);
		}
		else
		{
		 err=ansiprocess(&buff,&n,(xv==0)?isctrl:0);
		}

		if(!err)
		{
   err=fob_create(n+sizeof(sourcestr),file,OSOURCE,(fobjptr)&sourcep);
 		if(!err)
 		{
 			memcpy(sourcep->data,buff,n);

    *object=sourcep->key;
    sourcep->len=n;
    sourcep->maxlen=n;
    sourcep->goffset=n;
 		}
		}
 }

	sfree((flex_ptr)&buff);

 return(err);
}




static os_error * unicodetextimportpost(int ftype,int object,filestr * file)
{

	cprintf("unicode text import post");

 USE(ftype);
 USE(object);
 USE(file);

 return(NULL);
}





static os_error * unicodetextimport(char * name,int ftype,int xv,
                                                int * object,filestr * file)
{
	os_error * err;

	err=txunccheck(file);
	if(!err) err=xtextimport(name,ftype,xv,object,file);

	return(err);
}




/***********************************************************************************/


#ifdef NEVER


static os_error * stripsource(int source,filestr * file,int stripmode)
{
 os_error    * err;
 textsrcstr    textsrc;
 int           lastchar;
 int           lastcharp;
 int           firstchar;
 int           shift;
 char          string[4];
 char        * p;
 int           len;
 int           c;
// int           code;


 memset(&textsrc,0,sizeof(textsrcstr)); /* beware flsourcechange() */

 textsrc.source=source;

 err=fob_lock((fobjptr)&textsrc.sourcep,textsrc.source,file);
 if(!err)
 {
  // first pass for Windows convert CRLF to CR LFCR to LF
  
  lastchar=-1;
  len=textsrc.sourcep->len;				// this is right because there are len number codes we want to look at
  while(len--)
  {
   p=txptr(textsrc.sourcep,textsrc.offset);
   c=*p;
   if((c==NL && lastchar==CR) || (c==CR && lastchar==NL))
   {
    txsourceremove(1,&textsrc,file);
    c=-1;
   }
   else
   {
    if(c>31)
    {

/*
     code=code8inv(c);
     if(code<0)
     {
      txsourceremove(1,&textsrc,file);
      c=lastchar;
      textsrc.offset--;
     }
*/

					*p=(char)code8symbolinv(c);
    }

    textsrc.offset++;
   }

   lastchar=c;
  }

  // second pass convert CR or LF to LF
  // in strip mode convert double CR or LF to LF convert single to space

  lastchar=-1;
  lastcharp=-1;
  firstchar=1;             
  textsrc.offset=0;
  len=textsrc.sourcep->len;
  while(len--)																			// this is right because there are len number codes we want to look at
  {
			if(textsrc.offset>=textsrc.sourcep->len)
   {
    cprintf("**** offset passes len");
				break;
			}

   p=txptr(textsrc.sourcep,textsrc.offset);
   c=*p;
   shift=0;

   if(stripmode)
   {
    if(lastchar==CR || lastchar==NL)
    {
     if(c==CR || c==NL)
     {
      *p=NL;
      shift=1;
     }
     else
     if(!(lastcharp==CR || lastcharp==NL))
     {
      string[0]=SPACE;
      txsourceinsert(string,1,&textsrc,file);
      textsrc.offset++;
      p=txptr(textsrc.sourcep,textsrc.offset);
     }
    }
   }
   else
   {
    if(c==CR || c==NL)
    {
     c=NL;        
     *p=NL;
     shift=1;
    }
   }
				 
   switch(c)
   {
    case FF:
            c=EOPAGE;
            *p=(char)c;
            shift=1;
            break;

 /*   case NL:
    case CR:
            c=NL;        
            *p=c;
            break;   */

    case  9:
            *p=TABSEQ;
            memset(string,0,sizeof(string));
            textsrc.offset++;
            txsourceinsert(string,3,&textsrc,file);
            shift=3;
            break;


  case  '-':                 // generate emdash's from repeated hyphens
            shift=1;
            if(txsmartq)
            {
             if(lastchar=='-')
             {
              p=txptr(textsrc.sourcep,textsrc.offset-1);
              *p=(char)(c=152);
              shift=0;
             }
            }
            break;


  case '\'':
            if(txsmartq)                                                                    
            {                             
             if(firstchar || lastchar==SPACE || lastchar==NL || lastchar==CR || lastchar==TABCH) {c=144;}
             else                                                {c=145;}
             *p=(char)c;
            }
            shift=1;
            break;

   case '"':
            if(txsmartq)
            {
             if(firstchar || lastchar==SPACE || lastchar==NL || lastchar==CR || lastchar==TABCH) {c=148;}
             else                                                {c=149;}
             *p=(char)c;
            }
            shift=1;
            break;

#ifdef NEVER
				case		0:		// fix to handle clipboard text with wrong length value
												txsourceremove(len,&textsrc,file);
												len=0;
												break;
#endif

    default:

            if(c>31) shift=1;
            break;
   }

//			if(len==0) break;
   if(!shift) txsourceremove(1,&textsrc,file);
   textsrc.offset+=shift;

   firstchar=0;
   lastcharp=lastchar;
   lastchar=c;
  }

  err=fob_unlock((fobjptr)&textsrc.sourcep,file);
 } 

 return(err);
}






static os_error * textimportpost(int ftype,int object,filestr * file)
{
 USE(ftype);
 USE(object);
 USE(file);

 return(NULL);
}





static os_error * textimport(char * name,int ftype,int xv,int * object,filestr * file)
{
 os_error   * err;
 int          first;
 int          n;
 int          chunk;
 int          eof;
 int          read;
 sourcestr  * sourcep;
 int          skey;

 first=1;
 n=0;
 skey=0;


 cprintf("text import ftype %x xv %d",ftype,xv);

 err=bf_loadstart(name);
 if(!err)
 {
  do
  {
   err=bf_loadsize(&chunk);
   if(err) break;

   if(first)
   {
    err=fob_create(n+chunk+sizeof(sourcestr),file,OSOURCE,(fobjptr)&sourcep);
    if(err) break;
    skey=sourcep->key;
    first=0;
   }
   else
   {
    err=fob_change(skey,file,n+chunk+sizeof(sourcestr),(fobjptr)&sourcep);
    if(err) break;
   }

   err=bf_loaddata(name,sourcep->data+n,chunk,&read,&eof);
   if(err) break;

   n+=read;
  } while(!eof);
 }

 if(err)
 {
  *object=0;
  if(skey) fob_delete(skey,file);
 }
 else
 {
  err=fob_change(skey,file,n+sizeof(sourcestr),(fobjptr)&sourcep);

  *object=skey;
  sourcep->len=n;
  sourcep->maxlen=n;
  sourcep->goffset=n;

  stripsource(skey,file,(xv==0)?isctrl:0); // xv true means clipboard which is likely to involve the control key ctrl+V etc.
 }

 return(err);

 USE(xv);
 USE(ftype);
}



#endif


static os_error * textimportpost(int ftype,int object,filestr * file)
{
 USE(ftype);
 USE(object);
 USE(file);

 return(NULL);
}





static os_error * textimport(char * name,int ftype,int xv,int * object,filestr * file)
{

	return(xtextimport(name,ftype,xv,object,file));
}


/**************************************************************************/


static os_error * textexport(char * name,int text,int ftype,int xv,
                                                              filestr * file)
{
 os_error   * err;
 buffer       bf;
 int          source;
 textboxstr * textp;
 int          marked;
 int          u;
 texsrc     * texsp; 
 sourcestr  * sourcep;
 int          c;
 char       * p;
 int          bits;
 int          len;
 int          offset;
 int          maxoffset;
 int          fspace;
 char         buff[4];
 int          n;


 err=bf_open(name,'w',DEFBUFFSIZE,&bf);
 if(!err)
 {
  textp=(textboxstr*)fob_find(text,file);

  marked=ftype & MARKEDTEXT;
  u=(ftype & UNITMASK)/UNITTEXT;

  texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

  source=texsp[u].source;

  err=fob_lock((fobjptr)&sourcep,source,file);
  if(!err)
  {
   if(marked)
   {
    offset=lozon->textsrc.offset;
    maxoffset=hizon->textsrc.offset;
   }
   else
   {
    maxoffset=sourcep->len;
    offset=0;
   }

   while(offset<maxoffset && !err)
   {
    p=txptr(sourcep,offset);

    c=*p;
    bits=codex[c];
    len=(bits & CODELEN);

    switch(c)
    {

#ifdef NEVER
         case 144:
         case 145:
                  err=bf_putc(&bf,'\'');
                  break;

         case 148:
         case 149:
                  err=bf_putc(&bf,'"');
                  break;
#endif


       case EOBOX:
      case EOPAGE:
          case CR:
          case NL:
                           err=bf_putc(&bf,CR);
                  if(!err) err=bf_putc(&bf,NL);
                  break;

       case SPACE:
     case NBSPACE:
                  err=bf_putc(&bf,SPACE);
                  break;

        
      case NBHYPH:
                  err=bf_putc(&bf,'-');
                  break;

     case SPACESEQ:
                   fspace=(*(p+1))+((*(p+2))<<8)+((*(p+3))<<16);
                   if(fspace & SPACESEQDL) err=bf_putc(&bf,SPACE);
                   break;

     case  TABSEQ:
                  err=bf_putc(&bf,9);
                  break;

          default:
                  if(c>31)
                  {
                   fontgetcode8(c,-1,buff,&n);
                   bf_write(&bf,buff,n);
                  }
                  break;

    }

    offset+=len;
   }

   fob_unlock((fobjptr)&sourcep,file);
  }

  if(ftype & CLIPTEXT) err=bf_putc(&bf,0);

  err=bf_closec(&bf,err,name,TEXTFILE);
 }

 return(err);

 USE(xv);
}



static os_error * textdsexport(int ftype,int text,filestr * file,buffer * bf)
{
 os_error   * err;
 textboxstr * textp;
 int          marked;
 int          u;
 int          offset;
 int          maxoffset;
 texsrc     * texsp;
 int          source;


 textp=(textboxstr*)fob_find(text,file);

 marked=ftype & MARKEDTEXT;
 u=(ftype & UNITMASK)/UNITTEXT;

 texsp=(texsrc*)(((char*)textp)+sizeof(textboxstr));

 source=texsp[u].source;

 if(marked)
 {
  offset=lozon->textsrc.offset;
  maxoffset=hizon->textsrc.offset;
 }
 else
 {
  maxoffset=-1;
  offset=0;
 }


 err=dsmapinit();
 if(!err)
 {
  err=txprojectstart(source,0,offset,maxoffset,file);
  if(!err)
  {
   txdscolours(file,bf);
   txdsfontnames(file,bf);
   txdsusernames(file,bf);

   txprojectend();

   err=txwriteeobs(source,offset,maxoffset,file,bf);
   if(!err) err=txwritestory(source,-1,offset,maxoffset,file,bf); 
                                                           /* note -ve unit */
  }
  dsmapfinit();
 }

 return(err);
}



static os_error * textintexport(int pict,int ftype,
                                         filestr * file,posnstr * posn)
{
/* dprintf(6,"type=%x",ftype);*/

 return(txdragndrop(posn,file==posn->file,(ftype & IMPFTYPE)==TEXTFILE));
 USE(pict);
}



// void textexport(string & filename,int filetype)

void savetextastype(int fp)
{
 os_error * err;
 int         ftype;

 err=NULL;

 if(act.valid)
 {
  ftype=stack[fp+1];
  if(zone) ftype|=MARKEDTEXT;
  ftype|=act.textsrc.u*UNITTEXT;

  err=textexport(stringptr(stack[fp]),act.textsrc.text,ftype,0,act.file);

 }

 zreport(err);
}




/****************************************************************************/


static impexstr textstr=
{
 TEXTFILE,
 "text",

 IMPXLOAD|IMPXTEXT,   /* flags       */
 textimport,          /* import      */
 textimportpost,      /* import post */
 textexport,          /* export      */
 NULL,                /* render      */
 textdsexport,        /* dsexport    */
 NULL,                /* dsimport    */

 textintexport,       /* internal export */
 NULL,                /* exportinfo      */

 NULL,                /* cache      */
 NULL,                /* rendermem  */
 NULL,                /* datashift  */


 NULL,                /* x1 */
 NULL,                /* x2 */
 NULL,                /* x3 */
 NULL,                /* x4 */

};



static impexstr unicodetextstr=
{
 UNICODETEXTFILE,
 "text",

 IMPXLOAD|IMPXTEXT,   /* flags       */
 unicodetextimport,          /* import      */
 unicodetextimportpost,      /* import post */
 unicodetextexport,          /* export      */
 NULL,                /* render      */
 NULL,              /* dsexport    */
 NULL,                /* dsimport    */

 unicodetextintexport,       /* internal export */
 NULL,                /* exportinfo      */

 NULL,                /* cache      */
 NULL,                /* rendermem  */
 NULL,                /* datashift  */


 NULL,                /* x1 */
 NULL,                /* x2 */
 NULL,                /* x3 */
 NULL,                /* x4 */

};



static os_error * txexname(int eventn,int user,filestr * file,char ** name)
{
 if(act.valid && file==act.file)
 {
  if(zone) *name="{TX04}";
  else     *name="{TX05}";
 }
 return(NULL);
 USE(user);
 USE(eventn);
}


#ifdef NEVER

os_error * txdirectexport(void)
{
 int type;

 type=TEXTFILE;
 if(zone) type|=MARKEDTEXT;
 type|=act.textsrc.u*UNITTEXT;

 return(exportdirect(type,act.textsrc.text,act.file));
}


#endif


#ifdef NEVER

static os_error * txexbox(int eventn,int user,filestr * file,int * handle)
{
 os_error   * err;
 int          type;

 err=NULL;

 if(act.valid && file==act.file)
 {
  type=TEXTFILE;
  if(zone) type|=MARKEDTEXT;
  type|=act.textsrc.u*UNITTEXT;

  err=exportsave(type,act.textsrc.text,file,handle);
 }

 return(err);
 USE(user);
 USE(eventn);
}

#endif

static os_error * txexbox2(int eventn,int user,viewstr * view,int spare)
{
 os_error   * err;
 int          type;

 err=NULL;

 if(act.valid && view->file==act.file)
 {
  type=TEXTFILE;
  if(zone) type|=MARKEDTEXT;
  type|=act.textsrc.u*UNITTEXT;

  err=exportsave2(type,act.textsrc.text,view,spare);
 }

 return(err);
 USE(user);
 USE(eventn);
}






static os_error * txglobal(int eventn,int user,int * ack,int filetype)
{
 os_error   * err;
 filestr    * file;
 int          object;

 err=NULL;

 if(filetype==TEXTFILE || filetype==UNICODETEXTFILE)
 {
  clipinfo(&object,NULL,NULL,&file);

  *ack=1;
 
  err=exportglobal(filetype|CLIPTEXT,object,file,NULL);
 }



 return(err);
 USE(user);
 USE(eventn);
}








os_error * textimportinit(void)
{
 os_error * err;

          err=impexregister(&textstr);
	if(!err) err=impexregister(&unicodetextstr);
 if(!err) err=addevent(EVENT_EXPORTNAME,(eventfn)txexname,0);
// if(!err) err=addevent(EVENT_EXPORTBOX,(eventfn)txexbox,0);
 if(!err) err=addevent(EVENT_EXPORTBOX2,(eventfn)txexbox2,0);
 if(!err) err=addevent(EVENT_GLOBALPASTE,(eventfn)txglobal,0);


 return(err);
}


