/*->c.wc */


#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>  
#include <ctype.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "font.h"
#include "bbc.h"
#include "werr.h"


#include "transform.h"

#include "etc.h"
#include "err.h"
#include "wos.h"
#include "poll.h"
#include "key.h"
#include "fsx.h"
#include "timex.h"
#include "deb.h"

#include "str.h"
#include "constants.h"
#include "codes.h"

#include "object.h"

#include "file.h"
#include "view.h"
#include "viewr.h"
#include "viewo.h"


#include "txstr.h"
#include "tx.h"
#include "vec.h"
#include "sx.h"
#include "vl.h"
#include "fx.h"
#include "style.h"
#include "fl.h"
#include "act.h"


#include "wc.h"
#include "wcx.h"



/* count words in source on locked vector */

static int wordcount(vector * v,int soffset,int eoffset)
{
 int        offset;
 int        inword;
 int        words;
 int        c;
 int        bits;
 int        slen;


 offset=soffset;
 inword=0;
 words=0;

 while(1)
 {
  c=*txptr(v->textsrc.sourcep,offset);
  bits=codex[c];
  slen=bits & CODELEN;

  switch(c)
  {
   case     SNO:
                break;

   case  TABSEQ:
   case  MACSEQ:
   case   SPACE:
   case NBSPACE:
   case      NL:
   case      CR:
   case   EOBOX:
   case  EOPAGE:
                if(inword) {inword=0;words++;}
                break;

   case     EOT:
                goto finished;

        default:
                inword=1;
                break;
  }

  offset+=slen;
  if(eoffset>=0 && offset>=eoffset) break;
 }


finished:
 if(inword) {inword=0;words++;}


 return(words);
}




int gettextstoryinfo(filestr * file,int * ssize,int * swords)
{
 os_error * err;
 vector     s;

 if(act.valid && act.file==file)
 {
  s=act;

  err=txlock(&s.textsrc,s.file);
  if(!err)
  {
   if(swords)
   {
    *swords=zone?wordcount(&s,lozon->textsrc.offset,hizon->textsrc.offset):
                 wordcount(&s,0,-1);
   }

   if(ssize)
   {
    *ssize=zone?(hizon->textsrc.offset-lozon->textsrc.offset):
                s.textsrc.sourcep->len;
   }

   txunlock(&s.textsrc,s.file);
  }

  return(zone?2:1);
 }
 else 
  return(0);
}


/***************************************************************************/

static filestr * sfile;
static int       sobject;
static int       sbranch;
static int       sindex;
static int       starget;


void firststory(int branch,filestr * file)
{
 sobject=-1;
 sfile=file;
 sbranch=branch;
}



static os_error * sfn(textboxstr * textp,filestr * file,int * message)
{
 os_error   * err;

 err=NULL;

 if(textp->type==OTEXTBOX)
 {
  if(!textp->fchain.prev)
  {
   if(sindex==sobject)
   {
    *message=0;
    starget=textp->key;
   }
   else 
   {
    sindex++;
   }
  }
 }

 return(err);

 USE(file);
}





static os_error * sfn2(textboxstr * textp,filestr * file,int * message)
{

 if(textp->type==OTEXTBOX)
 {
  if(!textp->fchain.prev)
  {
   sobject++;
   if(starget==textp->key)
   {
    *message=0;
   }
  }
 }

 return(NULL);

 USE(file);
}






os_error * nextstory(vector * v,int * eof)
{
 os_error * err;
 int        message;

 *eof=0;
 sindex=0;
 sobject++;

 message=OM_FUNCTION2;
 err=broadcastmessageb(sfile,sbranch,&message,(void*)sfn);

 if(!message)
 {
  setvectorfrombox(v,0,starget,sfile);
  *eof=0;
 }
 else
 { 
  *eof=1;
 }

	cprintf("next story %d",*eof);

 return(err);
}



os_error * setstartstory(int branch,vector * v,int * eof)
{
 os_error * err;
 int        message;

 *eof=0;

 firststory(branch,v->file);
 starget=v->textsrc.text;

 message=OM_FUNCTION2;
 err=broadcastmessageb(sfile,sbranch,&message,(void*)sfn2);

 return(err);
}




/*************************************************************************/

static int wcount;

void wcdocfirst(viewstr * view)
{
 firststory(view->branch,view->file);
 wcount=0;
}

void wcdocnext(int * eof,int * fcount)
{
 os_error * err;
 vector     v;

 nextstory(&v,eof);
 if(*eof==0)
 {
  err=txlock(&v.textsrc,sfile);
  if(!err)
  {
   wcount+=wordcount(&v,0,-1);
   txunlock(&v.textsrc,sfile);
  }
 }

 *fcount=wcount;
}




