/*->c.applet */


#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>


#include "os.h"
#include "transform.h"
#include "xprocess.h"
#include "sprite.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"


#include "flex.h"

#include "err.h"
#include "trans.h"
#include "temp.h"
#include "sp.h"
#include "wos.h"
#include "poll.h"
#include "alloc.h"
#include "bits.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "colour.h"
#include "timex.h"
#include "hourglass.h"
#include "deb.h"
#include "oserr.h"
#include "oscb.h"
#include "scanplus.h"
#include "ram.h"
#include "xhelp.h"
#include "osddex.h"
#include "osshell.h"

#include "task.h"
#include "applet.h"



       char * appsbasepath;
       char * appspath;




typedef struct apphdrstr
{
 HMODULE      handle;
 int          offset;     // offset of info data
 unsigned int noload:2;   // not loaded
 unsigned int object:2;
 unsigned int templates:1;
 unsigned int sprites:1;
 unsigned int help:1;
 unsigned int messages:1;

} apphdrstr;



static apphdrstr * appchunk;
static int         appsize;
static char      * appinfo;
static int         appinfolen;


#define APPCHUNK (sizeof(apphdrstr)*16)

#define APPINFOCHUNK (0x400)



static void stripcrlf(char * d,char * s,unsigned int * length)
{
 char * slt;
 char * d1;
 int    c;
 int    lc;

 slt=s+(*length);
 d1=d;
 c=32;
 while(s<slt)
 {
  lc=c;
  c=*s++;
  if(!(c<32 && lc<32))
  {
   if(c<32) *d++=0;
   else     *d++=(char)c;
  }
 }
 *length=d-d1;
}



static char * tagsearch(char * taglist,char * tag)
{
 char * p;
 char * p1;
 char * t1;
 int    pc;
 int    tc;

 p=taglist;
 while(*p)
 {
  p1=p;
  t1=tag;
  while(1)
  {
   pc=toupper(*p1++);
   tc=toupper(*t1++);
   if(tc==0 && pc==':')
   {
    return(p1);
   }
   if(pc!=tc) break;
  }

  p+=strlen(p)+1;
 }

 return(NULL);
}


char * apptag(int appn,char * tag)
{
 if(appn>=0 && appn<appsize)
 {
  return(tagsearch(appinfo+appchunk[appn].offset,tag));
 }
 return(NULL);
}





int appletseentemplates(int appn)
{
 if(appn>=0 && appn<appsize)
 {
  return(appchunk[appn].templates);
 }
 return(0);
}

int appletseensprites(int appn)
{
 if(appn>=0 && appn<appsize)
 {
  return(appchunk[appn].sprites);
 }
 return(0);
}

int appletseenhelp(int appn)
{
 if(appn>=0 && appn<appsize)
 {
  return(appchunk[appn].help);
 }
 return(0);
}

int appletseenmessages(int appn)
{
 if(appn>=0 && appn<appsize)
 {
  return(appchunk[appn].messages);
 }
 return(0);
}


static int appindex(ascaninstance instance)
{
 int appn;

 for(appn=0;appn<appsize;appn++)
 {
  if((ascaninstance)appchunk[appn].handle==instance)
  {
   return(appn);
  }
 }

 return(-1);
}

os_error * appletmarktemplates(ascaninstance instance)
{
 int appn;

 appn=appindex(instance);
 if(appn>=0 && appn<appsize)
 {
  appchunk[appn].templates=1;
 }

 return(NULL);
}

os_error * appletmarksprites(ascaninstance instance)
{
 int appn;

 appn=appindex(instance);
 if(appn>=0 && appn<appsize)
 {
  appchunk[appn].sprites=1;
 }

 return(NULL);
}

os_error * appletmarkhelp(ascaninstance instance)
{
 int appn;

 appn=appindex(instance);
 if(appn>=0 && appn<appsize)
 {
  appchunk[appn].help=1;
 }

 return(NULL);
}

os_error * appletmarkmessages(ascaninstance instance)
{
 int appn;

 appn=appindex(instance);
 if(appn>=0 && appn<appsize)
 {
  appchunk[appn].messages=1;
 }

 return(NULL);
}



os_error * addspritesx2(char * path,char * leaf,ascaninstance instance)
{
 appletmarksprites((ascaninstance)instance);
 return(addspritesxs2(path,leaf,(sprite_area**)&sprites,instance));
}


os_error * addtemplates2(TCHAR * path,TCHAR * leaf,templates * temptable,
                                     templink * link,ascaninstance instance)
{
 appletmarktemplates(instance);
 return(addtemplates2a(path,leaf,temptable,link,instance));
}


os_error * addhelp2(char * path,char * leaf,ascaninstance instance)
{
 appletmarkhelp(instance);
 return(addhelp2a(path,leaf,instance));
}


os_error * addtranstable2(char * path,char * leaf,ascaninstance instance)
{
 appletmarkmessages(instance);
 return(addtranstable2a(path,leaf,instance));
}



os_error * appletscaninstance(ascanfni ascan)
{
 int appleti;

 for(appleti=0;appleti<appsize;appleti++)
 {
  if(appchunk[appleti].handle && !appchunk[appleti].noload)
  {
   ascan(NULL,(ascaninstance)appchunk[appleti].handle,appleti);
  }
 }

 return(NULL);
}


int appletstatus(int appn)
{
 if(appn>=0 && appn<appsize) return(appchunk[appn].noload);
 else                        return(-1);
}


void appletsetstatus(int appn,int status)
{
 if(appn>=0 && appn<appsize)
 {
  appchunk[appn].noload=status;
 }
}



int appletversion(int appn)
{
 char * p;
 int    v;

 v=0;
 p=apptag(appn,"majorversion");
 if(p) v=atoi(p)*100;
 p=apptag(appn,"minorversion");
 if(p) v+=atoi(p); 

 return(v);
}



char * appletinfo(int appn)
{
 return(apptag(appn,"info"));
}



char * appletname(int appn)
{
 char * p;

 p=apptag(appn,"name");
 if(!p) p=apptag(appn,"oname");
 if(!p) p="";

 return(p);
}



int appletfindname(char * name)
{
 int    i;
 char * p;

 for(i=0;i<appsize;i++)
 {
  p=apptag(i,"name");
  if(p) if(cstrcmp(p,name)==0) return(i);
 }

 return(-1);
}




static BOOL CALLBACK appload(
  HMODULE hModule,  // module handle
  LPCTSTR lpszType, // pointer to resource type
  LPTSTR lpszName,  // pointer to resource name
  LPARAM lParam       // application-defined parameter
)
{
 os_error * err;
 char     * rstart=NULL;
 HANDLE     hDialog=NULL; 
 HRSRC      hRsrc;
 int        length=0;
 int        ack;

          err=XFindResource((HINSTANCE)hModule,lpszName,"HELP",&hRsrc);
 if(!err) err=XLoadResource((HINSTANCE)hModule,hRsrc,(HGLOBAL*)&hDialog);
 if(!err) err=XLockResource(hDialog,(LPVOID*)&rstart);
 if(!err) err=XSizeofResource((HINSTANCE)hModule,hRsrc,(unsigned int*)&length);
 if(!err)
 {
  ramnextreadfile(rstart,length);
  dataopen(lpszName,1,&ack);
  ramreadoff();
 }

 return(err==NULL);

 USE(lParam);
 USE(lpszType);
}


os_error * appletrunhelp(int appn,wimp_w parent)
{
 os_error * err;
 TCHAR      path[MAX_PATH];
 fxstat     fs;
 int        eof;
 char     * p;
 char     * q;
 int        ack;

 err=NULL;

 if(appn>=0 && appn<appsize)
 {
  {
   if(appchunk[appn].object==2)
   {
    p=apptag(appn,"oname");
    if(p)
    {
     fs_join(path,NITEM(path),appsbasepath,p);
     fs_startscan();

     while(1)
     {
      err=fs_nextitem(path,&fs,TEXT("help.*"),&eof);
      if(err) break;
      if(eof) break;

      q=path+strlen(path);
      *q='\\';

      strcpy(q+1,fs.name);

      dataopen(path,0,&ack);
      if(ack==0) oscommand(parent,TEXT("open"),path,NULL,NULL,0);
      *q=0;
     }
     fs_endscan();
    }
   }
   else
   if(appchunk[appn].object==1)
   {
    HINSTANCE  handle;

    handle=appchunk[appn].handle;
    err=XEnumResourceNames((HINSTANCE)handle,TEXT("HELP"),appload,NULL);
   }
  }
 }

 return(err);
}


int appletnumber(void)
{
 return(appsize);
}


void appletscanstart(int * appn)
{
 *appn=-1;
}


void appletscannext(int * appn,fxstat * f,int * eof)
{
 int    n;
 char * p;

 n=*appn;

 while(1)
 {
  n++;
  if(n>=appsize)
  {
   *eof=1;
   break;
  }
  
  if(!appchunk[n].noload)
  {
   f->f.object=appchunk[n].object;
   p=apptag(n,"oname");
   if(p)
   {
//    cprintf("n %d oname %s",n,p);
    xzstrncpy(f->name,p,sizeof(f->name)/sizeof(TCHAR));
    *appn=n;
    *eof=0;
    break;
   }
  }
 }
}


os_error * appletsavestatus(void)
{
 os_error * err;
 char       path[MAX_PATH];
 buffer     bf;
 int        appn;
 char     * p;


 xsprintf(NITEM(path),NULL,path,"%s\\manifest.txt",appspath?appspath:appsbasepath);
 err=fs_validatepath(path,0);
 if(!err) err=bf_open(path,'w',DEFBUFFSIZE,&bf);
 if(!err)
 {
  for(appn=0;appn<appsize;appn++)
  {
   p=apptag(appn,"oname");
   if(p)
   {
    err=bf_printf(&bf,"%s:%d\r\n",p,appchunk[appn].noload);
   }
   if(err) break;
  }
  err=bf_close(&bf,err);
 }
 return(err);
}


static char * appsstatus;

os_error * appletloadstatus(void)
{
 os_error * err;
 char       path0[MAX_PATH];
 char       path1[MAX_PATH];
 char     * path;
 fstat      fs;
 int        length;


 err=NULL;

 xsprintf(NITEM(path0),NULL,path0,"%s\\manifest.txt",appsbasepath);
 if(appspath) xsprintf(NITEM(path1),NULL,path1,"%s\\manifest.txt",appspath);

 err=fs_pair(path0,appspath?path1:NULL,1,&path,&fs);
 if(fs.object==1)
 {
  length=fs.length+2;
 
  err=flex_alloc((flex_ptr)&appsstatus,length);
  if(!err)
  {
   err=fs_loadblock(path,appsstatus);
   if(!err)
   {
    stripcrlf(appsstatus,appsstatus,(unsigned int *)&length);
    appsstatus[length]=0;
    appsstatus[length+1]=0;
   }
  }
 }

 return(err);
}



static os_error * appletdelete(int * deln)
{
 os_error * err;
 char     * p;
 char     * q;
 char     * r;
 char       path[MAX_PATH];
 int        status;

 err=NULL;

 *deln=0;

 if(appsstatus)
 {
  xzstrncpy(path,appsbasepath,sizeof(path)/sizeof(TCHAR));
  q=path+strlen(path);
  *q++='\\';
  
  p=appsstatus;
  while(*p)
  {
   r=strchr(p,':');
   if(r)
   {
    status=atoi(r+1);
    if(status==APPDELETE)
    {
     strcpy(q,p);
     *(q+(r-p))=0;
//     cprintf("wipe %s %s",path,p);
     err=fs_wipe(path);
     if(err) break;
     *deln=(*deln)+1;
     cprintf("*deln %d",*deln);
    }
   }
   p+=strlen(p)+1;
  }
 }

 report(err);
 return(err);
}


static int appletnoload(char * name)
{
 char * p;

 if(appsstatus)
 {
  p=tagsearch(appsstatus,name);
  if(p) return(atoi(p));
 }

 return(0);
}



static os_error * appaddinfo(char * name,char * path,int index,HINSTANCE handle,int object)
{
 os_error * err;
 fstat      fs;
 int        length=0;
 int        tlen;
 char       temp[256];
 char     * rstart=NULL;
 HANDLE     hDialog=NULL; 
 HRSRC      hRsrc;
 int        infofile;


// cprintf("addinfo %d %s",index,name);

 appchunk[index].handle=handle;
 appchunk[index].offset=appinfolen;
 appchunk[index].object=object;
 appchunk[index].noload=appletnoload(name);
 xsprintf(NITEM(temp),NULL,temp,"oname:%s",name);
 tlen=strlen(temp)+1;
 err=flex_chunk((flex_ptr)&appinfo,appinfolen+tlen,APPINFOCHUNK);
 if(!err)
 {
  memcpy(appinfo+appinfolen,temp,tlen);
  appinfolen+=tlen;

  infofile=0;

  if(path)
  {
   fs_stat(path,&fs);
   if(fs.object==1)
   {
    length=fs.length;
 
    err=flex_chunk((flex_ptr)&appinfo,appinfolen+length,APPINFOCHUNK);
    if(!err)
    {
     fs_loadblock(path,appinfo+appinfolen);
     stripcrlf(appinfo+appinfolen,appinfo+appinfolen,(unsigned int *)&length);
     appinfolen+=length;
     infofile=1;
    }
   }
  }

  if(handle && (!path || !infofile))
  {
            err=XFindResource((HINSTANCE)handle,"info.txt","INFO",&hRsrc);
   if(!err) err=XLoadResource((HINSTANCE)handle,hRsrc,(HGLOBAL*)&hDialog);
   if(!err) err=XLockResource(hDialog,(LPVOID*)&rstart);
   if(!err) err=XSizeofResource((HINSTANCE)handle,hRsrc,(unsigned int*)&length);
   if(!err)
   {
    err=flex_chunk((flex_ptr)&appinfo,appinfolen+length,APPINFOCHUNK);
    if(!err)
    {
     memcpy(appinfo+appinfolen,rstart,length);
     stripcrlf(appinfo+appinfolen,appinfo+appinfolen,(unsigned int *)&length);
     appinfolen+=length;
    }
   }
  }

  if(!err)
  { 
   err=flex_chunk((flex_ptr)&appinfo,appinfolen+2,APPINFOCHUNK);
   if(!err)
   {
    *(appinfo+appinfolen)=0;
    appinfolen++;
    *(appinfo+appinfolen)=0;
    appinfolen++;
   }
  }
 }

 return(err);
}









os_error * appletinit(char * xappsbase,char * xapps,int aversion)
{
 os_error   * err;
 fxstat       f;
 int          eof;
 int          len;
 char         path[MAX_PATH];
 char       * p;
 char       * q;
 fsscanhandle scan1;
 fsscanhandle scan2;
 HMODULE      handle;
 int          deln=0;

 err=NULL;

 if(xapps)
 {
  err=fs_expandpath(xapps,path,MAX_PATH);
  if(!err)
  {
   len=strlen(path);
   err=flex_alloc((flex_ptr)&appspath,len+1); 
   if(!err)
   {
    strcpy(appspath,path);
   }
  }
 }

 if(!err) err=fs_expandpath(xappsbase,path,MAX_PATH);
 if(!err)
 {
  len=strlen(path);
  appsize=0;

           err=flex_alloc((flex_ptr)&appsbasepath,len+1); 
  if(!err) err=flex_alloc((flex_ptr)&appchunk,APPCHUNK);
  if(!err) err=flex_alloc((flex_ptr)&appinfo,APPINFOCHUNK);
  {
   strcpy(appsbasepath,path);

   appletloadstatus();
   appletdelete(&deln);

   p=path+strlen(path);

   err=fs_startsortscan(appsbasepath,"*.*",0,&scan1);
   if(err)
   {
    err=NULL;
   }
   else
   {
    while(1)
    {
     err=fs_nextsortitem(scan1,&f,&eof);
     if(err) break;
     if(eof) break;

     if(f.f.object>1)
     {
      *p='\\';
      strcpy(p+1,f.name);
      q=path+strlen(path);

      err=flex_chunk((flex_ptr)&appchunk,(appsize+1)*sizeof(apphdrstr),APPCHUNK);
      if(err) break;
      memset(appchunk+appsize,0,sizeof(apphdrstr));
      appsize++;
      handle=0;

//      cprintf("appname %s",f.name);

      // appsize
      // appchunk

//     fs_savescan(&save);

      err=fs_startsortscan(path,"*.dll",0,&scan2);
      if(err)
      {
       err=NULL;
      }
	     else
      {
       while(1)
       {
        err=fs_nextsortitem(scan2,&f,&eof);
//        cprintf("scan dll eof %d",eof);

        if(err) break;
        if(eof) break;

        *q='\\';
        strcpy(q+1,f.name);

 
        err=XLoadLibrary(path,&handle);
//       cprintf("load lib path %s handle %x err %x",path,handle,err);
        if(err) break;
        if(handle)
        {
//         cprintf("load lib");

        }
       }

       fs_endsortscan(&scan2);
      }
//     fs_loadscan(save);

      *q='\\';
      strcpy(q+1,"info.txt");
      xstrncpy(f.name,p+1,q-p);
      appaddinfo(f.name,path,appsize-1,handle,2);
      *q=0;

      *p=0;
     }
     else
     if(f.f.object==1)
     {
      if(fs_extensionis(f.name,TEXT("dll"))==0)
      {
       fs_strcat(p,NITEM(path)-(p-path),f.name);
  
       err=flex_chunk((flex_ptr)&appchunk,(appsize+1)*sizeof(apphdrstr),APPCHUNK);
       if(err) break;
       memset(appchunk+appsize,0,sizeof(apphdrstr));
       appsize++;

       err=XLoadLibrary(path,&handle);
       if(err) break;
       if(handle)
       {
//       cprintf("load lib %s",f.name);
        appaddinfo(f.name,NULL,appsize-1,handle,1);
       }

       *p=0;
      }
     }
     if(err) break;
    }

    fs_endsortscan(&scan1);
   }
  }
 }  


 if(!err)
 {
  char * p;
  int    v;
  int    i;

  for(i=0;i<appsize;i++)
  {
   v=0;
   p=apptag(i,"majorcompatible");
   if(p) v=atoi(p)*100;
   p=apptag(i,"minorcompatible");
   if(p) v+=atoi(p); 

   if(v>aversion) appchunk[i].noload=1;
  }

  if(deln) appletsavestatus();
 }

 return(err);
}


/* called at end of task initialisation */

os_error * appletboot(void)
{
 os_error   * err;
 int          appleti;
 FARPROC      farproc;

 err=NULL;

 if(appsbasepath)
 {
  for(appleti=0;appleti<appsize;appleti++)
  {
//   cprintf("applet %d handle %x",appleti,appchunk[appleti].handle);
   if(appchunk[appleti].handle && !appchunk[appleti].noload)
   {
    farproc=GetProcAddress(appchunk[appleti].handle,TEXT("entrypoint"));
    if(farproc)
    {
 //    cprintf("found entrypoint");
     err=((appletmainfn)farproc)(appsbasepath);
     report(err);
     err=NULL;
    }
   }
  }
 }

 return(err);
}





os_error * inittaska(char * name,char * textname,char * spritename,
                     char * resources,char * appsbase,char * apps,taskinitfn initfn,int aversion,char * dde)
{                   
 os_error * err;

#ifdef NEVER
 char       temp[64];
 char     * p;
#endif

 wimpversion=wimpt_init2(name,textname,spritename);

          err=inittemp();																			// first thing define windows classes
 if(!err && dde!=NULL) err=ddestart(dde);			// second register for DDE - problems with double click run on W98
 if(!err) err=osshellinit(OSSHELLOLE);

	if(!err)
	{
  vdumodevars();
	}

 if(!err) err=starttask();        /* does checks and retrieves task handle */
 if(!err) err=flex_init();

 if(!err) err=appletinit(appsbase,apps,aversion);
 if(!err) err=initerror();

 if(!err) err=initsprites();
 if(!err) err=inittrans();
 if(!err && initfn!=NULL) err=initfn(0);
 if(!err) err=initalloc();

 if(!err) err=pollinit();
  timexinitsys(NULL,NULL);
 if(!err) err=hourglassinit();


 if(!err) err=appletboot();


 if(!err) err=taskerrors();
 if(!err) err=addspritesx(resources,TEXT("Sprites.spr"));

 if(!err)
 {
//  if(ospresent(RISCOS310)<0) err=addspritesx(resources,"Sprites2.spr");
 }

 if(!err) err=event(EVENT_LOADSPRITES,NULL,0);
 if(!err) err=appletsprites();

 if(!err) err=event(EVENT_SUBRESOURCES,NULL,0);

 if(!err) err=addtranstable(resources,TEXT("Messages.txt"));
 if(!err) err=event(EVENT_LOADMESSAGES,NULL,0);
 if(!err) err=appletmessages();


#ifdef NEVER
 if(!err) 
 {
  sprintf(temp,"%s$Templates",name);


  if((p=getenv(temp))!=NULL) 
  {
   strcpy(temp,p);
   p=temp;
  }
  else p="Templates";

  err=addtemplates(resources,p,temptable,&templatelink);
 }
#endif

 return(err);
}





