

#include <stdafx.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>

#include "os.h"
#include "fsx.h"
#include "bits.h"

#include "comline.h"






os_error * glob(TCHAR * filename,TCHAR * wild,globfn fn)
{
 os_error * err;
 fxstat     f;
 TCHAR      name[MAX_PATH];
 TCHAR    * p;
 fsscanhandle save;
 int        eof;


 err=NULL;


 xzstrncpy(name,filename,sizeof(name)/sizeof(TCHAR));
 p=fs_leaf(name);

 fs_startscan();
 
 while(1)
 {
  err=fs_nextitem(filename,&f,wild,&eof);
  if(err || eof) break;

  strcpy(p,f.name);

  fs_savescan(&save);

  err=fn(name,&f);

  fs_loadscan(save);

  if(err) break;
 }

 fs_endscan();

	return(err);
}


/*******************************************************************************/



void parsecommandline(char * cmd,char * argv[],int * argcp,int maxargc)
{
 int    argc;
 char * p;
 int    inquotes;
	char * s;
	char * e;

 
 argc=0;
 p=cmd;
	inquotes=0;

 while(argc<maxargc)
	{
  while(*p==' ') p++;
		if(*p==0) break;
		s=p;

		while(1)
		{
   if(*p=='\"')
			{
			 inquotes^=1;
   }

  	if((!inquotes && *p==' ') || *p==0)
  	{
    e=p;
    if(*p!=0) p++;

    if(*s=='\"') s++;
				if(e>s && *(e-1)=='\"') e--;
				*e=0;
	   argv[argc++]=s;

				break;
   }
   p++;
  }
 }

 *argcp=argc;
}




/*****************************************************************************/


/*
 * get option letter from argument vector
 */


int      getoptind;                /* index into parent argv vector */
int      getoptopt;                /* character checked for validity */
char   * getoptarg;                /* argument associated with option */

#define BADCH  (int)'?'
#define EMSG   ""
#define tell(s) return(BADCH)

#define rindex(x, y) strrchr(x, y)
#define index(string, byte) strchr(string, byte)


static char * place=EMSG;  /* option letter processing */


int getopt(int nargc,char * nargv[],char * ostr)
{                     
 char   *oli;                    /* option letter list index */

 if(!*place)
 {                   /* update scanning pointer */
  if(getoptind>=nargc || *(place = nargv[getoptind])!= '-' || !*++place) return(EOF);
  if(*place=='-')
  {    /* found "--" */
   ++getoptind;
   return(EOF);
  }
 }                               /* option letter okay? */
 if((getoptopt=(int)*place++)==(int)':' || ((oli = index(ostr,getoptopt))==NULL))
 {
  if(!*place) ++getoptind;
  return(BADCH); //tell(": illegal option -- ");
 }
 if(*++oli != ':')
 {            /* don't need argument */
  getoptarg = NULL;
  if (!*place) ++getoptind;
 }
 else
 {                          /* need an argument */
  if (*place) getoptarg = place;     /* no white space */
  else
  if (nargc <= ++getoptind) 
  {   /* no arg */
   place = EMSG;
   return(BADCH); //tell(": option requires an argument -- ");
  }
  else getoptarg = nargv[getoptind];    /* white space */
  place = EMSG;
  ++getoptind;
 }

 return(getoptopt);                 /* dump back option letter */
}


void getoptboot(void)
{
 getoptind = 1;
 place = EMSG;
}

