/*->c.config */

#include <stdafx.h>

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>


#include "os.h"

#include "fsx.h"
#include "bf.h"
#include "err.h"
#include "etc.h"
#include "osreg.h"
#include "bits.h"
#include "deb.h"


#include "config.h"


static conlink  * firstlink;



os_error * addcontable(contag * tags,conlink * link)
{
 link->tags=tags;
 link->next=NULL;

 link->next=firstlink;
 firstlink=link;

 return(NULL);
}





static os_error * savecontok(buffer * bf,conlink * link,contag * tag)
{
 os_error  * err;
 int         value;
 contokstr * tok;

 value=*((int*)tag->address);

 tok=tag->data.list;
 while(tok && tok->name)
 {
  if(tok->value==value)
  {
   err=bf_printf(bf,"%s %s %s\r\n",link->name,tag->name,tok->name);
   return(err);
  }
  tok++;
 }

 return(geterror(ENOTOKVAL));
}







static int xstring(char * p,char * string)
{
 char * q;
 int    c;

 q=p;

 do
 {
  c=*string++;
  if(c==' ') 
  {
   *p++='\\';
   *p++='s';
  }
  else
  {
   *p++=(char)c;
  }
 } while(c);

 return(p-q-1);
}



static void getxstring(char * p,char * string)
{
 int c;

 while(1)
 {
  c=*p++;
  if(c<=' ') break;
  if(c=='\\') 
  {
   c=*p++;
   if(c=='s') c=' ';
  }

  *string++=(char)c;
 }

 *string=0;
}








static os_error * saveconarray(buffer * bf,conlink * link,contag * tag)
{
 os_error        * err;
 char              string[1024];
 char            * p;
 char            * q;
 int               count;
 void            * address;
 int               n;
	int               size;

 err=NULL;

 address=tag->address;
 count=*(tag->data.array->y);
 while(count--)
 {
		xsprintf(NITEM(string),&size,string,"%s %s ",link->name,tag->name);
  p=string+size;

  q=tag->data.array->types;
  while(*q)
  {
   if(*q=='I') 
   {
    xsprintf((sizeof(string)-(p-string))/sizeof(TCHAR),&size,p,"%d",*((int*)address));
    p+=size;
    address=(void*)(((char*)address)+sizeof(int));
    q++;
   }
   else
   if(*q=='S')
   {
    n=0;
    q++;
    while(isdigit(*q)) {n=((*q)-'0')+n*10;q++;}
    p+=xstring(p,(char*)address);
    address=(void*)(((char*)address)+n);
   }
   *p++=' ';
  }
  *(p-1)='\r';
  *p++='\n';
  *p=0;

  err=bf_write(bf,string,p-string);
  if(err) break;
 }
 return(err);
}






os_error * saveconfig(char * name)
{
 os_error * err;
 conlink  * link;
 contag   * tag;
 buffer     bf;
 char       temp[1024];
 char     * p;


          err=bf_open(name,'w',DEFBUFFSIZE,&bf);
 if(!err) err=stdfileheader(&bf,fs_leaf(name));
 if(!err)
 {

  link=firstlink;

  while(link)
  {
   tag=link->tags;
   while(tag->name)
   {
    switch(tag->type)
    {
     case CONINT:
                 err=bf_printf(&bf,"%s %s %d\r\n",link->name,tag->name,
                                                      *((int*)tag->address));
                 break;

     case CONSTR:
                 if(tag->con)
                 {
                  tag->con(temp,1);
                  p=temp;
                 }
                 else p=(char*)tag->address;

                 err=bf_printf(&bf,"%s %s %s\r\n",link->name,tag->name,p);
                 break;

     case CONTOK:
                 err=savecontok(&bf,link,tag);
                 break;

     case CONARRAY:
                   err=saveconarray(&bf,link,tag);
                   break;

    }
    tag++;
    if(err) break;
   }

   if(err) break;
   err=bf_printf(&bf,"\r\n");
   if(err) break;

   link=link->next;
  }

  err=bf_closec(&bf,err,name,0xFFF);
 }
 return(err);
}






static os_error * saveconarrayregistry(oskeyh key,contag * tag)
{
 os_error        * err;
 char              string[1024];
 char              name[1024];
 char            * p;
 char            * q;
 int               count;
 void            * address;
 int               n;
 oskeyh            skey;
 int               i;
	int               size;

 err=NULL;

 address=tag->address;
 count=*(tag->data.array->y);

 err=regcreatedir(key,tag->name,&skey);
 if(!err)
 {
  for(i=0;i<count;i++)
  {
   xsprintf(sizeof(name)/sizeof(TCHAR),NULL,name,"%s%02d",tag->name,i);
   p=string;

   q=tag->data.array->types;
   while(*q)
   {
    if(*q=='I') 
    {
     xsprintf((sizeof(string)-(p-string))/sizeof(TCHAR),&size,p,"%d",*((int*)address));
     p+=size;
     address=(void*)(((char*)address)+sizeof(int));
     q++;
    }
    else
    if(*q=='S')
    {
     n=0;
     q++;
     while(isdigit(*q)) {n=((*q)-'0')+n*10;q++;}
     p+=xstring(p,(char*)address);
     address=(void*)(((char*)address)+n);
    }
    *p++=' ';
   }
   *p=0;

   err=regsetstr(skey,name,string);
   if(err) break;
  }

  err=regclosekey(&skey,err);
 }
 return(err);
}






static os_error * savecontokregistry(oskeyh key,contag * tag)
{
 os_error  * err;
 int         value;
 contokstr * tok;

 value=*((int*)tag->address);

 tok=tag->data.list;
 while(tok && tok->name)
 {
  if(tok->value==value)
  {
   err=regsetstr(key,tag->name,tok->name);
   return(err);
  }
  tok++;
 }

 return(geterror(ENOTOKVAL));
}









os_error * saveconfigregistry(char * name)
{
 os_error * err;
 conlink  * link;
 contag   * tag;
 char       temp[1024];
 char     * p;
 oskeyh     key;
 oskeyh     skey;


 skey=key=0;

 err=regcreatepath(name,&key);
 if(!err)
 {
  link=firstlink;

  while(link)
  {
   tag=link->tags;
   if(link->name && strlen(link->name))
   {
    err=regcreatedir(key,link->name,&skey);
    if(err) break;
   }
   else
   {
    skey=key;
   }

//   cprintf("skey=%x",skey);

   while(tag->name)
   {
//    cprintf("tagname %s",tag->name);

    switch(tag->type)
    {
       case CONINT:
                   xsprintf(sizeof(temp)/sizeof(TCHAR),NULL,temp,"%d",*((int*)tag->address));
                   err=regsetstr(skey,tag->name,temp);
                   break;

       case CONSTR:
                   if(tag->con)
                   {
                    tag->con(temp,1);
                    p=temp;
                   }
                   else p=(char*)tag->address;

                   err=regsetstr(skey,tag->name,p);
                   break;

       case CONTOK:
                   err=savecontokregistry(skey,tag);
                   break;

     case CONARRAY:
                   err=saveconarrayregistry(skey,tag);
                   break;

    }
    tag++;
    if(err) break;
   }

   if(err) break;

   if(link->name && strlen(link->name)) regclosekey(&skey,err);
   link=link->next;
  }

  err=regclosekey(&key,err);
 }
 return(err);
}























/* a token is a non space, followed by a space or zero */

static char * gettok(char * string,int * len)
{
 int    tlen;
 char * p;
 char * q;

 p=string;
 while(*p==' ') p++;
 q=p;
 while(*q>' ') q++;

 tlen=q-p;
 if(*q)
 {
  *q=0;
  tlen++;
 }

 *len=tlen;

 return(p);
}





static os_error * loadcontok(contag * tag,char * p)
{
 os_error  * err;
 contokstr * tok;
 int         len;

 err=NULL;

 tok=tag->data.list;
 p=gettok(p,&len);

 while(tok && tok->name)
 {
  if(!strcmp(tok->name,p))
  {
   *((int*)tag->address)=tok->value;
   return(err);
  }
  tok++;
 }

 return(err);
}






static contag * lasttag;

static os_error * loadconarray(contag * tag,char * p)
{
 os_error        * err;
 char            * q;
 static void     * address;
 int               n;
 int               len;

 err=NULL;

 if(tag!=lasttag) address=tag->address;
 lasttag=tag;

 q=tag->data.array->types;
 while(*q)
 {
  p=gettok(p,&len);

  if(*q=='I') 
  {
   sscanf(p,"%d",((int*)address));
   address=(void*)(((char*)address)+sizeof(int));
   q++;
  }
  else
  if(*q=='S')
  {
   n=0;
   q++;

   while(isdigit(*q)) {n=((*q)-'0')+n*10;q++;}

   getxstring(p,(char*)address);

   address=(void*)(((char*)address)+n);
  }
  p+=len;
 }

 return(err);
}




static os_error * loadregconarray(contag * tag,char * name,oskeyh key)
{
 os_error        * err;
 oskeyh            skey;
 char              string[1024];
 int               eof;
 int               size;
 int               index2;
	int               stype;
	int               dsize;
	char              data[1024];


 err=regopensubkey(key,name,&skey);
 if(!err)
 {
  index2=0;
  while(1)
  {
   size=sizeof(string)/sizeof(TCHAR);
			dsize=sizeof(data); // NB bytes not TCHARs
   err=regenumvalue(skey,string,&size,&stype,data,&dsize,&eof,&index2);
   cprintf("enumvalue eof=%d string=%s data=%s",eof,string,data);

   if(err) break;
   if(eof) break;

   err=loadconarray(tag,data);
  }
  err=regclosekey(&skey,err); 
 }

 return(err);
}






static os_error * gettag(conlink * link,contag * tag,char * p)
{
 os_error * err;

 err=NULL;

 switch(tag->type)
 {
  case CONINT:
              sscanf(p,"%d",(int*)tag->address);
              break;


  case CONSTR:
              if(tag->con) tag->con(p,0);
              else
              if(strlen(p)<(unsigned int)tag->data.len) strcpy((char*)tag->address,p);
              break;


  case CONTOK:
              err=loadcontok(tag,p);
              break;

  case CONARRAY:
              err=loadconarray(tag,p);
              break;



 }

 return(err);

 USE(link);
}


static conlink * findlink(char * name)
{
 conlink * link;

 link=firstlink;

/* dprintf(0,"name=%s link=%x",name,link); */

 while(link)
 {
//  cprintf("name=%s link=%x",name,link);
  if(!strcmp(link->name,name)) break;
  link=link->next;
 }

 return(link);
}



static contag * findtag(conlink * link,char * name)
{
 contag * tag;
 tag=link->tags;

//	cprintf("find tag %s",name);

 while(tag->name)
 {
  if(!strcmp(tag->name,name)) return(tag);
  tag++;
 }
 return(NULL);
}



os_error * loadconfig(char * name)
{
 os_error * err;
 conlink  * link;
 contag   * tag;
 buffer     bf;
 char       string[1024];
 int        eof;
 int        len;
 char    *  p;



// cprintf("load config");

 lasttag=NULL;


 err=bf_open(name,'r',DEFBUFFSIZE,&bf);
 if(!err)
 {
//  cprintf("config open OK");

  eof=0;

  while(!eof)
  {
   err=bf_getstring(&bf,string,sizeof(string)/sizeof(TCHAR),&eof);
   if(err) break;

//			cprintf("string %s",string);

   p=gettok(string,&len);
   if(len)
   {
    if(strcmp(p,"//"))
    {
//     cprintf("findlink a string=%s",string);
//     cprintf("findlink b string=%s",p);

     link=findlink(p);
     if(link)
     {
      p=gettok(p+len,&len);
      if(len)
      {
       tag=findtag(link,p);
       if(tag) err=gettag(link,tag,p+len);
      }
     }
    }
   }
  }
  err=bf_close(&bf,err);
 }
 return(err);
}





#ifdef NEVER

static os_error * gettagregistry(conlink * link,contag * tag,char * p)
{
 os_error * err;

 err=NULL;

 switch(tag->type)
 {
  case CONINT:
              sscanf(p,"%d",(int*)tag->address);
//														cprintf("CONINT %s %s %d",p,tag->name,(int*)tag->address);
              break;


  case CONSTR:
              if(tag->con) tag->con(p,0);
              else
              if(strlen(p)<(unsigned int)tag->data.len) strcpy((char*)tag->address,p);
              break;


  case CONTOK:
              err=loadcontok(tag,p);
              break;

  case CONARRAY:
              err=loadconarray(tag,p);
              break;

 }

 return(err);

 USE(link);
}

#endif






os_error * loadconfigregistry(char * name)
{
 os_error * err;
 conlink  * link;
 contag   * tag;
 char       string[1024];
 int        eof;
 int        len;
 char    *  p;
 oskeyh     key;
 int        size;
 int        index1;
 int        index2;
 oskeyh     skey;
	int        stype;
	int        dsize;
	char       data[1024];


 cprintf("load config reg");

 lasttag=NULL;

 err=regopenkey(name,&key,'r');
 if(!err)
 {
  cprintf("openkey %s",name);
  index1=0;
  while(1)
  {
   size=sizeof(string)/sizeof(TCHAR);
   err=regenumkey(key,string,&size,&eof,&index1);
   if(err) break;
   if(eof) break;

   cprintf("** eof %d index %d string %s",eof,index1,string);

   p=gettok(string,&len);
   if(len)
   {
    link=findlink(p);
    cprintf("findlink %x %s",link,p);
    if(link)
    {
     cprintf("opensubkey %s",p);
     err=regopensubkey(key,p,&skey);
     if(!err)
     {
      cprintf("index2 skey=%d",skey);
      index2=0;
      while(1)
      {
       size=sizeof(string)/sizeof(TCHAR);
       err=regenumkey(skey,string,&size,&eof,&index2);
       if(err) break;
       if(eof) break;

       cprintf("enumkey string %s",string);

// know that this must be an array

       p=gettok(string,&len);
       if(len)
       {
        tag=findtag(link,p);
        if(tag) err=loadregconarray(tag,string,skey);
       }
      }

      index2=0;
      while(1)
      {
       size=sizeof(string)/sizeof(TCHAR);
							dsize=sizeof(data); // NB bytes not TCHARs
       err=regenumvalue(skey,string,&size,&stype,data,&dsize,&eof,&index2);
      cprintf("enumvalue eof=%d string=%s data=%s",eof,string,data);

       if(err) break;
       if(eof) break;

       p=gettok(string,&len);

       if(len)
       {
        tag=findtag(link,p);
        if(tag) err=gettag(link,tag,data);
       }
      }

      err=regclosekey(&skey,err); 
     }
     if(err) break;
    }
   }
  }
  err=regclosekey(&key,err);
 }
 return(err);
}








os_error * initcon(void)
{
 firstlink=NULL;
 return(NULL);
}


