/****************************************************************************
 * This source file was written by Acorn Computers Limited. It is part of   *
 * the RISCOS library for writing applications in C for RISC OS. It may be  *
 * used freely in the creation of programs for Archimedes. It should be     *
 * used with Acorn's C Compiler Release 3 or later.                         *
 *                                                                          *
 ***************************************************************************/

/*
 * Title  : os.h
 * Purpose: provides general access to low-level RISC OS routines         
 *        
 */

/*
 * This file is provided as an alternative to kernel.h
 * It provides low-level access to RISC OS.
 * 
 */

# ifndef __os_h
# define __os_h

#ifndef BOOL
#define BOOL int
#define TRUE 1
#define FALSE 0
#endif


typedef void * ascaninstance;

typedef HANDLE fshandle;

typedef void * oshdc;		// device context


typedef struct {
        int errnum;             /* error number */
        TCHAR errmess[252];      /* error message (zero terminated) */
} os_error;


extern os_error * osreadvar(char * in,char * out,int n);
 


# endif

/* end of os.h */
