/*->c.sprx */

#include <stdafx.h>


#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>


#include "os.h"


#include "flex.h"
#include "alloc.h"
#include "wimp.h"
#include "transform.h"
#include "xprocess.h"
#include "sprite.h"

#include "fsx.h"
#include "bf.h"
#include "deb.h"
#include "osgraphics.h"
#include "ossprite.h"

#include "sprx.h"




int palentriestab[4]={2,4,16,16};


void genpalette(int ln2bpp,int * palentries,int * paltab)
{

 if(ln2bpp<4) *palentries=palentriestab[ln2bpp];

 if(ln2bpp==3)
 {
  paltab[0]=0x0;
  paltab[1]=0x10101000;
  paltab[2]=0x20202000;
  paltab[3]=0x30303000;
  paltab[4]=0x4000;
  paltab[5]=0x10105000;
  paltab[6]=0x20206000;
  paltab[7]=0x30307000;
  paltab[8]=0x40000000;
  paltab[9]=0x50101000;
  paltab[10]=0x60202000;
  paltab[11]=0x70303000;
  paltab[12]=0x40004000;
  paltab[13]=0x50105000;
  paltab[14]=0x60206000;
  paltab[15]=0x70307000;
 }
 else
 if(ln2bpp==2)
 {
  paltab[0]=0xffffff00;
  paltab[1]=0xdddddd00;
  paltab[2]=0xbbbbbb00;
  paltab[3]=0x99999900;
  paltab[4]=0x77777700;
  paltab[5]=0x55555500;
  paltab[6]=0x33333300;
  paltab[7]=0x00000000;
  paltab[8]=0x99440000;
  paltab[9]=0x00eeee00;
  paltab[10]=0x00cc0000;
  paltab[11]=0x0000dd00;
  paltab[12]=0xbbeeee00;
  paltab[13]=0x00885500;
  paltab[14]=0x00bbff00;
  paltab[15]=0xffbb0000;
 }
 else
 if(ln2bpp==1)
 {
  paltab[0]=0xffffff00;
  paltab[1]=0xdddddd00;
  paltab[2]=0x99999900;
  paltab[3]=0x00000000;
 }
 else
 if(ln2bpp==0)
 {
  paltab[0]=0xffffff00;
  paltab[1]=0x00000000;
 }
}



/* generate a greyscale palette */

void gengreypal(int ln2bpp,int * palentries,int * paltab)
{
 int i;
 int palw;

 *palentries=(1<<(1<<ln2bpp));

 switch(ln2bpp)
 {
  case 0:
         paltab[0]=0;
         paltab[1]=0xFFFFFF00;
         break;

  case 1:
         paltab[0]=0;
         paltab[1]=0x55555500;
         paltab[2]=0xAAAAAA00;
         paltab[3]=0xFFFFFF00;
         break;

  case 2:
         for(i=0;i<16;i++)
         {
          palw=(i<<28)|(i<<24)|(i<<20)|(i<<16)|(i<<12)|(i<<8);
          paltab[i]=palw;
         }
         break;

  case 3:
         for(i=0;i<256;i++)
         {
          palw=(i<<24)|(i<<16)|(i<<8);
          paltab[i]=palw;
         }
         break;
 }
}




int isgreypal(int * pal,int ncolours)
{
 int i;
 int r;
 int g;
 int b;

 for(i=0;i<ncolours;i++)
 {
  r=(pal[i]>>8) & 0xFF;
  g=(pal[i]>>16) & 0xFF;
  b=(pal[i]>>24) & 0xFF;
  if(r!=g || g!=b) return(0);
 }
 return(1);
}


int isgreyscalepal(int * pal,int ncolours)
{
 int i;
 int g;
 int step;
 int sum;

// step=255/(ncolours-1);

 if(ncolours==2)  step=255;
 else
 if(ncolours==16) step=17;
 else
 if(ncolours==4)  step=85;
 else             step=1;

 if(isgreypal(pal,ncolours))
 {
  sum=0;
  for(i=0;i<ncolours;i++)
  {
   g=(pal[i]>>8) & 0xFF;
   if(g!=sum) break;
   sum+=step;
  }
  if(i>=ncolours) return(1);

  sum=255;
  for(i=0;i<ncolours;i++)
  {
   g=(pal[i]>>8) & 0xFF;
   if(g!=sum) break;
   sum-=step;
  }

  if(i>=ncolours) return(-1);
 }

 return(0);
}



int makemode(int obpp,int deltax,int deltay)
{
 int prmode;
 int sxdpi;
 int sydpi;

 if(obpp>8)
 {
  if(deltax) sxdpi=180/deltax;
  else       sxdpi=180;

  if(deltay) sydpi=180/deltay;
  else       sydpi=180;

  prmode=1+(sxdpi<<1)+(sydpi<<14);
  if(obpp==16) prmode|=(5<<27);
  else         prmode|=(6<<27);
 }
 else
 if(deltax==deltay) /* square */
 {
  if(obpp==8) prmode=28;
  else
  if(obpp==4) prmode=27;
  else
  if(obpp==2) prmode=26;
  else        prmode=25;
 }
 else               /* rect */
 {
  if(obpp==8) prmode=15;
  else
  if(obpp==4) prmode=12;
  else
  if(obpp==2) prmode=4;
  else        prmode=0;
 }

 return(prmode);
}




void genpal256(int * paltab,int ln2bpp,int * palentriesp)
{
 int          palentries;
 unsigned int c1;
 int          target;
 int          pal2[16];
 int          i;

 palentries=*palentriesp;

//  cprintf("palentries %d bpp=%d",palentries,spbpp);

 if(ln2bpp==3 && (palentries==64 || palentries==16))
 {

  for(i=0;i<16;i++)
  {
   if(palentries==64) pal2[i]=paltab[i+48];
   else               pal2[i]=paltab[i];
  }

  for(target=255;target>=0;target--)
  {
   c1=pal2[target & 0xF];

   if(target & 0x10) c1|=0x8000;
   else              c1&=~0x8000;

   if(target & 0x20) c1|=0x400000;
   else              c1&=~0x400000;

   if(target & 0x40) c1|=0x800000;
   else              c1&=~0x800000;

   if(target & 0x80) c1|=0x80000000;
   else              c1&=~0x80000000;

   c1&=0xF0F0F000;
   c1|=(c1>>4)&0xF0F0F00;

   paltab[target]=c1;
  }

  *palentriesp=256;
 }
}


void genpalbpp(int * paltab,int bpp,int * palentriesp)
{
 int ln2bpp=ln2bpptab[bpp];
 genpalette(ln2bpp,palentriesp,paltab);
 genpal256(paltab,ln2bpp,palentriesp);

// cprintf("p0=%x p1=%x p2=%x",paltab[0],paltab[1],paltab[2]);
}




void spgetpal(newsprite_header * sph,int * palentries,int * paltab)
{
 int   i;
 int * pal2;

 *palentries=(sph->image-sizeof(sprite_header))/8;
 if(*palentries<0) *palentries=0;
 pal2=(int*)(((char*)sph)+sizeof(sprite_header));


 for(i=0;i<(*palentries);i++)
 {
  paltab[i]=pal2[i*2];
 }
}



void spsetpal(newsprite_header * sph,int entries,int * pal)
{
 int   i;
 int * pal2;


 pal2=(int*)(((char*)sph)+sizeof(sprite_header));

 for(i=0;i<entries;i++)
 {
  pal2[i*2]=pal2[i*2+1]=pal[i];
 }
}

